﻿Imports System.Data.OracleClient
Imports System.IO
Imports System.Data
Imports System.Globalization
Imports System.Data.OleDb
Imports CTI.Utilities.Log
Partial Class CrearPedido
    Inherits claseBase

    Private NDOCUM As String
    Private TIPODOC As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private num_lineas_error_costo As Integer = 0
    Private _lineas As List(Of BCb2b.CLineaPedidoOff)



    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit

    '    If (Session("tipo_usuario") <> "CL") Then
    '        Me.MasterPageFile = "~/MasterPage_txiki.master"
    '    End If



    'End Sub

    Public ReadOnly Property PROP_N_DOC_SEL() As String
        Get
            Return Me.NDOCUM
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_DOC_SEL() As String
        Get
            Return Me.TIPODOC
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Private Property lineas As List(Of BCb2b.CLineaPedidoOff)
        Get
            Return _lineas
        End Get
        Set(value As List(Of BCb2b.CLineaPedidoOff))
            _lineas = value
        End Set
    End Property

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_Unidad_Gaart(ByVal grupo As String, ByVal gaart_cod As String) As String
        Dim unidad As String = ""
        Try
            Dim ARTICULOAUX As New BCb2b.CArticulo(grupo, gaart_cod.ToUpper)
            unidad = ARTICULOAUX.prop_gaunitip_uni1
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Dame_Unidad_Gaart] empgru = {empgru} art = {art} ", grupo, gaart_cod)
        End Try
        Return unidad
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_PesoTotal_Lin(ByVal grupo As String, ByVal gaart_cod As String, ByVal cantidad As String, ByVal gaclatip_peso As String) As String
        Dim peso_total As Double = 0

        cantidad = GestionaNumero(cantidad)
        If cantidad <> "" Then
            Try
                Dim clasi As New BCb2b.gaartclasi(grupo, gaart_cod, gaclatip_peso)

                If clasi.prop_VALOR <> "" Then
                    peso_total = CDbl(clasi.prop_VALOR) * CDbl(cantidad)
                End If
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Dame_PesoTotal_Lin] empgrup = {empgrup} art = {art} peso = {peso} cant = {cant} ", grupo, gaart_cod, gaclatip_peso, cantidad)
            End Try
        End If

        If peso_total = 0 Then
            Return ""
        Else
            Return FormatNumber(peso_total, 3)
        End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaTextoUrgente(ByVal texto_caja As String, ByVal texto_urgente As String) As String
        Try
            Dim arrayAdvert(4) As String
            arrayAdvert(0) = "-URGENTE-" 'ESP
            arrayAdvert(1) = "-URGENTE-" 'ITA
            arrayAdvert(2) = "-URGENT-" 'FRA
            arrayAdvert(3) = "-URGENT-" 'ING
            arrayAdvert(4) = "-DRINGEND-" 'ALE

            If Trim(texto_caja) <> "" Then
                Dim i As Integer = 0
                For i = 0 To arrayAdvert.Length - 1
                    If texto_caja.Contains(arrayAdvert(i)) Then
                        texto_caja = texto_caja.Replace(arrayAdvert(i), "")
                    End If
                Next i
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.GestionaTextoUrgente] caja = {caja} urgente = {urgente} ", texto_caja, texto_urgente)
        End Try

        If texto_urgente = "" Then
            Return texto_caja
        Else
            Return texto_urgente & Trim(texto_caja)
        End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_observacion(ByVal vOBSER As String) As String
        'AQUI LLAMO AL A FUCNION QUE INSERTA O NO SEGÚN LO QUE TENGA QUE HACER.
        Try
            'SRA HACER!
            'modificar obser
            Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("CRM_GGOFETIP_OPO_OBS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            Dim PARAM_OBS As String = PARAMETRO.prop_VALOR

            Dim ggOFEobs As New BCb2b.CObs_pedido(Session("cabeceraPed").prop_empgrupo_cod().ToString, Session("cabeceraPed").prop_emp_cod().ToString, Session("cabeceraPed").prop_tip_vc().ToString, Session("cabeceraPed").prop_GGOFETIP_COD().ToString, Session("cabeceraPed").prop_N_OFE().ToString, PARAM_OBS)
            'ggOFEobs.MODIFICAR_OBS("", vOBSER) SRA HACER!
            Return vOBSER
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.guardar_observacion] cab = {@cab} obs = {obs} ", Session("cabeceraPed"), vOBSER)
            Return ex.Message.ToString()
        End Try
    End Function


    'CrearPedido.guardar_linea(empresa,grupo,tip_vc,tipo,noferta,N_LIN,codigo_Art,DESCRIP,COD_CLI,cantidad,PR_PRECIO,descuento,F_ENTRPREV,lbltotal.innerHTML
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtener_precio_especial(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal cod_cli As String, ByVal vGAART_COD As String, ByVal CANTIDAD As String, ByVal v_cultura As String) As String
        Dim prec_especial As String = ""
        CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)

        Try
            If vGAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And CANTIDAD <> "" Then
                Dim precioEspecial As New BCb2b.crearPrecioEspecial()
                Dim valor As String = precioEspecial.damePrecEspecial(empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
                If valor <> "" Then
                    prec_especial = FormatNumber(valor, 2)
                Else
                    prec_especial = ""
                End If
            Else
                prec_especial = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.obtener_precio_especial] grupo = {grupo} tip = {tip} cli = {cli} art = {art} cant = {cant} ", empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
            prec_especial = ""
        End Try

        Return prec_especial
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function gaart_es_tira_o_rollo(ByVal empgrupoCod As String, ByVal vGAART_COD As String) As String
        Dim es_tira_o_rollo As String = "N"
        Dim clasi_tira As String = ""
        Try
            clasi_tira = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
            Dim clasi As New BCb2b.gaartclasi(empgrupoCod, vGAART_COD, clasi_tira)
            es_tira_o_rollo = clasi.prop_GACLASIF_COD

            If es_tira_o_rollo = "" Then
                es_tira_o_rollo = "N"
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.gaart_es_tira_o_rollo] grupo = {grupo} art = {art} tira = {tira} ", empgrupoCod, vGAART_COD, clasi_tira)
        End Try

        '---SI DESCOMENTAMOS ESTO EVITAMOS QUE SE ABRA LA LOV DE TIRAS Y ROLLOS.
        'es_tira_o_rollo = "N"

        Return es_tira_o_rollo

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GESTION_DESCRIP_ART_TIRAS_ROLLOS(ByVal empgrupo_cod As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal vCANTIDAD As String) As String
        Dim anadir_a_descrip As String = ""
        Try
            'COMPROBAMOS PARAMETROS
            Dim param1 As String = "AMC_GV082_CLASIFICACION_ART"
            Dim param2 As String = "GGXXXLIN_GACLATIP_CLASIF_AUT"

            Dim dameparam As New BCb2b.CParametros()
            Dim clasi1 As String = dameparam.dame_param(param1)
            Dim clasi2 As String = dameparam.dame_param(param2)

            Dim valor1 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi1)
            Dim valor2 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi2)

            If valor1.prop_GACLASIF_COD = "S" Then
                Dim gacodbar As New BCb2b.gacodbar()
                Dim existe_gaart_en_gacodbar As Boolean = gacodbar.ExisteGaartEnGacodbarPorGacodtip(empgrupo_cod, vGAART_COD, ConfigurationManager.AppSettings("UNID"))
                Dim art As New BCb2b.gaart(empgrupo_cod, vGAART_COD)

                Dim ancho As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "ANCHO")
                Dim largo As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "LARGO")

                If valor2.prop_GACLASIF_COD = "S" And existe_gaart_en_gacodbar = False And art.prop_GAUNITIP_UNI1 = "UN" Then
                    anadir_a_descrip = "Metros Cuadrados = (" & ancho.prop_VALOR & " x " & largo.prop_VALOR & ") " & vCANTIDAD
                Else
                    anadir_a_descrip = "Metros Cuadrados"
                End If

            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.GESTION_DESCRIP_ART_TIRAS_ROLLOS] grupo = {grupo} art = {art} descr = {descr} cant = {cant} ", empgrupo_cod, vGAART_COD, vDESCRIP, vCANTIDAD)
        End Try

        If anadir_a_descrip = "" Then
            Return Trim(vDESCRIP)
        Else
            Return Trim(vDESCRIP & vbCrLf & anadir_a_descrip)
        End If

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function ValidarPrecioLinea(ByVal gaart_cod As String, ByVal cod_cli As String, ByVal precio As String, ByVal cantidad As String, ByVal descuento As String, ByVal v_cultura As String, ByVal tipo_pedido As String) As String

        'TODO:JVC, OSTRAS, TENDRÁ QUE HABER OTRA FORMA DE TENER ESTO ACTIVADO O NO... CON JCE. NO SE SUPONE QUE EL CONTROL SE ACTIVABA CON EL MISMO PARÁMETRO QUE ACTIVABA LO DE JRJ???
        'AHORA MISMO ESTA FUNCION NO SE UTILIZA PORQUE NO LA QUIEREN AUN (PREC. ESTRATEGICOS)

        'If tipo_pedido <> ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
        '    Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        '    Dim transaccion_valida_prec As IDbTransaction
        '    transaccion_valida_prec = conexionole.BeginTransaction

        '    Dim mensajeinfo As String = ""
        '    Dim mensajeerror As String = ""
        '    Dim ES_VALIDO As String = "N"

        '    Dim prec_aux As Double = 0
        '    If descuento <> "" And precio <> "" Then

        '        prec_aux = precio - (precio * descuento / 100)

        '        Try
        '            ES_VALIDO = AMC_B2B_PKG.AMC_B2B_PKG.VALIDAR_PRECIO(transaccion_valida_prec, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, gaart_cod, prec_aux, CDate(Now.ToShortDateString), mensajeinfo, mensajeerror)
        '            transaccion_valida_prec.Commit()
        '        Catch ex As Exception
        '            transaccion_valida_prec.Rollback()
        '        Finally
        '            transaccion_valida_prec.Dispose()
        '        End Try

        '        Dim PARAM_TARIFA As New BCb2b.empparam(ConfigurationManager.AppSettings("PARAM_TARIFA_CUC"), ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), Nothing)
        '        Dim ARTICULOAUX As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), gaart_cod.ToUpper)
        '        Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, ConfigurationManager.AppSettings("venta"))

        '        If PRECIO_TARIFA = 0 Then
        '            Return "#OK" 'permitimos pedidos precio 0
        '        End If

        '        If mensajeerror <> "" Then
        '            Return mensajeerror
        '        Else
        '            Return "#OK"
        '        End If
        '    Else
        '        Return "#OK"
        '    End If
        'Else
        '    Return "#OK"
        'End If
        Return "#OK"
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaNumero(ByVal numero As String, Optional ByVal v_cultura As String = "") As String
        Try
            If numero <> "" And IsNumeric(numero) Then
                If v_cultura <> "" Then
                    Dim cnum As New BCb2b.Utilities()
                    numero = cnum.ConvierteNumSegunCulture(numero, v_cultura)
                End If
            Else
                numero = ""
            End If
        Catch ex As Exception
            'lo comento porque el formulario ya avisa que esta metiendo un numero no numerico. y al ser ajax siempre viene por aqui.
            'Log.Error(ex, "[Ajax:CrearPedido.GestionaNumero] num = {num} idioma = {idioma} ", numero, v_cultura)
        End Try
        Return numero
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaFecha(ByVal fecha As String) As String
        Try
            If fecha = "" Or IsDate(fecha) = False Then
                fecha = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.GestionaFecha] fec = {fec}", fecha)
        End Try

        Return fecha
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_TipoError_de_Error(ByVal cod_error As String) As String
        If cod_error.IndexOf("ERROR") <> -1 Then
            Return "#ERROR"
        ElseIf cod_error.IndexOf("WARNING") <> -1 Then
            Return "#WARNING"
        Else
            Return "#OK"
        End If
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_Descrip_Error(ByVal cod_error As String, ByVal culture As String) As String
        Dim resultado As String = cod_error
        Try
            'ES NECESARIO HACER ESTO PORQUE SINO NO TRADUCE
            If (String.IsNullOrEmpty(culture)) Then
                culture = "Auto"
            End If
            Dim ci As New System.Globalization.CultureInfo(culture)
            ci.NumberFormat.CurrencyDecimalDigits = 3
            ci.NumberFormat.NumberGroupSeparator = ""
            ci.NumberFormat.NumberDecimalSeparator = ","
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
            resultado = GetGlobalResourceObject("general", cod_error.Replace("#", "")) 'en los resources no deja poner #
            If resultado Is Nothing Then 'SI NO EXISTE EL CODIGO DE ERROR QUE LO MUESTRE PARA SABER QUE HAY QUE TRADUCIR
                resultado = cod_error
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Obtener_Descrip_Error] error = {error} idioma = {idioma} ", cod_error, culture)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function CompruebaSiDatosValidos(ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal vF_ENTRCONF As String, ByVal v_cultura As String) As Boolean
        CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)
        PR_PRECIO = GestionaNumero(PR_PRECIO, v_cultura)
        DESCUENTO = GestionaNumero(DESCUENTO, v_cultura)
        vF_ENTRCONF = GestionaFecha(vF_ENTRCONF)
        vF_ENTRPREV = GestionaFecha(vF_ENTRPREV)

        Dim es_valido As Boolean = False
        If CANTIDAD <> "" And PR_PRECIO <> "" And DESCUENTO <> "" And vF_ENTRCONF <> "" And vF_ENTRPREV <> "" Then
            es_valido = True
        End If
        Return es_valido
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGPEDTIP_COD As String, ByVal vN_PEDIDO As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PESO_LIN As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal vF_ENTRCONF As String, ByVal total As String, ByVal vGGOFETIP_COD As String, ByVal vGGOFELIN_N_OFE As String, ByVal vGGOFELIN_N_LIN As String, ByVal modificado_sn As String, ByVal PaisCodEnv_Sel As String, ByVal vgaunitip_uni1 As String, ByVal v_ancho As String, ByVal v_alto As String, ByVal v_tiras As String, ByVal v_rollos As String, ByVal v_m2 As String, ByVal v_equi_unpr As String, ByVal v_despercidio As String, ByVal tipo_error As String, ByVal mensajeInfo As String, ByVal v_cultura As String) As String
        Dim resultado As String = ""
        Try
            PR_PRECIO = IIf(String.IsNullOrEmpty(PR_PRECIO), "0", PR_PRECIO)
            DESCUENTO = IIf(String.IsNullOrEmpty(DESCUENTO), "0", DESCUENTO)

            If CompruebaSiDatosValidos(CANTIDAD, PR_PRECIO, DESCUENTO, vF_ENTRPREV, vF_ENTRCONF, v_cultura) Then
                Dim ERRORCOSTE As Boolean = False
                Dim ATENCIONCOSTE As Boolean = False

                Dim es_tira_o_rollo As String = gaart_es_tira_o_rollo(empgrupoCod, vGAART_COD.ToUpper)

                Dim art_ESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")

                Dim OBSERVACIONCOSTE As String = ""
                If Not EsPedidoPrecioCero(vGGPEDTIP_COD) And CDbl(total) <> 0 And es_tira_o_rollo = "N" And vGAART_COD.ToUpper <> art_ESP.ToUpper Then
                    'AMC_NE174
                    Select Case tipo_error
                        Case "#ERROR"
                            ERRORCOSTE = True 'MENOR QUE CUC Y QUE TARIF_ESTR
                        Case "#WARNING"
                            ATENCIONCOSTE = True 'MENOR QUE EL CUC PERO NO MENOR QUE TARIF_ESTR
                            OBSERVACIONCOSTE = mensajeInfo
                        Case "#OK"
                            OBSERVACIONCOSTE = ""
                    End Select

                End If

                Dim IDIOMA As String = Session("idioma")

                resultado = tipo_error

                Dim vienedepedidoSN As Boolean = False 'revisar esto!!!!JVC!!!
                Dim plazo As String = "guardar liena"

                If PaisCodEnv_Sel = "" Then
                    Dim cliente As New BCb2b.ggclipr(COD_CLI, empgrupoCod, vTIP_VC)
                    Dim rsoc As New BCb2b.CRSOCIAL(cliente.prop_RSOCIAL_COD)
                    Dim dir As New BCb2b.rsocdir(cliente.prop_RSOCIAL_COD, rsoc.PROP_RSOCDIR_COD, "")
                    PaisCodEnv_Sel = dir.PROP_PAISES_COD
                End If

                If vF_ENTRPREV = "" Then
                    Dim lin As New BCb2b.CLineaPedido()
                    vF_ENTRPREV = lin.amc_calcula_fecha_linea(PaisCodEnv_Sel, "", vF_ENTRCONF)
                    If CDate(vF_ENTRPREV) < Now Then
                        vF_ENTRPREV = Now.ToShortDateString
                    End If
                End If


                'Dim LINEAPED As New BCb2b.CLineaPedidoOff(ConfigurationManager.AppSettings("Grupo"), ConfigurationManager.AppSettings("Empresa"), ConfigurationManager.AppSettings("Venta"), vGGPEDTIP_COD, vN_PEDIDO, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, vF_ENTRCONF, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedepedidoSN, ERRORCOSTE)
                Dim LINEAPED As New BCb2b.CLineaPedidoOff(ConfigurationManager.AppSettings("Grupo"), ConfigurationManager.AppSettings("Empresa"), ConfigurationManager.AppSettings("Venta"), vGGPEDTIP_COD, vN_PEDIDO, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PESO_LIN, PR_PRECIO, vF_ENTRPREV, vF_ENTRCONF, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedepedidoSN, ERRORCOSTE, ATENCIONCOSTE, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, OBSERVACIONCOSTE)


                Dim GAUNITP_UNI1 As String = ""
                Dim vGGPEDCAB_GGCLIPR_COD As String = COD_CLI
                'jvc. aqui pongo la propiedad lineas para pasarselo al otro lado.

                Dim VCANTIDAD As String = CANTIDAD
                Dim list_LINEAS As New List(Of BCb2b.CLineaPedidoOff)
                Try
                    list_LINEAS = Session("lineasPedido")
                Catch ex As Exception

                End Try

                Dim es_pedido_muestras As Boolean = EsPedidoPrecioCero(vGGPEDTIP_COD)

                'PARA LOS ORDER INBOX EN USUARIO TIENE QUE INTRODUCIR EL PEDIDO ASIQUE LO MODIFICA, PONGO ESTE CONTROL.
                Dim es_pedido_order_inbox As Boolean = False
                Dim param As New BCb2b.CParametros()
                Dim serie_order_inbox As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX"))
                If vGGOFETIP_COD = serie_order_inbox Then
                    es_pedido_order_inbox = True
                End If

                If modificado_sn = "N" Or es_pedido_order_inbox Then
                    LINEAPED.prop_GGOFETIP_COD = vGGOFETIP_COD
                    LINEAPED.prop_GGOFELIN_N_OFE = vGGOFELIN_N_OFE
                    If vGGOFELIN_N_LIN = "" Then
                        vGGOFELIN_N_LIN = LINEAPED.prop_N_LIN
                    End If
                    LINEAPED.prop_GGOFELIN_N_LIN = vGGOFELIN_N_LIN
                End If
                LINEAPED.asignarNlinOriginal = vGGOFELIN_N_LIN

                lineas = LINEAPED.addLinea(list_LINEAS, LINEAPED, Session("idioma"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"), es_pedido_muestras)

                Session("lineasPedido") = lineas

                If resultado = "" Then
                    resultado = LINEAPED.prop_N_LIN
                End If

            End If

        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.guardar_linea] grupo = {grupo} emp = {emp} tip = {tip} tipoped = {tipoped} n_ped = {n_ped} lin = {lin} art = {art} descr = {descr} cli = {cli} cant = {cant} peso = {peso} prec = {prec} desc = {desc} f_prev = {f_prev} f_conf = {f_conf} tot = {tot} tip_ofe = {tip_ofe} nofe = {nofe} ofe_lin = {ofe_lin} modi_sn = {modi_sn} paisenv = {paisenv} uni = {uni} anch = {anch} alt = {alt} tira = {tira} roll = {roll} metrs2 = {metrs2} equiun = {equiun} desper = {desper} error = {error} info = {info} idioma = {idioma} ", empgrupoCod, EMCOD, vTIP_VC, vGGPEDTIP_COD, vN_PEDIDO, vN_LIN, vGAART_COD, vDESCRIP, COD_CLI, CANTIDAD, PESO_LIN, PR_PRECIO, DESCUENTO, vF_ENTRPREV, vF_ENTRCONF, total, vGGOFETIP_COD, vGGOFELIN_N_OFE, vGGOFELIN_N_LIN, modificado_sn, PaisCodEnv_Sel, vgaunitip_uni1, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, tipo_error, mensajeInfo, v_cultura)
        End Try
        'fuerzo el return
        Return resultado

    End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Actualizar_fechas_linea(ByVal vN_LIN As String, ByVal vF_ENTRPREV As String, ByVal vF_ENTRCONF As String) As String

        Dim listaLineasPed As New List(Of BCb2b.CLineaPedidoOff)
        Try
            listaLineasPed = Session("lineasPedido")
        Catch ex As Exception

        End Try

        Dim indice As Integer = listaLineasPed.FindIndex(Function(x) x.prop_N_LIN = vN_LIN)

        If (Not indice = -1) Then
            Dim lineaPed = listaLineasPed(indice)
            Dim es_pedido_muestras As Boolean = EsPedidoPrecioCero(lineaPed.prop_GGPEDTIP_COD)

            lineaPed.CambiarFechas(vF_ENTRPREV, vF_ENTRCONF)
            lineas = lineaPed.addLinea(listaLineasPed, lineaPed, Session("idioma"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"), es_pedido_muestras)
        End If
    End Function

    <Ajax.AjaxMethod()> _
    Public Function EsPedidoPrecioCeroSN(ByVal ggpedtip_cod As String) As String
        'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
        Dim param As New BCb2b.CParametros()
        Dim series_prec_cero As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_PEDIDO_PREC_CERO"))
        Dim valor As String = "N"
        If BCb2b.Listas.Existe(ggpedtip_cod, series_prec_cero.Split(",")) Then
            valor = "S"
        End If
        Return valor
    End Function

    Private Function EsPedidoPrecioCero(ggpedtip_cod As String) As Boolean
        'AMC_NE252. JCE. 06/09/2016. OBTENER DE PARAM SERIES PARA PRECIO 0 Y SI EL SELECCIONADO ESTA ENTRE ELLOS MOSTRAR ALERTA.
        Return (EsPedidoPrecioCeroSN(ggpedtip_cod) = "S")
    End Function

    'Private Function EsPedidoMuestras(ggpedtip_cod As String) As Boolean
    '    Return ggpedtip_cod = ConfigurationManager.AppSettings("tipo_pedido_muestras")
    'End Function

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function InsertarPrecioEspecial(ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal ggofetip_cod As String, ByVal ggclipr_cod As String, ByVal gaart_cod As String, ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal obser_prec_esp As String) As String
        Dim precio_esp_final As Double = 0
        Try
            'AMC_NE119.PRECIOS ESPECIALES
            '----------------------------------------------

            Dim precioEspecial = New BCb2b.crearPrecioEspecial()

            'INSERTAMOS PRECIO ESPECIAL
            precio_esp_final = FormatNumber((CDbl(precio) * CDbl(1)) - ((CDbl(precio) * CDbl(1)) * (CDbl(descuento) / 100)), 2)


            obser_prec_esp = ggofetip_cod.ToUpper & " " & obser_prec_esp & " " & precio_esp_final
            precioEspecial.crear_con_params(grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp, ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"), ConfigurationManager.AppSettings("Oferta"))

            'FIN AMC_NE119. PRECIOS ESPECIALES
            '----------------------------------------------

            Return "0"
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.InsertarPrecioEspecial] empgrup = {empgrup} tip = {tip} cli = {cli} art = {art} prec = {prec} obser = {obser} ", grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp)
            Return "1"
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Sub borrar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGPEDTIP_COD As String, ByVal vN_PEDIDO As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal total As String)
        Dim list_LINEAS As New List(Of BCb2b.CLineaPedidoOff)

        If Not Session("lineasPedido") Is Nothing Then
            list_LINEAS = Session("lineasPedido")
        End If

        Dim LINEAPED As New BCb2b.CLineaPedidoOff()
        Try
            Dim vienedepedidoSN As Boolean = False 'revisar esto!!!!JVC!!!
            Dim ERRORCOSTE As Boolean
            Dim plazo As String = "borrar línea"

            'Dim LINEAPED As New BCb2b.CLineaPedidoOff(ConfigurationManager.AppSettings("Grupo"), ConfigurationManager.AppSettings("Empresa"), ConfigurationManager.AppSettings("Venta"), vGGPEDTIP_COD, vN_PEDIDO, vN_LIN, "", "", vGAART_COD.ToUpper, vDESCRIP, "", CANTIDAD, OracleNumber.Null, PR_PRECIO, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, "", "", "", OracleNumber.Null, OracleNumber.Null, vF_ENTRPREV, OracleDateTime.Null, OracleNumber.Null, "", "", "", "", OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, OracleNumber.Null, "", "", OracleNumber.Null, OracleNumber.Null, "", OracleNumber.Null, OracleNumber.Null, "", "", "", "", "", OracleNumber.Null, "", "", OracleNumber.Null, "", "", "", "", "", "", "")
            'lineas = LINEAPED.delLinea(list_LINEAS, LINEAPED)

            LINEAPED = New BCb2b.CLineaPedidoOff(empgrupoCod, EMCOD, vTIP_VC, vGGPEDTIP_COD, vN_PEDIDO, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, Nothing, COD_CLI, DESCUENTO, plazo, vienedepedidoSN, ERRORCOSTE)
            lineas = LINEAPED.delLinea(list_LINEAS, LINEAPED)

            Session("lineasPedido") = lineas
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.borrar_linea] lineas = {@lineas} linped = {@linped} ", list_LINEAS, LINEAPED)
        End Try
    End Sub

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Obtener_precios(ByVal pGaartCod As String, ByVal pGgcliprCod As String, ByVal pCUni1 As String, ByVal pGgpedtipCod As String, ByVal pCultura As String) As String
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vPrecio As String = ""

        If Not String.IsNullOrEmpty(pGaartCod) Then
            Dim cliente As New BCb2b.ggclipr(pGgcliprCod, vEmpgrupoCod, vTipVc)
            Try
                Dim art_aux As New BCb2b.CArticulo(vEmpgrupoCod, pGaartCod.ToUpper)
                If pCUni1 <> "" Then
                    pCUni1 = GestionaNumero(pCUni1, pCultura)
                    vPrecio = art_aux.calcula_precio_b2b(cliente, CDbl(pCUni1))
                End If
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Obtener_precios] cli = {@cli} cant = {cant} ", cliente, pCUni1)
                vPrecio = ""
            End Try
        End If

        Return vPrecio
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Obtener_descuento(ByVal cod_Art As String, ByVal cod_cli As String, ByVal cantidad As String, ByVal TIPO_PEDIDO As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, al cambiar la cantidad cargo 
        ' precios y descuentos del artículo para esa cantidad.
        If (String.IsNullOrEmpty(cod_Art)) Then
            Return ""
        End If

        If (String.IsNullOrEmpty(cantidad)) Then ' Or TIPO_PEDIDO = ConfigurationManager.AppSettings("tipo_pedido_muestras")) Then
            Return FormatNumber("0", 2)
        End If

        Dim DTO As String = ""
        Dim cliente As New BCb2b.CUsuarios()
        Try
            If cantidad <> "" Then
                cantidad = GestionaNumero(cantidad, v_cultura)
                cod_Art = cod_Art.ToUpper
                cliente.CrearUsuario(cod_cli)
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)

                Return articulo_prueba.dame_porcentaje_dto_b2b(cliente, CDbl(cantidad), Nothing, Nothing)
            End If

            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Obtener_descuento] cli = {@cli} cant = {cant} ", cliente, cantidad)
            Return ""
        End Try

        'If (cod_Art <> "") Then
        '    Try
        '        Return DTO
        '    Catch ex As Exception
        '        Return "Articulo No válido"
        '    End Try
        'Else
        '    Return ""
        'End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Obtener_Precio_UnPr(ByVal precio As String, ByVal cantidad As String, ByVal equi_unpr As String, ByVal v_cultura As String) As String
        Dim resultado As String = ""
        Try
            cantidad = GestionaNumero(cantidad, v_cultura)
            precio = GestionaNumero(precio, v_cultura)

            If cantidad <> "" And precio <> "" Then
                resultado = FormatNumber(CDbl(precio) * CDbl(cantidad) * CDbl(equi_unpr), 2)
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Obtener_Precio_UnPr] prec = {prec} cant = {cant} equnpr = {equnpr} idioma = {idioma} ", precio, cantidad, equi_unpr, v_cultura)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function calcular_total_NP(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo y una cantidad. Al cambiar el precio
        ' recalculo el total (No hace falta query contra la bd)

        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim total As String = ""
            Try
                total = FormatNumber((precio * cantidad) - ((precio * cantidad) * (descuento / 100)), 2)
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.calcular_total_NP] prec = {prec} cant = {cant} desc = {desc} idioma = {idioma} ", precio, cantidad, descuento, v_cultura)
            End Try

            Return total
        Else
            Return FormatNumber("0", 2)
        End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function calcular_total_ND(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, una cantidad y un precio.
        ' Al cargar el descuento recalculo el total. (No hace falta query contra bd)

        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim precio_aux As String = ""
            Try
                precio_aux = (precio * cantidad) - ((precio * cantidad) * (descuento / 100))
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.calcular_total_ND] prec = {prec} cant = {cant} desc = {desc} idioma = {idioma} ", precio, cantidad, descuento, v_cultura)
            End Try

            Return FormatNumber(precio_aux, 2)
        Else
            Return FormatNumber("0", 2)
        End If
    End Function


    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArt(ByVal cod_Art As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        Return articulo_prueba.prop_descrip
                    Else
                        Return " "
                    End If
                Else
                    Return "Artículo no valido"
                End If

            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Obtener_DescripArt] art = {art} ", cod_Art)
                Return "Artículo no valido"
            End Try
        Else
            Return " "
        End If

    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try

        Return es
    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT_SUSTITUCION(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT_SUSTITUCION(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT_SUSTITUCION] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try
        Return es
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Obtener_FechaPrevista(ByVal cod_cli As String, ByVal fecha_puesta As String) As String
        If fecha_puesta <> "" And IsDate(fecha_puesta) Then
            Try
                Dim grupo As String = ConfigurationManager.AppSettings("grupo")
                Dim tip_vc As String = ConfigurationManager.AppSettings("Venta")
                Dim empresa As String = ConfigurationManager.AppSettings("empresa")
                Dim rsocdir As New BCb2b.rsocdir()
                Dim mi_pais As String = rsocdir.pais_cliente(grupo, tip_vc, cod_cli)
                Dim dias_sumar As String = ""
                If (mi_pais <> "") Then
                    Try
                        Dim param_componer As String = ConfigurationManager.AppSettings("AMC_SUMAR_X_F_ENTRCONF") & "_" & mi_pais
                        Dim param As New BCb2b.CParametros()
                        dias_sumar = param.dame_param(param_componer)

                        If dias_sumar = "" Then
                            dias_sumar = param.dame_param(ConfigurationManager.AppSettings("AMC_SUMAR_X_F_ENTRCONF"))
                        End If
                        'Dim PARAMETRO As New BCb2b.empparam(param_componer, grupo, empresa, Session("USUARIOB2B").PROP_COD)
                        'dias_sumar = PARAMETRO.prop_VALOR
                    Catch ex As Exception
                        Return "Fecha no válida"
                    End Try
                Else
                    Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("AMC_SUMAR_X_F_ENTRCONF"), grupo, empresa, Session("USUARIOB2B").PROP_COD)
                    dias_sumar = PARAMETRO.prop_VALOR
                End If
                If (dias_sumar = "") Then
                    dias_sumar = 0
                End If

                Dim fecha_hoy As Date = Today
                Dim fecha_sugerida As Date = fecha_hoy.AddDays(dias_sumar)
                If fecha_puesta <> "" Then
                    If (CDate(fecha_puesta) < CDate(fecha_sugerida)) Then 'si modifica con una fecha menor
                        fecha_puesta = fecha_sugerida
                    End If
                Else
                    fecha_puesta = fecha_sugerida
                End If
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Obtener_FechaPrevista] cli = {cli} puesta = {puesta} ", cod_cli, fecha_puesta)
            End Try
        Else
            fecha_puesta = ""
        End If

        Return fecha_puesta
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_FechaPrevista_Nuevo(ByVal texto_urgente As String, ByVal fecha_puesta As String, ByVal fecha_sugerida As String, ByVal fecha_minima As String) As String()
        Dim resultado(1) As String

        If fecha_puesta <> "" Then
            fecha_puesta = GestionaFecha(fecha_puesta)
        End If
        If fecha_sugerida <> "" Then
            fecha_sugerida = GestionaFecha(fecha_sugerida)
        End If

        If fecha_sugerida <> "" Or fecha_puesta <> "" Then

            '-------------
            'SI POR ALGUNA RAZON NO TRAE LA FECHA SUGERIDA, PONEMOS LA PUESTA, Y EN CASO DE QUE TAMBIEN ESTÉ VACÍA, PONEMOS LA MINIMA.
            If fecha_sugerida = "" Then
                fecha_sugerida = fecha_puesta
            End If
            If fecha_sugerida = "" Then
                fecha_sugerida = fecha_minima
            End If
            '-------------

            Try
                Dim resalto As String = texto_urgente
                Dim texto As String = ""

                If fecha_puesta <> "" Then
                    If (CDate(fecha_puesta) >= CDate(fecha_minima) And CDate(fecha_puesta) < CDate(fecha_sugerida)) Then
                        texto = resalto
                    End If
                    'caso fecha muy pequeña, ponemos la minima y va a ser urgente
                    If (CDate(fecha_puesta) < CDate(fecha_minima) And CDate(fecha_puesta) < CDate(fecha_sugerida)) Then
                        fecha_puesta = fecha_minima
                        texto = resalto
                    End If
                Else
                    fecha_puesta = CDate(fecha_sugerida).ToShortDateString
                End If

                resultado(0) = fecha_puesta
                resultado(1) = texto
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Obtener_FechaPrevista_Nuevo] urgente = {urgente} puesta = {puesta} sugerida = {sugerida} minima = {minima} ", texto_urgente, fecha_puesta, fecha_sugerida, fecha_minima)
            End Try
        Else
            resultado(0) = ""
            resultado(1) = ""
        End If

        Return resultado
    End Function

    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArtIdioma(ByVal cod_Art As String, ByVal vggobstip_cod As String, ByVal vcodigo_idioma As String) As String
        cod_Art = cod_Art.ToUpper

        'NO PERMITIMOS INTRODUCIR EL ARTICULO PARA COMISIONES.
        Dim param As New BCb2b.CParametros()
        If cod_Art = param.dame_param("B2B_ART_COMI_AGENTES") Then
            Return "Invalid article"
        Else
            'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
            Dim idioma As New BCb2b.idiomas()
            idioma.dameIdioma(vcodigo_idioma)
            If (cod_Art <> "") Then
                Try
                    Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art.ToUpper)
                    Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, idioma.prop_idioma, ConfigurationManager.AppSettings("ING_SPYRO"))
                    If dd <> "" Then
                        If (dd <> "Null") Then
                            Return dd
                        Else
                            Return articulo_prueba.prop_descrip
                        End If
                    Else
                        Return "Invalid article"
                    End If

                Catch ex As Exception
                    Log.Error(ex, "[Ajax:CrearPedido.Obtener_DescripArtIdioma] art = {art} cod_obs = {cod_obs} idioma = {idioma} ", cod_Art, vggobstip_cod, vcodigo_idioma)
                    Return "Invalid article"
                End Try
            Else
                Return ""
            End If
        End If
    End Function

    <Ajax.AjaxMethod()> _
    Public Function usuarioValido(ByVal usrnom As String, ByVal usrpass As String, ByVal Sesion_usuario As String) As String
        Dim Usuario As New BCb2b.CUsuarios(usrnom, _
                                           usrpass, _
                                           ConfigurationManager.AppSettings("grupo"), _
                                           ConfigurationManager.AppSettings("Venta"), _
                                           ConfigurationManager.AppSettings("usrnom"), _
                                           ConfigurationManager.AppSettings("usrpass"))
        If Not Usuario.es_vacio() Then
            If (Usuario.prop_LOGIN.CompareTo(Sesion_usuario) = 0) Then
                'If (Usuario.prop_LOGIN.CompareTo("CELMA") = 0) Then

                Return "S"
            Else
                Return "N"
            End If
        Else
            Return "N"
        End If
        Return "S"

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerSuRef(ByVal grupo As String, ByVal tip_vc As String, ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal ModificandoSN As String) As String
        Try
            If (ModificandoSN = "S") Then
                Return "modificando!!!"
            Else
                Dim ggpreres As New BCb2b.GGPRERES(grupo, COD_CLI, codigo_Art)
                Return ggpreres.prop_SREFER
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.obtenerSuRef] grupo = {grupo} tip = {tip} cli = {cli} art = {art} ", grupo, tip_vc, COD_CLI, codigo_Art)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Comprobar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String
        Dim parametro_ref As String = ""
        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)

            parametro_ref = "GGPRERES_" + ConfigurationManager.AppSettings("venta") + "_SREFER_UNICA"
            Dim PARAMETRO As New BCb2b.empparam(parametro_ref, GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            Dim PARAM_REFER As String = PARAMETRO.prop_VALOR
            If (PARAM_REFER = "S") Then
                Dim mensaje As String = ""
                mensaje = ggpreres.GGPRERES_CONTROL_SREFER_UNICA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
                If (mensaje = "") Then
                    Return "SI"
                Else
                    Return "NO"
                End If
            Else
                Return "NO"
            End If

        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Comprobar_su_ref] art = {art} cli = {cli} ref = {ref} param_ref = {param_ref} empgrup = {empgrup} emp = {emp} ", codigo_Art, COD_CLI, larefmodif, parametro_ref, GRUPO, EMPRESA)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Cambiar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)
            ggpreres.actualizar_su_ref(ConfigurationManager.AppSettings("grupo"), codclinumber, codigo_Art, larefmodif)
            ggpreres.GGPRERES_INSERTAR(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.Cambiar_su_ref] cli = {cli} art = {art} ref = {ref} ", COD_CLI, codigo_Art, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function amc_calcula_fecha_linea(ByVal codigo_pais As String, ByVal fecha_prevista As String, ByVal fecha_confirmada As String) As String
        Dim valor As String = ""
        Try
            valor = BCb2b.utilidades_fechas.amc_calcula_fecha_lineas(codigo_pais, fecha_prevista, fecha_confirmada)
        Catch ex As Exception
            valor = ex.Message.ToString
            Log.Error(ex, "[Ajax:CrearPedido.amc_calcula_fecha_linea] pais = {pais} prevista = {prevista} confirmada = {confirmada} ", codigo_pais, fecha_prevista, fecha_confirmada)
        End Try
        Return valor
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function dime_minimo_dias(ByVal codigo_pais As String) As String
        ' A ESTA FUNCIÓN LE LLEGA UN CODIGO DE PAIS DE TABLA.
        ' 1. CALCULAR EL ISO.
        Dim miPais As New BCb2b.CPaises(codigo_pais)
        Dim iso As String = miPais.prop_iso_cod

        ' 2. OBTENER EL CODIGO EQUIVALENTE EN CONFIRMS
        Dim cconfirm As New BCb2b.codigoConfirms()
        codigo_pais = cconfirm.ObtenerPaisConfirmsDeIso(iso, ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("ISO_CONFIRMS"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"))

        ' ESTA FUNCIÓN ESPERA, EL CODIGO DEL PAIS DE CONFIRMS.
        ' CUYO VALOR XXXI, con caracteristica ISO, COINCIDA CON EL ISO DEL PAIS DE LA DIRECCIÓN SELECCIONADA EN ENVÍO.
        ' EN CASO DE QUE ESTE NO EXISTA, COGE EL CORRESPONDIENTE VALOR RES DE CONFIRMS.

        Dim minimo_dias As String = ""
        Try
            Dim conn2 As New OracleConnection()
            Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
            Dim command As New OracleDataAdapter()
            conn2.ConnectionString = conexion.cadena_conexion

            Dim clasi_confirms_minimo As String = ""
            If codigo_pais = "" Then
                codigo_pais = ConfigurationManager.AppSettings("PAIS_DEF_FECHAS_MIN")
            End If

            clasi_confirms_minimo = codigo_pais & "M"

            Dim clasi As New BCb2b.GGCLACLASI()
            clasi.DAME_GGCLASIF_VALOR(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), clasi_confirms_minimo, ConfigurationManager.AppSettings("CLASI_DIAS_ENV"))
            minimo_dias = clasi.PROP_GGCLASIF_VALOR

            If minimo_dias = "" Then 'si no tiene minimo dicho pais cogemos de RESM
                clasi.DAME_GGCLASIF_VALOR(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), ConfigurationManager.AppSettings("PAIS_DEF_FECHAS_MIN") & "M", ConfigurationManager.AppSettings("CLASI_DIAS_ENV"))
                minimo_dias = clasi.PROP_GGCLASIF_VALOR
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.dime_minimo_dias] pais = {pais} ", codigo_pais)
        End Try

        Return minimo_dias
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function dame_fecha_sumar_dias(ByVal fecha As String, ByVal dias As String) As String
        Dim mn As New BCb2b.MetodosNumericos()
        Dim fecha_resul As String = ""
        Try
            If fecha = "" Or IsDate(fecha) = False Then
                fecha = Now.ToShortDateString
            End If

            fecha_resul = mn.DameFechaSumaDias(fecha, dias)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.dame_fecha_sumar_dias] date = {date} day = {day} ", fecha, dias)
        End Try

        Return fecha_resul
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Function pais_env(ByVal rsocial_cod As String, ByVal rsocdir As String) As String
        ' 
        Dim valor As String = ""
        Try
            Dim rsoc As New BCb2b.rsocdir()
            If rsocdir <> "" Then
                rsoc = New BCb2b.rsocdir(rsocial_cod, rsocdir, "")
            Else
                Dim soc As New BCb2b.CRSOCIAL(rsocial_cod)
                rsoc = New BCb2b.rsocdir(rsocial_cod, soc.PROP_RSOCDIR_COD, "")
            End If
            valor = rsoc.PROP_PAISES_COD

        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.pais_env] rsoc = {rsoc} socdire = {socdire} ", rsocial_cod, rsocdir)
        End Try

        Return valor
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_CodigoArtRef(ByVal cod_cli As String, ByVal cod_Ref As String) As String
        'cod_Ref = cod_Ref.ToUpper

        'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
        Dim idioma As New BCb2b.idiomas()
        If (cod_Ref <> "") Then
            Try
                Dim articulo_ref As New BCb2b.CArticulo()
                Dim cod_art As String = articulo_ref.articulo_con_ref(cod_cli, cod_Ref)
                'If (cod_art <> "") Then
                '    Dim articulo_de_ref As New BCb2b.CArticulo(cod_art)
                'Else : Return "NO"
                'End If
                Return cod_art

            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearPedido.Obtener_CodigoArtRef] cli = {cli} ref = {ref} ", cod_cli, cod_Ref)
                Return "Invalid article"
            End Try
        Else
            Return ""
        End If

    End Function
    <Ajax.AjaxMethod()> _
    Public Function Comprueba_Fecha(ByVal fecha As String) As String
        If fecha <> "" And IsDate(fecha) Then
            Dim hoy As Date = Now.Date
            If CDate(fecha) < hoy Then
                fecha = hoy.ToShortDateString
            End If
        Else
            fecha = Now.ToShortDateString
        End If
        Return fecha
    End Function
    'AMC_NE235. JCE. 24/05/2016. COMPROBAR SI EL ARTICULO DE LA LINEA TIENE PREVISIONES
    <Ajax.AjaxMethod()> _
    Public Function ObtenerSeriePrevision() As String
        'AMC_NE235. Comprobamos si el articulo tiene previsiones para mostrar una alerta al usuario en caso de tener alguna.
        Dim param As New BCb2b.CParametros()
        Dim serie_prevision As String = ""
        Try
            serie_prevision = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"))
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ObtenerSeriePrevision]")
        End Try
        Return serie_prevision
    End Function
    <Ajax.AjaxMethod()> _
    Public Function CompruebaLineasOferta(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgcliprCod As String, ByVal pGgofetipCod As String, ByVal pGaartCod As String) As String
        'AMC_NE235. Comprobamos si el articulo tiene previsiones para mostrar una alerta al usuario en caso de tener alguna.
        Dim n_lineas_ofe As String = "0"
        Try

            Dim lista_lineas_prev As New ArrayList
            Dim ofe As New BCb2b.COferta_lin()
            Dim i As Integer = 0
            Dim series_previvision() As String = pGgofetipCod.Split(",")
            For i = 0 To series_previvision.Length - 1
                lista_lineas_prev.AddRange(ofe.lista_lineas_filtro(pEmpgrupoCod, pEmpCod, pTipVc, series_previvision(i), OracleNumber.Null, "", pGgcliprCod, pGaartCod, "N"))
            Next

            n_lineas_ofe = lista_lineas_prev.Count.ToString
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.CompruebaLineasOferta] empgru = {empgru} emp = {emp} tip = {tip} serie = {serie} art = {art} ", pEmpgrupoCod, pEmpCod, pTipVc, pGgofetipCod, pGaartCod)
        End Try
        Return n_lineas_ofe
    End Function
    'FIN AMC_NE235. JCE. 24/05/2016. COMPROBAR SI EL ARTICULO DE LA LINEA TIENE PREVISIONES
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function HayDisponibilidad(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGaartCod As String, ByVal pCUni1 As String, ByVal pFPrev As String) As String
        'AMC_NE264. Comprobamos si hay disponilidad de la cantidad pedida en la fecha seleccionada.
        Dim vMensajeInfo As String = ""
        Dim vCUni1Dispo As Decimal? = Nothing
        Dim vFPrevDispo As Date? = Nothing

        'Obtenemos el almacén
        Dim param As New BCb2b.CParametros()
        Dim vGaalmnomCod As String = param.dame_param(ConfigurationManager.AppSettings("ALMACEN_POR_DEFECTO"))

        Try
            Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
            Dim transaccion As IDbTransaction
            transaccion = conexionole.BeginTransaction
            AMC_B2B_PED_PKG.AMC_B2B_PED_PKG.B2B_GGPEDLIN_CALC_DISPO(transaccion, pEmpgrupoCod, pEmpCod, pTipVc, Nothing, Nothing, Nothing, pGaartCod, vGaalmnomCod, Decimal.Parse(pCUni1), Nothing, CDate(pFPrev), "N", vCUni1Dispo, vFPrevDispo, vMensajeInfo)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.CompruebaDisponibilidad]")
        End Try

        Dim vDisponibilidad As String = "S::" & pCUni1 & "::" & FormatDateTime(pFPrev, DateFormat.ShortDate)
        If Not vCUni1Dispo Is Nothing And Not vFPrevDispo Is Nothing Then
            vDisponibilidad = vCUni1Dispo.ToString & "::" & FormatDateTime(vFPrevDispo, DateFormat.ShortDate)
            If vMensajeInfo = "" Then
                vDisponibilidad = "S::" & vDisponibilidad 'hay disponibilidad
            Else
                vDisponibilidad = "N::" & vDisponibilidad 'no hay disponibilidad
            End If
        End If
        
        Return vDisponibilidad
    End Function

    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    'Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.WebControl, ByVal art_desControl As System.Web.UI.WebControls.WebControl, ByVal art_radioControl As System.Web.UI.WebControls.WebControl)
    '    OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_radioControl.ClientID, "LOV", 400, 450)
    'End Sub
    Public Shared Sub ShowLupaSuRef(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal surefControl As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_su_ref.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & surefControl.ClientID & "&textbox4=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.Label, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub

    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    'Public Shared Sub ShowLupaTirasRollos(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal gaart_control As TextBox, ByVal cant_control As System.Web.UI.WebControls.TextBox, ByVal descrip_control As System.Web.UI.WebControls.TextBox, ByVal ancho_control As System.Web.UI.WebControls.Label, ByVal largo_control As System.Web.UI.WebControls.Label, ByVal tiras_control As System.Web.UI.WebControls.Label, ByVal rollos_control As System.Web.UI.WebControls.Label, ByVal m2_control As System.Web.UI.WebControls.Label, ByVal equi_control As System.Web.UI.WebControls.Label, ByVal desper_control As System.Web.UI.WebControls.Label)
    '    'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
    '    OpenPopUp(opener, "lov_tiras_rollos.aspx?textbox=" & gaart_control.Text & "&textbox2=" & cant_control.ClientID & "&textbox3=" & descrip_control.ClientID & "&textbox4=" & ancho_control.ClientID & "&textbox5=" & largo_control.ClientID & "&textbox6=" & tiras_control.ClientID & "&textbox7=" & rollos_control.ClientID & "&textbox8=" & m2_control.ClientID & "&textbox9=" & equi_control.ClientID & "&textbox10=" & desper_control.ClientID, "LOV_TR", 500, 450)
    'End Sub
    Protected Sub BulkEditGridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles BulkEditGridView1.RowDataBound

        If (e.Row.RowType = DataControlRowType.DataRow) Then
            Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
            Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
            Dim vTipVc As String = ConfigurationManager.AppSettings("venta")

            Dim cabeceraPed As New BCb2b.CCabeceraPedido()
            cabeceraPed = Session("cabeceraPed")

            Dim lblGaartCod As Label = e.Row.FindControl("lblGaartCod")
            Dim tboxGaartCod As TextBox = e.Row.FindControl("tboxGaartCod")
            Dim ibLupaArt As ImageButton = e.Row.FindControl("IBarticulo")

            Dim lblSuRef As Label = e.Row.FindControl("lblSuRef")
            Dim tboxSuRef As TextBox = e.Row.FindControl("tboxSuRef")
            Dim ibLupaSuRef As ImageButton = e.Row.FindControl("IBsuref")

            Dim lblDescripART As Label = e.Row.FindControl("lbldescrip_art")
            Dim tboxDescripART As TextBox = e.Row.FindControl("descrip_art")

            Dim lblfecha_prevista As Label = e.Row.FindControl("lblfecha_prevista")
            Dim tboxFPrev As TextBox = e.Row.FindControl("tboxFPrev")
            Dim PCFPrev As Control = e.Row.FindControl("PCFPrev")

            Dim lblfecha_confirmada As Label = e.Row.FindControl("lblfecha_confirmada")
            Dim tboxFConf As TextBox = e.Row.FindControl("tboxFConf")
            Dim PCFConf As Control = e.Row.FindControl("PCFConf")
            Dim fecha_conf_urgente_sn As Label = e.Row.FindControl("fecha_conf_urgente_sn")

            Dim tbox_cantidad As TextBox = e.Row.FindControl("tbox_cantidad")

            Dim lblDisponibilidad As Label = e.Row.FindControl("lblDisponibilidad")
            Dim Unidad As Label = e.Row.FindControl("lblUnidad")

            Dim imgBorrar As System.Web.UI.WebControls.Image = e.Row.FindControl("imgBorrar")
            Dim lblborrar As IButtonControl = e.Row.FindControl("lbBorrar")


            Dim lblPesoLin As Label = e.Row.FindControl("lblPesoLin")

            Dim lblPrecio As Label = e.Row.FindControl("lblPrecio")
            Dim tbox_precio As TextBox = e.Row.FindControl("tbox_precio")

            Dim lblDescuento As Label = e.Row.FindControl("lbldto")
            Dim tbox_dto As TextBox = e.Row.FindControl("tbox_dto")

            Dim lbltotal As Label = e.Row.FindControl("lblPrecio_final")

            Dim lblModif As HiddenField = e.Row.FindControl("HfModificado")
            Dim lblNLin As Label = e.Row.FindControl("lblnlinea") 'LINEA TRAZABILIDAD
            Dim HFLINEA As HiddenField = e.Row.FindControl("HFLINEA") 'LINEA PEDIDO

            Dim lblAncho As Label = e.Row.FindControl("lblAncho")
            Dim lblLargo As Label = e.Row.FindControl("lblLargo")
            Dim lblTiras As Label = e.Row.FindControl("lblTiras")
            Dim lblRollos As Label = e.Row.FindControl("lblRollos")
            Dim lblM2 As Label = e.Row.FindControl("lblM2")
            Dim lblEquiUnPr As Label = e.Row.FindControl("lblEquiUnPr")
            Dim lblDesperdicio As Label = e.Row.FindControl("lblDesperdicio")
            Dim imgEditTirasRollos As Image = e.Row.FindControl("imgEditTirasRollos")

            Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

            Dim TIPO_USUARIO As String = Session("tipo_usuario")

            tboxGaartCod.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")

            tbox_cantidad.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")
           
            'COMPROBAMOS SI EL CLIENTE TIENE LA CLASI NUMDIASMIN COMO CLIMAVENETA.
            Dim cli As New BCb2b.ggclipr()
            cli = Session("cliente")
            Dim clasi_min_dias As New BCb2b.CGGCLICLASI(vEmpgrupoCod, vTipVc, cli.prop_COD, ConfigurationManager.AppSettings("NUMDIASMIN"))
            Dim clasi_prv_dias As New BCb2b.CGGCLICLASI(vEmpgrupoCod, vTipVc, cli.prop_COD, ConfigurationManager.AppSettings("NUMDIASPRV"))
            Dim num_dias_min As String = clasi_min_dias.PROP_VALOR
            Dim num_dias_prv As String = clasi_prv_dias.PROP_VALOR
            'ocultar texbox de f_confirmada por el label.
            If num_dias_min <> "" Then
                tboxFConf.CssClass = "oculto"
                PCFConf.Visible = False
                lblfecha_prevista.CssClass = "oculto"
            Else
                lblfecha_confirmada.CssClass = "oculto"
                tboxFPrev.CssClass = "oculto"
                PCFPrev.Visible = False
            End If
            If num_dias_prv = "" Then
                num_dias_prv = "0"
            End If

            Dim cabeceraOfe As New BCb2b.COferta_Cab()
            If Not Session("cabecera") Is Nothing Then
                cabeceraOfe = Session("cabecera")
            End If

            Dim tipoPedido As String
            If Not DDLSeries.SelectedItem Is Nothing Then
                tipoPedido = DDLSeries.SelectedItem.Value
            Else
                tipoPedido = ConfigurationManager.AppSettings("seriePedido")
            End If

            Dim numPedido As String = Session("cabeceraPed").prop_N_PEDIDO

            Dim pais_cod As String = pais_env(cli.prop_RSOCIAL_COD, hdn_pais_env_ant.Value)

            Dim textoconfirm As String = GetLocalResourceObject("MsgModalModificarSuRef")
            Dim textorepetidos As String = GetLocalResourceObject("MsgModaltextorepetidos")
            Dim mensajenoexiste As String = GetLocalResourceObject("MsgModalmensajenoexiste")

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

            Dim age As New BCb2b.gvagente()
            If Not Session("agente") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<>ING,SVT
                age = Session("agente")
            ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, vEmpgrupoCod, 0)
            End If

            tboxGaartCod.Attributes.Add("onchange", "javascript:cambia_codigo_art_pedido('" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & tipoPedido & "','" & numPedido & "','" & HFLINEA.ClientID & "','" + cli.prop_COD + "','" & cli.prop_RSOCIAL_COD & "','" & DDLDir_Envio.SelectedValue.ToString & "','" + tboxGaartCod.ClientID + "','" + tboxDescripART.ClientID + "','" + obstip_articulo_idiomas + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" & lblPesoLin.ClientID & "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + tboxSuRef.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','','" + tboxFPrev.ClientID + "','" + lblfecha_prevista.ClientID + "','" + tboxFConf.ClientID + "','" & lblfecha_confirmada.ClientID & "','" + fecha_conf_urgente_sn.ClientID + "','" & num_dias_prv & "','" & num_dias_min & "','" & cabeceraOfe.prop_ggofetip_cod & "','" & cabeceraOfe.prop_N_OFE & "','" & lblNLin.Text & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "','" & hdn_pais_env_ant.Value & "','" & GetGlobalResourceObject("general", "texto_urgente").ToString & "','" & Session("cultura") & "','" & cabeceraPed.prop_PERMITIR_MODIF_PRECIOS_SN & "','" & TIPO_USUARIO & "','" & GetGlobalResourceObject("general", "lblConfPrecio") & "','" & ConfigurationManager.AppSettings("CLA_PESO") & "','" & GetLocalResourceObject("TxtTienePrevisiones") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "')")
            ShowLupaArticulo(ibLupaArt, tboxGaartCod, tboxDescripART, tbox_cantidad)

            tboxDescripART.Attributes.Add("onchange", "javascript:cambia_cantidad_pedido('" + cli.prop_COD + "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" & lblPesoLin.ClientID & "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numPedido + "','" + tipoPedido + "','" + tboxSuRef.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & obstip_articulo_idiomas & "','" & Session("idioma") & "','" + tboxFPrev.ClientID + "','" + tboxFConf.ClientID + "','" & cabeceraOfe.prop_ggofetip_cod & "','" & cabeceraOfe.prop_N_OFE & "','" & lblNLin.Text & "','" & GetLocalResourceObject("MsgModalEsKit") & "','" & GetLocalResourceObject("MsgModalNoPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & pais_cod & "','" & Unidad.ClientID & "','" & GetGlobalResourceObject("general", "lblConfPrecio") & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & cabeceraPed.prop_PERMITIR_MODIF_PRECIOS_SN & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & ConfigurationManager.AppSettings("CLA_PESO") & "')")
            tboxSuRef.Attributes.Add("onblur", "javascript:lov_cambiar_su_ref_pedido('" + cli.prop_COD + "','" & cli.prop_RSOCIAL_COD & "','" & DDLDir_Envio.SelectedValue.ToString & "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + obstip_articulo_idiomas + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" & "No existe, cambiar esto." + "','" + tboxSuRef.ClientID + "','" + textoconfirm + "','" + textorepetidos + "','" + mensajenoexiste & "','" + tboxFPrev.ClientID + "','" + lblfecha_prevista.ClientID + "','" + tboxFConf.ClientID + "','" & lblfecha_confirmada.ClientID & "','" + fecha_conf_urgente_sn.ClientID + "','" & num_dias_prv & "','" & num_dias_min & "','" & vEmpgrupoCod & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "','" & GetGlobalResourceObject("general", "texto_urgente").ToString & "')")
            ShowLupaSuRef(ibLupaSuRef, tboxGaartCod, tboxDescripART, tboxSuRef, tbox_cantidad)

            tboxFPrev.Attributes.Add("onchange", "javascript:CambiaFechas('" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & tboxGaartCod.ClientID & "','" & tbox_cantidad.ClientID & "','" & cli.prop_COD & "','" & pais_cod & "','" & cli.prop_RSOCIAL_COD & "','" & DDLDir_Envio.SelectedValue.ToString & "','" + tboxFPrev.ClientID + "','" + lblfecha_prevista.ClientID + "','" + tboxFConf.ClientID + "','" & lblfecha_confirmada.ClientID & "','" + fecha_conf_urgente_sn.ClientID + "','" & num_dias_prv & "','" & num_dias_min & "','" & GetGlobalResourceObject("general", "texto_urgente").ToString & "','" & HFLINEA.Value & "')")
            tboxFConf.Attributes.Add("onchange", "javascript:CambiaFechas('" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & tboxGaartCod.ClientID & "','" & tbox_cantidad.ClientID & "','" & cli.prop_COD & "','" & pais_cod & "','" & cli.prop_RSOCIAL_COD & "','" & DDLDir_Envio.SelectedValue.ToString & "','" + tboxFPrev.ClientID + "','" + lblfecha_prevista.ClientID + "','" + tboxFConf.ClientID + "','" & lblfecha_confirmada.ClientID & "','" + fecha_conf_urgente_sn.ClientID + "','" & num_dias_prv & "','" & num_dias_min & "','" & GetGlobalResourceObject("general", "texto_urgente").ToString & "','" & HFLINEA.Value & "')")

            tbox_cantidad.Attributes.Add("onchange", "javascript:cambia_cantidad_pedido('" + cli.prop_COD + "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" & lblPesoLin.ClientID & "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numPedido + "','" + tipoPedido + "','" + tboxSuRef.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & obstip_articulo_idiomas & "','" & Session("idioma") & "','" + tboxFPrev.ClientID + "','" + tboxFConf.ClientID + "','" & cabeceraOfe.prop_ggofetip_cod & "','" & cabeceraOfe.prop_N_OFE & "','" & lblNLin.Text & "','" & GetLocalResourceObject("MsgModalEsKit") & "','" & GetLocalResourceObject("MsgModalNoPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & pais_cod & "','" & Unidad.ClientID & "','" & GetGlobalResourceObject("general", "lblConfPrecio") & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & cabeceraPed.prop_PERMITIR_MODIF_PRECIOS_SN & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & ConfigurationManager.AppSettings("CLA_PESO") & "')")
            imgEditTirasRollos.Attributes.Add("onclick", "javascript:abrir_lov_tiras('" & tboxGaartCod.ClientID & "', '" & tbox_cantidad.ClientID & "', '" & tboxDescripART.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "');")
            tbox_precio.Attributes.Add("onchange", "javascript:calcula_precio_final_pedido('" + cli.prop_COD + "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" & lblPesoLin.ClientID & "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numPedido + "','" + tipoPedido + "','" + tboxSuRef.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & obstip_articulo_idiomas & "','" & Session("idioma") & "','" + tboxFPrev.ClientID + "','" + tboxFConf.ClientID + "','" & cabeceraOfe.prop_ggofetip_cod & "','" & cabeceraOfe.prop_N_OFE & "','" & lblNLin.Text & "','" & GetLocalResourceObject("MsgModalEsKit") & "','" & GetLocalResourceObject("MsgModalNoPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & pais_cod & "','" & Unidad.ClientID & "','" & GetGlobalResourceObject("general", "lblConfPrecio") & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & cabeceraPed.prop_PERMITIR_MODIF_PRECIOS_SN & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & ConfigurationManager.AppSettings("CLA_PESO") & "','N')")
            tbox_dto.Attributes.Add("onchange", "javascript:calcula_precio_final_pedido('" + cli.prop_COD + "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" & lblPesoLin.ClientID & "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numPedido + "','" + tipoPedido + "','" + tboxSuRef.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & obstip_articulo_idiomas & "','" & Session("idioma") & "','" + tboxFPrev.ClientID + "','" + tboxFConf.ClientID + "','" & cabeceraOfe.prop_ggofetip_cod & "','" & cabeceraOfe.prop_N_OFE & "','" & lblNLin.Text & "','" & GetLocalResourceObject("MsgModalEsKit") & "','" & GetLocalResourceObject("MsgModalNoPrecEsp") & "','" & age.prop_NOMBRE & " " & Date.Now & "','" & pais_cod & "','" & Unidad.ClientID & "','" & GetGlobalResourceObject("general", "lblConfPrecio") & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & cabeceraPed.prop_PERMITIR_MODIF_PRECIOS_SN & "','" & Session("cultura") & "','" & ConfigurationManager.AppSettings("COD_GAART_ESP") & "','" & ConfigurationManager.AppSettings("CLA_PESO") & "','S')")

            imgBorrar.Attributes.Add("onclick", "javascript:borraLinea_pedido('" + cli.prop_COD + "','" + tboxGaartCod.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + TIPO_USUARIO + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + numPedido + "','" & GetLocalResourceObject("MsgModalBorraLin") & "')")

            'OCULTA O MUESTRA TEXTBOX O LABEL SEGUN PERFIL Y PROPIEDAD PERMITIR O NO MOFIF PRECIOS.
            GestionarTextBoxesPrecios(TIPO_USUARIO, tipoPedido, cabeceraPed, lblPrecio, tbox_precio, lblDescuento, tbox_dto)

            Dim param As New BCb2b.CParametros()
            If tboxGaartCod.Text <> "" And tbox_cantidad.Text <> "" And tboxGaartCod.Text <> param.dame_param("B2B_ART_COMI_AGENTES") Then 'QUE NO COJA EL ESPB2B
                'COMPROBAMOS EL CUC PARA PONER EL MENSAJE.
                Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", vEmpgrupoCod, vEmpCod, Nothing)

                Dim PARAM_TARIFA As New BCb2b.empparam("B2B_TARIFA_COSTE", vEmpgrupoCod, vEmpCod, Nothing)
                Dim ARTICULOAUX As New BCb2b.CArticulo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, vTipVc)

                Dim PRECIO_TARIFA_AUX As Double = 0
                PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100) * CDbl(tbox_cantidad.Text)

                Dim list_LINEAS As New List(Of BCb2b.CLineaPedidoOff)
                list_LINEAS = Session("lineasPedido")
                Dim lin_ped_actual As BCb2b.CLineaPedidoOff = list_LINEAS(HFLINEA.Value - 1)
                Dim vGgofetipCod, vGgofelinNOfe, vGgofelinNLin As String
                vGgofetipCod = lin_ped_actual.prop_GGOFETIP_COD
                vGgofelinNOfe = lin_ped_actual.prop_GGOFELIN_N_OFE
                vGgofelinNLin = lin_ped_actual.prop_GGOFELIN_N_LIN
                GESTIONA_TRAZABILIDAD(lin_ped_actual, vGgofetipCod, vGgofelinNOfe, vGgofelinNLin)

                'tbox_precio.Text = Obtener_precios(tboxGaartCod.Text.ToUpper, cli.prop_COD, tbox_cantidad.Text, tipoPedido, Session("cultura"))
                If gaart_es_tira_o_rollo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper) = "S" Then
                    tbox_cantidad.ReadOnly = True
                    tbox_precio.ReadOnly = True
                    'If lblEquiUnPr.Text <> "" Then
                    '    tbox_cantidad.Text = lblM2.Text
                    '    tbox_precio.Text = Obtener_Precio_UnPr(tbox_precio.Text, tbox_cantidad.Text, lblEquiUnPr.Text, Session("cultura"))
                    'End If
                    'lblPrecio.Text = tbox_precio.Text
                End If

                'TODO IIG - POR LO QUE ENTIENDO ESTO SE USA POR EJEMPLO POR QUE CUANDO SE CAMBIA DE DIRECCION, COMO HACE POSTBACK, PARA QUE NO PONGA EL PRECIO QUE LE CORRESPONDE SI YA HABIA UN PRECIO CARGADO
                'SINO CADA VEZ QUE CAMBIMOS DE DIRECCION NOS PONDRÍA DE NUEVO EL PRECIO ORIGINAL. NO SE SI EN ALGUN CASO INTERESA QUE PONGA EL PRECIO ORIGINAL EN ESTE PUNTO, YO CREO QUE CON DEJAR EN PAZ LO QUE
                'HAYA VALDRÍA, PERO POR SI ACASO LO DEJO. ESO SI, QUITO DE LA CONDICION EL QUE SEA IGUAL A 0,00 PORQUE ENTIENDO QUE ES UN PRECIO VALIDO (AL MENOS EN PEDIDOS DE MUESTRA) Y SINO AL RECARGAR PONE
                'PRECIO ORIGINAL
                If lblPrecio.Text = "" Then 'Or lblPrecio.Text = "0,00" Then
                    lblPrecio.Text = tbox_precio.Text
                Else
                    'If tipoPedido <> ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
                    tbox_precio.Text = lblPrecio.Text
                    'End If
                End If

                tbox_dto.Text = Obtener_descuento(tboxGaartCod.Text.ToUpper, cli.prop_COD, tbox_cantidad.Text, tipoPedido, Session("cultura"))
                If lblDescuento.Text = "" Or lblDescuento.Text = "0,00" Then
                    lblDescuento.Text = tbox_dto.Text
                Else
                    'If tipoPedido <> ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
                    tbox_dto.Text = lblDescuento.Text
                    'End If
                End If

                Dim cantidad_aux As String = ""
                If (lblTiras.Text <> "" Or lblRollos.Text <> "") And Unidad.Text <> "UN" Then
                    If lblTiras.Text <> "" Then
                        cantidad_aux = lblTiras.Text
                    End If
                    If lblRollos.Text <> "" Then
                        cantidad_aux = lblRollos.Text
                    End If
                Else
                    cantidad_aux = tbox_cantidad.Text
                End If
                lbltotal.Text = calcular_total_NP(cantidad_aux, tbox_precio.Text, tbox_dto.Text, Session("cultura"))

                Unidad.Text = ARTICULOAUX.prop_gaunitip_uni1

                Dim es_tira_o_rollo As String = gaart_es_tira_o_rollo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper)

                If es_tira_o_rollo = "S" Then
                    imgEditTirasRollos.CssClass = imgEditTirasRollos.CssClass.Replace("oculto", "")
                End If

                Dim hoy As String = CDate(Now.ToShortDateString)
                Dim resultado(1) As String
                Dim codi_pais As String = pais_env(cli.prop_RSOCIAL_COD, DDLDir_Envio.SelectedValue.ToString)
                Dim fecha_sug As String = amc_calcula_fecha_linea(codi_pais, hoy, "")
                Dim dias_min As String = dime_minimo_dias(codi_pais)
                Dim fecha_min As String = dame_fecha_sumar_dias(hoy, dias_min)
                Dim fecha_a_visualizar As String = ""

                If hdn_pais_env_cambiado.Value = "S" Then 'esto esta porque si cambias de idioma te cambiaba todas las fechas, asi, solo cambia las fechas cuando cambias de dir.
                    tboxFConf.Text = "" 'inicialiamos a vacio para que cambie el valor de la fecha segun el pais de la dir del combo
                End If

                resultado = Obtener_FechaPrevista_Nuevo(GetGlobalResourceObject("general", "texto_urgente").ToString, tboxFConf.Text, fecha_sug, fecha_min)
                fecha_a_visualizar = resultado(0)

                If tboxFPrev.Text = "" Then
                    tboxFPrev.Text = dame_fecha_sumar_dias(hoy, num_dias_prv)
                End If

                If num_dias_min <> "" Then
                    fecha_a_visualizar = dame_fecha_sumar_dias(tboxFPrev.Text, num_dias_min)
                Else
                    tboxFPrev.Text = dame_fecha_sumar_dias(fecha_a_visualizar, dias_min * -1)
                End If

                lblfecha_prevista.Text = tboxFPrev.Text

                tboxFConf.Text = fecha_a_visualizar
                lblfecha_confirmada.Text = fecha_a_visualizar

                If resultado(1) <> "" And num_dias_min = "" Then
                    'If Not txtarea_observacion.Text.Contains(resultado(1)) Then
                    '    txtarea_observacion.Text = resultado(1) & txtarea_observacion.Text
                    'End If
                    fecha_conf_urgente_sn.Text = "S"
                    tboxFConf.CssClass = "urgente"
                    num_lineas_urge.Text = (CInt(num_lineas_urge.Text) + 1).ToString

                    txtarea_observacion.Text = GestionaTextoUrgente(txtarea_observacion.Text, resultado(1))
                Else
                    fecha_conf_urgente_sn.Text = "N"
                    tboxFConf.CssClass = tboxFConf.CssClass.Replace("urgente", "")
                End If

                'AMC_NE194. Gestion de Peso,portes en proformas
                lblPesoLin.Text = Dame_PesoTotal_Lin(vEmpgrupoCod, tboxGaartCod.Text, tbox_cantidad.Text, ConfigurationManager.AppSettings("CLA_PESO"))

                Dim ERRORCOSTE As Boolean = False
                Dim ATENCIONCOSTE As Boolean = False
                Dim OBSERVACIONCOSTE As String = ""

                GestionarPrecioAConfirmarVisible(tbox_precio, tbox_dto, lblDescuento, tipoPedido)

                GestionarErrorCosto(es_tira_o_rollo, tboxGaartCod, cli.prop_COD, tbox_precio, tbox_cantidad, tbox_dto, tipoPedido, e, OBSERVACIONCOSTE, ERRORCOSTE, ATENCIONCOSTE)

                Dim LINEAPED As New BCb2b.CLineaPedidoOff(vEmpgrupoCod, vEmpCod, vTipVc, cabeceraPed.prop_GGPEDTIP_COD, cabeceraPed.prop_N_PEDIDO, HFLINEA.Value, tboxGaartCod.Text.ToUpper, tboxDescripART.Text, tbox_cantidad.Text, lblPesoLin.Text, tbox_precio.Text, tboxFPrev.Text, tboxFConf.Text, Unidad.Text, cabeceraPed.prop_GGCLIPR_COD, tbox_dto.Text, "", True, ERRORCOSTE, ATENCIONCOSTE, lblAncho.Text, lblLargo.Text, lblTiras.Text, lblRollos.Text, lblM2.Text, lblEquiUnPr.Text, lblDesperdicio.Text, OBSERVACIONCOSTE)
                LINEAPED.asignarNlinOriginal = lblNLin.Text

                If HAY_TRAZABILIDAD(vGgofetipCod, vGgofelinNOfe, vGgofelinNLin) Then
                    LINEAPED.prop_GGOFETIP_COD = vGgofetipCod
                    LINEAPED.prop_GGOFELIN_N_OFE = vGgofelinNOfe
                    LINEAPED.prop_GGOFELIN_N_LIN = vGgofelinNLin
                ElseIf Not Session("cabecera") Is Nothing Then
                    LINEAPED.prop_GGOFETIP_COD = cabeceraOfe.prop_ggofetip_cod
                    LINEAPED.prop_GGOFELIN_N_OFE = cabeceraOfe.prop_N_OFE
                    LINEAPED.prop_GGOFELIN_N_LIN = lblNLin.Text
                End If

                list_LINEAS(HFLINEA.Value - 1) = LINEAPED
                Session("lineasPedido") = list_LINEAS
            End If
        End If
    End Sub
    Private Function HAY_TRAZABILIDAD(ByRef traza_ofe_tip As String, ByRef traza_ofe_num As String, ByRef traza_ofe_lin As String) As Boolean
        Return (traza_ofe_tip <> "" And traza_ofe_num <> "" And traza_ofe_lin <> "")
    End Function
    Private Sub GESTIONA_TRAZABILIDAD(ByVal linea As BCb2b.CLineaPedidoOff, ByRef traza_ofe_tip As String, ByRef traza_ofe_num As String, ByRef traza_ofe_lin As String)
        Dim validador As ITrazabilidadValidator = TrazabilidadValidatorFactory.ObtenerValidador(linea.prop_GGOFETIP_COD)
        If (validador.Valido(linea)) Then
            traza_ofe_tip = linea.prop_GGOFETIP_COD
            traza_ofe_num = linea.prop_GGOFELIN_N_OFE
            traza_ofe_lin = linea.prop_GGOFELIN_N_LIN
        Else
            traza_ofe_tip = ""
            traza_ofe_num = ""
            traza_ofe_lin = ""
        End If
    End Sub
    Private Sub GestionarTextBoxesPrecios(ByVal TIPO_USUARIO As String, tipoPedido As String, ByVal cabeceraPed As BCb2b.CCabeceraPedido, ByVal lblPrecio As Label, ByVal tbox_precio As TextBox, ByVal lblDescuento As Label, ByVal tbox_dto As TextBox)

        If (TIPO_USUARIO = "CL") Or cabeceraPed.prop_PERMITIR_MODIF_PRECIOS = False Then 'Or tipoPedido = ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
            lblPrecio.Attributes.Add("style", "display:inline")
            tbox_precio.Attributes.Add("style", "display:none")

            lblDescuento.Attributes.Add("style", "display:inline")
            tbox_dto.Attributes.Add("style", "display:none")
        Else
            lblPrecio.Attributes.Add("style", "display:none")
            tbox_precio.Attributes.Add("style", "display:inline")

            lblDescuento.Attributes.Add("style", "display:none")
            tbox_dto.Attributes.Add("style", "display:inline")
        End If

        'If (TIPO_USUARIO <> "CL") And cabeceraPed.prop_PERMITIR_MODIF_PRECIOS = True Then

        '    ' lblPrecio.Attributes.Add("style", "visibility:hidden")
        '    lblPrecio.Attributes.Add("style", "display:none")
        '    tbox_precio.Attributes.Add("style", "display:inline")

        '    ' lblDescuento.Attributes.Add("style", "visibility:hidden")
        '    lblDescuento.Attributes.Add("style", "display:none")
        '    tbox_dto.Attributes.Add("style", "display:inline")
        'Else
        '    ' lblPrecio.Attributes.Add("style", "visibility:hidden")
        '    lblPrecio.Attributes.Add("style", "display:inline")
        '    tbox_precio.Attributes.Add("style", "display:none")

        '    ' lblDescuento.Attributes.Add("style", "visibility:hidden")
        '    lblDescuento.Attributes.Add("style", "display:inline")
        '    tbox_dto.Attributes.Add("style", "display:none")

        'End If
    End Sub

    Private Sub GestionarPrecioAConfirmarVisible(tbox_precio As TextBox, tbox_dto As TextBox, lblDescuento As Label, tipoPedido As String)

        If CDbl(tbox_precio.Text) = 0 And tipoPedido <> ConfigurationManager.AppSettings("tipo_pedido_muestras") Then
            lblDescuento.Attributes.Add("style", "display:inline")
            lblDescuento.Text = GetGlobalResourceObject("general", "lblConfPrecio")
            tbox_dto.Attributes.Add("style", "display:none")
        End If

    End Sub

    Private Sub GestionarErrorCosto(es_tira_o_rollo As String, tboxGaartCod As TextBox, codCli As String, tbox_precio As TextBox, tbox_cantidad As TextBox, tbox_dto As TextBox, tipoPedido As String, e As System.Web.UI.WebControls.GridViewRowEventArgs, ByRef OBSERVACIONCOSTE As String, ByRef ERRORCOSTE As String, ByRef ATENCIONCOSTE As String)
        Dim art_ESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")

        If DDLSeries.SelectedValue <> ConfigurationManager.AppSettings("tipo_pedido_muestras") And es_tira_o_rollo = "N" And tboxGaartCod.Text.ToUpper <> art_ESP.ToUpper Then
            'AMC_NE174
            'VALIDAMOS PRECIO
            Dim cod_error As String = ValidarPrecioLinea(tboxGaartCod.Text, codCli, tbox_precio.Text, tbox_cantidad.Text, tbox_dto.Text, Session("cultura"), tipoPedido)
            Dim tipo_error As String = Dame_TipoError_de_Error(cod_error)
            OBSERVACIONCOSTE = Obtener_Descrip_Error(cod_error, Session("cultura"))

            Dim clase As String = ""
            Dim clase_inf As String = ""
            Select Case tipo_error  'PARA COLOR DE FONDO DE LA FILA.
                Case "#ERROR"
                    ERRORCOSTE = True 'MENOR QUE CUC Y QUE TARIF_ESTR
                    clase = "error"
                    clase_inf = "error_suave"
                Case "#WARNING"
                    ATENCIONCOSTE = True 'MENOR QUE EL CUC PERO NO MENOR QUE TARIF_ESTR
                    clase = "atencion"
                    clase_inf = "atencion_suave"
                Case "#OK"
            End Select

            e.Row.CssClass = clase
            'PINTAMOS LA FILA ACTUAL DE ROJO
            Dim i As Integer = 0
            For i = 0 To e.Row.Cells.Count - 1
                e.Row.Cells(i).CssClass = clase
            Next

            If tipo_error <> "#OK" Then 'si es OK no creamos otra fila.
                num_lineas_error_costo = num_lineas_error_costo + 1
                'AÑADIMOS LA NUEVA
                AddNewRow(BulkEditGridView1, e, num_lineas_error_costo, OBSERVACIONCOSTE, clase_inf)
            End If
        End If
    End Sub

    Public Sub AddNewRow(ByVal sender As Object, ByVal e As GridViewRowEventArgs, ByVal n_lin As Integer, ByVal textoMensaje As String, ByVal clasecss As String)
        Try
            Dim GridView1 As GridView = DirectCast(sender, GridView)
            Dim NewTotalRow As New GridViewRow(0, 0, DataControlRowType.DataRow, DataControlRowState.Insert)
            NewTotalRow.Font.Bold = True
            NewTotalRow.BackColor = System.Drawing.Color.Aqua
            Dim HeaderCell As New TableCell()
            HeaderCell.Height = 10
            HeaderCell.HorizontalAlign = HorizontalAlign.Center

            Dim IDIOMA As String = Session("idioma")

            HeaderCell.Text = textoMensaje
            HeaderCell.ColumnSpan = 10
            HeaderCell.CssClass = clasecss
            NewTotalRow.Cells.Add(HeaderCell)
            GridView1.Controls(0).Controls.AddAt(e.Row.RowIndex + n_lin + 1, NewTotalRow)
        Catch ex As Exception
            Log.Error(ex, "[CrearPedido.AddNewRow] lin = {lin} ", n_lin + 1)
        End Try

    End Sub
    Protected Sub BulkEditGridView1_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles BulkEditGridView1.RowCommand
        BulkEditGridView1.Save()
    End Sub
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(CrearPedido))

        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")

        Dim uti As New BCb2b.Utilities
        uti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalAceptar"))

        If (Session("cliente") Is Nothing) Then
            Server.Transfer("BusquedaClientes.aspx")
        End If

        'cargamos hiddens.
        tboxGrupo.Value = vEmpgrupoCod
        tboxempresa.Value = vEmpCod
        tboxggpedtip_cod.Value = DDLSeries.SelectedValue
        num_lineas_urge.Text = "0"
        'Meto esto para ajax.

        Dim DTO_DEFECTO As New BCb2b.CParametros()

        Session("N_PEDIDO") = ""
        Session("GRUPO_PED") = ""
        Session("EMPRESA_PED") = ""
        Session("TIPO_PED") = ""

        btnContinuar.Visible = True

        Dim cliente As New BCb2b.ggclipr()
        If (Not Session("cliente") Is Nothing) Then
            cliente = Session("cliente")
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<>ING,SVT
            age = Session("agente")
        ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
            age = New BCb2b.gvagente(cliente.prop_GVAGENTE_COD, vEmpgrupoCod, 0)
        End If

        Dim viene_de_ofe As Boolean = False 'es para que no cargue la direnvio vacia sino la de la oferta.
        If Not Page.IsPostBack Then
            div_LBLERROR.Visible = False

            'CARGAMOS LOS DOCUMENTOS SEGUN EL PAIS DEL CLIENTE.
            CARGA_DOCUMENTOS_TRANSPORTE(vEmpgrupoCod, vTipVc, cliente.prop_COD)

            'SEGUN EL ESTADO DEL CLIENTES Y EL TIPO DE USUARIO PUEDE HACER UNOS PEDIDOS U OTROS.
            GESTIONAR_SERIES_PEDIDO(vEmpgrupoCod, vTipVc, age.prop_COD, cliente.prop_COD)

            'OBTENEMOS DESCRIPCION FPAGO TRADUC.
            lblFormadepago.Text = DAME_DESCRIP_FPAGO_CLI_TRADUCIDA(vEmpgrupoCod, vTipVc, cliente.prop_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))

            'CARGAMOS LAS DIRECCIONES DE ENVIO
            CARGAR_DIRECCIONES_ENVIO(vEmpgrupoCod, vTipVc, cliente.prop_COD, viene_de_ofe)

            hdn_pais_env_cambiado.Value = "N"
        End If

        'AMC_NE127. SI NO TIENE TODAS LAS CLASIS METIDAS O ESTA EN ESTADO POT, VA A CREARCLIENTE
        COMPROBAR_SI_CLASIS_OBLIS_INTRODUCIDAS(cliente)

        'generamos la cabecera de la pedido.
        If DDLSeries.SelectedIndex <> -1 Then
            lblSerie.Text = DDLSeries.Items(DDLSeries.SelectedIndex).Value
            lblSerie.Text = DDLSeries.SelectedItem.Value()
        Else
            lblSerie.Text = ""
        End If

        lblSerie.Visible = False
        DDLSeries.Visible = True

        Dim direccion_envio As String
        If Not DDLDir_Envio.SelectedItem Is Nothing Then
            direccion_envio = DDLDir_Envio.SelectedItem.Value
        Else
            direccion_envio = ""
        End If

        If (Session("cabeceraPed") Is Nothing) Then
            Dim cabecera As New BCb2b.CCabeceraPedido
            If DDLSeries.SelectedValue = "" Then
                'no tiene tipo pedido asignado
                Server.Transfer("PedidoConsulta.aspx")
            End If
            cabecera = New BCb2b.CCabeceraPedido(cliente, vEmpCod, DDLSeries.SelectedItem.Value, _
                 ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), age.prop_COD, tboxRefCli.Text, tboxAtte.Text, direccion_envio, cliente.prop_RSOCCONDI_DEF)
            Session("cabeceraPed") = cabecera

        End If

        If Not (Page.IsPostBack) Then
            If Session("es_reaprovision") = "S" And Session("perfil_usuario") = "DIS" Then
                'ASIGNAMOS EL ALMACEN DE ASTEASU. AMC_GV172, AMC_NE199
                Session("cabeceraPed").prop_GAALMNOM_TRASP = GESTIONAR_ALMACEN_TRASPASO(age.prop_COD)
                'Gestiona si el distribuidor tiene un almacen correcto para poder continuar
            End If
           
            cargarListadoModosEnvio(cliente.prop_GGMENVIO_COD, Session("idioma_spyro"))

            'If Not (Session("cabeceraPed").prop_N_PEDIDO Is "") Then
            If Not (Session("cabeceraPed") Is Nothing) And viene_de_ofe Then
                Dim cabeceraPed As New BCb2b.CCabeceraPedido()
                cabeceraPed = Session("cabeceraPed")
                'cargar refe y atte del pedido creado que estamos revisando

                lblNpedido.Text = cabeceraPed.prop_N_PEDIDO

                tboxRefCli.Text = cabeceraPed.prop_SU_REF_PED
                tboxAtte.Text = cabeceraPed.prop_ATTE
                txtarea_observacion.Text = cabeceraPed.prop_OBSERVACION_dEFECTO

                'cargar observacion interna del pedido
                txtObservacion_interna.Text = cabeceraPed.prop_OBSERVACION_interna
                DDLSeries.SelectedValue = cabeceraPed.prop_GGPEDTIP_COD
                DDLDir_Envio.SelectedValue = cabeceraPed.prop_direccion_envio.PROP_COD
                comboModosEnvio.SelectedValue = cabeceraPed.prop_GGMENVIO_COD

                RellenarCamposDireccion(cabeceraPed.prop_direccion_envio)
            End If

            'TANTO SI VIENE DE OFE COMO REVISIÓN DE PED, TIENE QUE COGER LOS PORTES DEL ANTERIOR DOCUMENTO.
            Dim vPortes As String = ""
            If viene_de_ofe Then
                vPortes = Session("cabeceraPed").prop_PORTPAG_SN
            End If
            cargarListadoPortes(age, cliente.prop_PORTES_PD, vPortes)
            lblAgencia.Text = comboModosEnvio.SelectedItem.Text

            'HAY QUE LLAMAR PARA CALCULAR PARAMETROS DE CABECERA 
            guardar_info_cabecera()
        End If
        'cabecera.prop_OBSERVACION_dEFECTO = txtarea_observacion.Text 'SRA HACER!

        'CAMBIAMOS EL TEXTO DE ADVERTENCIA SOBRE LA FECHA PREVISTA, MINIMA.
        texto_f_prev.Text = DAME_ADVERTENCIA_FECHA_PREV(cliente.prop_RSOCIAL_COD, DDLDir_Envio.SelectedValue.ToString)

        Try

            'Datos de la cabecera fijos
            lblNombreCli.Text = cliente.prop_NOMBRE


            'DOMICILIACION
            Dim datos_domic As New BCb2b.CCliente(cliente.prop_COD, vEmpgrupoCod, vTipVc)
            Dim dato As String = datos_domic.prop_domiciliacion.PROP_IBAN & " - " & datos_domic.prop_domiciliacion.prop_cuenta_bancaria
            lblDomiciliacion.Text = dato

            lblRSocial.Text = cliente.prop_RSOCIAL_COD
            'lblAgencia.Text = cliente.prop_GGMENVIO_desc

            'Cabecera datos variables
            lblFPED.Text = Now.ToShortDateString

            lblSerie.Text = Session("cabeceraPed").prop_GGPEDTIP_COD

            Session("N_PEDIDO") = Session("cabeceraPed").prop_N_PEDIDO
            Session("GRUPO_PED") = Session("cabeceraPed").prop_EMPGRUPO_COD
            Session("EMPRESA_PED") = Session("cabeceraPed").prop_emp_cod
            Session("TIPO_PED") = Session("cabeceraPed").prop_ggpedtip_cod

        Catch ex As Exception
            Log.Error(ex, "[CrearPedido.Load] cab = {@cab} ", Session("cabeceraPed"))
            div_LBLERROR.Visible = True
            LBLERROR.Text = ex.ToString
        End Try

        'SI ES CLIENTES ESPECIAL COMO CLIMAVENETA, OCULTAMOS ALERTA DE FECHAS.
        texto_f_prev_div.Visible = True
        If ES_CLIENTE_ESPECIAL(vEmpgrupoCod, vTipVc, cliente.prop_COD, ConfigurationManager.AppSettings("NUMDIASMIN")) Then
            texto_f_prev_div.Visible = False
        End If

        If perfiles.prop_TIPO_PERFIL = 2 Then 'CLI
            UPObser2.Visible = False
            txtObservacion_interna.Text = ""
            div_transportista.Attributes.Add("class", "width_100 float_left")
        Else
            UPObser2.Visible = True
        End If
    End Sub


    Protected Sub btnContinuar_Click(sender As Object, e As EventArgs) Handles btnContinuar.Click
        BulkEditGridView1.DataBind()
    End Sub

    Protected Sub DDLSeries_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLSeries.SelectedIndexChanged
        Dim cli As New BCb2b.ggclipr()
        Dim age As New BCb2b.gvagente()
        Dim cabecera As New BCb2b.CCabeceraPedido()
        Dim direccion_envio As String = ""
        Dim almacen_cod As String = ""
        Try

            cli = Session("cliente")

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))


            If Not Session("agente") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<>ING,SVT
                age = Session("agente")
            ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            End If

            lblSerie.Text = DDLSeries.SelectedValue

            lblSerie.Visible = False
            DDLSeries.Visible = True


            direccion_envio = DDLDir_Envio.SelectedItem.Value

            cabecera = New BCb2b.CCabeceraPedido(cli, ConfigurationManager.AppSettings("empresa"), DDLSeries.SelectedItem.Value, _
                 ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), age.prop_COD, tboxRefCli.Text, tboxAtte.Text, direccion_envio, cli.prop_RSOCCONDI_DEF)

            'COMPROBAMOS ALMACEN DE TRASPASO Y ASIGNAMOS. AMC_GV172
            cabecera.prop_GAALMNOM_TRASP = GESTIONAR_ALMACEN_TRASPASO(age.prop_COD)

            Session("cabeceraPed") = cabecera

            guardar_info_cabecera()
        Catch ex As Exception
            Log.Error(ex, "[CrearPedido.DDLSeries_SelectedIndexChanged] cliente = {@cliente} agente = {@agente} cab = {@cab} dir_env = {dir_env} almac_cod = {almac_cod} ", cli, age, cabecera, direccion_envio, almacen_cod)
        End Try

    End Sub
    'Protected Sub DDLSeries_Click(sender As Object, e As EventArgs) Handles DDLSeries.TextChanged
    '    Dim mislineas As New List(Of BCb2b.CLineaPedidoOff)
    '    If Not Session("lineasPedido") Is Nothing Then
    '        mislineas = Session("lineasPedido")
    '    End If
    '    Dim numeroLinea As Integer = 0
    '    For Each element As BCb2b.CLineaPedidoOff In mislineas
    '        If Not element.prop_errorCosto And element.prop_GAART_COD <> "" Then
    '            If (element.prop_GGOFETIP_COD = ConfigurationManager.AppSettings("tipo_pedido")) Then
    '                element.prop_GGOFETIP_COD = ConfigurationManager.AppSettings("tipo_pedido_muestras")
    '                element.prop_PR_PRECIO = Obtener_precios(element.prop_GAART_COD, Session("cliente").prop_cod, element.prop_C_UNI1, ConfigurationManager.AppSettings("tipo_pedido_muestras"), Session("cultura"))
    '                element.prop_I_NETOEMP = calcular_total_NP(element.prop_C_UNI1, element.prop_PR_PRECIO, element.prop_descuento_B2B, Session("cultura"))
    '            ElseIf (element.prop_GGOFETIP_COD = ConfigurationManager.AppSettings("tipo_pedido_muestras")) Then
    '                element.prop_GGOFETIP_COD = ConfigurationManager.AppSettings("tipo_pedido")
    '                element.prop_PR_PRECIO = Obtener_precios(element.prop_GAART_COD, Session("cliente").prop_cod, element.prop_C_UNI1, ConfigurationManager.AppSettings("tipo_pedido"), Session("cultura"))
    '                element.prop_I_NETOEMP = calcular_total_NP(element.prop_C_UNI1, element.prop_PR_PRECIO, element.prop_descuento_B2B, Session("cultura"))
    '            End If
    '        End If
    '    Next
    '    BulkEditGridView1.DataBind()
    'End Sub

    Protected Sub btnRealizar_Click(sender As Object, e As EventArgs) Handles btnRealizar.Click
        'Controlamos que el su ref introducido no existe.
        Dim vExisteSuref As Boolean = ExisteRefPedCli()
        If DDLDir_Envio.SelectedValue <> "" And Not vExisteSuref Then
            RFVDDl_dirEnvio.IsValid = True
            Dim cabecera As New BCb2b.CCabeceraPedido
            cabecera = Session("cabeceraPed")
            cabecera.prop_dir_envio = New BCb2b.CDirecciones(lblRSocial.Text, DDLDir_Envio.SelectedValue)
            cabecera.prop_direccion_envio = cabecera.prop_dir_envio
            cabecera.prop_ATTE = tboxAtte.Text
            cabecera.prop_SU_REF_PED = tboxRefCli.Text
            cabecera.prop_OBSERVACION_dEFECTO = txtarea_observacion.Text
            cabecera.prop_OBSERVACION_interna = txtObservacion_interna.Text
            cabecera.prop_GGPEDTIP_COD = DDLSeries.SelectedValue
            'cabecera.prop_GGMENVIO_COD = DDLDir_Envio.SelectedValue
            Session("cabeceraPed") = cabecera

            Dim mislineas As New List(Of BCb2b.CLineaPedidoOff)
            If Not Session("lineasPedido") Is Nothing Then
                mislineas = Session("lineasPedido")
            End If
            If mislineas.Count > 0 Then
                Server.Transfer("pedidoValidar.aspx")
            Else
                'MOSTRAR ERROR SIN LINEAS.
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "NoLines", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetGlobalResourceObject("general", "NoLineasIntroduc") & "','err_red','',300);", True)
            End If
        Else
            RFVDDl_dirEnvio.IsValid = False
        End If
    End Sub

    Protected Sub DDLDir_Envio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLDir_Envio.SelectedIndexChanged
        Dim cliente As New BCb2b.ggclipr()
        Dim cabecera As New BCb2b.CCabeceraPedido()
        Dim pais_rsocdir_sel As String = ""
        Try

            If (Not Session("cliente") Is Nothing) Then
                cliente = Session("cliente")
            End If

            Dim dir_sel As New BCb2b.CDirecciones()
            If DDLDir_Envio.SelectedValue <> "" Then
                dir_sel = New BCb2b.CDirecciones(cliente.prop_RSOCIAL_COD, DDLDir_Envio.SelectedValue)
                pais_rsocdir_sel = pais_env(cliente.prop_RSOCIAL_COD, dir_sel.PROP_COD)
            End If


            cabecera = Session("cabeceraPed")

            cabecera.prop_dir_envio = dir_sel
            cabecera.prop_direccion_envio = dir_sel

            RellenarCamposDireccion(dir_sel)

            'COMPROBAMOS SI EL CLIENTE ES COMO CLIMAVENETA.
            Dim cli_especial As Boolean = ES_CLIENTE_ESPECIAL(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cliente.prop_COD, ConfigurationManager.AppSettings("NUMDIASMIN"))

            If hdn_pais_env_ant.Value <> pais_rsocdir_sel And cli_especial = False Then
                Dim actu As Boolean = True
                If hdn_pais_env_ant.Value = "" Or cliente.PROP_DIR_social.PROP_PAISES_COD = pais_rsocdir_sel Or pais_rsocdir_sel = "" Then
                    actu = False
                End If

                If actu Then
                    'SI PONEMOS ESTO A "S" EN EL ROWDATABOUND AL REFRESCAR CAMBIARÁ LAS FECHAS.
                    hdn_pais_env_cambiado.Value = "S"
                    hdn_pais_env_ant.Value = pais_rsocdir_sel
                    guardar_info_cabecera()
                    'DIALOGO DE CONTACTO CREADO
                    ScriptManager.RegisterStartupScript(Me, Me.GetType(), "ActuPagina", "ShowDialog('" & GetLocalResourceObject("MsgModalAtencion") & "','" & GetLocalResourceObject("MsgModalDirCambiado") & "','ok','CrearPedido.aspx',300);", True)
                End If
            Else
                hdn_pais_env_cambiado.Value = "N"
            End If
            hdn_pais_env_ant.Value = pais_rsocdir_sel
            guardar_info_cabecera()
        Catch ex As Exception
            Log.Error(ex, "[CrearPedido.DDLDir_Envio_SelectedIndexChanged] cli = {@cli} cab = {@cab} pais_rsoc = {pais_rsoc} ", cliente, cabecera, pais_rsocdir_sel)
        End Try

    End Sub
    Private Sub guardar_info_cabecera()
        'RECARGAMOS DATOS DE REF,ATT,OBSERS Y DIR PARA GUARDARLO Y QUE NO SE PIERDA
        Dim cabecera As New BCb2b.CCabeceraPedido
        cabecera = Session("cabeceraPed")
        cabecera.prop_ATTE = tboxAtte.Text
        cabecera.prop_SU_REF_PED = tboxRefCli.Text
        cabecera.prop_OBSERVACION_dEFECTO = txtarea_observacion.Text
        cabecera.prop_OBSERVACION_interna = txtObservacion_interna.Text
        cabecera.prop_GGPEDTIP_COD = DDLSeries.SelectedValue
        cabecera.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue

        Dim cli As New BCb2b.ggclipr()
        If Not Session("cliente") Is Nothing Then
            cli = Session("cliente")
        Else
            Response.Redirect("BusquedaClientes.aspx")
        End If

        cabecera.prop_direccion_envio = New BCb2b.CDirecciones(cli.prop_RSOCIAL_COD, DDLDir_Envio.SelectedValue)

        If DDLDir_Envio.SelectedIndex = 0 Then
            hdn_pais_env_ant.Value = ""
        Else
            hdn_pais_env_ant.Value = cabecera.prop_direccion_envio.PROP_PAISES_COD
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<>ING,SVT
            age = Session("agente")
        ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
            age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
        End If

        Dim clasi As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_MODIF_PREC"))
        'ESTA PROPIEDAD ES LA QUE PERMITE O NO MODIFICAR PRECIOS Y DESCUENTOS
        'NOTA PARA JCE: ESTO ES UN CHURRO. SI DEFINES UNA PROPIEDAD EN LA CLASE ALIMENTALA EN LA CLASE, SINO ES COMO SI PONES UNA VARIABLE GLOBAL, NADIE VA A SABER LA LOGICA DE ESO.
        '--------------------------------------------
        'If clasi.PROP_GGCLASIF_COD = "S" Then
        cabecera.prop_PERMITIR_MODIF_PRECIOS = (clasi.PROP_GGCLASIF_COD = "S")
        'Else
        '    cabecera.prop_PERMITIR_MODIF_PRECIOS = False
        'End If
        '--------------------------------------------

        'JCE. 06/06/2016. AMC_NE241. PORTES
        If DIME_SI_GESTIONAR_MINIMO_PORTES(age.prop_GGCLIPR_PROV) Then
            cabecera.prop_PORTPAG_SN = ddlPortes.SelectedValue
        End If

        Session("cabeceraPed") = cabecera
    End Sub

    Protected Sub tboxAtte_TextChanged(sender As Object, e As EventArgs) Handles tboxAtte.TextChanged
        'JCE. 02/08/16. INCI 883469. Aprobecho para controlar espacios en blanco a la hora de controlar att
        tboxAtte.Text = Trim(tboxAtte.Text)
        guardar_info_cabecera()
    End Sub

    Protected Sub tboxRefCli_TextChanged(sender As Object, e As EventArgs) Handles tboxRefCli.TextChanged
        'JCE. 02/08/16. INCI 883469. Controlar espacios en blanco a la hora de controlar suref
        ExisteRefPedCli()
        guardar_info_cabecera()
    End Sub

    Private Function ExisteRefPedCli() As Boolean
        'JCE. 02/08/16. INCI 883469. Controlar espacios en blanco a la hora de controlar suref
        tboxRefCli.Text = Trim(tboxRefCli.Text)

        'BUSCAMOS SI EXISTE ESTE SU REF EN OTRO PEDIDO.
        Dim cli As New BCb2b.ggclipr()
        If Not Session("cliente") Is Nothing Then
            cli = Session("cliente")
        End If

        Dim ggpedtip_cod As String = DDLSeries.SelectedValue
        Dim n_pedido As OracleNumber = OracleNumber.Null
        If Not Session("cabeceraPed") Is Nothing Then
            Dim cabeceraPed As New BCb2b.CCabeceraPedido()
            cabeceraPed = Session("cabeceraPed")
            ggpedtip_cod = cabeceraPed.prop_GGPEDTIP_COD
            If cabeceraPed.prop_N_PEDIDO <> "" Then
                n_pedido = CType(cabeceraPed.prop_N_PEDIDO, OracleNumber)
            End If
        End If

        Dim xxxcab As New BCb2b.GGXXXCAB(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), ggpedtip_cod, n_pedido, cli.prop_COD, OracleNumber.Null, "", "", OracleDateTime.Null)
        Dim vExisteSuRef As Boolean = False
        vExisteSuRef = xxxcab.GGXXXCAB_EXISTE_SREFER_IGUAL(tboxRefCli.Text, ConfigurationManager.AppSettings("Pedido"))
        If vExisteSuRef Then
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "ExisteSuRef", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("MsgExisteSuRef") & "','err_red','',300);", True)
            tboxRefCli.Text = ""
        End If

        Return vExisteSuRef
    End Function
    Protected Sub txtarea_observacion_TextChanged(sender As Object, e As EventArgs) Handles txtarea_observacion.TextChanged
        guardar_info_cabecera()
    End Sub

    Protected Sub txtObservacion_interna_TextChanged(sender As Object, e As EventArgs) Handles txtObservacion_interna.TextChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub BulkEditGridView1_Unload(sender As Object, e As EventArgs) Handles BulkEditGridView1.Unload
        hdn_pais_env_cambiado.Value = "N"
    End Sub
    Private Sub RellenarCamposDireccion(ByVal dir As BCb2b.CDirecciones)
        lbldir.Text = dir.PROP_DIR
        lblCP.Text = dir.PROP_COD_POSTAL
        lblProvi.Text = dir.PROP_PROVI_NOM
        lblTfono.Text = dir.PROP_TELEFONOS
        lblPoblacion.Text = dir.PROP_POBLAC_NOM
        lblpais.Text = dir.PROP_PAISES_nom
        lblFax.Text = dir.PROP_TELEFAX
    End Sub
    Private Function OBTENER_VALOR_CLASI_AGE_PROV(ByVal empgrupo_cod As String, ByVal tip_vc As String, ByVal agente As BCb2b.gvagente, ByVal perfil As String, ByVal cod_age As String, ByVal clasi As String) As Boolean
        Dim age As New BCb2b.gvagente()
        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(perfil)
        If perfiles.prop_TIPO_PERFIL = 1 Then 'age y dis
            age = agente
        ElseIf perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
            age = New BCb2b.gvagente(cod_age, empgrupo_cod, 0)
        Else
            'ES CLIENTE
        End If

        'OBTENGO VALOR DE CLASI B2B_AVIS
        Dim clasiProve As New BCb2b.CGGCLICLASI()
        If age.prop_GGCLIPR_PROV <> "" Then
            clasiProve = New BCb2b.CGGCLICLASI(empgrupo_cod, tip_vc, age.prop_GGCLIPR_PROV, clasi)
        End If

        Return clasiProve.PROP_GGCLASIF_COD
    End Function
    Private Sub cargarListadoPortes(ByVal pGvagente As BCb2b.gvagente, ByVal pPortesCli As String, ByVal pPortesPed As String)
        'AMC_NE241. JCE. 06/06/2016. PORTES.
        Dim clasiProve As New BCb2b.CGGCLICLASI()
        If pGvagente.prop_GGCLIPR_PROV <> "" Then
            clasiProve = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), pGvagente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"))
        End If

        Dim param As New BCb2b.CParametros()
        Dim cod_portes As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_CODIGOS_PORTES"))
        Dim listado_portes() As String = cod_portes.Split(",")
        ddlPortes.Items.Clear()
        For Each p As String In listado_portes
            Dim porte As New ListItem(GetGlobalResourceObject("general", "PORTES" & p), p)
            ddlPortes.Items.Add(porte)
        Next
        ddlPortes.DataBind()

        'JCE. 27/09/2016. NO INSERTABA BIEN LOS PORTES PORQUE INTENTABA INSERTAR AL PEDIDO UN CÓDIGO QUE NO EXISTE (al obtener del cliente, P o D por ejemplo, no funcionaba en Spyro porque deberia ser S o N) 
        'GESTIONAR PORTES DE CLIENTE RESPECTO A LOS DEL PEDIDO (NO ENTIENDO PORQUE NO ESTÁN UNIFICADOS EN SPYRO)
        'EN CLIENTE ES PORTES_PD Y EN PEDIDOS ES PORTPAG_SN.
        'PORTE PAGADO CLI --> P, EN PEDIDO --> S
        'PORTE DEBIDO CLI --> D, EN PEDIDO --> N
        'PORTE CARGADO COINCIDEN (C)
        'PORTE SIN DETERMINAR COINCIDEN (I)

        Dim portes_aux As String = pPortesCli
        If pPortesPed = "" Then 'SI EL PEDIDO TIENE PORTE ES QUE ESTÁ HACIENDO REVISIÓN Y COGEMOS ESE, SINO LLEGARA VACIO Y COGERÁ EL DEL CLIENTE
            Select Case pPortesCli
                Case "P"
                    portes_aux = "S"
                Case "D", "I", "E" '--> si por lo que sea es indeterminado o en escala, le ponemos debidos.
                    portes_aux = "N"
            End Select
        Else
            portes_aux = pPortesPed
        End If

        lblPortes.Text = GetGlobalResourceObject("general", "PORTES" & portes_aux)

        Dim imp_minimo_portes As Double = 0
        If clasiProve.PROP_VALOR <> "" Then
            'SI EL PROVEEDOR TIENE LA CLASI B2B_PORMIN PARA INDICAR EL PORTE MINIMO PARA CONSIDERAR PAGADOS OCULTAMOS LABEL
            lblPortes.Visible = False
            ddlPortes.SelectedValue = portes_aux
        Else
            ddlPortes.Items.Clear()
            ddlPortes.DataBind()
            ddlPortes.Visible = False
        End If
    End Sub
    Private Sub cargarListadoModosEnvio(Optional ByVal menvio_def As String = "", Optional ByVal idioma As String = "")
        Dim cli As New BCb2b.ggclipr()
        Dim age As New BCb2b.gvagente()
        Try
            comboModosEnvio.Items.Clear()
            Dim listaModosEnvio As New ArrayList
            Dim arrayModosEnvio As Array

            'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)

            cli = Session("cliente")

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))


            If Not Session("agente") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<>ING,SVT
                age = Session("agente")
            ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            End If

            Dim valor As String = ""
            Dim obs As New BCb2b.GGCLIPROBS()
            valor = obs.DameObserAGEdeGGCLIPR(ConfigurationManager.AppSettings("grupo"), age, cli.prop_COD, ConfigurationManager.AppSettings("OBME"))

            Dim tiene_el_ggmenvio_def As Boolean = False
            If valor <> "" Then
                arrayModosEnvio = Split(valor, ",")

                Dim i As Integer = 0
                For i = 0 To arrayModosEnvio.Length - 1

                    Dim mEnvio As New BCb2b.CGGMenvio()
                    If idioma <> "" Then
                        mEnvio.DameDatosModoEnvio(arrayModosEnvio(i), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    Else
                        mEnvio = New BCb2b.CGGMenvio(arrayModosEnvio(i))
                    End If

                    If mEnvio.PROP_cod = menvio_def Then
                        tiene_el_ggmenvio_def = True
                    End If

                    listaModosEnvio.Add(mEnvio)
                Next i
            Else
                '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
                Dim mEnvio As New BCb2b.CGGMenvio()
                If idioma <> "" Then
                    mEnvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                Else
                    mEnvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
                End If
                listaModosEnvio.Add(mEnvio)
                '------FIN AMC_NE183-------
                If menvio_def <> "" Then
                    Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                    MEnvioDefecto.DameDatosModoEnvio(menvio_def, idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    listaModosEnvio.Add(MEnvioDefecto)
                    tiene_el_ggmenvio_def = True
                End If
            End If

            If tiene_el_ggmenvio_def = False Then
                Dim modo_env_def As New BCb2b.CGGMenvio(menvio_def)
                listaModosEnvio.Add(modo_env_def)
            End If

            comboModosEnvio.DataSource = listaModosEnvio
            comboModosEnvio.DataTextField = "prop_descrip"
            comboModosEnvio.DataValueField = "prop_cod"
            comboModosEnvio.DataBind()

            comboModosEnvio.SelectedValue = menvio_def
        Catch ex As Exception
            Log.Error(ex, "[CrearPedido.cargarListadoModosEnvio] cliente = {@cliente} agente = {@agente} ", cli, age)
        End Try

    End Sub

    Protected Sub comboModosEnvio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboModosEnvio.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Private Function DAME_DESCRIP_FPAGO_CLI_TRADUCIDA(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal p_ggclipr_cod As String, ByVal p_idioma As String, ByVal p_fpago_idiomastab As String) As String
        Dim cli As New BCb2b.ggclipr(p_ggclipr_cod, p_empgrupo_cod, p_tip_vc)
        Dim forma_pago As New BCb2b.CFPago
        forma_pago = cli.prop_forma_pago
        forma_pago.DameDatosFPago(forma_pago.PROP_COD, p_idioma, p_fpago_idiomastab)
        Return forma_pago.PROP_DESCRIP
    End Function
    Private Function ES_CLIENTE_ESPECIAL(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal p_ggclipr_cod As String, ByVal p_clasi_numdiasmin As String) As Boolean
        'AQUI SE CONTROLA SI ES CLIENTE ESPECIAL. CLIMAVENETA
        Dim resul As Boolean = False
        Dim clasi As New BCb2b.CGGCLICLASI(p_empgrupo_cod, p_tip_vc, p_ggclipr_cod, p_clasi_numdiasmin)
        If clasi.PROP_VALOR <> "" Then
            resul = True
        End If
        Return resul
    End Function
    Private Function DAME_ADVERTENCIA_FECHA_PREV(ByVal p_rsocial_cod As String, ByVal p_direnv_cod As String) As String
        Dim hoy As String = Now.ToShortDateString
        Dim res_text_f_prev As String = ""
        Dim codi_pais As String = pais_env(p_rsocial_cod, p_direnv_cod)

        If codi_pais <> "" Then
            Dim fecha_sug As String = amc_calcula_fecha_linea(codi_pais, hoy, "")
            Dim dias_min As String = dime_minimo_dias(codi_pais)
            Dim fecha_min As String = dame_fecha_sumar_dias(hoy, dias_min)
            'VIENE ASI DE LOCAL RESOURCE Y CAMBIAMOS LAS FECHAS.
            'La fecha prevista de entrega es el <f_sug>, si usted necesita un plazo menor por favor indiquenos una fecha, esta se resaltará en rojo y se considerará su pedido como urgente, el plazo mínimo que le permitimos es el <f_min>
            res_text_f_prev = GetLocalResourceObject("TextoFechasPedido")
            res_text_f_prev = Replace(res_text_f_prev, "<f_sug>", CDate(fecha_sug).ToShortDateString)

            'PARA INGLES Y FRANCES NOS COMENTO EUKENE QUE QUEDABA MEJOR PONER LOS DIAS EN VEZ DE LA FECHA MINIMA.
            If Session("idioma_spyro") = "ING" Or Session("idioma_spyro") = "FRA" Then
                dias_min = 3 'TESTTTTT
                res_text_f_prev = Replace(res_text_f_prev, "<f_min>", CInt(dias_min).ToString)
            Else
                res_text_f_prev = Replace(res_text_f_prev, "<f_min>", CDate(fecha_min).ToShortDateString)
            End If
        End If

        Return res_text_f_prev
    End Function
    Private Sub CARGAR_DIRECCIONES_ENVIO(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal p_ggclipr_cod As String, ByRef viene_de_ofe As Boolean)
        Dim cabeceraOfe As New BCb2b.COferta_Cab()
        If Not Session("cabecera") Is Nothing Then
            cabeceraOfe = Session("cabecera")
        End If

        Dim cabeceraPed As New BCb2b.CCabeceraPedido()
        If Not Session("cabeceraPed") Is Nothing Then
            cabeceraPed = Session("cabeceraPed")
        End If

        Dim cli As New BCb2b.ggclipr(p_ggclipr_cod, p_empgrupo_cod, p_tip_vc)

        Dim dir_env As New BCb2b.CDirecciones()
        Dim ldir_env As New ArrayList

        'SI NO VIENE DE TRAZABILIDAD OFERTA AÑADO LINEA VACIA AL COMBO.
        If cabeceraOfe.prop_ggofetip_cod = "" And cabeceraOfe.prop_N_OFE = "" Then
            ldir_env.Add(New BCb2b.CDirecciones(cli.prop_RSOCIAL_COD, "", "", "", "", "", "", "", "", "", "", "", "", "", ""))
        End If

        ldir_env.AddRange(dir_env.LISTA_DIRECCIONES(cli.prop_RSOCIAL_COD))
        DDLDir_Envio.DataSource = ldir_env
        DDLDir_Envio.DataTextField = "PROP_NOMBRE_DIR"
        DDLDir_Envio.DataValueField = "PROP_COD"
        DDLDir_Envio.DataBind()

        'SINO VIENE DE TRAZABILIDAD DE OFERTA SELECCIONO LA LINEA VACIA
        If cabeceraOfe.prop_ggofetip_cod = "" And cabeceraOfe.prop_N_OFE = "" Then
            If Not Session("cabeceraPed") Is Nothing Then
                Dim dir_env_ped As New BCb2b.CDirecciones()
                dir_env_ped = cabeceraPed.prop_dir_envio
                DDLDir_Envio.SelectedValue = dir_env_ped.PROP_COD

                hdn_pais_env_ant.Value = dir_env_ped.PROP_PAISES_COD

                viene_de_ofe = True
                RellenarCamposDireccion(dir_env_ped)


                lblNpedido.Text = cabeceraPed.prop_serie & "-" & cabeceraPed.prop_N_PEDIDO

                tboxAtte.Text = cabeceraPed.prop_ATTE
                tboxRefCli.Text = cabeceraPed.prop_SU_REF_PED
                txtarea_observacion.Text = cabeceraPed.prop_OBSERVACION_dEFECTO
                txtObservacion_interna.Text = cabeceraPed.prop_OBSERVACION_interna
            Else
                DDLDir_Envio.SelectedIndex = 0

                hdn_pais_env_ant.Value = ""

                lbldir.Text = ""
                lblCP.Text = ""
                lblProvi.Text = ""
                lblTfono.Text = ""
                lblPoblacion.Text = ""
                lblpais.Text = ""
                lblFax.Text = ""

                tboxAtte.Text = ""
                tboxRefCli.Text = ""
                txtarea_observacion.Text = ""
                txtObservacion_interna.Text = ""
            End If

            lblatencion_confim_ofer.Visible = False
            div_lblatencion_confim_ofer.Visible = False

        Else 'SI VIENE DE OFE SELECCIONAMOS LA DIRECCION DE LA OFE.
            Dim dir_env_ofe As New BCb2b.CDirecciones()
            dir_env_ofe = cabeceraOfe.prop_dir_envio
            DDLDir_Envio.SelectedValue = dir_env_ofe.PROP_COD

            hdn_pais_env_ant.Value = dir_env_ofe.PROP_PAISES_COD

            viene_de_ofe = True
            RellenarCamposDireccion(dir_env_ofe)

            tboxAtte.Text = cabeceraOfe.prop_ATTE
            tboxRefCli.Text = cabeceraOfe.prop_su_ref_OFE
            txtarea_observacion.Text = cabeceraOfe.prop_OBSERVACION_dEFECTO

            lblatencion_confim_ofer.Visible = True
            div_lblatencion_confim_ofer.Visible = True

            Dim param As New BCb2b.CParametros()
            'SI LA OFE ES UN ORDER INBOX CAMBIAMOS EL TEXTO DE LA ALERTA.
            If cabeceraOfe.prop_ggofetip_cod = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX")) Then
                lblatencion_confim_ofer.Text = GetLocalResourceObject("lblAtenConfirInbox")
            Else
                lblatencion_confim_ofer.Text = GetLocalResourceObject("lblAtenConfirOfe")
            End If
            lblatencion_confim_ofer.Text = lblatencion_confim_ofer.Text & " " & cabeceraOfe.prop_ggofetip_cod & "-" & cabeceraOfe.prop_N_OFE
            If cabeceraOfe.prop_su_ref_OFE <> "" Then
                lblatencion_confim_ofer.Text = lblatencion_confim_ofer.Text & " (" & cabeceraOfe.prop_su_ref_OFE & ")"
            End If
        End If
    End Sub
    Private Sub COMPROBAR_SI_CLASIS_OBLIS_INTRODUCIDAS(ByVal cliente As BCb2b.ggclipr)
        Dim param As New BCb2b.CParametros()
        'AMC_NE127. SI NO TIENE TODAS LAS CLASIS METIDAS O ESTA EN ESTADO POT POR LO QUE SEA, VA A CREARCLIENTE
        Dim clasisOblis As String = param.dame_param(ConfigurationManager.AppSettings("B2B_CLASIS_OBLI_USU_CREACLI"))
        Dim comp_clasis As New BCb2b.CGGCLICLASI()
        Dim todas_llenas As Boolean = comp_clasis.CompruebaSiClasisObliRellenas(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), clasisOblis, cliente.prop_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGCLATIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGCLATIP_DESC"))
        If todas_llenas = False Then
            Session("new_cliente") = cliente
            'MOSTRAR DIALOGO DE CLASIS OBLIGATORIAS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "FaltanClasis", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("MsgModalClasisOblis") & "','err_red','CrearCliente.aspx',300);", True)
            'Response.Redirect("CrearCliente.aspx")
        End If
    End Sub
    Private Sub CARGA_DOCUMENTOS_TRANSPORTE(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal p_ggclipr_cod As String)
        Dim rsocdir As New BCb2b.rsocdir()
        Dim mi_pais As String = rsocdir.pais_cliente(p_empgrupo_cod, p_tip_vc, p_ggclipr_cod)
        Dim path_virtual As String = ConfigurationManager.AppSettings("pathB2BAMCSADocs")

        'LOS FICHEROS ESTAN EN:
        '\\172.16.0.38\s$\Transporte

        Dim nombre_carpeta As String = ConfigurationManager.AppSettings("DirecFichPedTrans")

        Dim lista_pdf_mostrar As ArrayList = New ArrayList

        Dim sArchivos() As String
        Dim archivo As String = ""
        Dim archivoInfo As FileInfo
        Try
            sArchivos = Directory.GetFiles(nombre_carpeta)
            Dim cuenta As Integer = sArchivos.Length
            If cuenta > 0 Then
                For Each archivo In sArchivos
                    archivoInfo = New FileInfo(archivo)
                    Dim nom_doc As String = archivoInfo.Name.ToUpper
                    If nom_doc.StartsWith(mi_pais & "_") = True Then
                        path_virtual = nombre_carpeta & nom_doc
                        If cuenta > 1 Then
                            nom_doc = nom_doc.Replace(mi_pais & "_", "").ToUpper
                        Else
                            nom_doc = GetLocalResourceObject("VerPrecTransport").ToString.ToUpper
                        End If
                        path_virtual = path_virtual.Replace(ConfigurationManager.AppSettings("rutaBaseFTPUpload"), ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
                        Dim pdf As New BCb2b.CDocumentos(nom_doc, "", path_virtual, "", "", "")
                        lista_pdf_mostrar.Add(pdf)
                    End If
                Next
                RepeaterPDFS.DataSource = lista_pdf_mostrar
                RepeaterPDFS.DataBind()
                RepeaterPDFS.Visible = True
            Else
                RepeaterPDFS.Visible = False
            End If
        Catch ex As Exception
            Log.Information(ex, "[CrearPedido.ObtenerDocumentosPrecios] carpeta = {carpeta} ", nombre_carpeta)
        End Try
    End Sub
    Private Function OBTENER_SERIES_PEDIDO() As ArrayList 'ESTÁNDAR
        Dim param As New BCb2b.CParametros()
        Dim series_ped As String = param.dame_param(ConfigurationManager.AppSettings("SERIES_PED_CRE"))
        Dim tipo_pedido As New BCb2b.CGGpedtip()
        Dim listado As ArrayList = tipo_pedido.listado_SeriePedido_traduc(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), series_ped, "", "", "", Session("cadena_conexion"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_SERIES_PED"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_SERIES_PED"), Session("idioma_spyro"))
        Return listado
    End Function
    Private Function SERIE_PEDIDO_VALIDO(ByVal pggcliprCod As String, ByVal pggpedtipCod As String) As Boolean
        Dim es_valido As Boolean = False
        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion_comprobar_estado_cli As IDbTransaction
        transaccion_comprobar_estado_cli = conexionole.BeginTransaction
        Try
            AMC_GV181_PKG_CS.AMC_GV181_PKG_CS.GGPEDCAB_GGCLIPR_VALIDA(transaccion_comprobar_estado_cli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), pggpedtipCod, pggcliprCod, Nothing, "B2B", Session("idioma_spyro"), mensaje_info, mensaje_error)
            If mensaje_error = "" Then
                es_valido = True
            End If
            transaccion_comprobar_estado_cli.Commit()
        Catch ex As Exception
            transaccion_comprobar_estado_cli.Rollback()
        Finally
            transaccion_comprobar_estado_cli.Dispose()
        End Try
        Return es_valido
    End Function
    Private Sub GESTIONAR_SERIES_PEDIDO(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal p_gvagente_cod As String, ByVal p_ggclipr_cod As String)
        comboModosEnvio.Visible = True
        lblAgencia.Visible = False

        Dim list_series_ddl As New ArrayList
        'AMC_NE199. Reaprovisionamiento
        If Session("es_reaprovision") = "S" And Session("perfil_usuario") = "DIS" Then 'Si se clica en el punto de menu de la master en reaprovisiona, envia este QueryString
            'SI ES CLIENTE SOLO PUEDE HACER PEDIDOS DE VENTA.
            Dim tipo_r = ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona")
            Dim tipo_reapro As New BCb2b.CGGpedtip(tipo_r, GetLocalResourceObject("TipoPedidoReaprovisiona"))
            list_series_ddl.Add(tipo_reapro)
            DDLSeries.Enabled = False
        Else 'Lo habitual
            If (Session("perfil_usuario") <> "CL") Then
                'VOLVEMOS A COGER DATOS DEL CLI ACTUAL PARA VER SI HA CAMBIADO EL ESTADO.
                Dim cliente As New BCb2b.ggclipr(p_ggclipr_cod, p_empgrupo_cod, p_tip_vc)
                'AMC_NE218. JCE. 10/03/2016. COMPROBAR ESTADO DEL CLIENTE PARA VER SI PUEDE HACER O NO PEDIDOS
                Dim puede_hacer_pedido As Boolean = False
                Dim list_series_std As ArrayList = OBTENER_SERIES_PEDIDO() 'ESTÁNDAR
                For Each serie As BCb2b.CGGpedtip In list_series_std 'A MEDIDA.
                    If SERIE_PEDIDO_VALIDO(cliente.prop_COD, serie.PROP_cod) Then
                        list_series_ddl.Add(serie)
                        puede_hacer_pedido = True
                    End If
                Next
                If Not puede_hacer_pedido Then
                    'SI DEVUELVE VALOR ES QUE NO PUEDE, MOSTRAMOS MENSAJE Y REDIRIGE A CONSULTA.
                    ScriptManager.RegisterStartupScript(Me, Me.GetType(), "NoPuedesHacerPedidos", "ShowDialog('" & GetLocalResourceObject("MsgModalAtencion") & "','" & GetLocalResourceObject("MsgModalClienteMoroso") & "','info','PedidoConsulta.aspx',300);", True)
                End If
                'FIN AMC_NE218. JCE. 10/03/2016. COMPROBAR ESTADO DEL CLIENTE PARA VER SI PUEDE HACER O NO PEDIDOS

                DDLSeries.Enabled = True
            Else
                'SI ES CLIENTE SOLO PUEDE HACER PEDIDOS DE VENTA.
                Dim tipo_w = ConfigurationManager.AppSettings("tipo_pedido")
                Dim tipo_web As New BCb2b.CGGpedtip(tipo_w, GetLocalResourceObject("TipoPedidoWeb"))
                list_series_ddl.Add(tipo_web)
                DDLSeries.Enabled = False
                comboModosEnvio.Visible = False 'SI ES CLIENTE NO PUEDE CAMBIAR EL MODO DE ENVIO.
                lblAgencia.Visible = True
            End If
        End If

        DDLSeries.DataSource = list_series_ddl
        DDLSeries.SelectedIndex = 0
        DDLSeries.DataBind()
    End Sub
    Private Function GESTIONAR_ALMACEN_TRASPASO(ByVal gvagente_cod As String) As String
        Dim ggxxxcab As New BCb2b.GGXXXCAB(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), DDLSeries.SelectedValue, OracleNumber.Null)
        Dim cliente As New BCb2b.ggclipr()
        'OBTENEMOS EL CLI DEL AGENTE
        Dim cli_age As BCb2b.ggclipr = cliente.OBTENER_CODCLI_DE_AGE(ConfigurationManager.AppSettings("grupo"), gvagente_cod)
        'MIRAR SI TODO OK Y SINO MOSTRAR ALERTA Y NO DEJAR AVANZAR.
        Dim almacen_cod As String = ggxxxcab.OBTENER_ALMACEN_TRASPASO(cli_age.prop_COD)
        'SI DEVUELVE "ERROR" MOSTRAMOS UNA ALERTA
        GESTIONAR_ALMACEN_OBTENIDO(almacen_cod)
        Return almacen_cod
    End Function
    Private Sub GESTIONAR_ALMACEN_OBTENIDO(ByRef gaalnom_cod As String)
        If gaalnom_cod = "ERROR" Then
            'MOSTRAMOS ALERTA ALMACEN TRASPASO NO DEFINIDO
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "ErrorAlmacen", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("NoAlmacenDefinido") & "','err_red','PedidoConsulta.aspx',300);", True)
        End If
    End Sub
    Protected Sub ddlPortes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddlPortes.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Private Function DIME_SI_GESTIONAR_MINIMO_PORTES(ByVal ggclipr_prov As String) As Boolean
        Dim gestionar As Boolean = False
        Dim clasiProve As New BCb2b.CGGCLICLASI()
        If ggclipr_prov <> "" Then
            clasiProve = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), ggclipr_prov, ConfigurationManager.AppSettings("CLASI_PORTES_AGEPROV"))
        End If
        Return clasiProve.PROP_VALOR <> ""
    End Function

    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        BulkEditGridView1.DataBind()
    End Sub
End Class