Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Partial Class LOV_clasificaciones
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then
            'Dim el_Agente As String = ""
            Try
                control.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                control.Value = ""
            End Try
            Try
                control1.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                control1.Value = ""
            End Try
            Try
                control2.Value = Request.QueryString("textbox3").ToString()
            Catch ex As Exception
                control2.Value = ""
            End Try
            'Try
            '    el_Agente = Request.QueryString("agen").ToString()
            'Catch ex As Exception
            '    el_Agente = ""
            'End Try


            'sql = calcula_Sql(control1.Value)
            sql = calcula_Sql()
            Me.SetFocus(Me.TextBox1)


            conn.ConnectionString = conexion.cadena_conexion
            sql = sql.Replace("<SUSTITUIR>", TextBox1.Text)
            Dim respuesta As String
            Dim lista As New ArrayList
            lista.Clear()
            Try
                Dim valores As New BCb2b.CCargarLov()
                lista = valores.lista_lov_previsiones(sql)
            Catch escep As Exception
                respuesta = escep.Message()
            Finally
                DGBusqueda.DataSource = lista
                DGBusqueda.DataBind()
            End Try


        End If
    End Sub

    Public Function calcula_Sql() As String


        Dim EMPRESAGRUPO As String = ConfigurationManager.AppSettings("Grupo")
        Dim EMPRESA As String = ConfigurationManager.AppSettings("Empresa")
        Dim tip_vc As String = ConfigurationManager.AppSettings("Venta")
        Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        Dim IDIOMA_aux As String = Session("idioma")

        Dim idioma As String = ""
        'todo: coger idioma spyro.
        Select Case IDIOMA_aux
            Case "de-DE"
                idioma = "ALE"
            Case "it-IT"
                idioma = "IT"
            Case "es-ES"
                idioma = "CAS"
            Case "en-GB"
                idioma = "ING"
            Case "fr-FR"
                idioma = "FRA"
            Case Else
                idioma = "ING"
        End Select
       

        Dim cargamax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")
        Dim PUBLICO As String = ConfigurationManager.AppSettings("clasif_publico")
        Dim valor_publico As String = ConfigurationManager.AppSettings("clasif_valor")

        Dim param As New BCb2b.CParametros()
        Dim tipo_OPREV As String = param.dame_param("GGPREVPED_V_GGOFETIP")

        sql = " select * from ( "
        sql = sql & " SELECT DISTINCT GAART_COD as valor, "
        sql = sql & " nvl( (SELECT gaartdescr.descrip "
        sql = sql & " FROM gaartdescr, GGOBSTIP  "
        sql = sql & " WHERE "
        sql = sql & " GAARTDESCR.GGOBSTIP_COD = GGOBSTIP.COD AND "
        sql = sql & " GAARTDESCR.TIP_VC = GGOBSTIP.TIP_VCAP AND "
        sql = sql & " GGOBSTIP.COD = '" & obstip_articulo_idiomas & "' "
        sql = sql & " AND gaart_cod = AMC_GGOFELIN_VW.gaart_cod "
        sql = sql & " AND idiomas_cod = '" & idioma & "' "
        sql = sql & " AND tip_vc = GGOBSTIP.TIP_VCAP "
        sql = sql & " AND ggobstip_cod = '" & obstip_articulo_idiomas & "' "
        sql = sql & " AND empgrupo_cod = '" & EMPRESAGRUPO & "') , descrip) as descrip "
        sql = sql & " FROM AMC_GGOFELIN_VW "
        sql = sql & " WHERE "
        sql = sql & " GAART_COD <> '*'  AND "
        sql = sql & " EMPGRUPO_COD ='" & EMPRESAGRUPO & "' "
        sql = sql & " AND EMP_COD = '" & EMPRESA & "' "
        sql = sql & " AND TIP_VC = '" & tip_vc & "' "
        sql = sql & " AND GGOFETIP_COD = '" & tipo_OPREV & "' "

        Dim agente_sel As String = ""
        If Not Session("agente") Is Nothing And Session("tipo_usuario") <> "SVT" Then
            agente_sel = Session("agente").prop_cod
        End If

        If Session("ver_clientes") = "A" And agente_sel <> "" Then
            sql = sql & " AND GVAGENTE_COD = '" & agente_sel & "' "
        End If

        sql = sql & " AND IDIOMAS_COD = '" & idioma & "' and "
        sql = sql & " GAART_COD IN ( SELECT COD FROM GAART "
        sql = sql & " WHERE   ( gaart.F_VIGENCIA <= sysdate or gaart.f_vigencia is null) and "
        sql = sql & " ( gaart.F_BAJA > sysdate or gaart.F_BAJA is null) "
        sql = sql & " AND EMPGRUPO_COD = '" & EMPRESAGRUPO & "') "
        sql = sql & "  )  "
        sql = sql & " WHERE (upper(VALOR) LIKE '%<SUSTITUIR>%'  OR upper(DESCRIP) LIKE '%<SUSTITUIR>%')  "
        sql = sql & " order by VALOR  "


        Return sql
    End Function

    Public Sub dgBusquedaCommand(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            ' Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            '   Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                '   Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            'If V3 = "" Then
            '    V3 = ""
            'End If
            'If V3 = "&nbsp;" Then
            '    V3 = ""
            'End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            script(2) = V1
            script(3) = "';"
            script(4) = ""

            script(5) = "opener.document.getElementById('" + control1.Value + "').value ='"
            'script(5) = ""
            'opener.document.getElementById('ctl00_ContentPlaceHolder1_BulkEditGridView1_ctl02_lbldescrip_art')

            script(6) = V2
            script(7) = "';"
            ' script(6) = ""
            ' script(7) = ""
            script(8) = ""
            script(9) = ""
            'script(10) = "window.opener.document.forms[0]." + control2.Value + ".focus();"
            script(10) = "window.opener.document.forms[0]." + control1.Value + ".onchange(); window.opener.document.forms[0]." + control1.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control.Value + "Cod.value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control.Value + "Cod.focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Public Sub dgBusquedaCommandANTE(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            If V3 = "" Then
                V3 = ""
            End If
            If V3 = "&nbsp;" Then
                V3 = ""
            End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            'script(2) = V2
            script(2) = V1
            script(3) = "';"
            script(4) = "window.opener.document.forms[0]." + control1.Value + ".value ='"
            script(5) = V2
            script(6) = "';"
            script(7) = "window.opener.document.forms[0]." + control2.Value + ".value ='"
            script(8) = V3
            script(9) = "';"
            script(10) = "window.opener.document.forms[0]." + control1.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control.Value + "Cod.value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control.Value + "Cod.focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Protected Sub DGBusqueda_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles DGBusqueda.PageIndexChanged

        Dim lista As New ArrayList
        lista.Clear()
        Dim valores As New BCb2b.CCargarLov()
        sql = calcula_Sql()
        sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
        lista = valores.lista_lov_previsiones(sql)
        DGBusqueda.DataSource = lista

        DGBusqueda.CurrentPageIndex = e.NewPageIndex
        DGBusqueda.DataBind()
    End Sub

    Protected Sub btnbuscar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnbuscar.Click
        conn.ConnectionString = conexion.cadena_conexion

        sql = calcula_Sql()

        sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
        Dim respuesta As String
        Dim lista As New ArrayList
        lista.Clear()
        Try
            Dim valores As New BCb2b.CCargarLov()
            lista = valores.lista_lov_previsiones(sql)
        Catch escep As Exception
            respuesta = escep.Message()
        Finally
            DGBusqueda.CurrentPageIndex = 0
            DGBusqueda.DataSource = lista
            DGBusqueda.DataBind()
        End Try
    End Sub

End Class
