﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb
Imports CTI.Utilities.Log

Partial Class Lov_disponibilidad
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        'ESTO PARA EVITAR EL ERROR DEL __DOPOSTBACK()
        ClientScript.GetPostBackEventReference(Me, String.Empty)

        Ajax.Utility.RegisterTypeForAjax(GetType(Lov_disponibilidad))

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "ConfirmarAccion", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "lblConfAccion"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        If Not Page.IsPostBack Then
            'Cantidad introducida
            Try
                hdn_cant.Value = Request.QueryString("cant").ToString()
            Catch ex As Exception
                hdn_cant.Value = ""
            End Try

            'Cantidad disponible
            Try
                hdn_cantDisp.Value = Request.QueryString("cantDisp").ToString()
            Catch ex As Exception
                hdn_cantDisp.Value = ""
            End Try

            'Fecha prevista introducida
            Try
                hdn_fprev.Value = Request.QueryString("fprev").ToString()
            Catch ex As Exception
                hdn_fprev.Value = ""
            End Try

            'Fecha prevista disponible
            Try
                hdn_fprevDisp.Value = Request.QueryString("fprevDisp").ToString()
            Catch ex As Exception
                hdn_fprevDisp.Value = ""
            End Try

            'Código de país para calcular los dias minimos para la fecha confirmada
            Try
                hdn_paisDir.Value = Request.QueryString("paisDir").ToString()
            Catch ex As Exception
                hdn_paisDir.Value = ""
            End Try

            'Código del cliente para obtener su razon social
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("codCli").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try

            If hdn_ggclipr_cod.Value <> "" And hdn_paisDir.Value = "" Then
                Dim cli As New BCb2b.ggclipr(hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                hdn_paisDir.Value = pais_env(cli.prop_RSOCIAL_COD, "")
            End If


            'Control cantidad
            Try
                ctl_cant.Value = Request.QueryString("ctl_cant").ToString()
            Catch ex As Exception
                ctl_cant.Value = ""
            End Try

            'Control fecha prev
            Try
                ctl_fprev.Value = Request.QueryString("ctl_fprev").ToString()
            Catch ex As Exception
                ctl_fprev.Value = ""
            End Try

            'Control fecha conf
            Try
                ctl_fconf.Value = Request.QueryString("ctl_fconf").ToString()
            Catch ex As Exception
                ctl_fconf.Value = ""
            End Try

            liFPrev.Attributes.Add("onmouseup", "chkSel('" & rbtnFPrev.ClientID & "');return false;")
            liCUni1.Attributes.Add("onmouseup", "chkSel('" & rbtnCUni1.ClientID & "');return false;")

            GestionaTextosOpciones()
        End If
    End Sub
    Private Sub GestionaTextosOpciones()
        'lblTitu.Text = "Lo sentimos, no tenemos disponibilidad de " & hdn_cant.Value & " UN para la fecha " & hdn_fprev.Value & ". Por favor, seleccione una de las opciones:"
        lblTitu.Text = GetLocalResourceObject("lblTituResource1.Text")
        lblTitu.Text = lblTitu.Text.Replace("[c_uni1]", hdn_cant.Value)
        lblTitu.Text = lblTitu.Text.Replace("[f_prev]", hdn_fprev.Value)

        'lblCUni1.Text = "Hay disponible " & hdn_cantDisp.Value & " UN para la fecha " & hdn_fprev.Value & "."
        lblCUni1.Text = GetLocalResourceObject("lblCUni1Resource1.Text")
        lblCUni1.Text = lblCUni1.Text.Replace("[c_uni1]", hdn_cantDisp.Value)
        lblCUni1.Text = lblCUni1.Text.Replace("[f_prev]", hdn_fprev.Value)

        'lblFPrev.Text = "Dispondríamos de " & hdn_cant.Value & " UN la fecha " & hdn_fprevDisp.Value & "."
        lblFPrev.Text = GetLocalResourceObject("lblFPrevResource1.Text")
        lblFPrev.Text = lblFPrev.Text.Replace("[c_uni1]", hdn_cant.Value)
        lblFPrev.Text = lblFPrev.Text.Replace("[f_prev]", hdn_fprevDisp.Value)
    End Sub
    Private Function AsignarATextboxPadre(ByVal tbox_id As String, ByVal valor As String, Optional ByVal n_decim As String = "") As String
        Dim cadena As String = ""
        'cadena = cadena & "window.opener.document.forms[0]." + tbox_id + ".value ='" 'cantidad.
        cadena = cadena & "window.opener.document.getElementById('" & tbox_id & "').value ='" 'cantidad.
        If n_decim = "" Then
            cadena = cadena & valor
        Else
            cadena = cadena & FormatNumber(valor, CInt(n_decim))
        End If
        cadena = cadena & "';"
        Return cadena
    End Function
    'COPIADAS DE CREARPEDIDO PARA EL CALCULO DE FECHA CONFIRMADA
    Public Function dame_fecha_sumar_dias(ByVal fecha As String, ByVal dias As String) As String
        Dim mn As New BCb2b.MetodosNumericos()
        Dim fecha_resul As String = ""
        Try
            If fecha = "" Or IsDate(fecha) = False Then
                fecha = Now.ToShortDateString
            End If

            fecha_resul = mn.DameFechaSumaDias(fecha, dias)
        Catch ex As Exception
            Log.Error(ex, "[Lov_disponibilidad.dame_fecha_sumar_dias] date = {date} day = {day} ", fecha, dias)
        End Try

        Return fecha_resul
    End Function
    Function pais_env(ByVal rsocial_cod As String, ByVal rsocdir As String) As String
        Dim valor As String = ""
        Try
            Dim rsoc As New BCb2b.rsocdir()
            If rsocdir <> "" Then
                rsoc = New BCb2b.rsocdir(rsocial_cod, rsocdir, "")
            Else
                Dim soc As New BCb2b.CRSOCIAL(rsocial_cod)
                rsoc = New BCb2b.rsocdir(rsocial_cod, soc.PROP_RSOCDIR_COD, "")
            End If
            valor = rsoc.PROP_PAISES_COD

        Catch ex As Exception
            Log.Error(ex, "[Lov_disponibilidad.pais_env] rsoc = {rsoc} socdire = {socdire} ", rsocial_cod, rsocdir)
        End Try

        Return valor
    End Function
    Public Function dime_minimo_dias(ByVal codigo_pais As String) As String
        ' A ESTA FUNCIÓN LE LLEGA UN CODIGO DE PAIS DE TABLA.
        ' 1. CALCULAR EL ISO.
        Dim miPais As New BCb2b.CPaises(codigo_pais)
        Dim iso As String = miPais.prop_iso_cod

        ' 2. OBTENER EL CODIGO EQUIVALENTE EN CONFIRMS
        Dim cconfirm As New BCb2b.codigoConfirms()
        codigo_pais = cconfirm.ObtenerPaisConfirmsDeIso(iso, ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("ISO_CONFIRMS"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"))

        ' ESTA FUNCIÓN ESPERA, EL CODIGO DEL PAIS DE CONFIRMS.
        ' CUYO VALOR XXXI, con caracteristica ISO, COINCIDA CON EL ISO DEL PAIS DE LA DIRECCIÓN SELECCIONADA EN ENVÍO.
        ' EN CASO DE QUE ESTE NO EXISTA, COGE EL CORRESPONDIENTE VALOR RES DE CONFIRMS.

        Dim minimo_dias As String = ""
        Try
            Dim conn2 As New OracleConnection()
            Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
            Dim command As New OracleDataAdapter()
            conn2.ConnectionString = conexion.cadena_conexion

            Dim clasi_confirms_minimo As String = ""
            If codigo_pais = "" Then
                codigo_pais = ConfigurationManager.AppSettings("PAIS_DEF_FECHAS_MIN")
            End If

            clasi_confirms_minimo = codigo_pais & "M"

            Dim clasi As New BCb2b.GGCLACLASI()
            clasi.DAME_GGCLASIF_VALOR(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), clasi_confirms_minimo, ConfigurationManager.AppSettings("CLASI_DIAS_ENV"))
            minimo_dias = clasi.PROP_GGCLASIF_VALOR

            If minimo_dias = "" Then 'si no tiene minimo dicho pais cogemos de RESM
                clasi.DAME_GGCLASIF_VALOR(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), ConfigurationManager.AppSettings("PAIS_DEF_FECHAS_MIN") & "M", ConfigurationManager.AppSettings("CLASI_DIAS_ENV"))
                minimo_dias = clasi.PROP_GGCLASIF_VALOR
            End If
        Catch ex As Exception
            Log.Error(ex, "[Lov_disponibilidad.dime_minimo_dias] pais = {pais} ", codigo_pais)
        End Try

        Return minimo_dias
    End Function
    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        Dim script(6) As String
        script(0) = "<script>"
        If rbtnFPrev.Checked Then 'Nos quedamos con la fecha prevista disponible (quiere todas las unidades que ha pedido aunque se le cambie la fecha)
            script(1) = AsignarATextboxPadre(ctl_cant.Value, hdn_cant.Value)
            script(2) = AsignarATextboxPadre(ctl_fprev.Value, hdn_fprevDisp.Value)
            Dim dias_min As String = dime_minimo_dias(hdn_paisDir.Value)
            Dim f_conf As Date = CDate(dame_fecha_sumar_dias(hdn_fprevDisp.Value, CInt(dias_min).ToString)) 'Calculamos la confirmada correspondiente.
            script(3) = AsignarATextboxPadre(ctl_fconf.Value, FormatDateTime(f_conf, DateFormat.ShortDate))
            script(4) = "opener.changeMyElement('#" + ctl_fprev.Value + "');"
        ElseIf rbtnCUni1.Checked Then 'Nos quedamos con la cantidad disponible (quiere todas las unidades disponibles a la fecha seleccionada)
            script(1) = AsignarATextboxPadre(ctl_cant.Value, hdn_cantDisp.Value)
            script(2) = AsignarATextboxPadre(ctl_fprev.Value, hdn_fprev.Value)
            script(3) = "opener.changeMyElement('#" + ctl_cant.Value + "');"
            script(4) = ""
        End If
        script(5) = "self.close();"
        script(6) = "</" + "script>"
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub
End Class
