Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.IO
Imports CTI.Utilities.Log
Partial Class LOV_emails
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_emails))
        If Not Page.IsPostBack Then
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try
            Try
                hdn_gvagente_cod.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                hdn_gvagente_cod.Value = ""
            End Try

            Try
                hdn_ggpedtip_cod.Value = Request.QueryString("c1").ToString()
            Catch ex As Exception
                hdn_ggpedtip_cod.Value = ""
            End Try

            Try
                hdn_n_pedido.Value = Request.QueryString("textbox3").ToString()
            Catch ex As Exception
                hdn_n_pedido.Value = ""
            End Try

            Try
                hdn_n_pedido_rev.Value = Request.QueryString("n_rev").ToString()
            Catch ex As Exception
                hdn_n_pedido_rev.Value = ""
            End Try

            Try
                hdn_origen_ofe_ped.Value = Request.QueryString("origen").ToString()
            Catch ex As Exception
                hdn_origen_ofe_ped.Value = ""
            End Try

            Dim listaEmailsCli, listaTodosEmailsCli, listaEmailsAge As New ArrayList

            Dim emails As New BCb2b.CEnvio_Emails()
            'JCE --> TIP VC = C PORQUE ES DEL PROVEEDOR

            If (hdn_origen_ofe_ped.Value = "PED") Then
                listaEmailsAge = emails.DameDestinatariosAgente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), hdn_gvagente_cod.Value, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"))
                listaEmailsCli = emails.DameDestinatariosCliente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"))
                listaTodosEmailsCli = emails.DameDestinatariosCliente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, "", "", Session("idioma_spyro"))
                chk_enviar_con_desc.Visible = False
                lbl_enviar_con_desc.Visible = False

                'AMC_NE255. JCE. 30/08/16 Si estamos en pedido puede seleccionar contactos para guardar al pedido.
                TabPanelProgEnvio.Visible = True
                GVEmailCliT.Enabled = True
            ElseIf (hdn_origen_ofe_ped.Value = "OFE") Then
                listaEmailsAge = emails.DameDestinatariosAgente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), hdn_gvagente_cod.Value, ConfigurationManager.AppSettings("CLASI_EMAIL_O"), "S", Session("idioma_spyro"))
                listaEmailsCli = emails.DameDestinatariosCliente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("CLASI_EMAIL_O"), "S", Session("idioma_spyro"))
                chk_enviar_con_desc.Visible = True
                lbl_enviar_con_desc.Visible = True

                'AMC_NE255. JCE. 30/08/16 Si estamos en oferta no puede seleccionar contactos para guardar al pedido.
                TabPanelProgEnvio.Visible = False
                Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("lblNoHayClisAsoc"), "", "")
                GVEmailCliT.Enabled = False
                lblConfPedido.Visible = False

                Label1.Text = GetLocalResourceObject("enviarEmailsResource1.Text")
            End If

            If listaEmailsAge.Count = 0 Then
                Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("lblNoHayAgesAsoc"), "", "")
                listaEmailsAge.Add(emailcontactnulo)
                GVEmailDis.Enabled = False
            Else
                GVEmailDis.Enabled = True
            End If

            'Dim emailsCli As New BCb2b.CEnvio_Emails()
            'JCE --> TIP VC = V PORQUE ES CLIENTE DE VENTAS
            If listaEmailsCli.Count = 0 Then
                Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("lblNoHayClisAsoc"), "", "")
                listaEmailsCli.Add(emailcontactnulo)
                GVEmailCli.Enabled = False
            Else
                GVEmailCli.Enabled = True
            End If

            Dim PedModificable As Boolean = SITUACION_PEDIDO()

            GVEmailCliT.Enabled = True
            If listaTodosEmailsCli.Count = 0 Then
                Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("lblNoHayClisAsoc"), "", "")
                listaTodosEmailsCli.Add(emailcontactnulo)
                GVEmailCliT.Enabled = False
            ElseIf Not PedModificable Then
                GVEmailCliT.Enabled = False
            End If

            GVEmailCli.DataSource = listaEmailsCli
            GVEmailCli.DataBind()
            GVEmailCliT.DataSource = listaTodosEmailsCli
            GVEmailCliT.DataBind()
            GVEmailDis.DataSource = listaEmailsAge
            GVEmailDis.DataBind()
        End If
    End Sub


    Protected Function ObtenerEmailsCliCheckeados() As String
        Dim correosCliSel As String = ""
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCli.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim name As String = row.Cells(3).Text
                    correosCliSel = correosCliSel & name & ","
                End If
            End If
        Next
        Return correosCliSel
    End Function
    Protected Function ObtenerContactosCliCheckeados() As ArrayList
        Dim correosCliSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCli.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then

                    Dim Pkey As DataKey = GVEmailCli.DataKeys(row.RowIndex)

                    Dim vRsocialCod As String = Pkey.Item("prop_rsocial_cod")
                    Dim vContactipCod As String = Pkey.Item("prop_tipocontacto")
                    Dim vNombre As String = Pkey.Item("prop_nombrecontacto")
                    Dim correo As String = Pkey.Item("prop_destinatarios")

                    Dim cont As New BCb2b.CContactos(vRsocialCod, vContactipCod, vNombre, conexion.cadena_conexion)
                    correosCliSel.Add(cont)
                End If
            End If
        Next
        Return correosCliSel
    End Function
    Protected Function ObtenerEmailsDisCheckeados() As String
        Dim correosDisSel As String = ""
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailDis.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim name As String = row.Cells(3).Text
                    correosDisSel = correosDisSel & name & ","
                End If
            End If
        Next
        Return correosDisSel
    End Function
    Protected Function ObtenerContactosDisCheckeados(ByVal pGvagente_cod As String) As ArrayList
        Dim correosDisSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailDis.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then
                    Dim Pkey As DataKey = GVEmailDis.DataKeys(row.RowIndex)

                    Dim vRsocialCod As String = Pkey.Item("prop_rsocial_cod")
                    Dim vContactipCod As String = Pkey.Item("prop_tipocontacto")
                    Dim vNombre As String = Pkey.Item("prop_nombrecontacto")

                    Dim cont As New BCb2b.CContactos()
                    cont.ContactosAgente(pGvagente_cod, vContactipCod, vNombre, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("CLASI_EMAIL_O"), "S")
                    correosDisSel.Add(cont)
                End If
            End If
        Next
        Return correosDisSel
    End Function

    Protected Sub enviarEmails_Click(sender As Object, e As EventArgs) Handles enviarEmails.Click
        Dim cli As New BCb2b.ggclipr()
        cli = Session("cliente")
        Dim age As New BCb2b.CAgente(cli.prop_GVAGENTE_COD)
        Dim Prov As New BCb2b.ggclipr(age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"))

        Dim elorigen As String = hdn_origen_ofe_ped.Value
        Dim destinatarios As String = ""
        destinatarios = ObtenerEmailsCliCheckeados()
        destinatarios = destinatarios & ObtenerEmailsDisCheckeados()

        destinatarios = destinatarios & correosAdicionales.Text
        If destinatarios <> "" Then
            If destinatarios.LastIndexOf(",") = destinatarios.Length - 1 Then
                destinatarios = Mid(destinatarios, 1, destinatarios.Length - 1)
            End If
        End If

        If destinatarios <> "" Then
            Dim rutaFichero As String = ""
            Dim titulo As String = ""
            If (elorigen = "PED") Then
                Dim cabecera As New BCb2b.CCabeceraPedido(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), hdn_ggpedtip_cod.Value, hdn_n_pedido.Value)

                Dim plantilla As String = New PlantillaImpresion().DAME_PLANTILLA_IMPRESION_SEGUN_FPAGO_CLIENTE(Prov, cabecera, ConfigurationManager.AppSettings("FORMAS_PAGO_PROFORMA"))
                Try
                    Dim rep As New BCb2b.CGeneraReport()
                    rutaFichero = rep.B2B_GENERA_REPORT_PEDIDO(ConfigurationManager.AppSettings("ReportPedidos"), ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), hdn_n_pedido.Value, hdn_ggpedtip_cod.Value, "S", plantilla, ConfigurationManager.AppSettings("Pedido"), "", True)
                Catch ex As Exception
                    Log.Information(ex, "cabecera {cabecera}", cabecera) ', "No se ha podido generar el report.  grupo = {grupo} emp = {emp} tip = {tip} ggpedtip = {ggpedtip} nped = {nped}  plantilla = {plantilla} ", cabecera.prop_empgrupo_cod, cabecera.prop_emp_cod, ConfigurationManager.AppSettings("venta"), cabecera.prop_GGPEDTIP_COD, cabecera.prop_N_PEDIDO, plantilla)
                    'Throw New Exception(ex.Message.ToString)

                End Try

                titulo = GetLocalResourceObject("txtCopiaOfertaEmail") & " " & hdn_ggpedtip_cod.Value & " - " & hdn_n_pedido.Value
            ElseIf (elorigen = "OFE") Then
                Dim cabecera As New BCb2b.COferta_Cab(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), Session("TIPO_OFE"), Session("N_OFE"))
                Try
                    Dim v_muestra_total_sn As String = "S"
                    If Not Session("agente") Is Nothing Then
                        Dim clasi_prov As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_PROV_TOTAL_OFER"))
                        If clasi_prov.PROP_GGCLASIF_COD <> "" Then
                            v_muestra_total_sn = clasi_prov.PROP_GGCLASIF_COD
                        End If
                    End If

                    Dim rep As New BCb2b.CGeneraReport()
                    Dim imp_descuento As String = "S"
                    If Not chk_enviar_con_desc.Checked Then
                        imp_descuento = "N"
                    End If
                    rep.CB2B_GENERA_REPORT_OFERTA_REV(ConfigurationManager.AppSettings("ReportOfertas"), cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, ConfigurationManager.AppSettings("venta"), cabecera.prop_N_OFE, cabecera.prop_ggofetip_cod, "S", ConfigurationManager.AppSettings("PlantillaRepOfe"), ConfigurationManager.AppSettings("Oferta"), cabecera.prop_N_REVISION, True, imp_descuento, v_muestra_total_sn)
                Catch ex As Exception
                    Throw New Exception(ex.Message.ToString)
                End Try
                'rutaFichero = ConfigurationManager.AppSettings("rutaBaseFTPUpload") & ConfigurationManager.AppSettings("Dir_Oferta") & "/" & Now.Year & Now.Month & Now.Day & "_" & cabecera.prop_ggclipr_cod & "_" & cabecera.prop_ggofetip_cod & "_" & cabecera.prop_N_OFE & "_" & cabecera.prop_N_REVISION & ".pdf"

                rutaFichero = System.Configuration.ConfigurationManager.AppSettings("pathlocal") & "/" & Now.Year & Now.Month & Now.Day & "_" & cabecera.prop_ggclipr_cod & "_" & cabecera.prop_ggofetip_cod & "_" & cabecera.prop_N_OFE & "_" & cabecera.prop_N_REVISION & ".pdf"
                titulo = GetLocalResourceObject("txtCopiaOfertaEmail") & " " & Session("TIPO_OFE") & " - " & Session("N_OFE")
                If cabecera.prop_N_REVISION <> "" Then
                    titulo = titulo & " / " & " " & GetLocalResourceObject("txtRevisionEmail") & " " & cabecera.prop_N_REVISION
                End If
            End If

            Dim parametro As New BCb2b.CParametros()
            Dim host As String = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")
            Dim port As Int32 = CInt(ConfigurationManager.AppSettings("PUERTO_MAIL"))
            Dim user As String = ConfigurationManager.AppSettings("USU_MAIL")
            Dim password As String = ConfigurationManager.AppSettings("PASS_MAIL")

            'cuerpo del detalle
            Dim cadena As String = Session("cuerpo_html")
            'Session("cuerpo_email_html") = sw.GetStringBuilder().ToString()

            'AMC_NE168 CABECERA EMAILS
            Dim cabecera_emails As String = ""
            cabecera_emails = cabecera_emails & ""
            cabecera_emails = cabecera_emails & "<A HREF='http://b2b.amcsa.es' TARGET='_BLANK'><IMG SRC='http://b2b.amcsa.es/images/logoemp.bmp' WIDTH=135 HEIGHT=70 ALT='AMC-MECANOCAUCHO' BORDER='0'></A>"

            'AMC_NE168 FIRMA
            Dim firma_final As String = ""
            firma_final = firma_final & " <div style='clear:both !important;margin-bottom:10px;'><font size='1' face='Verdana, Arial, Helvetica, sans-serif'><strong><font color='#000099'>"
            firma_final = firma_final & " <br> "
            firma_final = firma_final & "        Aplicaciones Mecnicas del caucho<br> "
            firma_final = firma_final & "        Departamento de Ventas.AMC-MECANOCAUCHO </font></strong><br> "
            firma_final = firma_final & "        <font color='#000099'>Industrialdea Zona A Pab 35<br> "
            firma_final = firma_final & "        Asteasu E-20159 </font><br> "
            firma_final = firma_final & "        <strong>Tel:</strong> + 34 943 696102<br> "
            firma_final = firma_final & "        <strong>Fax:</strong> + 34 943 696219 <br> "
            firma_final = firma_final & "        <strong> e-mail:</strong> <a href='mailto:sales@amcsa.es'>sales@amcsa.es</a><br> "
            firma_final = firma_final & "        <strong>website:</strong> <a href='http://www.amcsa.es'>www.amcsa.es</a><br>  "
            firma_final = firma_final & "        <strong>website:</strong> <a href='http://b2b.amcsa.es'>b2b.amcsa.es</a>  "
            firma_final = firma_final & "        </font></div>"

            Dim CUERPO As String = ""

            CUERPO = "<html><head><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/Content/Site.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/layout.css"" type=""text/css"" media=""all""/><link rel=""stylesheet"" href=""http://b2b.amcsa.es/Ofertas/App_Themes/general/general.css"" type=""text/css"" media=""all""/><style>@import url(""http://b2b.amcsa.es/Ofertas/Content/Site.css"");</style></head><body>"

            Dim texto_adicional As String = txtContenidoAdicional.Text
            CUERPO = CUERPO & cabecera_emails & "<br/><br/>"
            CUERPO = CUERPO & texto_adicional & "<br/><br/>"
            CUERPO = CUERPO & cadena & "<br/><br/>" & firma_final
            CUERPO = CUERPO & "</body></html>"

            'CUERPO = Replace(CUERPO, "<tr class=""titu_observaciones"" style=""text-align:left;"">", "<tr style=""visibility:hidden !important;display:none !important;"">")
            'CUERPO = Replace(CUERPO, "<tr class=""lineas_observaciones"" style=""text-align:left;"">", "<tr class=""lineas_observaciones"" style=""text-align:left;visibility:hidden !important;display:none !important;"">")
            CUERPO = Replace(CUERPO, "Content/images/", "http://b2b.amcsa.es/Ofertas/Content/images/")
            CUERPO = Replace(CUERPO, "<table border=""0""", "<table border=""0"" align=""left"" style=""border:1px solid !important;margin-bottom:10px !important;width:80%;""")
            CUERPO = Replace(CUERPO, "<th", "<th style=""color:#ffffff !important;background:#0081C6 !important;padding:10px !important;""")
            CUERPO = Replace(CUERPO, "id=""leyendaEstado""", "id=""leyendaEstado"" style=""visibility:hidden !important;display:none !important;""")



            Dim mailing As New BCb2b.EnviarMail()
            Try
                Dim enviado As String = ""

                'todo: revisar.
                If (Not String.IsNullOrEmpty(rutaFichero) AndAlso File.Exists(rutaFichero)) Then
                    enviado = mailing.SendMail(host, port, user, password, ConfigurationManager.AppSettings("EmailFrom"), ConfigurationManager.AppSettings("EmailFrom"), user, destinatarios, titulo, CUERPO, False, rutaFichero)
                Else
                    enviado = mailing.SendMail(host, port, user, password, ConfigurationManager.AppSettings("EmailFrom"), ConfigurationManager.AppSettings("EmailFrom"), user, destinatarios, titulo, CUERPO, False, "")
                End If
                Session("DESTINATARIOS_EMAIL") = destinatarios
            Catch ex As Exception
            End Try

            Dim listaContactosChecksCli As New ArrayList
            Dim listaContactosChecksDis As New ArrayList
            listaContactosChecksCli = ObtenerContactosCliCheckeados()
            listaContactosChecksDis = ObtenerContactosDisCheckeados(cli.prop_GVAGENTE_COD)

            Dim USRORI As String = ConfigurationManager.AppSettings("USRORI")
            Dim USRDEST As String = ConfigurationManager.AppSettings("USRDEST")
            Dim TIPOMENSAJE As String = ConfigurationManager.AppSettings("TIPOMENSAJE")
            Dim COD_DESCR_DOC As String = ConfigurationManager.AppSettings("COD_DESCR_DOC")

            Dim cuerpo_seg As String = ""
            cuerpo_seg = "<<<" & ConfigurationManager.AppSettings("PATRON_SEGUI") & ">>><<<" & correosAdicionales.Text & ">>>" & txtContenidoAdicional.Text

            'cuerpo_seg = cuerpo_seg & CUERPO

            'AMC_NE092. SEGUIMIENTO DE MAILS ENVIADOS
            Dim seg As New BCb2b.usrmail()
            seg.usrmail_insertar_seguimiento_amc(cli.prop_EMPGRUPO_COD, cli.prop_TIP_VC, cli.prop_COD, cli.prop_RSOCIAL_COD, Prov.prop_RSOCIAL_COD, titulo, cuerpo_seg, USRORI, USRDEST, TIPOMENSAJE, listaContactosChecksCli, listaContactosChecksDis, COD_DESCR_DOC, rutaFichero)

        End If

        'If (elorigen = "PED") Then
        '    Response.Redirect("PedidoDetalle.aspx", False)
        'ElseIf (elorigen = "OFE") Then
        '    Response.Redirect("OfertaDetalle.aspx", False)
        'End If

        ScriptManager.RegisterClientScriptBlock(Me.Page, Me.GetType, Guid.NewGuid().ToString(), "window.close();", True)

    End Sub

    Protected Sub GVEmailCliT_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVEmailCliT.RowDataBound
        'AMC_NE255. JCE. 31/08/2016. Obtenemos los contactos del cliente, y los asociados al pedido checkeados.
        If hdn_origen_ofe_ped.Value = "PED" Then
            If e.Row.RowType = DataControlRowType.DataRow Then
                Dim ind As Integer
                Integer.TryParse(e.Row.RowIndex, ind)

                Dim Pkey As DataKeyArray = GVEmailCliT.DataKeys

                Dim vRsocialCod As String = Pkey.Item(ind).Item("prop_rsocial_cod")
                Dim vContactipCod As String = Pkey.Item(ind).Item("prop_tipocontacto")
                Dim vNombre As String = Pkey.Item(ind).Item("prop_nombrecontacto")

                Dim chk As New CheckBox
                chk = e.Row.FindControl("chkRowT")
                chk.Checked = False
                If Not vRsocialCod Is Nothing Then
                    'COMPROBAR SI CADA CONTACTO ESTA EN EL PEDIDO Y SI ES AS CHECKEAR.
                    Dim cont As New BCb2b.GGPEDCONTDEF()
                    chk.Checked = cont.ExisteContacto(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), hdn_ggpedtip_cod.Value, hdn_n_pedido.Value, vRsocialCod, vContactipCod, vNombre, ConfigurationManager.AppSettings("tipoEnv"))
                    chk.Attributes.Add("onclick", "javascript:comprobar_chk(this,'" & vRsocialCod & "','" & vContactipCod & "','" & vNombre & "','" & hdn_ggpedtip_cod.Value & "','" & hdn_n_pedido.Value & "');")
                End If
            End If
        End If
    End Sub

    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function AsignarODesasignarContPed(ByVal pRsocialCod As String, ByVal pContactipCod As String, ByVal pNombre As String, ByVal pGgpedtipCod As String, ByVal pNPedido As String, ByVal pAsignar As Boolean) As String
        'AMC_NE255. JCE. 31/08/2016. Al checkear o descheckear un contacto lo asigna o desasigna del pedido.
        Dim error_asign As String = ""

        Dim cont As New BCb2b.GGPEDCONTDEF()
        Try
            If pAsignar Then
                'LO ASIGNAMOS AL PEDIDO
                cont.GGPEDCONTDEF_ACTUALIZA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), pGgpedtipCod, CType(pNPedido, OracleNumber), ConfigurationManager.AppSettings("tipoEnv"), pRsocialCod, pContactipCod, pNombre, ConfigurationManager.AppSettings("opcionInsertar"))
            Else
                'LO DESASIGNAMOS DEL PEDIDO
                cont.GGPEDCONTDEF_ACTUALIZA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), pGgpedtipCod, CType(pNPedido, OracleNumber), ConfigurationManager.AppSettings("tipoEnv"), pRsocialCod, pContactipCod, pNombre, ConfigurationManager.AppSettings("opcionBorrar"))
            End If
        Catch ex As Exception
            error_asign = ex.Message
            Log.Error(ex, "[Lov_emails.AsignarODesasignarContPed]: Error asignando/desasignando contacto a ped. tipoped = {tipoped} nped = {nped} rsoc = {rsoc} contactip = {contactip} nombre = {nombre} ", pGgpedtipCod, pNPedido, pRsocialCod, pContactipCod, pNombre)
        End Try

        Return error_asign
    End Function
    Public Function SITUACION_PEDIDO() As Boolean
        Dim vPedModificable As Boolean = False
        If hdn_ggpedtip_cod.Value <> "" And hdn_n_pedido.Value <> "" Then
            'ESTANDAR.
            vPedModificable = BCb2b.GGPEDCAB.PED_PERMITE_REV(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), _
                                                             ConfigurationManager.AppSettings("venta"), hdn_ggpedtip_cod.Value, hdn_n_pedido.Value, _
                                                             ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                             ConfigurationManager.AppSettings("bbdd"))
            'AMC A MEDIDA.
            If vPedModificable Then
                vPedModificable = Not BCb2b_AMC.GGPEDCAB.PEDIDO_B2B_REVISADO_AMC(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), _
                                                                             ConfigurationManager.AppSettings("venta"), hdn_ggpedtip_cod.Value, hdn_n_pedido.Value, _
                                                                             ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), _
                                                                             ConfigurationManager.AppSettings("bbdd"))
            End If
        End If
        Return vPedModificable
    End Function
End Class
