Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Partial Class LOV_poblaciones
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            Try
                hdn_pais_cod.Value = Request.QueryString("pais").ToString()
            Catch ex As Exception
                hdn_pais_cod.Value = ""
            End Try
            Try
                hdn_cod_postal.Value = Request.QueryString("postal").ToString()
            Catch ex As Exception
                hdn_cod_postal.Value = ""
            End Try
            Try
                ctl_cod_postal.Value = Request.QueryString("ctlcodpostal").ToString()
            Catch ex As Exception
                ctl_cod_postal.Value = ""
            End Try
            Try
                ctl_cod_poblac.Value = Request.QueryString("ctlcodpoblac").ToString()
            Catch ex As Exception
                ctl_cod_poblac.Value = ""
            End Try
            Try
                ctl_cod_provi.Value = Request.QueryString("ctlcodprovi").ToString()
            Catch ex As Exception
                ctl_cod_provi.Value = ""
            End Try
            Try
                ctl_nom_poblac.Value = Request.QueryString("ctlnompoblac").ToString()
            Catch ex As Exception
                ctl_nom_poblac.Value = ""
            End Try

            If hdn_pais_cod.Value <> "" And hdn_cod_postal.Value <> "" Then
                CargarPoblaciones(hdn_pais_cod.Value, hdn_cod_postal.Value)
            End If
        End If
    End Sub
    Private Sub CargarPoblaciones(ByVal pPaisesCod As String, ByVal pCodPostal As String)
        Dim listado_poblacs As New ArrayList
        Dim pob As New BCb2b.CPoblaciones()
        listado_poblacs = pob.obtener_poblaciones(pPaisesCod, "", "", pCodPostal)

        'Excluimos la poblacin cuyo cdigo no tiene _
        listado_poblacs = ExcluirPoblacion(listado_poblacs)

        GVPoblaciones.DataSource = listado_poblacs
        GVPoblaciones.DataBind()
    End Sub
    Private Function ExcluirPoblacion(ByVal pListadoPoblac As ArrayList) As ArrayList
        'Excluyo la poblacin cuyo codigo de poblacin no tenga _
        ' Ejem: 48260   --> ZIZURKIL/ASTEASU --> Ocultariamos esta.
        '       48260_1 --> ASTEASU
        '       48260_2 --> ZIZURKIL

        Dim listado_aux As New ArrayList
        For Each poblac As BCb2b.CPoblaciones In pListadoPoblac
            If poblac.PROP_COD.Contains("_") Then
                listado_aux.Add(poblac)
            End If
        Next
        Return listado_aux
    End Function
    Protected Sub GVPoblaciones_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GVPoblaciones.RowCommand
        Dim rowIndex As Integer = Integer.Parse(e.CommandArgument.ToString())
        Dim vProviCod As String = GVPoblaciones.DataKeys(rowIndex)("prop_provi_cod")
        Dim vPoblacCod As String = GVPoblaciones.DataKeys(rowIndex)("prop_cod")
        Dim vPoblacNom As String = GVPoblaciones.DataKeys(rowIndex)("prop_nombre")
        Dim vCodPostal As String = GVPoblaciones.DataKeys(rowIndex)("prop_cod_postal")
        If e.CommandName = "Select" Then
            Dim script(8) As String
            script(1) = "<script>"
            script(2) = "window.opener.document.forms[0]." + ctl_cod_provi.Value + ".value = '" & vProviCod & "';"
            script(3) = "window.opener.document.forms[0]." + ctl_cod_poblac.Value + ".value = '" & vPoblacCod & "';"
            script(4) = "window.opener.document.forms[0]." + ctl_nom_poblac.Value + ".value = '" & vPoblacNom & "';"
            script(5) = "window.opener.document.forms[0]." + ctl_cod_postal.Value + ".value = '" & vCodPostal & "';"
            script(6) = "self.close();"
            script(7) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("Poblaciones", Join(script, ""))
        End If
    End Sub
End Class