Imports System.Data
Imports System.Data.OleDb

Partial Class MasterCliPage
    Inherits System.Web.UI.MasterPage

    Public ReadOnly Property Model() As Object
        Get
            Return ""
        End Get
    End Property



    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Cargamos el script de idiomas de manera dinmica.
        Dim cultura As String
        Try
            cultura = Request.Cookies("_culture").Value
            If cultura = "" Then
                cultura = "es"
            End If
        Catch ex As Exception
            cultura = "es"
        End Try
        Try
            'SACADO DE INTERIOR DEL IF ANTERIOR YA QUE SOLO VALDRIA CON AGENTES Y LOS IDIOMAS HAY QUE CARGARLOS SIEMPRE
            If Not Page.IsPostBack Then
                'CARGAR IDIOMAS DESDE PARAMETRO B2B_IDIOMAS
                DDLIdidomas.Items.Clear()
                Dim listaIdiomas As New ArrayList
                Dim listaIdiomasFinal As New ArrayList
                Dim idiomasL As New BCb2b.idiomas
                listaIdiomas = idiomasL.listado_idiomas_param_b2b_idiomas(ConfigurationManager.AppSettings("B2B_IDIOMAS"))
                Dim i As Integer = 0
                For i = 0 To listaIdiomas.Count - 1
                    Dim idi As New BCb2b.idiomas()
                    idi = listaIdiomas.Item(i)
                    Dim idifinal As New BCb2b.idiomas()
                    idifinal.dameDatosIdioma(idi.prop_idioma, idi.prop_idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_IDIOMAS"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_IDIOMAS"))
                    listaIdiomasFinal.Add(idifinal)
                Next i
                DDLIdidomas.DataSource = listaIdiomasFinal
                DDLIdidomas.DataTextField = "prop_descrip"
                DDLIdidomas.DataValueField = "prop_culture"
                DDLIdidomas.DataBind()

                If (Not Session("idioma") Is Nothing) Then
                    DDLIdidomas.SelectedValue = Session("idioma")
                End If
            End If

            'Dim ruta As String = "c:\temp\jce\identi.txt"
            'Dim escritor As IO.StreamWriter
            'escritor = IO.File.AppendText(ruta)

            'escritor.WriteLine(" ")
            'escritor.WriteLine("---ANTES DE IDEN--- " & Now & " ------")

            'escritor.WriteLine("sess_perfil: " & Session("perfil_usuario"))

            Dim usuario As New BCb2b.CUsrnom()
            Dim usuario_age As New BCb2b.gvagente()
            If Not Session("usuario") Is Nothing Then
                Dim cod_usu As String = ""
                If Session("perfil_usuario") = "DIS" Then
                    Dim age As New BCb2b.gvagente()
                    age = Session("agente")

                    'escritor.WriteLine("disss: " & age.prop_COD)

                    'OBTENGO EL CLIENTE DEL DISTRIBUIDOR EL CUAL TIENE SU USUARIO Y PASSWORD.
                    Dim cli As New BCb2b.ggclipr()
                    Dim cod_cli As String = cli.DameCliDeRSocial(ConfigurationManager.AppSettings("grupo"), age.prop_COD, ConfigurationManager.AppSettings("compra"))
                    Dim clasi_USU As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, ConfigurationManager.AppSettings("ClasifLogin"))
                    cod_usu = clasi_USU.PROP_VALOR
                ElseIf Session("perfil_usuario") = "CL" Then
                    Dim cli As New BCb2b.ggclipr()
                    cli = Session("cliente")
                    Dim clasi_USU As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cli.prop_COD, ConfigurationManager.AppSettings("ClasifLogin"))
                    cod_usu = clasi_USU.PROP_VALOR

                    'escritor.WriteLine("cl: " & cod_usu)
                Else
                    usuario = Session("usuario")
                    cod_usu = usuario.PROP_COD

                    'escritor.WriteLine("otro: " & cod_usu)
                End If
                Call IdentificarUsuarioLogeado(Session("perfil_usuario"), cod_usu)
            Else
                Response.Redirect("~/Expirado.aspx")
            End If
        Catch ex As Exception
            CTI.Utilities.Log.Log.Error(ex, "[MasterPage.Load]")
        End Try
        'escritor.WriteLine("-------------")
        'escritor.WriteLine(" ")
        'escritor.Flush()
        'escritor.Close()
    End Sub


    Protected Sub DDLIdidomas_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLIdidomas.SelectedIndexChanged
        Session("idioma") = DDLIdidomas.SelectedValue
        Page.Response.Redirect(Page.Request.Url.ToString(), True)
    End Sub

    'Protected Sub IBCrearOferta_Click(sender As Object, e As ImageClickEventArgs) Handles IBCrearOferta.Click
    '    'server transfer a crear ofe.

    '    'Dim cabecera As New BCb2b.COferta_Cab(cliente, ConfigurationManager.AppSettings("empresa"), DDLSeries.SelectedItem.Value, _
    '    ' ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), AGENTE, tboxRefCli.Text, tboxAtte.Text, direccion_envio, Session("cliente").prop_rsoccondi_DEF)

    '    ' Dim cabecera As New BCb2b.COferta_Cab()
    '    Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)

    '    Session("cabecera") = Nothing
    '    Session("lineasOferta") = list_LINEAS
    '    Response.Redirect("CrearOferta.aspx")
    'End Sub

    'Protected Sub IBCrearOferta_Click(sender As Object, e As System.EventArgs) Handles IBCrearOferta.Click
    '    'server transfer a crear ofe.

    '    'Dim cabecera As New BCb2b.COferta_Cab(cliente, ConfigurationManager.AppSettings("empresa"), DDLSeries.SelectedItem.Value, _
    '    ' ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), AGENTE, tboxRefCli.Text, tboxAtte.Text, direccion_envio, Session("cliente").prop_rsoccondi_DEF)

    '    ' Dim cabecera As New BCb2b.COferta_Cab()
    '    Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)

    '    Session("cabecera") = Nothing
    '    Session("cabeceraPed") = Nothing
    '    Session("calculos") = Nothing
    '    Session("lineasOferta") = list_LINEAS
    '    Response.Redirect(ResolveClientUrl("~/CrearOferta.aspx"))
    'End Sub


    'Protected Sub IBlListadoOfertas_Click(sender As Object, e As ImageClickEventArgs) Handles IBlListadoOfertas.Click
    '    Response.Redirect("OfertasConsulta.aspx")
    'End Sub
    Protected Sub IBlListadoOfertas_Click(sender As Object, e As System.EventArgs) Handles IBlListadoOfertas.Click
        Response.Redirect(ResolveClientUrl("~/OfertasConsulta.aspx"))
    End Sub
    'Protected Sub IBlCrearCliente_Click(sender As Object, e As ImageClickEventArgs) Handles IBlCrearCliente.Click
    '    Response.Redirect("CrearCliente.aspx")
    'End Sub
    'Protected Sub IBlCrearCliente_Click(sender As Object, e As System.EventArgs) Handles IBlCrearCliente.Click
    '    Dim cli As New BCb2b.ggclipr()
    '    Session("new_cliente") = cli
    '    Response.Redirect(ResolveClientUrl("~/CrearCliente.aspx"))
    'End Sub
    'Protected Sub IBlListadoClientes_Click(sender As Object, e As ImageClickEventArgs) Handles IBlListadoClientes.Click
    '    Response.Redirect("SelCliente.aspx")
    'End Sub
    'Protected Sub IBlListadoClientes_Click(sender As Object, e As System.EventArgs) Handles IBlListadoClientes.Click
    '    'Response.Redirect("SelCliente.aspx")
    '    Response.Redirect("~/BusquedaClientes.aspx")
    'End Sub

    Protected Sub IBCrearPedido_Click(sender As Object, e As System.EventArgs) Handles IBCrearPedido.Click

        Dim list_LINEAS As New List(Of BCb2b.CLineaPedidoOff)

        Session("cabecera") = Nothing
        Session("cabeceraPed") = Nothing
        Session("lineasPedido") = list_LINEAS
        Session("calculos") = Nothing
        Response.Redirect("~/PrevioPedido.aspx")
    End Sub

    Protected Sub IBListadoPedidos_Click(sender As Object, e As System.EventArgs) Handles IBListadoPedidos.Click
        Response.Redirect("~/PedidoConsulta.aspx")
    End Sub

    'Protected Sub IBlSeguimiento_Click(sender As Object, e As EventArgs) Handles IBlSeguimiento.Click
    '    Response.Redirect(ResolveClientUrl("~/Seguimiento.aspx"))
    'End Sub

    'Protected Sub IBlListadoPrevisiones_Click(sender As Object, e As EventArgs) Handles IBlListadoPrevisiones.Click
    '    Response.Redirect("~/PrevisionesConsulta.aspx")
    'End Sub
    'Protected Sub IBlCrearMensaje_Click(sender As Object, e As EventArgs) Handles IBlCrearMensaje.Click
    '    Response.Redirect(ResolveClientUrl("~/SeguimientoCrear.aspx"))
    'End Sub

    Protected Sub IBlCalculos_Click(sender As Object, e As EventArgs) Handles IBlCalculos.Click
        Response.Redirect(ResolveClientUrl("~/Proyectos/lista_proyectos.aspx"))
    End Sub

    'Public Sub IdentificarUsuarioLogeado()

    '    Dim codUsuario As String = ""

    '    'estas lineas es porque la variable session("usuario") desde ofertas es string y desde proyectos es Cusrnom y daba error segun desde donde entrases.
    '    Try
    '        'por aqui entraria desde proyectos
    '        Dim usuario As New BCb2b.CUsrnom()
    '        usuario = Session("usuario")
    '        codUsuario = usuario.PROP_NOMBRE
    '    Catch ex As Exception
    '        'por aqui entraria desde ofertas
    '        codUsuario = Session("usuario")
    '    End Try
    '    Dim perfil_usu As String = ""
    '    If Not codUsuario Is Nothing Then
    '        Dim identificar_usuario As New BCb2b.CUsrnom(codUsuario)
    '        Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
    '        Dim transaccion_perfil_usu As IDbTransaction
    '        transaccion_perfil_usu = conexionole.BeginTransaction
    '        Dim usu As New BCb2b.CUsuarios()
    '        perfil_usu = usu.DamePerfilUsuario(AMC_B2B_PKG.AMC_B2B_PKG.DAME_PERFILES(transaccion_perfil_usu, ConfigurationManager.AppSettings("grupo"), identificar_usuario.PROP_COD.ToUpper, identificar_usuario.PROP_PASSWORD))
    '    End If

    '    If perfil_usu = "INGENIERO" Then
    '        Session("tipo_usuario") = "ING"
    '        Session("perfil_usuario") = "ING"
    '    End If
    '    Dim tipo_usuario As String = Session("tipo_usuario")

    '    If Not codUsuario Is Nothing And Not tipo_usuario Is Nothing Then
    '        'ESTO CAMBIAR EL TEXTO SEGUN EL TIPO DE USUARIO
    '        'MIRAR LOCALRESOURCES TipoUsuING, TipoUsuCL, TipoUsuAG
    '        lblAgente.Text = GetLocalResourceObject("TipoUsu_" & tipo_usuario.ToUpper) & " "
    '        If Not Session("agente") Is Nothing Then
    '            Dim agente As New BCb2b.gvagente()
    '            agente = Session("agente")
    '            lblNombreAgente.Text = agente.prop_NOMBRE
    '        End If

    '        If Session("cliente") Is Nothing Then
    '            lblNombreCliente.Text = GetLocalResourceObject("NoCliSelec") 'Sin cliente seleccionado.
    '        Else
    '            Dim cli As New BCb2b.ggclipr()
    '            cli = Session("cliente")
    '            lblNombreCliente.Text = cli.prop_NOMBRE
    '            If tipo_usuario = "ING" Then
    '                lblNombreAgente.Text = codUsuario
    '            Else
    '                If Not Session("agente") Is Nothing Then
    '                    Dim age As New BCb2b.gvagente()
    '                    age = Session("agente")
    '                    lblNombreAgente.Text = age.prop_NOMBRE
    '                Else
    '                    Dim age2 = New BCb2b.CAgente(cli.prop_GVAGENTE_COD)
    '                    lblNombreAgente.Text = age2.prop_nombre
    '                End If
    '            End If
    '        End If


    '        'ESTO QUEDARIA ASI--> Bienvenido Ingeniero: IGOR o Bienvenido Agente: Sebastian Wuttke
    '    Else
    '        lblNombreAgente.Visible = False
    '        lblAgente.Visible = False
    '        lbltitSeleccionarCliente.Visible = False
    '        lblNombreCliente.Visible = False
    '    End If

    'End Sub
    Private Function ObtenerUsuPassDeUsrnom(ByVal usu_logueado As String, ByRef USER As String, ByRef PASSWORD As String) As BCb2b.CUsrnom
        Dim usuario As New BCb2b.CUsrnom(usu_logueado)
        If Not usuario.PROP_COD Is Nothing Then
            Session("usuario") = usuario

            USER = usuario.PROP_COD
            PASSWORD = usuario.PROP_PASSWORD
        End If
        Return usuario
    End Function
    Private Sub ObtenerUsuPassDeClasiCli(ByVal usu_logueado As String, ByVal ggcliprCod As String, ByRef USER As String, ByRef PASSWORD As String)
        Dim clasi_USU As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ggcliprCod, ConfigurationManager.AppSettings("ClasifLogin"))
        Dim clasi_PASS As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ggcliprCod, ConfigurationManager.AppSettings("ClasifPass"))
        USER = clasi_USU.PROP_VALOR
        PASSWORD = clasi_PASS.PROP_VALOR
    End Sub
    Private Function ObtenerPerfilBDUsuario(ByVal usu_logueado As String, ByVal USER As String, ByVal PASSWORD As String) As String
        Dim perfil_usu As String = ""
        Try
            If Not usu_logueado Is Nothing Then
                Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                Dim transaccion_perfil_usu As IDbTransaction
                transaccion_perfil_usu = conexionole.BeginTransaction
                Dim usu As New BCb2b.CUsuarios()
                Try
                    perfil_usu = usu.DamePerfilUsuario(AMC_B2B_PKG.AMC_B2B_PKG.DAME_PERFILES(transaccion_perfil_usu, ConfigurationManager.AppSettings("grupo"), USER.ToUpper, PASSWORD.ToUpper))
                    transaccion_perfil_usu.Commit()
                Catch ex As Exception
                    transaccion_perfil_usu.Rollback()
                End Try
                transaccion_perfil_usu.Dispose()
            End If
        Catch ex As Exception

        End Try

        Return perfil_usu
    End Function
    Private Function GestionaPerfilBDUsuario(ByVal perfil_bd As String) As String
        Select Case perfil_bd
            Case "CLIENTE"
                perfil_bd = "CL"
            Case "AGENTE"
                perfil_bd = "AG"
            Case "DISTRIBUIDOR"
                perfil_bd = "DIS"
            Case "INGENIERO"
                perfil_bd = "ING"
            Case "SUPERVENTAS"
                perfil_bd = "SVT"
            Case "SUPERCOMPRAS"
                perfil_bd = "SCP"
            Case Else
                perfil_bd = "CL"
        End Select
        Return perfil_bd
    End Function
    Private Sub GestionarUsuarioMenu(ByVal tipo_usuario As String, ByVal nombre_a_mostrar As String)
        Dim cli As New BCb2b.ggclipr()
        lblAgente.Text = GetLocalResourceObject("TipoUsu_" & tipo_usuario.ToUpper) & " "

        If Session("cliente") Is Nothing Then
            lblNombreCliente.Text = GetLocalResourceObject("NoCliSelec") 'Sin cliente seleccionado.
        Else
            cli = Session("cliente")
            lblNombreCliente.Text = cli.prop_NOMBRE
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(tipo_usuario)
        If perfiles.prop_TIPO_PERFIL = 0 Then 'ING,SVT,SCP
            lblNombreAgente.Text = nombre_a_mostrar
        Else
            If Not Session("agente") Is Nothing Then 'AGENTES
                Dim age As New BCb2b.gvagente()
                age = Session("agente")
                lblNombreAgente.Text = age.prop_NOMBRE
            Else
                If perfiles.prop_TIPO_PERFIL <> 2 Then 'DISTRIBUIDORES
                    Dim age2 = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                    lblNombreAgente.Text = age2.prop_NOMBRE
                Else 'CLIENTES
                    lblNombreAgente.Text = cli.prop_NOMBRE
                    lbltitSeleccionarCliente.Visible = False
                    lblNombreCliente.Visible = False
                End If
            End If
        End If
    End Sub
    Public Sub IdentificarUsuarioLogeado(ByVal tipo_usuario As String, ByVal usu_logueado As String)
        Dim USER As String = ""
        Dim PASSWORD As String = ""
        Dim nombre_mostrar As String = ""
        If usu_logueado <> "" Then
            Select Case tipo_usuario
                Case "SVT", "SCP", "ING", "AG"
                    Dim usu As New BCb2b.CUsrnom()
                    usu = ObtenerUsuPassDeUsrnom(usu_logueado, USER, PASSWORD)
                    tipo_usuario = GestionaPerfilBDUsuario(ObtenerPerfilBDUsuario(usu_logueado, USER, PASSWORD))
                    Session("ver_clientes") = IIf(tipo_usuario = "AG", "A", "T")
                    nombre_mostrar = IIf(tipo_usuario = "AG", usu.PROP_NOMBRE, usu.PROP_COD)
                    If tipo_usuario = "ING" Then
                        Session("agente") = Nothing
                    End If
                Case "DIS"
                    Dim cli As New BCb2b.ggclipr()
                    Dim cod_cli As String = cli.DameCliDeRSocial(ConfigurationManager.AppSettings("grupo"), Session("agente").prop_COD, ConfigurationManager.AppSettings("compra"))
                    ObtenerUsuPassDeClasiCli(usu_logueado, cod_cli, USER, PASSWORD)
                    tipo_usuario = GestionaPerfilBDUsuario(ObtenerPerfilBDUsuario(usu_logueado, USER, PASSWORD))
                    Session("ver_clientes") = "A"
                    nombre_mostrar = USER
                Case "CL"
                    ObtenerUsuPassDeClasiCli(usu_logueado, Session("cliente").prop_cod, USER, PASSWORD)
                    tipo_usuario = GestionaPerfilBDUsuario(ObtenerPerfilBDUsuario(usu_logueado, USER, PASSWORD))
                    nombre_mostrar = USER
                Case Else
                    Response.Redirect("~/Expirado.aspx")
            End Select

            Session("tipo_usuario") = tipo_usuario
            Session("perfil_usuario") = tipo_usuario

            GestionarUsuarioMenu(tipo_usuario, nombre_mostrar)
        End If
    End Sub

    'Protected Sub IBOrderInbox_Click(sender As Object, e As EventArgs) Handles IBOrderInbox.Click
    '    Response.Redirect("OrderInbox.aspx")
    'End Sub
End Class

