
Imports System.IO
Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Diagnostics


Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports BCb2b
Imports System.Data.SqlClient

'para pasar a pdf.
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.text.html
Imports iTextSharp.text.html.simpleparser
Imports iTextSharp.tool.xml
Imports System.Data.OracleClient
Imports System.Data.OleDb
Imports CTI.Utilities.Log

Partial Class _oferta_validar
    Inherits claseBase

    Private NOFE As String
    Private TIPOOFE As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private lineas As List(Of BCb2b.COferta_linOff)
    Private _trasaccion As IDbTransaction

    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.NOFE
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOOFE
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Private Property trasaccion As IDbTransaction
        Get
            Return _trasaccion
        End Get
        Set(value As IDbTransaction)
            _trasaccion = value
        End Set
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'HABILITAMOS LOS MENSAJES MODALES
        Dim dame_error As String = "1"
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        Try
            'JCE. 16/09/2016. COMPROBAMOS QUE HAY CABECERA Y LINEAS, SINO REDIRIGIMOS.
            Dim list_lineas_aux As New List(Of BCb2b.COferta_linOff)
            list_lineas_aux = Session("lineasOferta")
            If Session("cabecera") Is Nothing Or list_lineas_aux.Count = 0 Then
                Response.Redirect("OfertasConsulta.aspx")
            End If

            If Not Page.IsPostBack Then

                lblatencion_confim_calc.Visible = False
                div_lblatencion_confim_calc.Visible = False
                lblatencion_confim_calc.Text = ""

                Dim origen_PROP_GRUPO, origen_PROP_EMPRESA, origen_PROP_TIPVC, origen_PROP_TIPO_OFE_SEL, origen_PROP_N_OFE_SEL As String
                origen_PROP_GRUPO = ""
                origen_PROP_EMPRESA = ""
                origen_PROP_TIPVC = ""
                origen_PROP_TIPO_OFE_SEL = ""
                origen_PROP_N_OFE_SEL = ""
                dame_error = dame_error & "2"

                Dim origen_lineas As New List(Of BCb2b.COferta_linOff)
                origen_lineas = Nothing


                If (Not Session("cliente") Is Nothing) Then

                    'Me.NOFE = origen_PROP_N_OFE_SEL
                    'Me.TIPOOFE = origen_PROP_TIPO_OFE_SEL
                    'Me.EMPRESA = origen_PROP_EMPRESA
                    'Me.GRUPO = origen_PROP_GRUPO
                    Me.TIPVC = ConfigurationManager.AppSettings("VENTA")
                    ' Me.lineas = origen_lineas

                    'solo vamos a mostrar las lneas que no tengan error.
                    Me.lineas = Session("lineasOferta")

                    Dim cliente As New BCb2b.ggclipr()
                    cliente = Session("cliente")
                    Dim lineasAux As New List(Of BCb2b.COferta_linOff)
                    Dim cabecera As New BCb2b.COferta_Cab()
                    cabecera = Session("cabecera")
                    dame_error = dame_error & "2"
                    Dim numeroLinea As Integer = 0
                    For Each element As BCb2b.COferta_linOff In Me.lineas
                        If Not element.prop_errorCosto And element.prop_GAART_COD <> "" Then
                            'controlo que no sea un error de costo y que la lnea no sea vacia por algn motivo.
                            element.asignarNlin = numeroLinea
                            lineasAux.Add(element)
                            numeroLinea = numeroLinea + 1

                            'AQUI MIRO SI LA LINEA TIENE PREC ESPECIAL PARA PINTARLA DE OTRO COLOR.
                            'SI ES EL ARTICULO ESP NO SE INSERTARA COMO PRECIO ESPECIAL.
                            Try
                                dame_error = dame_error & "3"
                                If element.prop_GAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And element.prop_EQUI_UNPR = "" Then
                                    Dim precioEspecial As New BCb2b.crearPrecioEspecial(cabecera, element)
                                    Dim esPrecNuevo As Boolean = precioEspecial.dimeSiNuevoPrecEspecial(ConfigurationManager.AppSettings("grupo"), cabecera.prop_ggclipr_cod, element.prop_GAART_COD, element.prop_C_UNI1, element.prop_I_NETOEMP)

                                    If esPrecNuevo = True Then
                                        element.prop_ES_PRECIO_ESP = True
                                    Else
                                        element.prop_ES_PRECIO_ESP = False
                                    End If
                                Else
                                    element.prop_ES_PRECIO_ESP = False
                                End If

                            Catch ex As Exception
                                Log.Error(ex, "[OfertaValidar.dimeSiNuevoPrecEspecial] cab_ofe = {@cab_ofe} linea = {@linea} ", cabecera, element)
                                dame_error = dame_error & "4" & ex.Message.ToString
                            End Try
                        End If
                    Next

                    Me.lineas = lineasAux

                    dame_error = dame_error & "5"
                    Session("lineasOferta") = Me.lineas

                    Dim lin_aux As New BCb2b.COferta_linOff()
                    lin_aux = Me.lineas(0)
                    dame_error = dame_error & "5.1 " & lin_aux.prop_GAART_COD
                    RDP.DataSource = Session("lineasOferta")
                    dame_error = dame_error & "5.2"
                    If Not Page.IsPostBack Then
                        Try

                            'ERROR BINDEANDO SIN EL TRY
                            RDP.DataBind()
                        Catch ex As Exception
                            dame_error = dame_error & " 5.3 ..." & ex.Message.ToString
                        End Try
                    End If
                    dame_error = dame_error & "6"
                    Dim cliente_cabecera As New BCb2b.ggclipr(cabecera.prop_ggclipr_cod, cabecera.prop_EMPGRUPO_COD, cabecera.prop_tip_Vc)
                    lblNombreCli.Text = cliente_cabecera.prop_NOMBRE


                    dame_error = dame_error & "7"
                    'If cliente_cabecera.prop_PORTES_PD = "P" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesPagadosDescrip.Text").ToString()
                    'ElseIf cliente_cabecera.prop_PORTES_PD = "D" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesDebidosDescrip.Text").ToString()
                    'End If
                    lblRSocial.Text = cliente_cabecera.prop_RSOCIAL_COD

                    Dim raz_social As New BCb2b.CRSOCIAL(cliente_cabecera.prop_RSOCIAL_COD)
                    lblRSocialNombre.Text = raz_social.PROP_NOMBRE
                    dame_error = dame_error & "8"
                    'LE PASO EL cliente_cabecera.prop_GGMENVIO_COD PORQUE SI NO TIENE MODOS DE ENVIO DEFINIDOS EN LA OBSER DEL PROVEEDOR PARA QUE PONGA ESA.
                    cargarListadoModosEnvio(cliente_cabecera.prop_GGMENVIO_COD, Session("idioma_spyro"))
                    'OBTENEMOS EL MODO DE ENVIO DE LA CABECERA
                    comboModosEnvio.SelectedValue = cabecera.prop_GGMENVIO_COD
                    lblAgencia.Text = comboModosEnvio.SelectedItem.Text

                    dame_error = dame_error & "9"
                    'Dim traduc As New BCb2b.CSPTRADDATOS()
                    'lblAgencia.Text = traduc.DameTraduccion(ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("ING_SPYRO"), cliente_cabecera.prop_GGMENVIO_COD)
                    'If lblAgencia.Text = "" Then
                    '    lblAgencia.Text = cliente_cabecera.prop_GGMENVIO_desc
                    'End If

                    'Cabecera datos bloque 1
                    lblNOferta.Text = cabecera.prop_N_OFE
                    lblFOferta.Text = cabecera.prop_F_OFE
                    lblRefCli.Text = cabecera.prop_su_ref_OFE
                    'If cabecera.prop_PORTPAG_SN = "S" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesPagadosDescrip.Text").ToString()
                    'ElseIf cabecera.prop_PORTPAG_SN = "N" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesDebidosDescrip.Text").ToString()
                    'End If
                    dame_error = dame_error & "10"
                    lblSerie.Text = cabecera.prop_ggofetip_Desc
                    lblSerieCod.Text = cabecera.prop_ggofetip_cod()
                    lblatte.Text = cabecera.prop_ATTE()
                    lblEstado.Text = cabecera.prop_ggestado_cod
                    lblObservacion.Text = cabecera.prop_OBSERVACION_dEFECTO
                    'sra
                    lblRefCli.Text = Session("cabecera").prop_su_ref_OFE
                    lblatte.Text = Session("cabecera").prop_ATTE
                    'cargar observacion de la oferta creada que estamos revisando
                    lblObservacion.Text = Session("cabecera").prop_OBSERVACION_dEFECTO
                    'cargar observacion de pie de la oferta creada que estamos revisando
                    lblObservacion_pie.Text = cabecera.prop_OBSERVACION_pie
                    dame_error = dame_error & "11"

                    Dim calc As New AMC_Proyectos_pkg.CCalculos()
                    Dim listado_calculos As New ArrayList
                    listado_calculos = cabecera.prop_LISTADO_IDDISTRIBUCION
                    If listado_calculos.Count = 0 Then 'si los pierde lo obtenemos.
                        listado_calculos = calc.DameCalculosDeOferta(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, cabecera.prop_N_REVISION)
                    End If

                    'calculo asociado
                    If listado_calculos.Count > 0 Then
                        Dim ggestcampa_cod As String = ""
                        lblCalculoAsoc.Text = ""
                        For Each calculo As AMC_Proyectos_pkg.CCalculos In listado_calculos
                            ggestcampa_cod = calculo.prop_idestudio.PadLeft(10, "0")
                            Dim revision As String = calculo.prop_revision
                            Dim observacion As String = calculo.prop_observaciones

                            lblCalculoAsoc.Text = lblCalculoAsoc.Text & observacion & ","
                        Next
                        lblCalculoAsoc.Text = lblCalculoAsoc.Text.Remove(lblCalculoAsoc.Text.LastIndexOf(","))
                        lblCalculoAsoc.Text = ggestcampa_cod & " (" & lblCalculoAsoc.Text & ")"

                        If ggestcampa_cod <> "" Then
                            cabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
                        Else
                            lblcalcasoctitu.Visible = False
                            lblCalculoAsoc.Visible = False
                        End If

                        lblatencion_confim_calc.Visible = True
                        div_lblatencion_confim_calc.Visible = True
                        lblatencion_confim_calc.Text = GetLocalResourceObject("lblAtenConfirCalc")
                        If lblCalculoAsoc.Text <> "" Then
                            lblatencion_confim_calc.Text = lblatencion_confim_calc.Text & " " & lblCalculoAsoc.Text
                        End If
                    Else
                        lblcalcasoctitu.Visible = False
                        lblCalculoAsoc.Visible = False
                        lblatencion_confim_calc.Visible = False
                        div_lblatencion_confim_calc.Visible = False
                        lblatencion_confim_calc.Text = ""
                    End If

                    'PREPARADO POR SI NO HAY AGENTE: INGENIEROS..
                    Dim ggclipr_prov As String = ""
                    If Not Session("agente") Is Nothing Then
                        Dim ag As New BCb2b.gvagente()
                        ag = Session("agente")
                        ggclipr_prov = ag.prop_GGCLIPR_PROV
                    Else
                        'Dim age As New CAgente(cliente.prop_GVAGENTE_COD)
                        Dim age As New BCb2b.gvagente(cliente.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                        ggclipr_prov = age.prop_GGCLIPR_PROV
                    End If
                    dame_error = dame_error & "12"
                    Dim ggcliprobs As New BCb2b.GGCLIPROBS(cabecera.prop_EMPGRUPO_COD, ConfigurationManager.AppSettings("Compra"), ggclipr_prov, ConfigurationManager.AppSettings("OBCA"))
                    txtObservacion_cabecera.Text = ggcliprobs.PROP_COMENTARIO
                    cabecera.prop_OBSERVACION_cabecera = ggcliprobs.PROP_COMENTARIO



                    'observacion titulo
                    Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("GGOFECAB_GGOBSTIP_TITULO"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                    Dim PARAM_OBS As String = PARAMETRO.prop_VALOR
                    Dim ggOFEobs As New BCb2b.CObs_oferta()
                    Dim ggOFEobs_titulo As New BCb2b.CObs_oferta(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOOFE, Me.NOFE, PARAM_OBS)
                    lblTitulo.Text = ggOFEobs_titulo.prop_OBSER
                    dame_error = dame_error & "13"
                    'Cabecera datos bloque 2
                    Dim Direnvio As New BCb2b.CDirecciones()
                    Direnvio = cabecera.prop_dir_envio()
                    hfdirenvio.Value = Direnvio.PROP_COD
                    lblDir.Text = Direnvio.PROP_DIR
                    lblCP.Text = Direnvio.PROP_COD_POSTAL()
                    lblProvi.Text = Direnvio.PROP_PROVI_NOM()
                    lblPoblacion.Text = Direnvio.PROP_POBLAC_NOM()
                    lblpais.Text = Direnvio.PROP_PAISES_nom()
                    lblFax.Text = Direnvio.PROP_TELEFAX()
                    lblTfono.Text = Direnvio.PROP_TELEFONOS()
                    Dim uti As New BCb2b.Utilities()
                    If uti.IsMobileBrowser() = True Then
                        lblTfono.NavigateUrl = uti.DameMailtoTelefono(Direnvio.PROP_TELEFONOS())
                        lblTfono.CssClass = ""
                    Else
                        lblTfono.NavigateUrl = ""
                        lblTfono.CssClass = "HyperlinkSinStyles"
                    End If

                    'cargar forma de pago
                    'Dim forma_pago As New BCb2b.CFPago
                    'forma_pago = cliente_cabecera.prop_forma_pago
                    ''TRADUCIR FORMA DE PAGO
                    'forma_pago.DameDatosFPago(forma_pago.PROP_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                    'lblFormadepago.Text = forma_pago.PROP_DESCRIP

                    'AMC_NE243. JCE. 07/06/16. FORMA DE PAGO INGENIERO. Pueden modificarla en la pantalla de crearoferta, por lo tanto seleccionamos la de la cabecera.
                    '-----CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT
                    '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
                    Dim perfiles As New BCb2b.USUARIOS_B2B()
                    perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

                    Dim param As New BCb2b.CParametros()
                    Dim fpago As String = ""

                    If perfiles.prop_TIPO_PERFIL = 0 Then 'ING o SVT
                        fpago = cabecera.prop_FORMA_DE_PAGO
                    Else
                        'LO HABITUAL
                        If cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
                            fpago = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
                        Else
                            fpago = cliente.prop_forma_pago.PROP_COD
                        End If
                    End If

                    Dim forma_pago As New BCb2b.CFPago()
                    forma_pago.DameDatosFPago(fpago, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"))
                    lblFormadepago.Text = forma_pago.PROP_DESCRIP
                    '-----------------------------------------------

                    'Pie 
                    lblObservacion.Text = cabecera.prop_OBSERVACION_dEFECTO
                    dame_error = dame_error & "14"

                    Dim obs As New BCb2b.CObs_oferta(origen_PROP_GRUPO, origen_PROP_EMPRESA, origen_PROP_TIPVC, origen_PROP_TIPO_OFE_SEL, origen_PROP_N_OFE_SEL, System.Configuration.ConfigurationManager.AppSettings("Obs_defecto_Ofertas"))

                Else
                    If (Not Session("agente") Is Nothing) Then
                        'Response.Redirect("SelCliente.aspx", False)
                        Response.Redirect("BusquedaClientes.aspx", False)
                    Else
                        'Response.Redirect("index.aspx", False)
                        Response.Redirect("~/Expirado.aspx", False)
                    End If
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Load] var_error = {var_error}", dame_error)
            'lblObservacion.Text = dame_error & " " & ex.Message.ToString
        End Try
    End Sub
    Private Function VALIDAR_USUARIO(ByVal usuario_txt As String, ByVal password_txt As String, ByRef age As BCb2b.gvagente) As Boolean
        Dim es_valido As Boolean = False
        If Session("Usuario").prop_cod.ToString.ToUpper = txtLogin.Text.ToUpper Then
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            Dim usuario As New BCb2b.CUsrnom()
            Dim usuario_aux As New BCb2b.CUsuarios()
            If perfiles.prop_TIPO_PERFIL = 0 Then 'svt ing
                If Session("perfil_usuario") = "ING" Then
                    Dim RESULTADO As String = usuario_aux.es_ingeniero(usuario_txt.ToUpper, password_txt.ToUpper)
                    es_valido = (RESULTADO <> "")
                Else 'svt
                    usuario = New BCb2b.CUsrnom(Session("usuario").prop_cod)
                    age = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                    es_valido = age.prop_validado And age.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            ElseIf perfiles.prop_TIPO_PERFIL = 1 Then 'dis y age
                If Session("perfil_usuario") = "DIS" Then
                    Dim RESULTADO As String = usuario_aux.es_agenteConDeposito(txtLogin.Text.ToUpper, tboxClave.Text.ToUpper, Session("agente").prop_cod)
                    es_valido = (RESULTADO <> "")
                    age = Session("AGENTE")
                Else
                    age = New BCb2b.gvagente(txtLogin.Text.ToUpper, tboxClave.Text.ToUpper, ConfigurationManager.AppSettings("GRUPO"), "N")
                    es_valido = age.prop_validado And age.prop_USRNOM_COD = Session("agente").prop_usrnom_cod
                End If
            End If
        End If

        Return es_valido
    End Function
    Private Function ObtenerAgente(ByVal cliente As BCb2b.ggclipr) As Decimal
        Dim vGvagenteCod As Decimal = Nothing
        If Not Session("agente") Is Nothing Then
            vGvagenteCod = Session("agente").prop_cod()
        Else
            If cliente.prop_GVAGENTE_COD <> "" Then
                vGvagenteCod = CDbl(cliente.prop_GVAGENTE_COD)
            End If
        End If
        Return vGvagenteCod
    End Function
    Private Sub GestionarFormaDePago(ByRef cabecera As BCb2b.COferta_Cab, ByVal cliente As BCb2b.ggclipr)
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        'AMC_NE243. JCE. 07/06/16. Ingenieros pueden elegir fpago a convenir, clientes pc o pot con "A Convenir"
        Dim condi As New BCb2b.CRSoccondi()
        'SI LA CABECERA VIENE SIN RSOCCONDI_COD PERO CON FORMA DE PAGO
        If cabecera.prop_RSOCCONDI_COD = "" And cabecera.prop_FORMA_DE_PAGO <> "" Then
            'BUSCAMOS EL RSOCCONDI_COD DE LA FORMA DE PAGO DEL CLIENTE
            condi.RSOCCONDI_POR_FPAGO(cliente.prop_RSOCIAL_COD, cabecera.prop_FORMA_DE_PAGO)
            If condi.PROP_COD = "" Then
                'NO EXISTE RSOCCONDI CON LA FORMA DE PAGO SELECCIONADA, ASIQUE LA INSERTAMOS
                'BUSCAMOS UN NUEVO RSOCCONDI_COD QUE NO EXISTA: W, W1, W2 ...
                Dim rsoccondi_aux As String = ConfigurationManager.AppSettings("COD_RSOCCONDI_A_COVENIR") 'W
                condi.Nuevo(cliente.prop_RSOCIAL_COD, rsoccondi_aux)
                Dim i As Integer = 1
                Do While condi.PROP_COD <> "" Or i = 1
                    rsoccondi_aux = ConfigurationManager.AppSettings("COD_RSOCCONDI_A_COVENIR") & i.ToString
                    condi.Nuevo(cliente.prop_RSOCIAL_COD, rsoccondi_aux)
                    i += 1
                Loop

                'INSERTAMOS
                condi = New BCb2b.CRSoccondi(cliente.prop_RSOCIAL_COD)
                condi.rsoccondi_insertar_transaction(transaccion, cabecera.prop_FORMA_DE_PAGO, rsoccondi_aux, "WEB")

                'COMPROBAMOS QUE HA INSERTADO BIEN OBTENIENDO EL RSOCCONDI_COD INSERTADO.
                condi.RSOCCONDI_POR_FPAGO(cliente.prop_RSOCIAL_COD, cabecera.prop_FORMA_DE_PAGO)
            End If
            cabecera.prop_RSOCCONDI_COD = condi.PROP_COD
        End If
        Session("cabecera") = cabecera
    End Sub
    Private Sub CargarCabeceraOferta(ByRef cabecera As BCb2b.COferta_Cab, ByRef cliente As BCb2b.ggclipr, ByVal pGvagenteCod As String)
        'CAMBIO EL MODO DE ENVIO POR DEFECTO DEL CLIENTE PARA QUE A LA HORA DE INSERTAR COJA EL QUE A SELECCIONADO DEL COMBO DE MODOS DE ENVIO
        cliente.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue

        If Session("cabecera") Is Nothing Then
            '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
            Dim param As New BCb2b.CParametros()
            Dim valor_param_fp As String = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
            '-----------------------------------------------

            cabecera = New BCb2b.COferta_Cab(cliente, ConfigurationManager.AppSettings("empresa"), lblSerieCod.Text, _
            ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), pGvagenteCod, lblRefCli.Text, lblatte.Text, hfdirenvio.Value, "", valor_param_fp, lblNOferta.Text)
        Else
            cabecera = Session("cabecera")
        End If

        lblNOferta.Text = cabecera.prop_N_OFE
    End Sub
    Private Sub CrearCabeceraOferta(ByRef cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff)
        Dim es_nueva As Boolean = linea.prop_N_OFE = ""
        If (es_nueva) Then
            cabecera.insertar_cabecera_oferta()
        Else
            cabecera.crearRevisionOferta(ConfigurationManager.AppSettings("conexion_ole"), linea.prop_N_OFE, lblRefCli.Text, lblatte.Text, lblRSocial.Text, hfdirenvio.Value, comboModosEnvio.SelectedValue)
        End If

        'AMC_NE243. JCE. 07/06/16. Modificar cabecera de la oferta con la forma de pago seleccionada.
        Dim ofe_cab As New BCb2b.GGOFECAB()
        ofe_cab.GGOFECAB_MODIFICA(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, cabecera.prop_su_ref_OFE, cabecera.prop_ATTE, cabecera.prop_dir_envio.PROP_COD, "", "", "", cabecera.prop_RSOCCONDI_COD, cabecera.prop_GGMENVIO_COD)
    End Sub
    Private Function InsertarLinea(ByVal cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff) As Integer
        Dim lineaaux As New BCb2b.COferta_lin()
        Try
            lineaaux.insertar_linea_oferta(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, Nothing, linea.prop_GAART_COD, linea.prop_DESCRIP, linea.prop_C_UNI1, linea.prop_PR_PRECIO, Nothing, Nothing, linea.prop_GGCLIPR_COD, linea.prop_descuento_lin, linea.prop_C_UNIPR, linea.prop_GAUNITIP_PR)
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.InsertarLineaOferta] cab = {@cab} lin = {@lin} ", cabecera, linea)
            Throw
        End Try
        Return lineaaux.prop_N_LIN
    End Function
    Private Sub ActualizarDescuentosLinea(ByVal cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff, ByVal pNLin As String)
        'actualizamos el descuento.
        Dim linea_dto As New BCb2b.ggofedtol(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_serie, cabecera.prop_N_OFE, pNLin, "WEB", "S")
        linea_dto.actualizar_dto_b2b(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_serie, cabecera.prop_N_OFE, pNLin, "WEB", linea.prop_descuento_B2B)
    End Sub
    Private Sub ActualizarPlazoLinea(ByVal cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff, ByVal pNLin As String)
        'ACTUALIZAMOS EL PLAZO
        Dim plazo As New ggxxxlobs(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, pNLin, ConfigurationManager.AppSettings("OBPZ"))
        plazo.GGXXXLOBS_INSERTAR(linea.prop_plazo, "O")
    End Sub
    Private Sub InsertarTirasRollosLinea(ByVal cabecera As BCb2b.COferta_Cab, ByVal linea As BCb2b.COferta_linOff, ByVal pNLin As String)
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))

        'JCE. 05/09/2016. UNIFICADO CON PEDIDOS PARA QUE ESTN IGUAL.
        If (Not String.IsNullOrEmpty(pNLin)) Then
            'INSERTAMOS CLASIFICACIONES DE TIRAS Y ROLLOS.
            INSERTAR_TIRAS_ROLLOS(conexionole, linea, cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, pNLin, "OFE", Session("perfil_usuario"))
        End If
    End Sub
    Private Sub AsociarCalculos(ByVal cabecera As BCb2b.COferta_Cab)
        Dim listado_calculos As New ArrayList
        listado_calculos = cabecera.prop_LISTADO_IDDISTRIBUCION

        For Each calculo As AMC_Proyectos_pkg.CCalculos In listado_calculos
            Dim iddistribucion_calculo As String = ""
            iddistribucion_calculo = calculo.prop_iddistribucion

            'LLAMAMOS A AMC_ACTUALIZAR_ADISTRIBUCION PARA ASOCIAR EL CALCULO A LA OFERTA
            If iddistribucion_calculo <> "" Then
                Dim msg_info, msg_error As String
                msg_info = ""
                msg_error = ""

                Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                Dim transaccion_ASOCIAR_OFE_A_CALC As IDbTransaction
                transaccion_ASOCIAR_OFE_A_CALC = conexionole.BeginTransaction
                Try
                    Dim num_rev As Integer = 0
                    If cabecera.prop_N_OFE_REV.ToString <> "Null" And cabecera.prop_N_OFE_REV.ToString <> "1" Then
                        num_rev = cabecera.prop_N_OFE_REV
                    Else
                        num_rev = cabecera.prop_N_REVISION
                    End If
                    AMC_ACTUALIZAR_ADISTRIBUCION_CS.AMC_ACTUALIZAR_ADISTRIBUCION_CS.AMC_ACTUALIZAR_ADISTRIBUCION(transaccion_ASOCIAR_OFE_A_CALC, iddistribucion_calculo, cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, num_rev, msg_info, msg_error)
                    transaccion_ASOCIAR_OFE_A_CALC.Commit()
                Catch ex As Exception
                    Log.Error(ex, "[OfertaValidar.AsociarOferta a Calculo] iddistribuci = {iddistribuci} cab = {@cab} ", iddistribucion_calculo, cabecera)
                    transaccion_ASOCIAR_OFE_A_CALC.Rollback()
                Finally
                    transaccion_ASOCIAR_OFE_A_CALC.Dispose()
                End Try
            End If
        Next
    End Sub
    Private Sub InsertarObservaciones(ByRef cabecera As BCb2b.COferta_Cab)
        Dim la_observacion_pie As String = ""
        Dim la_observacion_cabecera As String = ""
        Dim PARAM_OBS As String = ""
        Try
            'inserto observacion parametrizada si no es vaca al crear la cabecera
            Dim la_observacion As String = lblObservacion.Text
            If Not (la_observacion = "") Then
                Dim ggOFEobs As New BCb2b.CObs_oferta(cabecera, la_observacion, ConfigurationManager.AppSettings("Obs_defecto_ofertas"))
                ggOFEobs.ggOFEobs_insertar()

                cabecera.prop_OBSERVACION_dEFECTO = la_observacion
            End If

            Dim la_observacion_AUT As String = txtLogin.Text & " " & Now().ToString("dd/MM/yyyy HH:mm")


            Dim ggOFEobsAUT As New BCb2b.CObs_oferta(cabecera, la_observacion_AUT, "AUT")
            ggOFEobsAUT.ggOFEobs_insertar()

            'inserto observacion pie oferta
            la_observacion_pie = lblObservacion_pie.Text
            Dim PARAMETRO2 As New BCb2b.empparam(ConfigurationManager.AppSettings("AMC_OFER_OBS_PIE"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            PARAM_OBS = PARAMETRO2.prop_VALOR
            Dim ggOFEobs2 As New BCb2b.CObs_oferta(cabecera, la_observacion_pie, PARAM_OBS)
            ggOFEobs2.ggOFEobs_insertar()
            'ggOFEobs2.MODIFICAR_OBS("", vOBSER)

            'inserto observacion cabecera oferta. AMC_NE120
            la_observacion_cabecera = txtObservacion_cabecera.Text
            Dim ggOFEobsCab As New BCb2b.CObs_oferta(cabecera, la_observacion_cabecera, ConfigurationManager.AppSettings("OBCA"))
            ggOFEobsCab.ggOFEobs_insertar()
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Insertar Observaciones] cab = {@cab} obs_pie = {obs_pie} obs_cab = {obs_cab} obs_param = {obs_param} ", cabecera, la_observacion_pie, la_observacion_cabecera, PARAM_OBS)
        End Try
    End Sub
    Private Sub ActualizarEstadoCabecera(ByVal cabecera As BCb2b.COferta_Cab, ByVal cliente As BCb2b.ggclipr)
        'JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.
        Dim estado_aux As String = ConfigurationManager.AppSettings("ESTADO_ACTIVO")
        Dim ggxxccab As New BCb2b.GGXXXCAB(cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, cabecera.prop_tip_Vc, cabecera.prop_ggofetip_cod, cabecera.prop_N_OFE, cliente.prop_COD, OracleNumber.Null, estado_aux, cabecera.prop_HIST_SN, Now.Date)
        estado_aux = ggxxccab.GGXXXCAB_CALCULA_ESTADO_GGXXXCAB(ConfigurationManager.AppSettings("Oferta"))
        ggxxccab.GGXXXCAB_ACTUALIZA_ESTADO_CABECERA(estado_aux, ConfigurationManager.AppSettings("Oferta"))
        'FIN JCE. 09/03/2016. AMC_NE217. GGXXXCAB_CALCULA_ESTADO_GGXXXCAB. OBTENEMOS ESTADO CON EL QUE SE CREARA LA CABECERA.
    End Sub
    Private Function GenerarReportOferta(ByVal cabecera As BCb2b.COferta_Cab) As String
        Dim RutaOfe As String = ""
        Dim n_rev As String = ""
        Try
            Dim rep As New BCb2b.CGeneraReport()
            n_rev = cabecera.prop_N_OFE_REV
            If n_rev = "Null" Then
                n_rev = 1 'si el campo es Null esque es nueva oferta y ponemos 1.
            End If

            Dim v_muestra_total_sn As String = "S"
            If Not Session("agente") Is Nothing Then
                Dim clasi_prov As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), Session("agente").prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("CLASI_PROV_TOTAL_OFER"))
                If clasi_prov.PROP_GGCLASIF_COD <> "" Then
                    v_muestra_total_sn = clasi_prov.PROP_GGCLASIF_COD
                End If
            End If

            RutaOfe = ConfigurationManager.AppSettings("pathlocal") & Now.Year & Now.Month & Now.Day & "_" & cabecera.prop_ggclipr_cod & "_" & cabecera.prop_ggofetip_cod & "_" & cabecera.prop_N_OFE & "_" & n_rev & ".pdf"
            rep.CB2B_GENERA_REPORT_OFERTA_REV(ConfigurationManager.AppSettings("ReportOfertas"), cabecera.prop_EMPGRUPO_COD, cabecera.prop_emp_cod, ConfigurationManager.AppSettings("venta"), cabecera.prop_N_OFE, cabecera.prop_ggofetip_cod, "S", ConfigurationManager.AppSettings("PlantillaRepOfe"), ConfigurationManager.AppSettings("Oferta"), n_rev, True, "S", v_muestra_total_sn)

        Catch ex As Exception
            'error en la generacin del report 
            RutaOfe = ""
            Log.Error(ex, "[OfertaValidar.GenerarReport] cab = {@cab} rev = {rev} ", cabecera, n_rev)
        End Try

        Dim ftp As New BCb2b.ftp()
        Dim fich_subido As Boolean = ftp.SUBIR_FICHERO_FTP_WAIT_X_SECS(ConfigurationManager.AppSettings("pathServFileDocs"), ConfigurationManager.AppSettings("Dir_Oferta"), ConfigurationManager.AppSettings("pathlocal"), RutaOfe, ConfigurationManager.AppSettings("usuario_ftp"), ConfigurationManager.AppSettings("pass_ftp"), 10)
        If fich_subido = False Then 'SI NO LO HA SUBIDO QUE NO INTENTE ADJUNTARLO PORQUE IGUAL DA FALLO.
            RutaOfe = ""
        End If

        Return RutaOfe
    End Function
    Private Sub EnviarEmail(ByVal cabecera As BCb2b.COferta_Cab, ByVal cliente As BCb2b.ggclipr, ByVal age As BCb2b.gvagente, ByVal RutaOfe As String)

        Dim titulo As String = ""
        Dim cuerpo As String = ""
        Dim obtenerMailing As New CEnvio_Emails()
        Try
            'AQUI OBTENEMOS LOS MAIL DE LA CLASIFICACION CONFIRMS PARA MANDAR A QUIEN CORRESPONDA.
            obtenerMailing.DameDestinatarios(cabecera.prop_EMPGRUPO_COD, cabecera.prop_tip_Vc, ConfigurationManager.AppSettings("CLASI_NACION"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), cliente.prop_COD, ConfigurationManager.AppSettings("TipoOfe"))
            'AS OBTENGO LOS MAILS--> obtenerMailing.PROP_DESTINATARIOS

            Dim parametro As New BCb2b.CParametros()
            Dim host As String = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")
            Dim port As Int32 = CInt(ConfigurationManager.AppSettings("PUERTO_MAIL"))
            Dim user As String = ConfigurationManager.AppSettings("USU_MAIL")
            Dim password As String = ConfigurationManager.AppSettings("PASS_MAIL")

            'Dim age As New BCb2b.gvagente(cliente.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            Dim nombreAgeDis As String = age.prop_NOMBRE

            Dim textoAgeDis As String = ""
            'DEJAMOS SIEMPRE LA PALABRA AGENTE QUE DISTRIBUIDOR NO LES GUSTA.
            'If age.es_agente = True Then
            textoAgeDis = GetLocalResourceObject("lblAgente.Text").ToString()
            'Else
            'textoAgeDis = GetLocalResourceObject("lblDistribuidor.Text").ToString()
            'End If


            If cabecera.prop_N_OFE_REV.ToString <> "Null" Then
                If cabecera.prop_N_OFE_REV > 1 Then
                    titulo = GetLocalResourceObject("lblRevision.Text").ToString() & " " & cabecera.prop_N_OFE_REV & " " & GetLocalResourceObject("lblDe.Text").ToString()
                End If
            End If


            titulo = titulo & " " & GetLocalResourceObject("lblOfew.Text").ToString() & " " & Me.TIPOOFE & "/" & Me.NOFE & " " & GetLocalResourceObject("lbldesdeCli.Text").ToString() & " " & cliente.prop_NOMBRE & " (" & cliente.prop_COD & ")" & " " & GetLocalResourceObject("lblYel.Text").ToString() & " " & textoAgeDis & " " & age.prop_NOMBRE.ToUpper & " (" & age.prop_COD & ")"
            cuerpo = titulo

            Dim mailing As New EnviarMail()
            Dim enviado As String = mailing.SendMail_NET("", ConfigurationManager.AppSettings("EmailFrom"), obtenerMailing.PROP_DESTINATARIOS, titulo, cuerpo, RutaOfe)

        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.Error Enviando Email] destino = {destino} titu = {titu} body = {body} ruta = {ruta} ", obtenerMailing.PROP_DESTINATARIOS, titulo, cuerpo, RutaOfe)
        End Try
    End Sub
    Private Sub CREAR_OFERTA()
        'FALTA TRANSACCIONAR.
        Dim age As New BCb2b.gvagente()
        Dim es_valido As Boolean = VALIDAR_USUARIO(txtLogin.Text, tboxClave.Text, age)
        If es_valido Then
            Try
                lblerrorLogin.Visible = False

                Dim cliente As New BCb2b.ggclipr()
                cliente = Session("cliente")
                Dim vGvagenteCod As Decimal = ObtenerAgente(cliente)

                Dim cabecera As New BCb2b.COferta_Cab()
                CargarCabeceraOferta(cabecera, cliente, vGvagenteCod)
                GestionarFormaDePago(cabecera, cliente)

                Dim indiceLineas As Integer = 0
                For Each linea As BCb2b.COferta_linOff In Session("lineasOferta")
                    If (indiceLineas = 0) Then
                        CrearCabeceraOferta(cabecera, linea)
                    End If
                    Dim vNLin As String = InsertarLinea(cabecera, linea)
                    ActualizarDescuentosLinea(cabecera, linea, vNLin)
                    ActualizarPlazoLinea(cabecera, linea, vNLin)
                    InsertarTirasRollosLinea(cabecera, linea, vNLin)
                    indiceLineas = indiceLineas + 1
                Next

                AsociarCalculos(cabecera)
                InsertarObservaciones(cabecera)
                ActualizarEstadoCabecera(cabecera, cliente)
                Dim RutaOfe As String = GenerarReportOferta(cabecera)
                EnviarEmail(cabecera, cliente, age, RutaOfe)

                Me.TIPOOFE = cabecera.prop_serie
                Me.NOFE = cabecera.prop_N_OFE
                Me.GRUPO = cabecera.prop_EMPGRUPO_COD
                Me.EMPRESA = cabecera.prop_emp_cod
                Me.TIPVC = cabecera.prop_tip_Vc
                Server.Transfer("OfertaDetalle.aspx")
            Catch ex As Exception
                Log.Error(ex, "[OfertaValidar.CreandoOferta]")
                ScriptManager.RegisterClientScriptBlock(Me, Me.GetType(), "ErrorCreandoOfe", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetGlobalResourceObject("general", "MsgErrorGen") & "','err_red','',300);", True)
            End Try
        Else
            lblerrorLogin.Visible = True
        End If
    End Sub
    Protected Sub btnValidar_Click(sender As Object, e As EventArgs) Handles btnValidar.Click
        CREAR_OFERTA()
    End Sub
    Private Sub INSERTAR_TIRAS_ROLLOS(ByVal conexionole As IDbConnection, ByVal linea As COferta_linOff, ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal ggxxxtip_cod As String, ByVal n_docum As String, ByVal n_lin As String, ByVal tipo_OFE_PED_ALB As String, ByVal perfil As String)
        Dim transaccion_clasis_tirOroll As IDbTransaction
        transaccion_clasis_tirOroll = conexionole.BeginTransaction

        Try
            'INSERTAMOS CLASIS DE TIRAS Y ROLLOS
            'ANCHO,LARGO,N_TIRAS,TIRAS,N_ROLLOS,ROLLOS,M2,EQUI_UNPR
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_ANCHO"), "", linea.prop_ANCHO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_LARGO"), "", linea.prop_LARGO, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_M2"), "", linea.prop_M2, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_EQUI_UNPR"), "", linea.prop_EQUI_UNPR, "", False)
            GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_DESPERDICIO"), "", linea.prop_DESPERDICIO, "", True)

            'COMPROBAMOS PARAMETROS PARA INSERTAR CLASI UNMANUAL EN CASO DE QUE EL ARTICULO SEA TE TIRAS ROLLOS, NO ESTE EN
            'GACODBAR Y SEA DE UNIDAD UN
            Dim gacodbar As New BCb2b.gacodbar()
            Dim tiene_rollos As Boolean = gacodbar.ExisteGaartEnGacodbarPorGacodtip(grupo, linea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("ROLL"))
            Dim tiene_tiras As Boolean = gacodbar.ExisteGaartEnGacodbarPorGacodtip(grupo, linea.prop_GAART_COD, ConfigurationManager.AppSettings("UNID"), ConfigurationManager.AppSettings("TIRA"))
            Dim art As New BCb2b.gaart(grupo, linea.prop_GAART_COD)

            If Not tiene_rollos And Not tiene_tiras And art.prop_GAUNITIP_UNI1 = "UN" Then
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_ROLLOS"), "", linea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_TIRAS"), "", linea.prop_TIRAS, "", False)
            Else
                'SI NO ES UN ARTICULO DE TIPO B (LOS RAROS, EJ: 26103) METEMOS N.TIRAS.
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_N_ROLLOS"), "", linea.prop_ROLLOS, "", False)
                GGXXXCLASI.INSERTAR_GGXXXCLASI_PKG(transaccion_clasis_tirOroll, grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, ConfigurationManager.AppSettings("TR_N_TIRAS"), "", linea.prop_TIRAS, "", False)
            End If

            transaccion_clasis_tirOroll.Commit()
        Catch ex As Exception
            transaccion_clasis_tirOroll.Rollback()
            transaccion_clasis_tirOroll.Dispose()
            Log.Error(ex, "[OfertaValidar.INSERTAR_TIRAS_ROLLOS] empgrup = {empgrup} emp = {emp} tip = {tip} tip_ofe = {tipofe} nofe = {nofe} numlin = {numlin} tipdocOfe = {tipdocOfe} lin = {@lin} ", grupo, empresa, tip_vc, ggxxxtip_cod, n_docum, n_lin, tipo_OFE_PED_ALB, linea)
        End Try
    End Sub
    Protected Sub btnModificar_Click(sender As Object, e As EventArgs) Handles btnModificar.Click
        Response.Redirect("crearOferta.aspx", True)
    End Sub
    Private Sub cargarListadoModosEnvio(Optional ByVal menvio_def As String = "", Optional ByVal idioma As String = "")
        Dim cli As New BCb2b.ggclipr()
        Dim age As New BCb2b.gvagente()
        Try
            comboModosEnvio.Items.Clear()
            Dim listaModosEnvio As New ArrayList
            Dim arrayModosEnvio As Array

            'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)

            cli = Session("cliente")

            If Not Session("agente") Is Nothing Then
                age = Session("agente")
            Else
                age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            End If

            Dim valor As String = ""
            Dim obs As New BCb2b.GGCLIPROBS()
            valor = obs.DameObserAGEdeGGCLIPR(ConfigurationManager.AppSettings("grupo"), age, cli.prop_COD, ConfigurationManager.AppSettings("OBME"))

            Dim tiene_el_ggmenvio_def As Boolean = False
            If valor <> "" Then
                arrayModosEnvio = Split(valor, ",")

                Dim i As Integer = 0
                For i = 0 To arrayModosEnvio.Length - 1

                    Dim mEnvio As New BCb2b.CGGMenvio()
                    If idioma <> "" Then
                        mEnvio.DameDatosModoEnvio(arrayModosEnvio(i), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    Else
                        mEnvio = New BCb2b.CGGMenvio(arrayModosEnvio(i))
                    End If

                    If mEnvio.PROP_cod = menvio_def Then
                        tiene_el_ggmenvio_def = True
                    End If

                    listaModosEnvio.Add(mEnvio)
                Next i
            Else
                '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
                Dim mEnvio As New BCb2b.CGGMenvio()
                If idioma <> "" Then
                    mEnvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                Else
                    mEnvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
                End If
                listaModosEnvio.Add(mEnvio)
                '------FIN AMC_NE183-------
                If menvio_def <> "" Then
                    Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                    MEnvioDefecto.DameDatosModoEnvio(menvio_def, idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"))
                    listaModosEnvio.Add(MEnvioDefecto)
                    tiene_el_ggmenvio_def = True
                End If
            End If

            If tiene_el_ggmenvio_def = False Then
                Dim modo_env_def As New BCb2b.CGGMenvio(menvio_def)
                listaModosEnvio.Add(modo_env_def)
            End If

            comboModosEnvio.DataSource = listaModosEnvio
            comboModosEnvio.DataTextField = "prop_descrip"
            comboModosEnvio.DataValueField = "prop_cod"
            comboModosEnvio.DataBind()
        Catch ex As Exception
            Log.Error(ex, "[OfertaValidar.cargarListadoModosEnvio] cliente = {@cliente} agente = {@agente} ", cli, age)
        End Try

    End Sub
    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        RDP.DataBind()
    End Sub
    Protected Sub RDP_ItemDataBound(sender As Object, e As RepeaterItemEventArgs) Handles RDP.ItemDataBound
        'ESTO PINTA LOS PRECIOS ESPECIALES EN ROJO
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            Dim fila As BCb2b.COferta_linOff = e.Item.DataItem
            Dim lblUnidad As Label = e.Item.FindControl("lblUnidad")
            Dim lblcant As Label = e.Item.FindControl("lblcant")

            lblUnidad.Text = fila.prop_GAUNITIP_UNI1
            If fila.prop_GAUNITIP_PR <> "" And fila.prop_C_UNIPR <> "" Then
                lblcant.Text = fila.prop_C_UNIPR
                lblUnidad.Text = fila.prop_GAUNITIP_PR
            End If

            lblcant.Text = CDbl(lblcant.Text).ToString ' para quitar los 4 decimales de la pag anterior.

            Dim clasi_tira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
            Dim clasi As New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), fila.prop_GAART_COD, clasi_tira)
            Dim es_tira_o_rollo As String = "N"
            es_tira_o_rollo = clasi.prop_GACLASIF_COD
            If es_tira_o_rollo = "" Then
                es_tira_o_rollo = "N"
            End If

            'SI ES TIRA O ROLLO NO ES PRECIO ESPECIAL
            If fila.prop_ES_PRECIO_ESP = True And es_tira_o_rollo = "N" And CDbl(fila.prop_I_NETOEMP) > 0 Then
                Dim lbl_prec_esp As Label = e.Item.FindControl("lblprec_esp")
                lbl_prec_esp.ForeColor = Color.Red
            End If
        End If
    End Sub
End Class
