﻿Imports CTI.Utilities.Log
Imports System.Data.OracleClient
Imports System.IO
Imports System.Data
Imports System.Globalization
Imports System.Data.OleDb
Partial Class OrderInbox
    Inherits claseBase
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function CambiarCliente_OrderInbox(ByVal pEmpgrupoCod As String, ByVal pEmpCod As String, ByVal pTipVc As String, ByVal pGgofetipCod As String, ByVal pNOfe As String, ByVal pViejoCodCli As String, ByVal pNuevoCodCli As String) As String
        Dim hay_error As String = "0"
        Try
            'AQUI LLAMAR A FUNCION DE LEIRE PARA MODIFICAR EL CODIGO DEL CLIENTE DEL INBOX
            Dim cs As New BCb2b.CS_B2B_PKG()
            Dim resul As String = cs.b2b_amc_actualiza_cli_ofe(Session("idioma_spyro"), pEmpgrupoCod, pEmpCod, pTipVc, pGgofetipCod, pNOfe, pViejoCodCli, pNuevoCodCli)
            hay_error = "0"
            If resul <> "" Then
                hay_error = "1"
            End If
        Catch ex As Exception
            hay_error = "1"
            Log.Error(ex, "[OrderInbox.CambiarCliente_OrderInbox]: grupo = {grupo} emp = {emp} vc = {vc} ofetip = {ofetip} nofe = {nofe} newcli = {newcli}", pEmpgrupoCod, pEmpCod, pTipVc, pGgofetipCod, pNOfe, pNuevoCodCli)
        End Try
        Return hay_error
    End Function
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(OrderInbox))
        'HABILITAMOS LOS MENSAJES MODALES
        'Dim mensaje As New BCb2b.Utilities
        'mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        'mensaje.CrearModalConfirm(Me, "CrearPedido", GetGlobalResourceObject("general", "MsgModalBtnConfirm"), GetLocalResourceObject("MsgModalCrearPedido"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        If Not Page.IsPostBack Then
            Dim mensaje As New BCb2b.Utilities
            mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
            mensaje.CrearModalConfirm(Me, "CrearPedido", GetGlobalResourceObject("general", "MsgModalBtnConfirm"), GetLocalResourceObject("MsgModalCrearPedido"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

            div_lblatencion_error.Visible = False
            ShowLupaCliente(IBCliente, tboxClienteCod, tboxCliente)

            Dim vcodcli As String = ""
            Dim vnomcli As String = ""
            'If Not Session("cliente") Is Nothing Then
            '    vcodcli = Session("cliente").prop_COD
            '    vnomcli = Session("cliente").prop_NOMBRE
            'End If
            tboxClienteCod.Text = vcodcli
            tboxCliente.Text = vnomcli

            tboxClienteCod.Attributes.Add("onchange", "javascript:return false;")

            GVOrderInbox.VirtualItemCount = GetRowCount()
            BindPagingGrid()
        End If
    End Sub

    Protected Sub GVOrderInbox_PageIndexChanging(sender As Object, e As GridViewPageEventArgs) Handles GVOrderInbox.PageIndexChanging
        GVOrderInbox.PageIndex = e.NewPageIndex
        BindPagingGrid()
    End Sub

    Protected Sub GVOrderInbox_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GVOrderInbox.RowCommand
        If e.CommandName <> "Page" Then
            Try
                Dim fila As GridViewRow
                fila = GVOrderInbox.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = GVOrderInbox.Rows(ind)

                Dim Pkey As DataKeyArray = GVOrderInbox.DataKeys

                'prop_empgrupo_cod,prop_emp_cod,prop_tip_vc,prop_ggclipr_cod,prop_gvagente_cod,prop_ggofetip_cod,prop_n_ofe
                Dim vEmpgrupoCod As String = Pkey.Item(ind).Item(0)
                Dim vEmpCod As String = Pkey.Item(ind).Item(1)
                Dim vTipVc As String = Pkey.Item(ind).Item(2)
                'Dim vGgcliprCod As String = Pkey.Item(ind).Item(3)
                'Dim vGvagentecod As String = Pkey.Item(ind).Item(4)
                Dim vGgofetipCod As String = Pkey.Item(ind).Item(5)
                Dim vNOfe As String = Pkey.Item(ind).Item(6)

                If (e.CommandName = "ver_pedido") Then 'SI ENTRA POR AQUI ES QUE HA CLICADO EN EL BOTON PERO POR SI ACASO COMPRUEBO SI TIENE TRAZABILIDAD.
                    Dim vGgpedtipCod As String = ""
                    Dim vNPedido As String = ""

                    Dim cab As New BCb2b.COferta_Cab(vEmpgrupoCod, vEmpCod, vTipVc, vGgofetipCod, vNOfe)
                    cab.obtener_trazabilidad_oinbox(vGgpedtipCod, vNPedido)

                    If vGgpedtipCod <> "" And vNPedido <> "" Then
                        Session("GRUPO_PED") = vEmpgrupoCod
                        Session("EMPRESA_PED") = vEmpCod
                        Session("TIPO_PED") = vGgpedtipCod
                        Session("N_PED") = vNPedido

                        Server.Transfer("PedidoDetalle.aspx")
                        'Response.Redirect("PedidoDetalle.aspx")
                    End If
                End If
            Catch ex As Exception
                lblerror.Text = ex.Message.ToString
            End Try
        End If
    End Sub
    Protected Sub GVOrderInbox_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVOrderInbox.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            'prop_empgrupo_cod,prop_emp_cod,prop_tip_vc,prop_ggclipr_cod,prop_gvagente_cod,prop_ggofetip_cod,prop_n_ofe
            Dim Pkey As DataKeyArray = GVOrderInbox.DataKeys
            Dim vEmpgrupoCod As String = Pkey.Item(e.Row.RowIndex).Item(0)
            Dim vEmpCod As String = Pkey.Item(e.Row.RowIndex).Item(1)
            Dim vTipVc As String = Pkey.Item(e.Row.RowIndex).Item(2)
            Dim vGgcliprCod As String = Pkey.Item(e.Row.RowIndex).Item(3)
            Dim vGvagenteCod As String = Pkey.Item(e.Row.RowIndex).Item(4)
            Dim vGgofetipCod As String = Pkey.Item(e.Row.RowIndex).Item(5)
            Dim vNOfe As String = Pkey.Item(e.Row.RowIndex).Item(6)

            Dim listado_documentos As New ArrayList
            Dim docs As New BCb2b.CGGXXXCGRAF()
            listado_documentos = docs.DameGGXXXCGRAFS(ConfigurationManager.AppSettings("Oferta"), vGgofetipCod, vNOfe, vGgcliprCod)
            If listado_documentos.Count = 0 Then
                e.Row.Cells(7).Controls(0).Visible = False 'ocultamos el boton de documentos.
            End If

            Dim imgLovCli As New Image
            imgLovCli = e.Row.FindControl("IBTNLovClientes")
            imgLovCli.CssClass = "oculto"

            Dim imgCreaPed As New Image
            imgCreaPed = e.Row.FindControl("IBTNCrearPedido")

            Dim tboxclientecod As New TextBox
            tboxclientecod = e.Row.FindControl("tboxggcliprcod")
            tboxclientecod.CssClass = "oculto"

            Dim tboxclientenom As New TextBox
            tboxclientenom = e.Row.FindControl("tboxggcliprnom")
            tboxclientenom.CssClass = "oculto"

            tboxclientecod.Attributes.Add("onchange", "javascript:cambia_cliente_oinbox('" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & vGgofetipCod & "','" & vNOfe & "','" & vGgcliprCod & "','" & tboxclientecod.ClientID & "','" & "No se ha podido seleccionar el cliente." & "');")

            Dim clasi_permit_oinbox_to_ped As String = ConfigurationManager.AppSettings("CLASI_PERMITIR_ORDERINBOX_TO_PED")
            Dim clasi As New BCb2b.CGGCLICLASI(vEmpgrupoCod, vTipVc, vGgcliprCod, clasi_permit_oinbox_to_ped)
            If clasi.PROP_GGCLASIF_COD = "N" Then
                'AQUI OCULTAR BOTON DE CREAR PEDIDO Y PONER LOV DE CLIENTES.
                imgCreaPed.CssClass = "oculto"
                imgLovCli.CssClass = ""
                ShowLupaCliente(imgLovCli, tboxclientecod, tboxclientenom, "S")
            End If
        End If
    End Sub
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub

    Public Shared Sub ShowLupaCliente(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxcliControl As System.Web.UI.WebControls.TextBox, ByVal tboxnomControl As System.Web.UI.WebControls.TextBox, Optional ByVal permitir_redirigir_a_selcli_SN As String = "N")
        OpenPopUp(opener, "lov_clientes_amc.aspx?textbox=" & tboxcliControl.ClientID & "&textbox2=" & tboxnomControl.ClientID & "&textbox3=" & permitir_redirigir_a_selcli_SN, "LOV", 410, 600)
    End Sub
    Private Sub BindPagingGrid()
        GVOrderInbox.DataSource = GetDataPage(GVOrderInbox.PageIndex, GVOrderInbox.PageSize, GVOrderInbox.OrderBy)
        GVOrderInbox.DataBind()

        GVOrderInbox.Columns(8).HeaderStyle.CssClass = "" 'mostramos la columna de crear pedido
        GVOrderInbox.Columns(8).ItemStyle.CssClass = ""
        GVOrderInbox.Columns(9).HeaderStyle.CssClass = "oculto"
        GVOrderInbox.Columns(9).ItemStyle.CssClass = "oculto" 'ocultamos la columna de trazabilidad pedido
        If Not checkboxVigente.Checked Then
            GVOrderInbox.Columns(8).HeaderStyle.CssClass = "oculto"
            GVOrderInbox.Columns(8).ItemStyle.CssClass = "oculto" 'ocultamos la columna de crear pedido
            GVOrderInbox.Columns(9).HeaderStyle.CssClass = ""
            GVOrderInbox.Columns(9).ItemStyle.CssClass = "" 'mostramos la columna de trazabilidad pedido
        End If
    End Sub
    Private Function GetRowCount() As Integer

        Dim COInbox As New BCb2b.GGOFECAB()

        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")

        Dim param As New BCb2b.CParametros()

        'SERIE DE OFERTA PARA LOS ORDER INBOX
        Dim vGgofetipCod As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX"))
        Dim clasi_respons As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_CLASI_RESP_ORDER_INBOX"))

        Dim vFInicio As String = tboxFdesde.Text
        Dim vFFin As String = tboxFHasta.Text

        Dim vNOfe As String = ""
        Dim vcodcli As String = tboxClienteCod.Text

        Dim vhist_sn As String = "N"
        If Not (checkboxVigente.Checked) Then
            vhist_sn = "S"
        End If

        Dim vtodos_sn As String = "N"

        Dim FILTRO_CLIENTE As String = ConfigurationManager.AppSettings("FiltroCliente")
        Dim VAGENTE As String
        If Not Session("AGENTE") Is Nothing Then
            VAGENTE = Session("AGENTE").prop_cod()
            If Session("AGENTE").PROP_COD <> "" Then
                FILTRO_CLIENTE = Session("ver_clientes")
            End If
        Else
            VAGENTE = ""
            FILTRO_CLIENTE = Session("ver_clientes")
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
        If perfiles.prop_TIPO_PERFIL = 0 Then 'svt ing
            VAGENTE = ""
            FILTRO_CLIENTE = Session("ver_clientes")
        End If

        Dim vsuref As String = tboxdescripcion.Text

        Dim vpublicos_sn As String = ConfigurationManager.AppSettings("publico")

        Dim VSERIES_SI As String = "" 'PARAMETRO.prop_VALOR
        Dim VSERIES_NO As String = ""
        Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")

        Dim gaart_cod As String = "" ' txtArticuloCod.Text
        Dim param_cliente_generico As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_CLIENTE_GENERICO"))

        Dim total As Integer = COInbox.lista_cabeceras_orderinbox_cuantos_int(vEmpgrupoCod, vEmpCod, vTipVc, vGgofetipCod, vNOfe, vcodcli, vhist_sn, vtodos_sn, Session("cadena_conexion"), vpublicos_sn, vFInicio, vFFin, FILTRO_CLIENTE, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref, "-1", "", gaart_cod, tboxFPrevDesde.Text, tboxFPrevHasta.Text, clasi_respons, tboxResponsable.Text, True, param_cliente_generico)

        Return total
    End Function


    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList

        Dim COInbox As New BCb2b.GGOFECAB()
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")

        'SERIE DE OFERTA PARA LOS ORDER INBOX
        Dim param As New BCb2b.CParametros()
        Dim vGgofetipCod As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_ORDER_INBOX"))
        Dim clasi_respons As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_CLASI_RESP_ORDER_INBOX"))

        Dim vNOfe As String = ""

        Dim vhist_sn As String = "N"
        If Not checkboxVigente.Checked Then
            vhist_sn = "S"
        End If

        Dim vtodos_sn As String = "N"

        Dim vpublicos_sn As String = ConfigurationManager.AppSettings("publicos")
        Dim vpagina_inicio As String = ((GVOrderInbox.PageIndex) * GVOrderInbox.PageSize) + 1
        Dim vpagina_fin As String = ((GVOrderInbox.PageIndex + 1) * GVOrderInbox.PageSize)
        Dim vordenado_por As String = "F_OFE DESC,N_OFE DESC"
        Dim vidiomas_cod As String = Session("idiomas")
        Dim tipo_observacion_idioma As String = ConfigurationManager.AppSettings("cod_obs_idioma")
        Dim vf_inicio As String = tboxFdesde.Text
        Dim vf_fin As String = tboxFHasta.Text
        Dim filtro_cliente As String = ConfigurationManager.AppSettings("FiltroCliente")

        Dim vsuref As String = tboxdescripcion.Text

        Dim lista As ArrayList

        Dim VAGENTE As String
        If Not Session("AGENTE") Is Nothing Then
            VAGENTE = Session("AGENTE").prop_cod()
            If Session("AGENTE").PROP_COD <> "" Then
                filtro_cliente = Session("ver_clientes")
            End If
        Else
            VAGENTE = ""
            filtro_cliente = Session("ver_clientes")
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
        If perfiles.prop_TIPO_PERFIL = 0 Then 'svt ing
            VAGENTE = ""
            filtro_cliente = Session("ver_clientes")
        End If

        Dim vcodcli As String = tboxClienteCod.Text

        Dim VSERIES_SI As String = ""
        Dim VSERIES_NO As String = ""
        Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")

        Dim param_cliente_generico As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_CLIENTE_GENERICO"))
        Dim gaart_cod As String = ""

        lista = COInbox.lista_cabecera_orderinbox_paginado_strings(vEmpgrupoCod, vEmpCod, vTipVc, vGgofetipCod, vNOfe, vcodcli, vhist_sn, vtodos_sn, vpagina_inicio, vpagina_fin, vordenado_por, Session("cadena_conexion"), vpublicos_sn, vidiomas_cod, tipo_observacion_idioma, vf_inicio, vf_fin, filtro_cliente, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref, "-1", "", gaart_cod, tboxFPrevDesde.Text, tboxFPrevHasta.Text, clasi_respons, tboxResponsable.Text, True, param_cliente_generico)
        Return lista
    End Function
    Protected Sub btnBuscar_Click(sender As Object, e As EventArgs) Handles btnBuscar.Click
        GVOrderInbox.VirtualItemCount = GetRowCount()
        BindPagingGrid()
    End Sub
    Protected Sub ImgBTCliente_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTCliente.Click
        tboxCliente.Text = ""
        tboxClienteCod.Text = ""
    End Sub
    Protected Sub ImgBTFDesde_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFDesde.Click
        tboxFdesde.Text = ""
    End Sub

    Protected Sub ImgBTFHasta_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFHasta.Click
        tboxFHasta.Text = ""
    End Sub
    Protected Sub ImgBTFPrevDesde_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFPrevDesde.Click
        tboxFPrevDesde.Text = ""
    End Sub

    Protected Sub ImgBTFPrevHasta_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFPrevHasta.Click
        tboxFPrevHasta.Text = ""
    End Sub
    Protected Sub IBTNCrearPedido_Click(sender As Object, e As ImageClickEventArgs)
        Dim img As New ImageButton
        img = sender

        Dim rowIndex As Integer = CInt(img.CommandArgument) 'FILA CLICK

        Dim Pkey As DataKeyArray = GVOrderInbox.DataKeys

        'prop_empgrupo_cod,prop_emp_cod,prop_tip_vc,prop_ggclipr_cod,prop_gvagente_cod,prop_ggofetip_cod,prop_n_ofe
        Dim EMPGRUPO_COD As String = Pkey.Item(rowIndex).Item(0)
        Dim EMP_COD As String = Pkey.Item(rowIndex).Item(1)
        Dim TIP_VC As String = Pkey.Item(rowIndex).Item(2)
        Dim GGCLIPR_COD As String = Pkey.Item(rowIndex).Item(3)
        Dim GVAGENTE_COD As String = Pkey.Item(rowIndex).Item(4)
        Dim GGOFETIP_COD As String = Pkey.Item(rowIndex).Item(5)
        Dim N_OFE As String = Pkey.Item(rowIndex).Item(6)
        Dim cabeceraOfe As New BCb2b.COferta_Cab(EMPGRUPO_COD, EMP_COD, TIP_VC, GGOFETIP_COD, N_OFE)


        Dim cli As New BCb2b.ggclipr(GGCLIPR_COD, EMPGRUPO_COD, TIP_VC)
        Dim cabeceraPed As New BCb2b.CCabeceraPedido(cli, ConfigurationManager.AppSettings("empresa"), _
                                                ConfigurationManager.AppSettings("tipo_pedido"), _
                                                ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), _
                                                ConfigurationManager.AppSettings("imprimir_sn"), _
                                                ConfigurationManager.AppSettings("historico_sn"), GVAGENTE_COD, _
                                                "", "", "", cli.prop_RSOCCONDI_DEF)

        Session("cliente") = cli
        Session("cabecera") = cabeceraOfe
        Session("cabeceraPed") = cabeceraPed

        Log.Information("[CREAR PEDIDO DESDE OIBOX] grupo:" & EMPGRUPO_COD & " emp:" & EMP_COD & " tipvc:" & TIP_VC & " cli:" & GGCLIPR_COD & " age:" & GVAGENTE_COD & " oinb:" & GGOFETIP_COD & "-" & N_OFE & " " & Now.ToString)

        Response.Redirect("CrearPedido.aspx")
        'TODO IIG Lo comento y pongo de nuevo lo de arriba porque haciendo el transfer, no hace un get a CrearPedido y luego las peticiones AJAX fallan porque no encuentra CrearPedido
        'Server.Transfer("CrearPedido.aspx")
    End Sub
End Class
