Imports System.IO
Imports System.Data

Partial Class PrevioPedido
    Inherits claseBase


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(PrevioPedido))

        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))

        Session("cabeceraPed") = Nothing
        Session("lineasPedido") = Nothing

        Dim cliente As New BCb2b.ggclipr()
        If (Not Session("cliente") Is Nothing) Then
            cliente = Session("cliente")
            COMPROBAR_SI_CLASIS_OBLIS_INTRODUCIDAS(cliente)
            GESTIONAR_SERIES_PEDIDO(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cliente)
        End If

        'If cliente.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoM") Then 'moroso
        '    'SI DEVUELVE VALOR ES QUE NO PUEDE, MOSTRAMOS MENSAJE Y REDIRIGE A CONSULTA.
        '    ScriptManager.RegisterStartupScript(Me, Me.GetType(), "NoPuedesHacerPedidos", "ShowDialog('" & GetLocalResourceObject("MsgModalAtencion") & "','" & GetLocalResourceObject("MsgModalClienteMoroso") & "','info','PedidoConsulta.aspx',300);", True)
        'End If
    End Sub

    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        Response.Redirect("CrearPedido.aspx")
    End Sub

    Protected Sub btnCancelar_Click(sender As Object, e As EventArgs) Handles btnCancelar.Click
        Server.Transfer("PedidoConsulta.aspx")
    End Sub
    Private Sub COMPROBAR_SI_CLASIS_OBLIS_INTRODUCIDAS(ByVal cliente As BCb2b.ggclipr)
        Dim param As New BCb2b.CParametros()
        'AMC_NE127. SI NO TIENE TODAS LAS CLASIS METIDAS O ESTA EN ESTADO POT POR LO QUE SEA, VA A CREARCLIENTE
        Dim clasisOblis As String = param.dame_param(ConfigurationManager.AppSettings("B2B_CLASIS_OBLI_USU_CREACLI"))
        Dim comp_clasis As New BCb2b.CGGCLICLASI()
        Dim todas_llenas As Boolean = comp_clasis.CompruebaSiClasisObliRellenas(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), clasisOblis, cliente.prop_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGCLATIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGCLATIP_DESC"))
        If todas_llenas = False Then
            Session("new_cliente") = cliente
            'MOSTRAR DIALOGO DE CLASIS OBLIGATORIAS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "FaltanClasis", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("MsgModalClasisOblis") & "','err_red','CrearCliente.aspx',300);", True)
            'Response.Redirect("CrearCliente.aspx")
        End If
    End Sub
    Private Sub GESTIONAR_SERIES_PEDIDO(ByVal p_empgrupo_cod As String, ByVal p_tip_vc As String, ByVal cliente As BCb2b.ggclipr)
        Dim listado_series As New ArrayList()
        Dim tipo_w = ConfigurationManager.AppSettings("tipo_pedido")
        Dim tipo_m = ConfigurationManager.AppSettings("tipo_pedido_muestras")
        Dim tipo_web As New BCb2b.CGGpedtip(tipo_w, GetLocalResourceObject("TipoPedidoWeb"))
        Dim tipo_muestras As New BCb2b.CGGpedtip(tipo_m, GetLocalResourceObject("TipoPedidoMuestras"))


        'If (Session("perfil_usuario") <> "CL") Then
        'VOLVEMOS A COGER DATOS DEL CLI ACTUAL PARA VER SI HA CAMBIADO EL ESTADO.
        Dim estado_cli As String = cliente.prop_GGESTADO_COD


        'AMC_NE218.JCE.10/03/2016. COMPROBAR ESTADO DEL CLIENTE PARA VER SI PUEDE HACER O NO PEDIDOS
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion_comprobar_estado_cli As IDbTransaction
        transaccion_comprobar_estado_cli = conexionole.BeginTransaction

        Dim puede_hacer_pedido As Boolean = False
        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""
        Try
            AMC_GV181_PKG_CS.AMC_GV181_PKG_CS.GGPEDCAB_GGCLIPR_VALIDA(transaccion_comprobar_estado_cli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), tipo_w, cliente.prop_COD, Nothing, "B2B", Session("idioma_spyro"), mensaje_info, mensaje_error)
            If mensaje_error = "" Then
                listado_series.Add(tipo_web)
                puede_hacer_pedido = True
            End If

            '------DE MOMENTO NO CONTROLAMOS EL PEMW------
            AMC_GV181_PKG_CS.AMC_GV181_PKG_CS.GGPEDCAB_GGCLIPR_VALIDA(transaccion_comprobar_estado_cli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), tipo_m, cliente.prop_COD, Nothing, "B2B", Session("idioma_spyro"), mensaje_info, mensaje_error)
            If mensaje_error = "" Then
                listado_series.Add(tipo_muestras)
                puede_hacer_pedido = True
            End If

            transaccion_comprobar_estado_cli.Commit()
        Catch ex As Exception
            transaccion_comprobar_estado_cli.Rollback()
        End Try

        If Not puede_hacer_pedido Then
            'SI DEVUELVE VALOR ES QUE NO PUEDE, MOSTRAMOS MENSAJE Y REDIRIGE A CONSULTA.
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "NoPuedesHacerPedidos", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("NoPuedeHacerPedido") & "','err_red','PedidoConsulta.aspx',300);", True)
        End If
        transaccion_comprobar_estado_cli.Dispose()
        'FIN AMC_NE218.JCE.10/03/2016. COMPROBAR ESTADO DEL CLIENTE PARA VER SI PUEDE HACER O NO PEDIDOS
        'End If
    End Sub
End Class
