﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Data.OracleClient
Imports CTI.Utilities.Log

'Imports System.Data
'Imports System.Data.SqlClient
'Imports System.Data.OracleClient
'Imports System.Configuration
'Imports System.Globalization
'Imports System.Threading

Partial Class _PrevisionesConsulta
    Inherits claseBase
    Private Nofe As String
    Private TIPOofe As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.Nofe
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOofe
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "ConfirmarNewLlamada", GetGlobalResourceObject("general", "MsgModalBtnConfirm"), GetLocalResourceObject("MsgLlamadaRealizarQ"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        If Not Page.IsPostBack Then
            Dim param As New BCb2b.CParametros()
            Dim serieOPREV As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"))

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If (Not Session("cliente") Is Nothing) Or perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                ' If (Not Session("cliente") Is Nothing) Or Session("tipo_usuario") = "ING" Or Session("tipo_usuario") = "SVT" Then
                If Not IsPostBack Then
                    If Session("cliente") Is Nothing Then '(Session("tipo_usuario") = "ING" Or Session("tipo_usuario") = "SVT") And 
                        tboxggclipr.Text = ""
                        tboxggcliprCod.Text = ""
                    Else
                        Dim cli As New BCb2b.ggclipr()
                        cli = Session("cliente")
                    End If

                    If Not Session("AGENTE") Is Nothing And perfiles.prop_TIPO_PERFIL <> 0 Then '<> svt o ing
                        tboxAgente.Text = Session("AGENTE").prop_NOMBRE()
                        tboxAgenteCod.Text = Session("AGENTE").prop_cod()
                        tboxPais.Text = ""
                        tboxAgente.Visible = False
                        tboxAgenteCod.Visible = False
                        tboxPais.Visible = False
                        tboxPaisCod.Visible = False
                        tboxPaisCod.Text = ""
                        ImgBtAgeBorrar.Visible = False
                        ImgAge.Visible = False
                        ImgBtPaisBorrar.Visible = False
                        ImgPais.Visible = False
                        lblcabage.Visible = False
                        lblcabpais.Visible = False
                    End If

                    GRUPO = ConfigurationManager.AppSettings("GRUPO")
                    EMPRESA = ConfigurationManager.AppSettings("EMPRESA")

                    DDLSerie.Items.Clear()
                    DDLSerie.Items.Add(serieOPREV)
                    DDLSerie.DataBind()

                    'LO DE CONTACTIP ES UNICAMENTE PARA QUE CARGUE LAS CLASIS COD Y DESCRIP
                    Dim tipo_pedido_todos As New BCb2b.contactip("", GetLocalResourceObject("MsgTodos"), True)
                    Dim tipo_pedido_prev As New BCb2b.contactip("OPREV", GetLocalResourceObject("MsgPedPrev"), True)
                    Dim tipo_pedido_contrato As New BCb2b.contactip("OCONTRA", GetLocalResourceObject("MsgContra"), True)
                    Dim listado_tipos As New ArrayList
                    listado_tipos.Add(tipo_pedido_todos)
                    listado_tipos.Add(tipo_pedido_prev)
                    listado_tipos.Add(tipo_pedido_contrato)
                    DDL_TipoPrev.DataSource = listado_tipos
                    DDL_TipoPrev.DataTextField = "prop_descrip"
                    DDL_TipoPrev.DataValueField = "prop_cod"
                    DDL_TipoPrev.DataBind()

                    GVPrevisiones.VirtualItemCount = GetRowCount()
                    BindPagingGrid()
                End If
            Else
                If (Not Session("rsocial") Is Nothing) Then
                    If Not IsPostBack Then

                        Dim tipo_oferta As New BCb2b.CGGOfetip()
                        Dim CODIGOS_NO As String = ""

                        DDLSerie.Items.Clear()
                        DDLSerie.Items.Add(serieOPREV)
                        DDLSerie.DataBind()

                    End If
                Else
                    If (Not Session("agente") Is Nothing) Then
                        Response.Redirect("BusquedaClientes.aspx", False)
                    Else
                        Response.Redirect("index.aspx", False)
                    End If
                End If
            End If

            ShowLupaCliente(ImgGGclipr, tboxggcliprCod, tboxggclipr)
            ShowLupaArticulo(ImgGaart, tboxgaartCod, tboxgaart)
            tboxgaart.Attributes.Add("onchange", "javascript:return false;")
            tboxggclipr.Attributes.Add("onchange", "javascript:return false;")
            ShowLovAge(ImgAge, tboxAgenteCod, tboxAgente)
            ShowLovPais(ImgPais, tboxPaisCod, tboxPais)
        End If

    End Sub


    Protected Sub btnBuscar_Click(sender As Object, e As EventArgs) Handles btnBuscar.Click
        GVPrevisiones.VirtualItemCount = GetRowCount()
        BindPagingGrid()
    End Sub

    Protected Sub GVPrevisiones_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GVPrevisiones.PageIndexChanging
        GVPrevisiones.PageIndex = e.NewPageIndex
        BindPagingGrid()
    End Sub

    Private Function GetColumnIndexByName(ByVal row As GridViewRow, ByVal columnName As String) As Integer
        Dim columnIndex As Integer = 0
        Dim encontrado As Boolean = False
        Dim cell As DataControlFieldCell
        Dim cell2 As New BoundField

        For Each cell In row.Cells
            If TypeOf cell.ContainingField Is BoundField Then
                If CType(cell.ContainingField, BoundField).DataField.Equals(columnName) Then
                    encontrado = True
                    Exit For
                End If
                columnIndex = columnIndex + 1
            End If
        Next
        If encontrado = False Then
            columnIndex = -1
        End If
        Return columnIndex
    End Function

    Private Sub BindPagingGrid()
        GVPrevisiones.DataSource = GetDataPage(GVPrevisiones.PageIndex, GVPrevisiones.PageSize, GVPrevisiones.OrderBy)
        GVPrevisiones.DataBind()
    End Sub

    Private Function GetRowCount() As Integer
        Dim elemento As New BCb2b.CPrevisiones()

        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vemp_COD As String = ConfigurationManager.AppSettings("empresa")
        Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
        'Dim vggofetip_cod As String = DDLSerie.SelectedValue
        Dim vtipo_prevision As String = DDL_TipoPrev.SelectedValue
        If vtipo_prevision = "" Then
            Dim param As New BCb2b.CParametros()
            vtipo_prevision = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"))
        End If

        Dim total As Integer = elemento.dame_listado_previsiones_cuantos_int(vEMPGRUPO_COD, vemp_COD, vtip_vc, vtipo_prevision, tboxAgenteCod.Text.ToUpper, Session("idioma_spyro"), tboxNOferta.Text.ToUpper, tboxggcliprCod.Text.ToUpper, tboxgaartCod.Text.ToUpper, tboxDescrip.Text.ToUpper, RBLPorcen.SelectedValue, tboxbscporcen.Text, tboxFOfeInicio.Text, tboxFOfeFin.Text, tboxFCadInicio.Text, tboxFCadFin.Text, tboxfplazoIni.Text, tboxfplazoFin.Text, chkHistoricos.Checked, chkAgrupados.Checked, tboxPaisCod.Text.ToUpper, ConfigurationManager.AppSettings("CLASI_PRVRESPONS"), ConfigurationManager.AppSettings("CLASI_PRVTMPLLAM"), ConfigurationManager.AppSettings("CLASI_PRVULTLLAM"), tboxRespon.Text)

        Return total
    End Function


    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList

        Dim elemento As New BCb2b.CPrevisiones()

        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vemp_COD As String = Session("empresa").prop_cod 'ConfigurationManager.AppSettings("empresa")
        Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
        'Dim vggofetip_cod As String = DDLSerie.SelectedValue
        Dim vtipo_prevision As String = DDL_TipoPrev.SelectedValue
        If vtipo_prevision = "" Then
            Dim param As New BCb2b.CParametros()
            vtipo_prevision = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"))
        End If

        Dim vpagina_inicio As String = ((GVPrevisiones.PageIndex) * GVPrevisiones.PageSize) + 1
        Dim vpagina_fin As String = ((GVPrevisiones.PageIndex + 1) * GVPrevisiones.PageSize)
        Dim vordenado_por As String = " (CASE WHEN CANT_PREV<>0 THEN CANT_ENTG*100/CANT_PREV ELSE 0 END) DESC, F_ENTRPREV DESC, N_OFE DESC "

        Dim lista As ArrayList

        lista = elemento.dame_listado_previsiones_paginado(vEMPGRUPO_COD, vemp_COD, vtip_vc, vtipo_prevision, tboxAgenteCod.Text, Session("idioma_spyro"), vpagina_inicio, vpagina_fin, vordenado_por, tboxNOferta.Text.ToUpper, tboxggcliprCod.Text.ToUpper, tboxgaartCod.Text.ToUpper, tboxDescrip.Text.ToUpper, RBLPorcen.SelectedValue, tboxbscporcen.Text, tboxFOfeInicio.Text, tboxFOfeFin.Text, tboxFCadInicio.Text, tboxFCadFin.Text, tboxfplazoIni.Text, tboxfplazoFin.Text, chkHistoricos.Checked, chkAgrupados.Checked, tboxPaisCod.Text.ToUpper, ConfigurationManager.AppSettings("CLASI_PRVRESPONS"), ConfigurationManager.AppSettings("CLASI_PRVTMPLLAM"), ConfigurationManager.AppSettings("CLASI_PRVULTLLAM"), tboxRespon.Text)

        Return lista
    End Function
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos_previsiones.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID, "LOV", 410, 600)
    End Sub
    Public Shared Sub ShowLupaCliente(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal CliControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripCLI As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_clientes_previsiones.aspx?textbox=" & CliControl.ClientID & "&textbox2=" & lblDescripCLI.ClientID, "LOV", 410, 600)
    End Sub

    Protected Sub ImgBPorcen_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBPorcen.Click
        RBLPorcen.SelectedIndex = -1
        tboxbscporcen.Text = ""
    End Sub

    Protected Sub GVPrevisiones_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GVPrevisiones.RowCommand
        'AMC_NE211 Previsions Azkue. asignar nueva llamada.
        If e.CommandName = "asig_llam" Then
            Dim p_grupo As String = ""
            Dim p_empresa As String = ""
            Dim p_tip_vc As String = ""
            Dim p_tipo_ofe As String = ""
            Dim p_n_oferta As String = ""
            Dim p_cod_age As String = ""
            Dim p_cod_cli As String = ""
            Dim p_responsable_cli As String = ""
            Try
                Dim fila As GridViewRow
                fila = GVPrevisiones.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = GVPrevisiones.Rows(ind)

                Dim Pkey As DataKeyArray = GVPrevisiones.DataKeys

                'prop_empgrupo_cod,prop_emp_cod,prop_tip_vc,prop_ggofetip_cod,prop_n_ofe,prop_gvagente_cod,prop_ggclipr_cod,prop_responsable_cli
                p_grupo = Pkey.Item(ind).Item(0)
                p_empresa = Pkey.Item(ind).Item(1)
                p_tip_vc = Pkey.Item(ind).Item(2)
                p_tipo_ofe = Pkey.Item(ind).Item(3)
                p_n_oferta = Pkey.Item(ind).Item(4)
                p_cod_age = Pkey.Item(ind).Item(5)
                p_cod_cli = Pkey.Item(ind).Item(6)
                p_responsable_cli = Pkey.Item(ind).Item(7)

                Dim prv As New BCb2b.CPrevisiones()
                prv.asignarNuevaLlamada(p_grupo, p_tip_vc, p_cod_cli, ConfigurationManager.AppSettings("CLASI_PRVULTLLAM"))

                'AMC_NE211.JCE.02/03/2016. AGENDA OUTLOOK AL RESPONSABLE DE LA OFERTA
                If p_responsable_cli <> "" Then
                    Dim usuario As New BCb2b.CUsrnom(p_responsable_cli)
                    If usuario.PROP_E_MAIL <> "" Then

                        Dim cliclasi As New BCb2b.CGGCLICLASI(p_grupo, p_tip_vc, p_cod_cli, ConfigurationManager.AppSettings("CLASI_PRVTMPLLAM"))
                        Dim fecha_sig As String = ""
                        If cliclasi.PROP_VALOR <> "" Then
                            Dim dias_entre_llamadas As Integer = CInt(cliclasi.PROP_VALOR)
                            Dim uti As New BCb2b.utilidades_fechas()
                            fecha_sig = uti.SUMAR_DIAS_A_FECHA(Now.Date, dias_entre_llamadas)
                        End If
                        Dim cli As New BCb2b.ggclipr(p_cod_cli, p_grupo, p_tip_vc)
                        Dim v_asunto As String = "REALIZAR LLAMADA. Previsión: " & p_tipo_ofe.ToUpper & " - " & p_n_oferta & ". Cliente: " & cli.prop_NOMBRE & " (" & cli.prop_COD & ")."
                        Dim v_cuerpo As String = "Llamada prevista para hoy con el cliente " & cli.prop_NOMBRE & " (" & cli.prop_COD & ") para tratar la oferta " & p_tipo_ofe.ToUpper & " - " & p_n_oferta
                        Dim v_horacomi As String = fecha_sig & " 11:00:00"
                        Dim v_horafin As String = fecha_sig & " 11:30:00"

                        Dim v_remitente As String = ConfigurationManager.AppSettings("EmailFrom")
                        Dim v_destinatario As String = usuario.PROP_E_MAIL
                        Dim v_servidor As String = ConfigurationManager.AppSettings("correoServidor")
                        Dim v_usuario As String = ""
                        Dim v_password As String = ""
                        Dim v_outlook_agen_sn As String = "S"

                        Dim resul As String = "0"
                        Dim mensa As New BCb2b.CS_MENSAMAIL()
                        resul = mensa.GuardarAgenda(v_remitente, v_destinatario, v_servidor, v_usuario, v_password, v_asunto, v_cuerpo, v_outlook_agen_sn, v_horacomi, v_horafin)
                        If resul = "1" Then
                            Log.Information("No se ha guardado en la agenda: Destino: " & v_destinatario & " Error: " & resul)
                        End If
                    End If
                End If
                'FIN AMC_NE211.JCE.02/03/2016. AGENDA OUTLOOK

                GVPrevisiones.VirtualItemCount = GetRowCount()
                BindPagingGrid()
            Catch ex As Exception
                Log.Error(ex, "[PrevisionesConsulta.GVPrevisiones_RowCommand] grupo = {grupo} emp = {emp} tipvc = {tipvc} tipofe = {tipofe} nofe = {nofe} age = {age} cli = {cli}", p_grupo, p_empresa, p_tip_vc, p_tipo_ofe, p_n_oferta, p_cod_age, p_cod_cli)
            End Try
        End If
    End Sub
    Protected Sub GVPrevisiones_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVPrevisiones.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim fila As BCb2b.CPrevisiones = e.Row.DataItem

            Dim lblSigLlam As New Label
            lblSigLlam = e.Row.FindControl("lblSigLlam")

            If fila.PROP_F_CADUCIDAD <> "" Then
                If CDate(fila.PROP_F_CADUCIDAD) = Now.Date Then
                    'ALERTA
                    e.Row.Cells(7).ForeColor = Drawing.Color.DarkOrange
                ElseIf CDate(fila.PROP_F_CADUCIDAD) < Now.Date Then
                    'CADUCADO
                    e.Row.Cells(7).ForeColor = Drawing.Color.Red
                End If
            End If

            If fila.PROP_SIGUIENTE_LLAMADA <> "" Then
                If CDate(fila.PROP_SIGUIENTE_LLAMADA) < Now.Date Then
                    lblSigLlam.ForeColor = Drawing.Color.Red
                End If
            End If
        End If
    End Sub

    Protected Sub ImgBtArtBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtArtBorrar.Click
        tboxgaartCod.Text = ""
        tboxgaart.Text = ""
    End Sub

    Protected Sub ImgBtCliBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtCliBorrar.Click
        tboxggcliprCod.Text = ""
        tboxggclipr.Text = ""
    End Sub

    Protected Sub ImgBtFCadfinBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFCadfinBorrar.Click
        tboxFCadFin.Text = ""
    End Sub

    Protected Sub ImgBtFCadiniBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFCadiniBorrar.Click
        tboxFCadInicio.Text = ""
    End Sub

    Protected Sub ImgBtFfinBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFfinBorrar.Click
        tboxFOfeFin.Text = ""
    End Sub

    Protected Sub ImgBtFiniBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFiniBorrar.Click
        tboxFOfeInicio.Text = ""
    End Sub
    Public Sub ShowLovAge(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxagente_cod As System.Web.UI.WebControls.TextBox, ByVal tboxagente_descrip As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_agentes.aspx?textbox=" & tboxagente_cod.ClientID & "&textbox2=" & tboxagente_descrip.ClientID, "LOV", 500, 530)
    End Sub
    Public Sub ShowLovPais(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxpais_cod As System.Web.UI.WebControls.TextBox, ByVal tboxpais_descrip As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_paises.aspx?textbox=" & tboxpais_cod.ClientID & "&textbox2=" & tboxpais_descrip.ClientID, "LOV", 500, 530)
    End Sub
    Protected Sub ImgBtAgeBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtAgeBorrar.Click
        tboxAgente.Text = ""
        tboxAgenteCod.Text = ""
    End Sub
    Protected Sub ImgBtPaisBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtPaisBorrar.Click
        tboxPais.Text = ""
        tboxPaisCod.Text = ""
    End Sub

    Protected Sub ImgBtFPlazoIniBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFPlazoIniBorrar.Click
        tboxfplazoIni.Text = ""
    End Sub

    Protected Sub ImgBtFPlazoFinBorrar_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtFPlazoFinBorrar.Click
        tboxfplazoFin.Text = ""
    End Sub
End Class
