﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports AMC_Proyectos_pkg


Partial Class CDG
    'Inherits System.Web.UI.Page
    Inherits claseBase
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        lblError.Visible = False

        Dim calculos As New AMC_Proyectos_pkg.CCalculos()
        If Not Session("calculos") Is Nothing Then
            calculos = Session("calculos")
            If calculos.prop_GGOFETIP_COD <> "" And calculos.prop_N_OFE_REV <> "" Then
                txtTieneOfe.Value = "S"
            Else
                txtTieneOfe.Value = "N"
            End If
        End If

        If Session("editarNOeditar") = False Or txtTieneOfe.Value = "S" Then
            GVCentros.Enabled = False
            nuevoAcentro.Visible = False
            enviarResul.Visible = False
        Else
            GVCentros.Enabled = True
            nuevoAcentro.Visible = True
            enviarResul.Visible = True
        End If

        If Not Page.IsPostBack Then
            CargarApoyos()

            If Not Session("calculos") Is Nothing Then
                Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
                miCalculo = Session("calculos")
                Dim unid_rev As String = miCalculo.PROP_unidadrev
                Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(unid_rev)
                Dim unid_peso_rev As String = uni_calc.prop_peso

                GVCentros.Columns(0).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource1.HeaderText"), String), "(m)", "(" & unid_rev & ")")
                GVCentros.Columns(1).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource2.HeaderText"), String), "(m)", "(" & unid_rev & ")")
                GVCentros.Columns(2).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource3.HeaderText"), String), "(kg)", "(" & unid_peso_rev & ")")
                'GVCentros.Columns(2).HeaderText = CType(GetLocalResourceObject("BoundFieldResource3.HeaderText"), String)
                GVCentros.Columns(3).HeaderText = CType(GetLocalResourceObject("BoundFieldResource4.HeaderText"), String)
                GVCentros.DataBind()
            Else
                Response.Redirect("~/Expirado.aspx")
            End If
        End If
    End Sub

    Protected Sub GVCentros_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles GVCentros.RowDeleting
        lblError.Visible = False
        Dim iddistribucion = Request.QueryString("dist")
        Dim idestudio = Request.QueryString("est")
        Dim fila As GridViewRow
        fila = GVCentros.Rows(e.RowIndex)

        Session("idcentro") = e.RowIndex + 1

        'Dim mifila As Integer = fila.RowIndex.ToString

        'Dim x As String = GridView1.DataKeys.Item(mifila).Item(0).ToString
        'Dim y As String = GridView1.DataKeys.Item(mifila).Item(1).ToString
        'Dim m As String = GridView1.DataKeys.Item(mifila).Item(2).ToString
        'Dim nombre As String = GridView1.DataKeys.Item(mifila).Item(3).ToString

        'Dim v_x As OracleNumber = Metodos.StringToOracleNumber(x)
        'Dim v_y As OracleNumber = Metodos.StringToOracleNumber(y)
        'Dim v_m As OracleNumber = Metodos.StringToOracleNumber(m)
        'Dim v_nombre As String = Replace(nombre, "&nbsp;", "")

        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command As New OracleDataAdapter()
        Dim sql As String

        sql = " DELETE FROM ACENTROS"
        sql = sql & " WHERE IDESTUDIO = :P1 "
        sql = sql & " AND IDDISTRIBUCION = :P2 "
        sql = sql & " AND IDCENTRO = :P3 "
        'sql = sql & " AND X = :P4 "
        'sql = sql & " AND Y = :P5 "
        'sql = sql & " AND M = :P6 "
        'sql = sql & " AND NOMBRE = :P7 "

        conn.ConnectionString = conexion.cadena_conexion
        Dim cmd As New OracleCommand(sql, conn)

        cmd.Parameters.AddWithValue("P1", idestudio)
        cmd.Parameters.AddWithValue("P2", iddistribucion)
        cmd.Parameters.AddWithValue("P3", e.RowIndex + 1)
        'cmd.Parameters.AddWithValue("P4", v_x)
        'cmd.Parameters.AddWithValue("P5", v_y)
        'cmd.Parameters.AddWithValue("P6", v_m)
        'cmd.Parameters.AddWithValue("P7", v_nombre)


        Try
            conn.Open()
            cmd.ExecuteNonQuery()

        Catch ex As Exception
            'Throw New Exception("[Error eliminando Acentro]" & ex.Message)
            'lblError.Text = "[Error eliminando Acentro]" & ex.Message
            lblError.Text = CType(GetLocalResourceObject("Error_Acentro.Text"), String) & " " & ex.Message
            lblError.Visible = True
        End Try

        'UPDATEAR LA TABLA ACENTROS PARA ORDENAR IDCENTRO POR INDICE DE FILA
        Dim i As Integer = 1
        Dim k As Integer = 1

        For i = 1 To GVCentros.Rows.Count - 1
            Dim conn2 As New OracleConnection()
            Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
            Dim command2 As New OracleDataAdapter()
            Dim sql2 As String

            sql2 = " UPDATE ACENTROS SET IDCENTRO=:P1 "
            sql2 = sql2 & " WHERE IDESTUDIO = :P2 "
            sql2 = sql2 & " AND IDDISTRIBUCION = :P3 "
            sql2 = sql2 & " AND IDCENTRO = :P4 "

            conn2.ConnectionString = conexion2.cadena_conexion
            Dim cmd2 As New OracleCommand(sql2, conn2)
            'Dim rdr As OracleDataReader

            cmd2.Parameters.AddWithValue("P1", i)
            cmd2.Parameters.AddWithValue("P2", idestudio)
            cmd2.Parameters.AddWithValue("P3", iddistribucion)
            If i <> Session("idcentro") Then
                cmd2.Parameters.AddWithValue("P4", k)
            Else
                k = k + 1
                cmd2.Parameters.AddWithValue("P4", k)
            End If



            Try
                conn2.Open()
                cmd2.ExecuteNonQuery()

            Catch ex As Exception
                'Throw New Exception("[Error en CDG.resultados()]" & ex.Message)
                lblError.Visible = True
                'lblError.Text = "[Error en CDG.resultados()]" & ex.Message
                lblError.Text = CType(GetLocalResourceObject("Error_Resultados.Text"), String) & " " & ex.Message
            Finally
                conn2.Close()
            End Try
            k = k + 1
        Next i

        CargarApoyos()

        InsertarResponsableModificacion()
    End Sub

    Protected Sub Editar(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewEditEventArgs) Handles GVCentros.RowEditing
        Dim fila As GridViewRow
        fila = GVCentros.Rows(e.NewEditIndex)
        Session("idcentro") = GVCentros.Rows(e.NewEditIndex).RowIndex + 1

        Dim mifila As Integer = fila.RowIndex.ToString

        Dim x As String = GVCentros.DataKeys.Item(mifila).Item(0).ToString
        Dim y As String = GVCentros.DataKeys.Item(mifila).Item(1).ToString
        Dim m As String = GVCentros.DataKeys.Item(mifila).Item(2).ToString
        Dim nombre As String = GVCentros.DataKeys.Item(mifila).Item(3).ToString


        'Para poner el Grid View en modo de edición.
        'GridView1.EditIndex = e.NewEditIndex
        'Dim v_x As OracleNumber = GridView1.DataKeys(fila.RowIndex)(0)
        Dim v_x As OracleNumber = Metodos.StringToOracleNumber(x)
        Dim v_y As OracleNumber = Metodos.StringToOracleNumber(y)
        Dim v_m As OracleNumber = Metodos.StringToOracleNumber(m)
        Dim v_nombre As String = Replace(nombre, "&nbsp;", "")

        Dim l_linea_aux As New ArrayList
        Dim linea_aux As New CAcentros(v_x, v_y, v_m, v_nombre)

        l_linea_aux.Add(linea_aux)

        FVCentros.ChangeMode(FormViewMode.Edit)
        FVCentros.DataSource = l_linea_aux
        FVCentros.DataBind()
        FVCentros.Visible = True
        FVCentros.Enabled = True

        nuevoAcentro.Visible = False

        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")
        Dim unid_rev As String = miCalculo.PROP_unidadrev
        Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(unid_rev)
        Dim unid_peso_rev As String = uni_calc.prop_peso

        CType(FVCentros.FindControl("Label1"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource1.HeaderText"), String), "(m)", "(" & unid_rev & ")")
        CType(FVCentros.FindControl("Label2"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource2.HeaderText"), String), "(m)", "(" & unid_rev & ")")
        CType(FVCentros.FindControl("Label3"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource3.HeaderText"), String), "(kg)", "(" & unid_peso_rev & ")")

        e.Cancel = True
    End Sub

    'Protected Sub calcularResul_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles calcularResul.Click
    'Call resultados()
    'End Sub

    Protected Sub resultados()


        Dim x As String
        Dim y As String
        Dim m As String

        Dim i As Integer = 0
        Dim sumaX As Double = 0
        Dim sumaY As Double = 0
        Dim sumaM As Double = 0

        For i = 0 To GVCentros.Rows.Count - 1
            x = GVCentros.DataKeys.Item(i).Item(0).ToString
            m = GVCentros.DataKeys.Item(i).Item(2).ToString
            sumaX = sumaX + (Metodos.StringToOracleNumber(x) * Metodos.StringToOracleNumber(m))
        Next i

        For i = 0 To GVCentros.Rows.Count - 1
            y = GVCentros.DataKeys.Item(i).Item(1).ToString
            m = GVCentros.DataKeys.Item(i).Item(2).ToString
            sumaY = sumaY + (Metodos.StringToOracleNumber(y) * Metodos.StringToOracleNumber(m))
        Next i

        For i = 0 To GVCentros.Rows.Count - 1
            m = GVCentros.DataKeys.Item(i).Item(2).ToString
            sumaM = sumaM + Metodos.StringToOracleNumber(m)
        Next i


        Dim Rxcda As Double = 0
        Dim Rycda As Double = 0
        If sumaM <> 0 Then
            Rxcda = (sumaX / sumaM)
            Rycda = (sumaY / sumaM)
        Else
            Rxcda = 0
            Rycda = 0
        End If
        Dim Rmtot As Double = sumaM

        Rxcda = Format(Rxcda, "##,##0.0000")
        Rycda = Format(Rycda, "##,##0.0000")
        Rmtot = Format(Rmtot, "##,##0.00")

        xcda.Text = Rxcda.ToString
        ycda.Text = Rycda.ToString
        mtot.Text = Rmtot.ToString

    End Sub

    Protected Sub enviarResul_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles enviarResul.Click
        lblError.Visible = False
        Call resultados()

        'UPDATEAR LA TABLA ADISTRIBUCION PARA ACTUALIZAR PCDG, XCDG Y YCDG
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")

        Dim revision As OracleNumber
        'revision = Session("revision")
        'If Not Session("revision") Is Nothing Then
        '    If Session("revision").ToString = "Null" Then
        '        revision = miCalculo.prop_revision
        '    Else
        '        revision = Session("revision")
        '    End If
        'Else
        revision = miCalculo.prop_revision
        'End If



        Dim ggestcampa_cod As String
        ggestcampa_cod = miProyecto.prop_cod

        Dim conn, conn2 As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command As New OracleDataAdapter()
        Dim sql As String
        Dim vsql As String = ""

        sql = " UPDATE ADISTRIBUCION SET PCDG=:P3,XCDG=:P4,YCDG=:P5"
        sql = sql & " WHERE IDESTUDIO = :P1 "
        sql = sql & " AND REVISION = :P2 "

        conn.ConnectionString = conexion.cadena_conexion
        Dim cmd As New OracleCommand(sql, conn)
        'Dim rdr As OracleDataReader

        If xcda.Text = "NaN" Or xcda.Text = "NeuN" Then
            xcda.Text = 0
        End If
        If ycda.Text = "NaN" Or ycda.Text = "NeuN" Then
            ycda.Text = 0
        End If
        cmd.Parameters.AddWithValue("P1", ggestcampa_cod)
        cmd.Parameters.AddWithValue("P2", revision)
        cmd.Parameters.AddWithValue("P3", mtot.Text)
        cmd.Parameters.AddWithValue("P4", xcda.Text)
        cmd.Parameters.AddWithValue("P5", ycda.Text)


        Try
            conn.Open()
            cmd.ExecuteNonQuery()

        Catch ex As Exception
            'Throw New Exception("[Error en CDG.resultados()]" & ex.Message)
            'lblError.Text = "[Error en CDG.resultados()]" & ex.Message
            lblError.Text = CType(GetLocalResourceObject("Error_EnvResultados.Text"), String) & " " & ex.Message
            lblError.Visible = True
        End Try

        Dim script(11) As String

        script(1) = "<script>window.opener.document.forms[0]." + Request.QueryString("c1") + ".value ='"
        script(2) = mtot.Text
        script(3) = "';"
        script(4) = "window.opener.document.forms[0]." + Request.QueryString("c2") + ".value ='"
        script(5) = xcda.Text
        script(6) = "';"
        script(7) = "window.opener.document.forms[0]." + Request.QueryString("c3") + ".value ='"
        script(8) = ycda.Text
        script(9) = "';"
        script(10) = "self.close();"
        script(11) = "</" + "script>"
        Dim KK As String = Join(script, "")
        'RegisterClientScriptBlock("test", Join(script, ""))
        ClientScript.RegisterClientScriptBlock(Me.GetType, "CdgLov", Join(script, ""), False)


        Dim valores(2) As String

        If xcda.Text = "NaN" Or xcda.Text = "NeuN" Then
            valores(0) = ("")
        Else
            valores(0) = (xcda.Text)
        End If
        If ycda.Text = "NaN" Or ycda.Text = "NeuN" Then
            valores(1) = ("")
        Else
            valores(1) = (ycda.Text)
        End If
        valores(2) = (mtot.Text)

        Session("ValoresCentros") = valores

        Dim num As Integer = 0
        num = GVCentros.Rows.Count
        If num = 0 Then
            tablaresults.Visible = False
            lblnocentros.Visible = True
            div_lblnocentros.Visible = True
        Else
            tablaresults.Visible = True
            lblnocentros.Visible = False
            div_lblnocentros.Visible = False
        End If

    End Sub


    Protected Sub nuevoAcentro_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles nuevoAcentro.Click
        nuevoAcentro.Visible = False
        FVCentros.ChangeMode(FormViewMode.Insert)
        FVCentros.Visible = True
        FVCentros.Enabled = True
        FVCentros.DataBind()

        Try
            Dim v_x As New System.Web.UI.WebControls.TextBox
            v_x = CType(FVCentros.FindControl("ins_x"), System.Web.UI.WebControls.TextBox)
            v_x.Text = ""

            Dim v_y As New System.Web.UI.WebControls.TextBox
            v_y = CType(FVCentros.FindControl("ins_y"), System.Web.UI.WebControls.TextBox)
            v_y.Text = ""

            Dim v_m As New System.Web.UI.WebControls.TextBox
            v_m = CType(FVCentros.FindControl("ins_m"), System.Web.UI.WebControls.TextBox)
            v_m.Text = ""

            Dim v_nombre As New System.Web.UI.WebControls.TextBox
            v_nombre = CType(FVCentros.FindControl("ins_nombre"), System.Web.UI.WebControls.TextBox)
            v_nombre.Text = ""

            Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
            miCalculo = Session("calculos")
            Dim unid_rev As String = miCalculo.PROP_unidadrev
            Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(unid_rev)
            Dim unid_peso_rev As String = uni_calc.prop_peso

            CType(FVCentros.FindControl("Label1"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource1.HeaderText"), String), "(m)", "(" & unid_rev & ")")
            CType(FVCentros.FindControl("Label2"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource2.HeaderText"), String), "(m)", "(" & unid_rev & ")")
            CType(FVCentros.FindControl("Label3"), Label).Text = Replace(CType(GetLocalResourceObject("BoundFieldResource3.HeaderText"), String), "(kg)", "(" & unid_peso_rev & ")")
        Catch ex As Exception

        End Try

    End Sub
    Protected Sub GVCentros_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)

        If (e.Row.RowType = DataControlRowType.DataRow) Then

            Dim lbBorrar As ImageButton = e.Row.FindControl("lbBorrar")
            'lbBorrar.Attributes.Add("onclick", "javascript:return " & "confirm('¿Desea eliminar el registro número " & DataBinder.Eval(e.Row.DataItem, "prop_x") + "?')")
            'lbBorrar.Attributes.Add("onclick", "javascript:return " & "confirm('¿Desea eliminar el registro número " & e.Row.RowIndex + 1 & "?')")
            lbBorrar.Attributes.Add("onclick", "javascript:return " & CType(GetLocalResourceObject("Preg_elim.Text"), String) & " " & e.Row.RowIndex + 1 & "?')")

        End If

    End Sub

    Protected Sub btnActualizar_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        Dim micalculo As New AMC_Proyectos_pkg.CCalculos()
        micalculo = Session("calculos")

        Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(micalculo.PROP_unidadrev)

        'Aquí actualizamos el registro.
        Dim v_x As New System.Web.UI.WebControls.TextBox
        v_x = CType(FVCentros.FindControl("x"), System.Web.UI.WebControls.TextBox)
        Dim x As OracleNumber = Metodos.StringToOracleNumber(v_x.Text)
        uni_calc.ConvertirUnidad(micalculo.PROP_unidadrev, x)

        Dim v_y As New System.Web.UI.WebControls.TextBox
        v_y = CType(FVCentros.FindControl("y"), System.Web.UI.WebControls.TextBox)
        Dim y As OracleNumber = Metodos.StringToOracleNumber(v_y.Text)
        uni_calc.ConvertirUnidad(micalculo.PROP_unidadrev, y)

        Dim v_m As New System.Web.UI.WebControls.TextBox
        v_m = CType(FVCentros.FindControl("m"), System.Web.UI.WebControls.TextBox)
        Dim m As OracleNumber = Metodos.StringToOracleNumber(v_m.Text)
        Dim pesoOri As String = uni_calc.prop_peso 'PESO ORIGINAL DE UNIDAD DE CALCULO. uni IN --> peso LB
        Dim uni_def As String = uni_calc.prop_uni_def 'UNI_DEF DEL CALCULO --> MM

        Dim castUniDes As New AMC_Proyectos_pkg.CUnidades_Calculos(uni_def)
        Dim pesoDest As String = castUniDes.prop_peso 'PESO DE UNI_DEF --> KG
        castUniDes.ConvertirUnidad(pesoOri, m, pesoDest) 'CONVERTIR DE LB A KG PARA INSERTAR

        Dim v_nombre As New System.Web.UI.WebControls.TextBox
        v_nombre = CType(FVCentros.FindControl("nombre"), System.Web.UI.WebControls.TextBox)
        Dim nombre As String = v_nombre.Text

        'Dim txtvalor_E As New System.Web.UI.WebControls.TextBox
        'txtvalor_E = CType(FormView1.FindControl("txtvalor_E"), System.Web.UI.WebControls.TextBox)
        'txtvalor_E.Text = txtvalor_E.Text

        'Dim codlibre_sn As String
        'Dim Cggclatip = New BCb2b.CGGCLATIP(ConfigurationManager.AppSettings("Venta"), v_x.Text)
        'codlibre_sn = Cggclatip.prop_CODLIBRE_SN

        'Dim p_valor As String
        'Dim p_ggclasif_cod As String

        'If codlibre_sn = "N" Then
        '    p_valor = Nothing
        '    If Session("CodSel") <> Nothing Then
        '        p_ggclasif_cod = Session("CodSel")
        '    Else
        '        p_ggclasif_cod = txtvalor_E.Text
        '    End If
        'Else
        '    p_valor = txtvalor_E.Text
        '    p_ggclasif_cod = Nothing
        'End If

        Dim iddistribucion = Request.QueryString("dist")
        Dim idestudio = Request.QueryString("est")

        'calcular idcentro cuando instalen dreamweaver para ver formula

        Dim idcentro As String = Session("idcentro").ToString

        'xxxx
        'Dim cantidad_aux As String = x.ToString
        'Dim aux As Double
        'aux = CType(cantidad_aux, Double)
        'Dim xaux As OracleNumber = OracleNumber.op_Explicit(aux)
        'xxxx

        AMC_Proyectos_pkg.CAcentros.actualiza_centro(idestudio, iddistribucion, _
        idcentro, x, y, m, Left(nombre, 19))

        CargarApoyos()

        InsertarResponsableModificacion()
        'btnInsertarClasif.Visible = True
    End Sub

    Protected Sub btnCancelar_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        CargarApoyos()
    End Sub
    Private Sub CargarApoyos()
        nuevoAcentro.Visible = True
        FVCentros.ChangeMode(FormViewMode.ReadOnly)
        FVCentros.DataSource = Nothing
        FVCentros.DataBind()
        FVCentros.Visible = False
        FVCentros.Enabled = False

        Dim iddistribucion = Request.QueryString("dist")
        Dim idestudio = Request.QueryString("est")

        Dim lista_centros As ArrayList
        lista_centros = AMC_Proyectos_pkg.CAcentros.cargar_datos(iddistribucion, idestudio)

        GVCentros.DataSource = lista_centros
        GVCentros.DataBind()

        Call resultados()

        If GVCentros.Rows.Count = 0 Then
            tablaresults.Visible = False
            lblnocentros.Visible = True
            div_lblnocentros.Visible = True
        Else
            tablaresults.Visible = True
            lblnocentros.Visible = False
            div_lblnocentros.Visible = False
        End If
    End Sub
    Protected Sub btnInsertar_Click(ByVal sender As Object, ByVal e As System.EventArgs)


        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim micalculo As New AMC_Proyectos_pkg.CCalculos()
        micalculo = Session("calculos")

        Dim uni_calc As New CUnidades_Calculos(micalculo.PROP_unidadrev)

        'Dim idcentro As String = Session("idcentro").ToString
        Dim num As Integer = 0
        num = GVCentros.Rows.Count

        Dim v_x As New System.Web.UI.WebControls.TextBox
        v_x = CType(FVCentros.FindControl("ins_x"), System.Web.UI.WebControls.TextBox)
        Dim x As OracleNumber = Metodos.StringToOracleNumber(v_x.Text)
        uni_calc.ConvertirUnidad(micalculo.PROP_unidadrev, x)

        Dim v_y As New System.Web.UI.WebControls.TextBox
        v_y = CType(FVCentros.FindControl("ins_y"), System.Web.UI.WebControls.TextBox)
        Dim y As OracleNumber = Metodos.StringToOracleNumber(v_y.Text)
        uni_calc.ConvertirUnidad(micalculo.PROP_unidadrev, y)

        Dim v_m As New System.Web.UI.WebControls.TextBox
        v_m = CType(FVCentros.FindControl("ins_m"), System.Web.UI.WebControls.TextBox)
        Dim m As OracleNumber = Metodos.StringToOracleNumber(v_m.Text)
        Dim pesoOri As String = uni_calc.prop_peso 'PESO ORIGINAL DE UNIDAD DE CALCULO. uni IN --> peso LB
        Dim uni_def As String = uni_calc.prop_uni_def 'UNI_DEF DEL CALCULO --> MM

        Dim CasrUniDest As New CUnidades_Calculos(uni_def)
        Dim pesoDest As String = CasrUniDest.prop_peso 'PESO DE UNI_DEF --> KG
        CasrUniDest.ConvertirUnidad(pesoOri, m, pesoDest) 'CONVERTIR DE LB A KG PARA INSERTAR

        Dim v_nombre As New System.Web.UI.WebControls.TextBox
        v_nombre = CType(FVCentros.FindControl("ins_nombre"), System.Web.UI.WebControls.TextBox)
        Dim nombre As String = v_nombre.Text

        Dim iddistribucion = Request.QueryString("dist")
        Dim idestudio = Request.QueryString("est")

        Dim centro As New AMC_Proyectos_pkg.CAcentros.centro
        centro.introducirAcentro(miProyecto, iddistribucion, idestudio, m, x, y, Left(nombre, 19), num)

        CargarApoyos()

        InsertarResponsableModificacion()
    End Sub
    Private Sub InsertarResponsableModificacion()
        Dim micalculo As New AMC_Proyectos_pkg.CCalculos()
        micalculo = Session("calculos")

       '---------ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
        Dim uti As New BCb2b.Utilities()
        Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
        micalculo.Gestiona_UsuResp_CreMod_Calculo(micalculo.prop_idestudio, micalculo.prop_iddistribucion, micalculo.prop_revision, cod_usuario.ToUpper)
        '---------FIN ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
    End Sub
End Class
