﻿Imports System.Data.OracleClient
Imports AMC_Proyectos_pkg
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports System.Web.Mail
Imports System.Diagnostics
Imports System.IO

Partial Class editarApoyos
    Inherits System.Web.UI.Page


    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArt(ByVal cod_Art As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        Return articulo_prueba.prop_descrip
                    Else
                        Return " "
                    End If
                Else
                    Return "Artículo no valido"
                End If

            Catch ex As Exception
                Return "Artículo no valido"
            End Try
        Else
            Return " "
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArtIdioma(ByVal cod_Art As String, ByVal vggobstip_cod As String, ByVal vcodigo_idioma As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, vcodigo_idioma)
                If dd <> "" Then
                    If (dd <> "Null") Then
                        Return dd
                    Else
                        Return articulo_prueba.prop_descrip
                    End If
                Else
                    Return "Invalid"
                End If

            Catch ex As Exception
                Return "Invalid"
            End Try
        Else
            Return " "
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function usuarioValido(ByVal usrnom As String, ByVal usrpass As String, ByVal Sesion_usuario As String) As String
        Dim Usuario As New BCb2b.CUsuarios(usrnom, _
                                           usrpass, _
                                           ConfigurationManager.AppSettings("grupo"), _
                                           ConfigurationManager.AppSettings("Venta"), _
                                           ConfigurationManager.AppSettings("usrnom"), _
                                           ConfigurationManager.AppSettings("usrpass"))
        If Not Usuario.es_vacio() Then
            If (Usuario.prop_LOGIN.CompareTo(Sesion_usuario) = 0) Then
                'If (Usuario.prop_LOGIN.CompareTo("CELMA") = 0) Then

                Return "S"
            Else
                Return "N"
            End If
        Else
            Return "N"
        End If
        Return "S"

    End Function
    <Ajax.AjaxMethod()> _
    Public Function transfiereme() As String
        ' Dado un codigo artículo calculo precios y descuentos para
        ' cantidad 1.
        'btn_crearPedido.Attributes.Add("onclick", "javascript:document.forms[0].target='_blank';")
        'Server.Transfer("verPedido.aspx")
        'btn_crearPedido.Attributes.Add("onclick", "javascript:document.forms[0].target='_self';")
        Return ""
    End Function


    <Ajax.AjaxMethod()> _
    Public Function Obtener_RadioArt(ByVal cod_Art As String) As String
        ' Dado un codigo artículo calculo precios y descuentos para
        ' cantidad 1.


        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim calculo As CCalculos.operacionesCalculos
                calculo = New CCalculos.operacionesCalculos
                Dim radio_art As String = calculo.RADIO(cod_Art, ConfigurationManager.AppSettings("grupo"))

                If (radio_art <> "") Then
                    Return radio_art
                Else
                    Return ""
                End If


            Catch ex As Exception
                Return "Artículo no valido"
            End Try
        Else
            Return ""
        End If
    End Function

    Protected Sub SaveButton_Click(sender As Object, e As System.EventArgs) Handles SaveButton.Click
        Dim kk As String = ""

    End Sub
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Session("iddistribucion") = 126 '3549
        Ajax.Utility.RegisterTypeForAjax(GetType(editarApoyos))

        ShowLupaArticulo(IBarticuloInsertar, tbxCodigoArticulo, lblDescripcionArt, lblRadioArt)
        '  Response.Cache.SetCacheability(HttpCacheability.NoCache)
    End Sub

    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.WebControl, ByVal art_desControl As System.Web.UI.WebControls.WebControl, ByVal art_radioControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_radioControl.ClientID, "LOV", 400, 450)
    End Sub

    Protected Sub BulkEditGridView1_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles BulkEditGridView1.RowDataBound

        If (e.Row.RowType = DataControlRowType.DataRow) Then

            Dim cargas As Boolean = False

            Dim tboxX As TextBox
            Dim tboxy As TextBox
            Dim tboxCarga As TextBox
            Dim tboxCodigoArt As TextBox
            Dim tboxDescripART As TextBox
            Dim tboxRadio_art As TextBox
            Dim lblborrar As IButtonControl


            Dim lblDescripART As System.Web.UI.WebControls.Label
            Dim lblRadio_art As System.Web.UI.WebControls.Label

            Dim ibLupaArt As ImageButton

            tboxX = e.Row.FindControl("tboxX")
            tboxy = e.Row.FindControl("tboxY")
            tboxCarga = e.Row.FindControl("tboxCarga")
            tboxCodigoArt = e.Row.FindControl("tboxGaartCod")
            tboxDescripART = e.Row.FindControl("descrip_art")
            tboxRadio_art = e.Row.FindControl("tboxRadio_art")

            lblDescripART = e.Row.FindControl("lbldescrip_art")
            lblRadio_art = e.Row.FindControl("lblRadio_art")

            ibLupaArt = e.Row.FindControl("IBarticulo")

            lblborrar = e.Row.FindControl("lbBorrar")



            If cargas Then
                tboxX.Enabled = False
                tboxy.Enabled = False
                tboxCarga.Enabled = True
            Else
                tboxX.Enabled = True
                tboxy.Enabled = True
                tboxCarga.Enabled = False
            End If

            'Datos del artículo:
            Dim EMPRESAGRUPO As String = ConfigurationManager.AppSettings("Grupo")
            Dim clasifCargas As String = ConfigurationManager.AppSettings("KZ")
            Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
            Dim IDIOMA As String = Session("idioma")
            Dim cargamax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")


            Dim p_com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")


            Dim ART As New BCb2b.gaart(EMPRESAGRUPO, tboxCodigoArt.Text)
            Dim descripcionArtIdioma As String
            descripcionArtIdioma = ART.descripcion_idiomas(p_com, Session("idioma"))
            If descripcionArtIdioma = "" Then
                descripcionArtIdioma = ART.prop_DESCRIP
            End If
            tboxDescripART.Text = descripcionArtIdioma
            lblDescripART.Text = descripcionArtIdioma

            Dim vRadio As String = New CCalculos.operacionesCalculos().RADIO(tboxCodigoArt.Text, EMPRESAGRUPO)
            tboxRadio_art.Text = vRadio
            lblRadio_art.Text = vRadio

            Dim vAmortig As String = New CCalculos.operacionesCalculos().AMORTIGUACION(tboxCodigoArt.Text, EMPRESAGRUPO)



            'fin datos del artículo
            'PONEMOS AJAX 
            tboxCodigoArt.Attributes.Add("onBlur", "javascript:dame_xx('" + tboxCodigoArt.ClientID + "', '" + lblDescripART.ClientID + "','" + lblRadio_art.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "')")
            'lblborrar.Attributes.Add("onclick", "javascript:return " & CType(GetLocalResourceObject("Preg_elim.Text"), String) & " " & e.Row.RowIndex + 1 & "?')")

            ShowLupaArticulo(ibLupaArt, tboxCodigoArt, lblDescripART, lblRadio_art)

        End If
    End Sub

    Protected Sub BulkEditGridView1_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles BulkEditGridView1.RowCommand
        'Dim DesigCode As String = GridView1.Rows(e.RowIndex).Cells(1).Text
        If e.CommandName = "Delete" Then
            Dim calculos As New AMC_Proyectos_pkg.CCalculos.apoyo
            Dim numeroApoyo As Integer = e.CommandArgument

            Dim calculo As New AMC_Proyectos_pkg.CCalculos()


            Dim misCalculos As New AMC_Proyectos_pkg.CCalculos
            misCalculos.cargar_datos("1205175009", "3549", "1", ConfigurationManager.AppSettings("Grupo"), "", "", "", "", Session("idioma"), "COM")


            Session("calculos") = misCalculos

            calculos.eliminar_apoyos(Session("iddistribucion"), numeroApoyo, Session("calculos"))

        End If
    End Sub

    Protected Sub btnAnadirApoyos_Click(sender As Object, e As System.EventArgs) Handles btnAnadirApoyos.Click
        Dim numeroApoyos As OracleNumber = tboxNApoyos.Text
        Dim CodigoArticulo As String = tbxCodigoArticulo.Text

        Dim iddistribucion As OracleNumber = Session("iddistribucion").ToString
        Dim idapoyo As OracleNumber = OracleNumber.Null
        Dim idarticulo As String = CodigoArticulo
        Dim x As String = "0"
        Dim y As String = "0"
        Dim carga As String = "0"
        Dim radio As String = "0"

        Dim i As Integer = 0
        For i = 0 To numeroApoyos - 1
            Dim apoyo As New AMC_Proyectos_pkg.CCalculos.apoyo()
            apoyo.introducir_apoyos(iddistribucion, idarticulo, x, y, carga, radio)
        Next

        BulkEditGridView1.DataBind()

    End Sub
End Class
