﻿Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration
Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports AMC_Proyectos_pkg
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports System.Web.Mail
Imports System.Resources

Imports System.Web.Security
Imports System.Runtime.InteropServices
Imports System.Security.Principal
Imports System.IO

Imports System.Diagnostics




Partial Class imprimirProyecto
    Inherits claseBase
    Dim CR As New CrystalDecisions.CrystalReports.Engine.ReportDocument

    Private _pFilePath_ini As String
    Private _listaFics As ArrayList

    Private Property pFilePath_ini As String
        Get
            Return _pFilePath_ini
        End Get
        Set(value As String)
            _pFilePath_ini = value
        End Set
    End Property

    Private Property listaFics As ArrayList
        Get
            Return _listaFics
        End Get
        Set(value As ArrayList)
            _listaFics = value
        End Set
    End Property
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init

        Dim listaImagenApoyos As ArrayList = New ArrayList()
        Dim listaGridview2 As ArrayList = New ArrayList()

        Dim vlistaFics As ArrayList = New ArrayList()

        Dim lista_calculos As ArrayList = Session("LISTA_CALCULOS")
        Dim i As Int32 = 0

        Dim pdfs As New MergeEx()
        'Dim lFrecuencias As ArrayList = Session("lgridview2")
        'Dim ldataset As ArrayList = Session("ldataset")

        Dim lFrecuencias As New ArrayList
        Dim ldataset As New ArrayList
        If Not Session("lgridview2") Is Nothing Then
            lFrecuencias = Session("lgridview2")
        Else 'PARA QUE RECALCULE SI POR LO QUE SEA NO TRAE NADA.
            Try
                Server.Transfer("pruebagraficos.aspx?mail=" & Request.QueryString("mail"))
            Catch ex As Exception
            End Try
        End If


        If Not Session("ldataset") Is Nothing Then
            ldataset = Session("ldataset")
        Else 'PARA QUE RECALCULE SI POR LO QUE SEA NO TRAE NADA.
            Try
                Server.Transfer("pruebagraficos.aspx?mail=" & Request.QueryString("mail"))
            Catch ex As Exception
            End Try
        End If

        Dim indice = 0

        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        'Código para cargar el report.
        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        conn.ConnectionString = conexion.cadena_conexion
        conn.Open()

        For Each element As CCalculos In lista_calculos
            'CR.Load(Server.MapPath("~/Proyectos/informes/varios_calculos.rpt"))
            CR.Load(Server.MapPath("~/Proyectos/informes/calculos.rpt"))

            Try
                'obtengo las sqls
                Dim sql As String = DAMESQL(element)
                Dim sql_gridview As String = DAMESQL_GRIDVIEW(element)
                Dim sql_centros As String = DAMESQL_CENTROS(element)
                Dim sql_frecuencias As String = DAMESQL_FRECUENCIAS(element, lFrecuencias(indice), ldataset(indice))

                indice = indice + 1

                'Código para cargar el report.
                Dim cmd As New OracleCommand(sql, conn)
                cmd.CommandText = sql
                cmd.CommandType = CommandType.Text

                Dim DatosDS As New DataSet2()
                Dim DatosDAC As New OracleDataAdapter(sql, conn)
                Dim DatosDAP As New OracleDataAdapter(sql_gridview, conn)
                Dim DatosDACE As New OracleDataAdapter(sql_centros, conn)
                Dim DatosDAFreq As New OracleDataAdapter(sql_frecuencias, conn) 'JVC COMENTO ESTO POR AHORA

                DatosDAC.Fill(DatosDS.DataTable1)
                DatosDAP.Fill(DatosDS.DataTable_GridView)
                DatosDACE.Fill(DatosDS.DataTableCentros)
                DatosDAFreq.Fill(DatosDS.DataTableFrecuencias) 'JVC COMENTO ESTO POR AHORA.

                CR.SetDataSource(DatosDS)

                ' 'Configuramos del report viewer
                CrystalReportViewer1.ReportSource = CR
                CrystalReportViewer1.BestFitPage = True
                CrystalReportViewer1.CssFilename = "~/Proyectos/default.css"

                'CrystalReportViewer1.HasCrystalLogo = False

                'CrystalReportViewer1.PDFOneClickPrinting = False

                'CrystalReportViewer1.HasDrillUpButton = False
                'CrystalReportViewer1.HasToggleGroupTreeButton = False
                'CrystalReportViewer1.HasZoomFactorList = False
                'CrystalReportViewer1.PrintMode = CrystalDecisions.Web.PrintMode.ActiveX
                'CrystalReportViewer1.AutoDataBind = True
                'CrystalReportViewer1.HasPrintButton = True


                Dim nombre As String = "informe"
                If Not (element Is Nothing) Then
                    miCalculo = element
                    nombre = miCalculo.prop_idestudio.ToString() & "_" & DateTime.Now.ToString


                End If


                If Not (Session("proyecto") Is Nothing) Then

                    Dim miProyecto As AMC_Proyectos_pkg.CProyectos
                    miProyecto = New AMC_Proyectos_pkg.CProyectos()
                    miProyecto = Session("proyecto")
                    ' nombre = "AMC_calc_" & miProyecto.prop_cod & "_" & miProyecto.prop_descrip 'porque esto da problemas en el caso de que la descrip lleve por ejemplo ,, windows no admite eso en el nombre de un fichero.
                    If nombre = "" Then
                        nombre = "AMC_caculation_" & DateTime.Now.ToString
                    End If
                End If

                'Añado los nombres de las imagenes a una lista.
                listaImagenApoyos.Add(nombre)


                ' Esto es lo nuevo....
                'Para ponerlo en pantalla
                '  CR.ExportToHttpResponse(ExportFormatType.PortableDocFormat, Response, False, nombre)
                'Para pasarlo a disco
                CambiarIdiomaReport(miCalculo.PROP_unidadrev)
                Dim rutaFisica As String = ConfigurationManager.AppSettings("ruta_fisica_merge_docs")
                Dim nombreFic As String = rutaFisica & DateTime.Now.ToString("yyyyMMddHmmss") & "_" & i & ".pdf"
                CR.ExportToDisk(ExportFormatType.PortableDocFormat, nombreFic)

                vlistaFics.Add(nombreFic)
                pdfs.AddFile(nombreFic)

                CambiarIdiomaReport(miCalculo.PROP_unidadrev)



            Catch ex As Exception
                Throw New Exception("Error:" + ex.Message.ToString)
                lblError.Text = "Error:" + ex.Message.ToString
            End Try
            i = i + 1
        Next

        conn.Close()
        conn.Dispose()

        listaFics = vlistaFics
        pdfs.DestinationFile = "c:\temp\PC_" & DateTime.Now.ToString("yyyyMMddHmmss") & ".pdf"
        pdfs.Execute()

        Dim volver As String = ""
        ' /*************************************************/
        Dim FilePath_ini As String = pdfs.DestinationFile
        pFilePath_ini = FilePath_ini
        If (Request.QueryString("mail") = "") Then


            'Establecer el ContentType apropiado. 
            'Response.ClearContent()
            'Response.ClearHeaders()
            'Response.Clear()
            'Response.ContentType = "Application/pdf"
            ''Obtener la ruta de acceso física del archivo.

            ''Escribir el archivo directamente en la secuencia de salida HTTP.
            'Response.WriteFile(FilePath_ini)

            Dim nombrefich As String = Path.GetFileName(FilePath_ini)

            Response.Clear()
            Response.ContentType = "application/pdf"
            Response.AddHeader("content-disposition", "filename=" + nombreFich)
            Response.Flush()
            Response.WriteFile(FilePath_ini)
            Response.End()

        End If

        '-----------------INICIO CUERPO DEL EMAIL-----------------

        Dim cuerpo_html As String = Session("contenido_email_html")

        Dim cuerpo_a_enviar As String = ""

        cuerpo_a_enviar = cuerpo_html
        If cuerpo_html = "" Then
            cuerpo_a_enviar = CType(GetLocalResourceObject("Correo_Cuerpo.Text"), String)
        End If
        '------------------FIN CUERPO DEL EMAIL-------------------

        'AMC_NE149. GESTION DE ENVIO DE EMAILS.
        Dim mail As New BCb2b_AMC.CEnvio_Emails()
        Dim resul As String = "0"
        resul = mail.AMC_NE149_ENVIO_EMAILS(ConfigurationManager.AppSettings("grupo"), cliente, Session("agente"), Session("usuario"), "R_EMAIL_C", ConfigurationManager.AppSettings("CLASI_NACION"), ConfigurationManager.AppSettings("CLASI_CONFIRMS"), ConfigurationManager.AppSettings("REP_OFER"), ConfigurationManager.AppSettings("ClasifLogin"), Session("idioma_spyro"), ConfigurationManager.AppSettings("correoFrom"), Request.QueryString("mail"), ConfigurationManager.AppSettings("correoOc"), CType(GetLocalResourceObject("Correo_Asunto.Text"), String), cuerpo_a_enviar, FilePath_ini, Server.MapPath(ConfigurationManager.AppSettings("ruta_plantilla_calc")), ConfigurationManager.AppSettings("ruta_logo_plantilla_calc"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_CONTACTIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_CONTACTIP"), Session("perfil_usuario"))
        volver = resul
        ''SI RESUL = 0 --> OK
        ''SI RESUL = 1 --> ERROR

        'borrar ficheros auxiliares

        For Each elemento As String In listaFics
            'System.IO.File.Delete(elemento)
        Next

        If (Request.QueryString("mail") = "") Then
            Response.Flush()

            'System.IO.File.Delete(pFilePath_ini)
            Response.End()
        Else
            'System.IO.File.Delete(pFilePath_ini)
            Response.Redirect("~/Proyectos/ver_revisiones.aspx?l=" & volver)
            Response.End()
        End If


        '/*************************************************/

        
    End Sub
    Private Sub CambiarIdiomaReport(ByVal uni_calc As String)
        Dim calc_uni As New AMC_Proyectos_pkg.CUnidades_Calculos(uni_calc)

        ' PROYECTO
        Dim myTextObjectOnReport1_1 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport1_1 = CType(CR.ReportDefinition.ReportObjects.Item("txtProyecto"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport1_1.Text = CType(GetLocalResourceObject("txtProyecto.Text"), String)

        ' CONTACTO
        Dim myTextObjectOnReport1_3 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport1_3 = CType(CR.ReportDefinition.ReportObjects.Item("txtContacto"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport1_3.Text = CType(GetLocalResourceObject("txtContacto.Text"), String)


        ' OBSERVACIONES
        Dim myTextObjectOnReport1 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport1 = CType(CR.ReportDefinition.ReportObjects.Item("txtObservaciones"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport1.Text = CType(GetLocalResourceObject("txtObservaciones.Text"), String)

        'Idioma AMC MECANOCAUCHO® SERVICIO DE ASISTENCIA TÉCNICA
        Dim myTextObjectOnReport1_2 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport1_2 = CType(CR.ReportDefinition.ReportObjects.Item("Text1"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport1_2.Text = CType(GetLocalResourceObject("Titulo.Text"), String)

        'Idioma SERVICIOS
        Dim myTextObjectOnReport2 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport2 = CType(CR.ReportDefinition.ReportObjects.Item("Text2"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport2.Text = CType(GetLocalResourceObject("Servicios.Text"), String)

        'Idioma Estudio nº:
        Dim myTextObjectOnReport3 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport3 = CType(CR.ReportDefinition.ReportObjects.Item("Text3"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport3.Text = CType(GetLocalResourceObject("NEstudio.Text"), String)

        'Idioma Fecha de Estudio:
        Dim myTextObjectOnReport4 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport4 = CType(CR.ReportDefinition.ReportObjects.Item("Text4"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport4.Text = CType(GetLocalResourceObject("FEstudio.Text"), String)

        ''Idioma Contacto:
        'Dim myTextObjectOnReport5 As CrystalDecisions.CrystalReports.Engine.TextObject
        'myTextObjectOnReport5 = CType(CR.ReportDefinition.ReportObjects.Item("Text5"), CrystalDecisions.CrystalReports.Engine.TextObject)
        'myTextObjectOnReport5.Text = CType(GetLocalResourceObject("Contacto.Text"), String)

        'Idioma Fax:
        Dim myTextObjectOnReport6 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport6 = CType(CR.ReportDefinition.ReportObjects.Item("Text6"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport6.Text = CType(GetLocalResourceObject("Fax.Text"), String)

        'Idioma Revisión:
        Dim myTextObjectOnReport7 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport7 = CType(CR.ReportDefinition.ReportObjects.Item("Text7"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport7.Text = CType(GetLocalResourceObject("Revision.Text"), String)

        'Idioma Fecha:
        Dim myTextObjectOnReport8 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport8 = CType(CR.ReportDefinition.ReportObjects.Item("Text8"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport8.Text = CType(GetLocalResourceObject("Fecha.Text"), String)

        'Idioma Autor:
        Dim myTextObjectOnReport9 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport9 = CType(CR.ReportDefinition.ReportObjects.Item("Text9"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport9.Text = CType(GetLocalResourceObject("Autor.Text"), String)

        'Idioma E-mail:
        Dim myTextObjectOnReport10 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport10 = CType(CR.ReportDefinition.ReportObjects.Item("Text10"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport10.Text = CType(GetLocalResourceObject("Email.Text"), String)

        ''Idioma Caso nº A
        'Dim myTextObjectOnReport11 As CrystalDecisions.CrystalReports.Engine.TextObject
        'myTextObjectOnReport11 = CType(CR.ReportDefinition.ReportObjects.Item("Text11"), CrystalDecisions.CrystalReports.Engine.TextObject)
        'myTextObjectOnReport11.Text = CType(GetLocalResourceObject("Caso.Text"), String)

        'Idioma Cargas del Sistema
        Dim myTextObjectOnReport12 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport12 = CType(CR.ReportDefinition.ReportObjects.Item("Text12"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport12.Text = CType(GetLocalResourceObject("Cargas.text"), String)

        'Idioma Centro de gravitación Total
        Dim myTextObjectOnReport17 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport17 = CType(CR.ReportDefinition.ReportObjects.Item("Text17"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport17.Text = CType(GetLocalResourceObject("TextCentro.Text"), String)

        'Idioma Masa Total
        Dim myTextObjectOnReport20 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport20 = CType(CR.ReportDefinition.ReportObjects.Item("Text20"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport20.Text = CType(GetLocalResourceObject("MasaTotal.Text"), String)

        'Idioma AMC MECANOCAUCHO® SERVICIO DE ASISTENCIA TÉCNICA
        Dim myTextObjectOnReport69 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport69 = CType(CR.ReportDefinition.ReportObjects.Item("Text69"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport69.Text = CType(GetLocalResourceObject("Titulo.Text"), String)

        'unidad Flecha CDG
        Dim myTextObjectOnReport68 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport68 = CType(CR.ReportDefinition.ReportObjects.Item("Text68"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport68.Text = calc_uni.prop_uni_flecha_def

        'Idioma Código
        Dim myTextObjectOnReport22 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport22 = CType(CR.ReportDefinition.ReportObjects.Item("Text22"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport22.Text = CType(GetLocalResourceObject("GCodigoArt.Text"), String)

        'Idioma Descripción
        Dim myTextObjectOnReport23 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport23 = CType(CR.ReportDefinition.ReportObjects.Item("Text23"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport23.Text = CType(GetLocalResourceObject("GDescripArt.Text"), String)

        'Unidad k [N/mm]
        Dim myTextObjectOnReportKUnidad As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportKUnidad = CType(CR.ReportDefinition.ReportObjects.Item("Text24"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportKUnidad.Text = "k (" & calc_uni.prop_rigidez & ")"

        'Idioma Cargas (Kg)
        Dim myTextObjectOnReport27 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport27 = CType(CR.ReportDefinition.ReportObjects.Item("Text27"), CrystalDecisions.CrystalReports.Engine.TextObject)
        'myTextObjectOnReport27.Text = "F (Kg)" 'CType(GetLocalResourceObject("GCargas.Text"), String)
        myTextObjectOnReport27.Text = "F (" & calc_uni.prop_peso & ")"

        'Idioma Flecha (mm)
        Dim myTextObjectOnReport28 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport28 = CType(CR.ReportDefinition.ReportObjects.Item("Text28"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport28.Text = "s (" & calc_uni.prop_uni_flecha_def & ")" 'CType(GetLocalResourceObject("GFlecha.Text"), String)

        'Idioma Giro OX:
        Dim myTextObjectOnReport30 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport30 = CType(CR.ReportDefinition.ReportObjects.Item("Text30"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport30.Text = CType(GetLocalResourceObject("GiroOx.Text"), String)

        'Idioma Giro OY:
        Dim myTextObjectOnReport38 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport38 = CType(CR.ReportDefinition.ReportObjects.Item("Text38"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport38.Text = CType(GetLocalResourceObject("GiroOy.Text"), String)

        'Idioma Fleche del CDG:
        Dim myTextObjectOnReport40 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport40 = CType(CR.ReportDefinition.ReportObjects.Item("Text40"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport40.Text = CType(GetLocalResourceObject("FCdg.Text"), String)

        'Idioma Ratio de flechas extremas:
        Dim myTextObjectOnReport41 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport41 = CType(CR.ReportDefinition.ReportObjects.Item("Text41"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport41.Text = CType(GetLocalResourceObject("RFlechasExt.Text"), String)

        'Idioma Frecuencia Propia:
        Dim myTextObjectOnReport42 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport42 = CType(CR.ReportDefinition.ReportObjects.Item("Text42"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport42.Text = CType(GetLocalResourceObject("FrecProp.Text"), String)

        'Idioma Nº de Soportes:
        Dim myTextObjectOnReport43 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport43 = CType(CR.ReportDefinition.ReportObjects.Item("Text43"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport43.Text = CType(GetLocalResourceObject("NSoportes.Text"), String)

        'Idioma Rpm Minima:
        Dim myTextObjectOnReport31 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport31 = CType(CR.ReportDefinition.ReportObjects.Item("Text31"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport31.Text = CType(GetLocalResourceObject("TextoRpmMin.Text"), String)

        'Idioma Rpm Maxima:
        Dim myTextObjectOnReport32 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport32 = CType(CR.ReportDefinition.ReportObjects.Item("Text32"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport32.Text = CType(GetLocalResourceObject("TextoRpmMax.Text"), String)

        'Idioma Aislamiento estimado para el orden nº
        Dim myTextObjectOnReport56 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport56 = CType(CR.ReportDefinition.ReportObjects.Item("Text56"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport56.Text = CType(GetLocalResourceObject("Aislamiento.Text"), String)

        'Idioma a
        Dim myTextObjectOnReport57 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport57 = CType(CR.ReportDefinition.ReportObjects.Item("Text57"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport57.Text = CType(GetLocalResourceObject("AislamientoA.Text"), String)

        'Idioma rpm
        Dim myTextObjectOnReport58 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport58 = CType(CR.ReportDefinition.ReportObjects.Item("Text58"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport58.Text = CType(GetLocalResourceObject("AislamientoB.Text"), String)

        Dim myTextObjectOnReportC7 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC7 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text7"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC7.Text = CType(GetLocalResourceObject("NombreCen.Text"), String)

        'Idioma Frecuencia [Hz]
        Dim myTextObjectOnReportC1 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC1 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text1"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC1.Text = CType(GetLocalResourceObject("Frecuencia.Text"), String)

        'Idioma Transmisibilidad [dB]
        Dim myTextObjectOnReportC2 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC2 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text2"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC2.Text = CType(GetLocalResourceObject("AislamientoTabla.Text"), String)

        'Idioma Aislamiento [dB]
        'Dim myTextObjectOnReportC3 As CrystalDecisions.CrystalReports.Engine.TextObject
        'myTextObjectOnReportC3 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text3"), CrystalDecisions.CrystalReports.Engine.TextObject)
        'myTextObjectOnReportC3.Text = CType(GetLocalResourceObject("AislamientoTabla.Text"), String)


        'Unidad X [m/mm]
        Dim myTextObjectOnReportXUnidad As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportXUnidad = CType(CR.ReportDefinition.ReportObjects.Item("Text25"), CrystalDecisions.CrystalReports.Engine.TextObject)

        'Unidad Y [m/mm]
        Dim myTextObjectOnReportYUnidad As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportYUnidad = CType(CR.ReportDefinition.ReportObjects.Item("Text26"), CrystalDecisions.CrystalReports.Engine.TextObject)

        Dim myTextObjectOnReportXUnidadcentro As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportXUnidadcentro = CType(CR.ReportDefinition.ReportObjects.Item("Text18"), CrystalDecisions.CrystalReports.Engine.TextObject)

        Dim myTextObjectOnReportYUnidadcentro As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportYUnidadcentro = CType(CR.ReportDefinition.ReportObjects.Item("Text19"), CrystalDecisions.CrystalReports.Engine.TextObject)

        myTextObjectOnReportXUnidad.Text = "X (" & calc_uni.prop_distancia & ")"
        myTextObjectOnReportXUnidadcentro.Text = "Xcdg (" & calc_uni.prop_distancia & ")"
        myTextObjectOnReportYUnidad.Text = "Y (" & calc_uni.prop_distancia & ")"
        myTextObjectOnReportYUnidadcentro.Text = "Ycdg (" & calc_uni.prop_distancia & ")"

        'Unidad Masa Total
        Dim myTextObjectOnReportKgAcentro As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportKgAcentro = CType(CR.ReportDefinition.ReportObjects.Item("Text63"), CrystalDecisions.CrystalReports.Engine.TextObject)

        myTextObjectOnReportKgAcentro.Text = calc_uni.prop_peso

        'If Session("UnidadMedida") = "m" Then  'TODO JVC
        '    myTextObjectOnReportXUnidad.Text = "X (m)"
        '    myTextObjectOnReportXUnidadcentro.Text = "Xcdg (m)"
        '    myTextObjectOnReportYUnidad.Text = "Y (m)"
        '    myTextObjectOnReportYUnidadcentro.Text = "Ycdg (m)"
        'ElseIf Session("UnidadMedida") = "mm" Then 'TODO JVC
        '    myTextObjectOnReportXUnidad.Text = "X (mm)"
        '    myTextObjectOnReportYUnidad.Text = "Y (mm)"
        '    myTextObjectOnReportXUnidadcentro.Text = "Xcdg (mm)"
        '    myTextObjectOnReportYUnidadcentro.Text = "Ycdg (mm)"
        'End If

    End Sub

    'Protected Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload
    '    CR.Dispose()
    'End Sub

    'Protected Sub Page_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
    '    CR.Dispose()
    'End Sub

    Public Function dameNombreImagen(ByVal ruta As String) As String

        If (ruta <> "") Then
            Dim lista As String() = ruta.Split("/")
            Return lista(lista.GetUpperBound(0) - 1)
        End If
        Return ruta
    End Function

    Public Function DAMESQL(ByVal calculo As CCalculos) As String
        Dim resultado As String = ""
        Dim sql As String

        'sql = " select 'Mi maquina' as maquina, '1' as  n_estudio, " & _
        '" '01/01/2001' as  fecha_estudio, '6547965470' as  contacto, " & _
        '" '9647896548' as fax, 1 as  revision, '01/01/2001' as fecha, " & _
        '" 'Jokin' as autor,'jce@spyro.es' as email, 'descrip' as descrip_estudio " & _
        '" from dual "
        'sql = "select cod as maquina from ggpedtip "

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = calculo.prop_revision  '//Session("RevisionSel").ToString

        ' AMC_NE026, EL email se calculará de la siguiente forma:
        ' Si existe la clasificación EMAIL_CALC, entonces se mostará ese email, sino se tomará de lo que existe actualmente.

        Dim email As String = ""

        'Dim EMAIL_CALC As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), "V", Session("cliente").prop_cod, "EMAIL_CALC")
        'If EMAIL_CALC.PROP_VALOR <> Nothing Then
        '    email = EMAIL_CALC.PROP_VALOR
        'Else
        '    email = cliente.PROP_DIR_social.PROP_E_MAIL
        'End If

        'Dim kk As New OracleNumber(CDbl(Session("cliente").prop_cod))

        'Dim obsEmailCli As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), "V", kk, ConfigurationManager.AppSettings("OCAL"))
        'If obsEmailCli.PROP_COMENTARIO <> Nothing Then
        '    email = obsEmailCli.PROP_COMENTARIO
        'Else
        '    email = cliente.PROP_DIR_social.PROP_E_MAIL
        'End If
        'Segun lo que hay en la master.
        email = New BCb2b.ggcampaobs(miProyecto.prop_cod, "V", ConfigurationManager.AppSettings("OCAL")).PROP_OBSER


        'jvc. OJO AQUI INTENTO COMPONER EL CALCULO'
        Dim misCalculos As AMC_Proyectos_pkg.CCalculos
        Dim iddistribucion As String = calculo.prop_iddistribucion 'JVC NO SE COMO OBTENER ESTE DATO.
        Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        'misCalculos = New AMC_Proyectos_pkg.CCalculos(miProyecto.prop_cod, iddistribucion, revision, ConfigurationManager.AppSettings("Grupo"), Session("idioma"), com)
        misCalculos = calculo



        '   misCalculos = Session("calculos")
        Dim xcdg As Double = misCalculos.prop_xcdg
        Dim ycdg As Double = misCalculos.prop_ycdg
        Dim pcdg As Double = misCalculos.prop_pcdg

        Dim giroOx As String = misCalculos.prop_giroOx
        Dim giroOy As String = misCalculos.prop_giroOy

        Dim fleche As Double = misCalculos.prop_fleche
        Dim ratio_ext As Double = misCalculos.prop_ratio
        Dim freq_prop As Double = misCalculos.prop_frecProp
        Dim n_soportes As Double
        If Not misCalculos.prop_apoyos Is Nothing Then
            n_soportes = misCalculos.prop_apoyos.Count
        Else
            n_soportes = 0
        End If

        Dim mox As Double = misCalculos.prop_mx
        Dim moy As Double = misCalculos.prop_my
        Dim orden As Double = misCalculos.prop_idorden
        Dim rpm As Double = misCalculos.prop_rpm
        Dim rpmmin As Double = misCalculos.prop_rpmmin
        Dim rpmmax As Double = misCalculos.prop_rpmmax

        Dim aislamiento As Double = misCalculos.prop_aislamiento

        'ESTOOOOO

        'SI LA FRECUENCIA PROPIA ES MAYOR A LA FRECUENCIA RPM CAMBIAR SIGNO,falta multiplicar por el orden seleccionado del combo
        If freq_prop > ((rpm * misCalculos.prop_idorden) / 60) Then
            aislamiento = aislamiento * -1
        End If


        Dim ftp As New BCb2b.ftp()
        Dim rutaLogo As String = ""
        Try
            Dim rutarelativaFTP As String = BuscarFoto()
            Dim nombreImagen As String = dameNombreImagen(rutarelativaFTP)
            If nombreImagen = "" Then
                rutaLogo = ".\\Images\SinFoto.png"
            Else
                rutaLogo = ".\\Images\" & nombreImagen
            End If

            'MsgBox("descomentame!!!")
            ftp.downloadFile(Server.MapPath(rutaLogo), rutarelativaFTP, ConfigurationManager.AppSettings("host_ftp"), ConfigurationManager.AppSettings("usuario_ftp"), ConfigurationManager.AppSettings("pass_ftp"))

        Catch ex As Exception

        End Try


        'obtenemos el contacto para mostrarlo en el report
        Dim Proy As New CProyectos
        Dim vcontacto As String = Proy.gestionar_ResponsableProy(miProyecto.prop_cod, ConfigurationManager.AppSettings("COD_RESP"))


        Dim fecha_proyecto As String = miProyecto.prop_f_desde

        Dim datosCliente As String = cliente.prop_NOMBRE
        If cliente.PROP_DIR_social.PROP_TELEFONOS <> "" Then
            datosCliente = datosCliente & " (" & cliente.PROP_DIR_social.PROP_TELEFONOS & ")"
        End If

        Dim uti As New BCb2b.Utilities
        ' sql = " SELECT '" & miProyecto.prop_descrip & "' as nom_proy, '" & miProyecto.prop_cod & "' AS N_ESTUDIO,ADISTRIBUCION.FECHA AS FECHA_ESTUDIO, "
        sql = " SELECT '" & uti.EscaparComilla(miProyecto.prop_descrip) & "' as nom_proy, '" & uti.EscaparComilla(miProyecto.prop_cod) & "' AS N_ESTUDIO,'" & fecha_proyecto & "' AS FECHA_ESTUDIO, "
        sql = sql & " ADISTRIBUCION.OBSERVACIONES AS DESCRIP_ESTUDIO,ADISTRIBUCION.REVISION, "
        sql = sql & "  '" & vcontacto & "' as contacto,"
        'sql = sql & " TRUNC(SYSDATE,'DD') AS FECHA, '" & Replace(miProyecto.prop_responsable, "'", "''") & "' AS AUTOR, "
        sql = sql & " ADISTRIBUCION.FECHA AS FECHA, '" & uti.EscaparComilla(miProyecto.prop_responsable) & "' AS AUTOR, "
        sql = sql & " '" & uti.EscaparComilla(datosCliente) & "' AS FAX,'" & uti.EscaparComilla(email) & "' AS EMAIL, "

        'sql = sql & " '" & Server.MapPath(".\\Images\\grafico_apoyos.png") & " ' AS RUTA_GRAFICO, "
        'sql = sql & " '" & Server.MapPath(".\\Images\\grafico_aislamiento.png") & " ' AS RUTA_GRAFICO2, "
        'sql = sql & " '" & Server.MapPath(".\\Images\\grafico_transmisibilidad.png") & " ' AS RUTA_GRAFICO4, "
        sql = sql & " '" & ConfigurationManager.AppSettings("rutaPDFmail") & "_" & misCalculos.PROP_ruta_grafico_apoyos & "' AS RUTA_GRAFICO, "
        sql = sql & " '" & ConfigurationManager.AppSettings("rutaPDFmail") & "_" & misCalculos.PROP_ruta_grafico_aislamiento & "' AS RUTA_GRAFICO2, "
        sql = sql & " '" & ConfigurationManager.AppSettings("rutaPDFmail") & "_" & misCalculos.PROP_ruta_grafico_transmisibilidad & "' AS RUTA_GRAFICO4, "

        sql = sql & " '" & Server.MapPath(".\\Images\\cabecera" & "_" & Session("idioma") & ".jpg") & "' AS RUTA_CABECERA, "
        sql = sql & " '" & Server.MapPath(rutaLogo) & " ' AS RUTA_GRAFICO3, "

        sql = sql & " '" & xcdg & "' AS XCDG, '" & ycdg & "' AS YCDG, '" & pcdg & "' AS PCDG, "
        sql = sql & " '" & giroOx & "' AS GIROOX, '" & giroOy & "' AS GIROOY, '" & fleche & "' AS FLECHE, "
        sql = sql & " '" & ratio_ext & "' AS RATIO_EXT, '" & freq_prop & "' AS FREQ_PROP, '" & n_soportes & "' AS N_SOPORTES, "
        sql = sql & " '" & mox & "' AS MOX, '" & moy & "' AS MOY, '" & orden & "' AS ORDEN, "
        sql = sql & " '" & rpm & "' AS RPM, '" & rpmmin & "' AS RPMMIN, '" & rpmmax & "' AS RPMMAX, "
        sql = sql & " '" & aislamiento & "' AS AISLAMIENTO, "

        'IDIOMA_REPORT
        sql = sql & " '" & Session("idioma") & "' AS idioma_report, "

        'PARA CONTROLAR SI OCULTAR ELEMNTS SI MERGE (PAGINACION)
        sql = sql & " 'S' AS es_merge_sn "

        sql = sql & " FROM ADISTRIBUCION, GGESTCAMPA, GGCLIPR "
        sql = sql & " WHERE "
        sql = sql & " GGESTCAMPA.COD = lpad(TO_CHAR (adistribucion.idestudio),10,'0') AND "
        sql = sql & " GGESTCAMPA.COD = '" & miProyecto.prop_cod & "'  AND "
        sql = sql & " ADISTRIBUCION.REVISION = '" & revision & "' AND "
        sql = sql & " GGCLIPR.COD = '" & cliente.prop_COD & "' AND "
        sql = sql & " GGCLIPR.EMPGRUPO_COD = '" & ConfigurationManager.AppSettings("grupo") & "' AND "
        sql = sql & " GGCLIPR.TIP_VC = 'V' "

        Return sql
    End Function


    Public Function TratarFicheroDescarga(ByVal rutaCompleta As String) As String


        Dim rutaBaseFTP1 As String = ConfigurationManager.AppSettings("rutaBaseFTP1")
        Dim rutaBaseFTP2 As String = ConfigurationManager.AppSettings("rutaBaseFTP2")
        Dim dirVirtual As String = ConfigurationManager.AppSettings("dirVirtual")
        Dim dirRaizApp As String = ConfigurationManager.AppSettings("dirRaizApp")

        Dim resultado As String = rutaCompleta
        Try


            resultado = resultado.Replace(rutaBaseFTP1, dirVirtual)
            resultado = resultado.Replace(rutaBaseFTP2, dirVirtual)
            resultado = resultado.Replace(dirRaizApp, "")
            resultado = resultado.Replace("\", "/")



            If (resultado.Length = 0) Then
                'Si la  Foto no existe entonces cargo por defecto
                resultado = "~/Proyectos/Images/SinFoto.png"
            End If

            Return resultado

        Catch ex As Exception
            'Lblerror.Text = "[CalcularRuta]" & ex.Message.ToString
            'Lblerror.Text = CType(GetLocalResourceObject("CalcularRuta.Text"), String) & " " & ex.Message.ToString
        End Try
        Return ""
    End Function

    Private Function BuscarFoto() As String
        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")


        Dim cliente As BCb2b.ggclipr
        cliente = Session("cliente")

        'Dim nom_imagen As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
        'amc_ne026, aqui obteníamos la imagen del logo del proy, ahora de la ficha de cliente.
        ' Dim nom_img As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
        Dim nom_imagen As String = New BCb2b.CGGCLIPRGRA(ConfigurationManager.AppSettings("GRUPO"), "V", cliente.prop_COD, ConfigurationManager.AppSettings("LOGO"), "").PROP_PATH_FIC 'OBTENEMOS EL PATH DEL FICHERO


        Dim rutaBase As String = ConfigurationManager.AppSettings("rutaBaseFTPUpload")
        nom_imagen = nom_imagen.Replace(rutaBase, "")
        nom_imagen = nom_imagen.Replace("\", "/")
        Return nom_imagen

    End Function



    Public Function DAMESQL_GRIDVIEW(ByVal calculo As CCalculos) As String
        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = calculo.prop_revision

        Dim sql As String = ""

        'jvc. OJO AQUI INTENTO COMPONER EL CALCULO'
        Dim misCalculos As AMC_Proyectos_pkg.CCalculos
        Dim iddistribucion As String = calculo.prop_iddistribucion 'JVC NO SE COMO OBTENER ESTE DATO.
        Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        misCalculos = New AMC_Proyectos_pkg.CCalculos(miProyecto.prop_cod, iddistribucion, revision, ConfigurationManager.AppSettings("Grupo"), Session("idioma"), com)

        Dim mi_gridView As ArrayList = misCalculos.prop_apoyos
        Dim num_apoyos As Integer = 0
        If Not misCalculos.prop_apoyos Is Nothing Then
            num_apoyos = misCalculos.prop_apoyos.Count
        Else
            num_apoyos = 0
        End If

        Session("iddistribucion") = misCalculos.prop_iddistribucion
        Session("RevisionSel") = misCalculos.prop_revision

        Dim uti As New BCb2b.Utilities
        Dim i As Integer = 0
        sql = " select * from ( "
        sql = sql & " SELECT '" & miProyecto.prop_cod & "' as n_estudio, '" & revision & "' as revision, "
        ' For i = 0 To mi_gridView.Rows.Count - 1
        If num_apoyos <> 0 Then
            For Each ELEMENT As CCalculos.apoyo In mi_gridView

                If i > 0 Then
                    sql = sql & " UNION SELECT '" & miProyecto.prop_cod & "' as n_estudio, '" & revision & "' as revision, "
                End If
                i = i + 1
                Dim IdApoyo As String = ELEMENT.prop_idapoyo
                sql = sql & " '" & IdApoyo & "' AS num_apoyo,"
                Dim IdArticulo As String = ELEMENT.prop_idarticulo
                sql = sql & " '" & IdArticulo & "' AS gaart_cod,"
                Dim Descripcion As String = ELEMENT.prop_descripcion
                sql = sql & " '" & uti.EscaparComilla(Descripcion) & "' AS gaart_descrip,"
                Dim Radio As String = ELEMENT.prop_radio
                sql = sql & " '" & Radio & "' AS radio,"
                Dim X As String = ELEMENT.prop_x
                sql = sql & " '" & X & "' AS x,"
                Dim Y As String = ELEMENT.prop_y
                sql = sql & " '" & Y & "' AS y,"
                Dim Carga As String = ELEMENT.prop_carga
                sql = sql & " '" & Carga & "' AS carga,"
                Dim Flecha As String = ELEMENT.prop_flecha
                sql = sql & " '" & Flecha & "' AS flecha, "
                Dim CargaMax As String = ELEMENT.prop_cargamax
                sql = sql & " '" & CargaMax & "' AS cargamax, "

                Dim superado As String = "N"
                Dim supera_carga_max As Boolean = New CCalculos.operacionesCalculos().supera_carga_max(IdArticulo, ConfigurationManager.AppSettings("grupo"), Carga)
                If supera_carga_max = True Then
                    superado = "S"
                End If
                sql = sql & " '" & superado & "' AS carga_superada "

                sql = sql & " FROM DUAL "


            Next
        Else
            sql = sql & " '0' as num_apoyo from dual "
        End If
        sql = sql & ") order by to_number(num_apoyo) "
        Return sql
    End Function
    Public Function DAMESQL_CENTROS(ByVal calculo As CCalculos) As String
        Dim resultado As String = ""
        Dim sql As String

        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        'sql = " select nombre,x,y,m from acentros "
        sql = " select NOMBRE,X * NVL((SELECT EQUIVALENCIA FROM AMC_UNID_EQUIV WHERE UNIDAD_1 = (SELECT UNI_DEF FROM AMC_UNIDADES_CALCULOS WHERE DISTANCIA = (SELECT UNIDAD  FROM ADISTRIBUCION  WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "') AND  UNIDAD_2 =(SELECT UNIDAD FROM ADISTRIBUCION WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "'))),'1') AS X,Y * NVL((SELECT EQUIVALENCIA FROM AMC_UNID_EQUIV WHERE UNIDAD_1 = (SELECT UNI_DEF FROM AMC_UNIDADES_CALCULOS WHERE DISTANCIA = (SELECT UNIDAD  FROM ADISTRIBUCION  WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "') AND  UNIDAD_2 =(SELECT UNIDAD FROM ADISTRIBUCION WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "'))),'1') AS Y,M * NVL((SELECT EQUIVALENCIA FROM AMC_UNID_EQUIV WHERE UNIDAD_1 = (SELECT PESO FROM AMC_UNIDADES_CALCULOS WHERE DISTANCIA = (SELECT UNI_DEF FROM AMC_UNIDADES_CALCULOS  WHERE DISTANCIA = (	SELECT UNIDAD 	FROM ADISTRIBUCION 	WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "'	)    )) AND UNIDAD_2 =(SELECT PESO FROM AMC_UNIDADES_CALCULOS WHERE DISTANCIA = ( SELECT UNIDAD FROM ADISTRIBUCION WHERE IDDISTRIBUCION = '" & calculo.prop_iddistribucion & "'))),'1') AS M FROM ACENTROS "
        sql = sql & " where idestudio  = '" & miProyecto.prop_cod & "' "
        sql = sql & " and iddistribucion = '" & calculo.prop_iddistribucion & "' "

        Return sql
    End Function

    Public Function DAMESQL_FRECUENCIAS(ByVal calculo As CCalculos, ByVal listaFrecuencias As GridView, listaDataset As DataTable) As String
        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = calculo.prop_iddistribucion

        Dim sql As String = ""
        Dim mi_gridView As GridView = listaFrecuencias 'Session("GridView2") 'JVC. OJO AL ROYO ESTE. DEBERÍA IR DENTRO DEL CALCULO.
        Dim mi_dataset As DataTable = listaDataset




        '  Dim mi_gridView As GridView = Nothing

        Dim cuantos As Int16 = 0
        '  If Not Session("GridView2") Is Nothing Then
        If Not listaFrecuencias Is Nothing Then
            cuantos = mi_gridView.Rows.Count - 1
        End If

        Dim i As Integer = 0
        sql = " SELECT * from ( "
        sql = sql & " SELECT '" & miProyecto.prop_cod & "' as n_estudio, '" & revision & "' as revision, "
        For i = 0 To cuantos

            'Si no se dibujan los gráficos, esto da error porque la variable de session de gridview no tiene nada.
            'esto es bastante chapuza...
            Dim Freq As String = "-"
            Dim D As String = "-"

            Dim Freqaux As String = "-"
            Dim Daux As String = "-"
            ' If Not Session("GridView2") Is Nothing Then
            If Not listaFrecuencias Is Nothing Then
                Freqaux = mi_gridView.Rows(i).Cells(0).Text.ToString
                Daux = mi_gridView.Rows(i).Cells(2).Text.ToString

                Freq = mi_dataset.Rows(i)(0).ToString()
                D = mi_dataset.Rows(i)(2).ToString()


            End If

            If i > 0 Then
                sql = sql & " UNION SELECT '" & miProyecto.prop_cod & "' as n_estudio, '" & revision & "' as revision, "
            End If

            sql = sql & " '" & Replace(Replace(Freq, ",", ".") & "'", " Hz", "") & " AS frecuencia,"
            sql = sql & "'" & Freq & "' AS texto_frecuencia,"

            Dim Trans As String = "-"
            Dim transaux As String = "-"
            '  If Not Session("GridView2") Is Nothing Then
            If Not listaFrecuencias Is Nothing Then
                transaux = mi_gridView.Rows(i).Cells(1).Text.ToString
                Trans = mi_dataset.Rows(i)(1).ToString()
            End If

            sql = sql & " '" & Trans & "' AS transmisibilidad,"

            sql = sql & " '" & D & "' AS indiceD"
            sql = sql & " FROM DUAL "
        Next
        sql = sql & " )  "
        sql = sql & " ORDER BY  to_number(replace(frecuencia,'.',',')) "

        Return sql


    End Function





End Class
