﻿Imports System.Data.OracleClient
Imports AMC_Proyectos_pkg
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports BCb2b.Metodos
Imports System.Web.Mail
Imports System.Diagnostics
Imports System.IO
Imports BCb2b

Partial Class pruebaGraficos
    Inherits claseBase

    Dim tablaAislamentiento As ArrayList



    Public Shared Sub setTarget(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal siNo As Boolean)

        Dim clientScript As String

        If True Then
            clientScript = "document.forms[0].target = '_blank';"
        Else
            clientScript = "document.forms[0].target = '_self';"
        End If
        opener.Attributes.Add("onClick", clientScript)
    End Sub

    Private iddistribucion As OracleNumber
    Public Property prop_iddistribucion() As OracleNumber
        Get
            Return Me.iddistribucion
        End Get
        Set(ByVal value As OracleNumber)
            Me.iddistribucion = value
            Session("iddistribucion") = value

        End Set
    End Property



    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        If Session("cliente") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If
        If Session("proyecto") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If

        If (Not Page.IsPostBack) Then
            Me.tablaAislamentiento = New ArrayList()
        End If

    End Sub




    Protected Sub ZedGraphWeb1_RenderGraph(ByVal webObject As ZedGraph.Web.ZedGraphWeb, ByVal g As System.Drawing.Graphics, ByVal masterPane As ZedGraph.MasterPane) Handles ZedGraphWeb1.RenderGraph

        '   Protected Sub ZedGraphWeb1_renderiza(ByVal webObject As ZedGraph.Web.ZedGraphWeb, ByVal g As System.Drawing.Graphics, ByVal masterPane As ZedGraph.MasterPane)

        Dim lista_calculos As ArrayList = New ArrayList()

        'Dim calculoSeleccionado As New AMC_Proyectos_pkg.CCalculos("1300000105", 2)
        'lista_calculos.Add(calculoSeleccionado)
        'Dim calculoSeleccionado2 As New AMC_Proyectos_pkg.CCalculos("1300000105", 1)
        'lista_calculos.Add(calculoSeleccionado2)

        ' Get the GraphPane so we can work with it
        Dim myPane As GraphPane = masterPane(0)
        lista_calculos = Session("LISTA_CALCULOS")

        Dim LISTA_CALCULOS_AUX As New ArrayList()

        Dim indice As Int32 = 0

        Dim dibujado As Boolean = False

        For Each elemento_calculo As AMC_Proyectos_pkg.CCalculos In lista_calculos



            Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
            miProyecto = Session("proyecto") '******* TODO

            Dim ggestcampa_cod As String
            ggestcampa_cod = miProyecto.prop_cod

            Dim revision As OracleNumber
            'Dim ddlRevisiones As TextBox
            'ddlRevisiones = Master.Master.FindControl("ContentPlaceHolder1").FindControl("num_revision")
            'If Not ddlRevisiones Is Nothing Then
            '    revision = ddlRevisiones.Text
            'End If

            revision = elemento_calculo.prop_revision

            Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")



            ' Set the title and axis labels        
            'myPane.XAxis.Title.Text = "Frecuencia [Hz]"
            myPane.XAxis.Title.Text = CType(GetLocalResourceObject("Frecuencia.Text"), String)


            'myPane.YAxis.Title.Text = "Aislamiento [dB]"
            myPane.YAxis.Title.Text = CType(GetLocalResourceObject("Aislamiento.Text"), String)

            'LA ESCALA LOGARITMICA ES DE BASE 10, NO SIRVE.
            'myPane.YAxis.Type = AxisType.Log

            'Dim idorden As Double 'NO ME DEJA UTILIZAR ORACLE NUMBER PORQUE FALLARIA LA OPERACION ^
            Dim rpm As Double
            Dim Frecnat As Double
            Dim D As Double
            prop_iddistribucion = elemento_calculo.prop_iddistribucion ' JVC!!!! todo, poner bien los otros datos que estan fijados.

            'Dim misCalculos As New AMC_Proyectos_pkg.CCalculos


            Dim comboNumOrden_Value As String = elemento_calculo.prop_idorden
            Dim txtRpm_Text As String = elemento_calculo.prop_rpm
            Dim txtMx_Text As String = elemento_calculo.prop_mx
            Dim txtMy_Text As String = elemento_calculo.prop_my

            elemento_calculo.cargar_datos(miProyecto.prop_cod, prop_iddistribucion, revision, ConfigurationManager.AppSettings("Grupo"), txtMx_Text, txtMy_Text, comboNumOrden_Value, txtRpm_Text, Session("idioma"), com)


            'idorden = misCalculos.prop_idorden
            rpm = elemento_calculo.prop_rpm
            Frecnat = elemento_calculo.prop_frecProp

            Dim miAmortig As New AMC_Proyectos_pkg.CCalculos.apoyo
            miAmortig.cargar_apoyos(iddistribucion, ConfigurationManager.AppSettings("Grupo"), miProyecto.prop_cod, revision, Session("idioma"), com)
            D = miAmortig.prop_sumaAmortig
            D = D / elemento_calculo.prop_apoyos.Count
            'D = 1

            '--------------------------------------------------------
            Dim pointsGraf() As String = {}
            Dim xAxisGraf() As Double = {}
            Dim freqGraf As Double = 0
            Dim indicePoint As Integer = 0
            Do While freqGraf <= 125
                ReDim Preserve pointsGraf(indicePoint)
                ReDim Preserve xAxisGraf(indicePoint)
                pointsGraf(indicePoint) = freqGraf.ToString
                xAxisGraf(indicePoint) = indicePoint + 1
                indicePoint = indicePoint + 1
                freqGraf = freqGraf + 0.5
            Loop
            '--------------------------------------------------------

            'ESTOS PUNTOS NO VALES PARA NADA PORQUE DEBAJO SE LES CAMBIA EL VALOR
            ' Make up some data points
            'Dim labels() As String = {"4", "5", "6,3", "8", "10", "12,5", "14,7", "16", "20", "25", _
            '"31,5", "40", "50", "63", "80", "100", "125", "160", "200"}
            Dim labels() As String = {"2", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", _
                                      "18", "20", "25", "30", "40", "50", "63", "80", "100", "125"}
            'Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19}
            Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}

            '--------------------------------------------------------
            labels = pointsGraf
            xAxis = xAxisGraf

            '--------------------------------------------------------

            Dim ais(labels.Length) As Double
            Dim i As Integer = 0

            Dim cadenaprueba As String = ""
            For i = 0 To labels.Length - 1

                'ais(i) = 1 - Math.Sqrt((1 + (2 * D * CDbl(labels(i)) * idorden / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i)) * idorden) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) * idorden / Frecnat) ^ 2))
                ais(i) = 1 - Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2))
                ais(i) = (ais(i) * 100)
                'ais(i) = (ais(i) * 100) + 15
                'cadenaprueba = cadenaprueba & vbCrLf & labels(i) & " Hz = " & ais(i) & " %"
            Next i

            'Response.Write(cadenaprueba)
            'MsgBox(cadenaprueba)

            Dim oLineItem As LineItem
            'oLineItem = myPane.AddCurve("Aislamiento", xAxis, ais, Color.Blue, SymbolType.Circle)

            '******************************************************************************

            Dim xAxisVac() As Double = {}
            Dim aisVac() As Double = {}


            'JVC. AQUI
            If Not dibujado Then
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMinGraf.Text"), String), xAxisVac, aisVac, Color.DarkCyan, SymbolType.None)
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMaxGraf.Text"), String), xAxisVac, aisVac, Color.DarkOrange, SymbolType.None)
            Else
                oLineItem = myPane.AddCurve("", xAxisVac, aisVac, Color.DarkCyan, SymbolType.None)
                oLineItem = myPane.AddCurve("", xAxisVac, aisVac, Color.DarkOrange, SymbolType.None)
            End If
            'JVC . FIN AQUI

            'crearLineasVelMinMax(labels, xAxis, ais, myPane, 1500, 2400)

            Dim txtVelMax_Text As String = elemento_calculo.prop_rpmmax
            Dim txtVelMin_Text As String = elemento_calculo.prop_rpmmin
            Dim nuevoslabels() As String = crearLineasVelMinMax(labels, xAxis, ais, myPane, CDbl(txtVelMin_Text), CDbl(txtVelMax_Text), True) ' todo 
            'Dim nuevoslabels() As String = crearLineasVelMinMax(labels, xAxis, ais, myPane, CDbl(0), CDbl(0), True)

            If nuevoslabels.Length > labels.Length Then
                labels = nuevoslabels
                ReDim Preserve xAxis(labels.Length - 1)
                xAxis(labels.Length - 1) = xAxis.GetUpperBound(0) + 1
                ais = recalcularAis(labels, D, Frecnat)

            End If

            '******************************************************************************

            'JVC. AQUI
            If Not dibujado Then
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("Aislamiento.Text"), String), xAxis, ais, Color.Blue, SymbolType.None)
                dibujado = True ' JVC. Si no pongo esta condición, entonces me dibuja muchas veces el texto este, si imprimimos varios seguidos.
            Else
                oLineItem = myPane.AddCurve("", xAxis, ais, Color.Blue, SymbolType.None)
            End If
            'JVC. FIN AQUI

            ' Set the XAxis labels
            myPane.XAxis.Scale.TextLabels = labels
            ' Set the YAxis to Text type
            myPane.XAxis.Type = AxisType.Text
            ' Draw the X tics at the labels
            myPane.XAxis.MajorTic.IsBetweenLabels = False

            myPane.YAxis.Scale.Min = 10
            myPane.YAxis.Scale.Max = 100

            myPane.YAxis.Type = AxisType.Log

            'AddHandler myPane.YAxis.ScaleFormatEvent, AddressOf YAxis_ScaleFormatEvent


            'myPane.AxisChange()


            ' Fill the axis background with a color gradient
            myPane.Chart.Fill = New Fill(Color.White, Color.FromArgb(255, 255, 166), 45.0F)
            'myPane.Chart.Fill = New Fill(Color.White, Color.White, 45.0F)
            masterPane.AxisChange(g)

            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")
            Dim nombreGraf As String = "grafico_aislamiento_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & "_" & indice & ".png"
            'Dim nombreGraf2 As String = "grafico_transmisibilidad_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & "_" & indice & ".png"
            masterPane.GetImage.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)


            myPane.GraphObjList.Clear()

            'JVC AQUI
            oLineItem.Clear()
            'JVC FIN AQUI

            elemento_calculo.PROP_ruta_grafico_aislamiento = nombreGraf
            'elemento_calculo.PROP_ruta_grafico_transmisibilidad = nombreGraf2

            'JVC TODO. aqui me falta añadirle la ruta del documento.

            LISTA_CALCULOS_AUX.Add(elemento_calculo)


            Session("calculos") = elemento_calculo '******* TODO

            indice = indice + 1
        Next



        Session("lista_calculos") = LISTA_CALCULOS_AUX
        'Server.Transfer("imprimirProyecto.aspx")



    End Sub

    Private Function crearLineasVelMinMax(ByVal labels() As String, ByVal xAsis() As Double, ByVal ais() As Double, ByVal myPane As GraphPane, ByVal velmin As Double, ByVal velmax As Double, ByVal esAislamiento As Boolean) As String()


        'ZedGraphWeb1.DataBind()

        Dim aisLineaMax As Double = myPane.YAxis.Scale.Max ' da 0
        Dim aisLineaMin As Double = myPane.YAxis.Scale.Min ' da 0

        If aisLineaMin = 0 And aisLineaMin = 0 Then
            Dim aisY() As Double = {0}
            For i = 0 To labels.Length - 1
                If i = 0 Then
                    aisLineaMax = ais(i)
                    aisLineaMin = aisLineaMax
                End If
                If ais(i) >= aisLineaMax Then
                    aisLineaMax = ais(i)
                ElseIf ais(i) < aisLineaMin Then
                    aisLineaMin = ais(i)
                End If
            Next i
        End If


        Dim logaritmic(16) As Double
        logaritmic(0) = 0.0000000010000000000000001
        logaritmic(1) = 0.00000001
        logaritmic(2) = 0.000000099999999999999995
        logaritmic(3) = 0.00000099999999999999995
        logaritmic(4) = 0.000010000000000000001
        logaritmic(5) = 0.0001
        logaritmic(6) = 0.001
        logaritmic(7) = 0.01
        logaritmic(8) = 0.10000000000000001
        logaritmic(9) = 1
        logaritmic(10) = 10
        logaritmic(11) = 100
        logaritmic(12) = 1000
        logaritmic(13) = 10000
        logaritmic(14) = 100000
        logaritmic(15) = 1000000
        logaritmic(16) = 10000000

        Dim hayNegat As Boolean = False
        For i = 0 To logaritmic.Length - 2
            If aisLineaMin > CDbl(logaritmic(i)) And aisLineaMin <= CDbl(logaritmic(i + 1)) Then
                aisLineaMin = CDbl(logaritmic(i))
            ElseIf aisLineaMin < 0 Then
                hayNegat = True
                'aisLineaMin = 0.10000000000000001
            End If

            If aisLineaMax > CDbl(logaritmic(i)) And aisLineaMax <= CDbl(logaritmic(i + 1)) Then
                aisLineaMax = CDbl(logaritmic(i + 1))
            End If
        Next i

        'EN EL AISLAMIENTO SOLO INTERESAN LOS VALORES ENTRE 10 Y 100 (JON I)
        If aisLineaMax > 100 Then
            aisLineaMax = 100
        End If
        If esAislamiento = True Then
            If aisLineaMin < 10 Then
                aisLineaMin = 10
            End If
        End If

        '------------------------------------------------------------------------------------------
        'ESTE CODIGO MAS QUE NADA ES PARA EL AISLAMIENTO YA QUE TIENE VALORES NEGATIVOS
        'LO QUE HACE ES CALCULAR EL VALOR MINIMO DE LOS POSITIVOS PARA PODER CALCULAR LA ALTURA DE LA
        'LINEA VERTICAL DE LAS VELOCIDADES.
        If hayNegat = True Then
            Dim z As Integer = 0
            'AQUI HAGO UN ARRAY CON LOS VALORES POSITIVOS
            Dim arrayPosit() As Double = {}
            For i = 0 To labels.Length - 2
                If CDbl(ais(i)) > 0 Then
                    ReDim Preserve arrayPosit(z)
                    arrayPosit(z) = CDbl(ais(i))
                End If
            Next i
            'AQUI CALCULO EL POSITIVO MENOR
            Dim positivMenor As Double = 0
            For i = 0 To arrayPosit.Length - 1
                If i = 0 Then
                    positivMenor = arrayPosit(i)
                End If
                If arrayPosit(i) < positivMenor Then
                    positivMenor = arrayPosit(i)
                End If
            Next i
            'AQUI AVERIGUO CUAL ES SU ESCALA LOGARITMICA MAS CERCANA
            For i = 0 To logaritmic.Length - 2
                If positivMenor > CDbl(logaritmic(i)) And positivMenor <= CDbl(logaritmic(i + 1)) Then
                    aisLineaMin = CDbl(logaritmic(i))
                End If
            Next i

        End If
        '---------------------------------------------------------------------------------------

        Dim freqvelmin As Double = velmin / 60
        Dim freqvelmax As Double = velmax / 60

        Dim result As String() = Array.FindAll(labels, Function(s) s.Contains(CInt(freqvelmin)))
        If result.Length = 0 Then
            ReDim Preserve labels(labels.Length)
            labels(labels.Length - 1) = CInt(freqvelmin).ToString
        End If

        Dim result2 As String() = Array.FindAll(labels, Function(s) s.Contains(CInt(freqvelmax)))
        If result2.Length = 0 Then
            ReDim Preserve labels(labels.Length)
            labels(labels.Length - 1) = CInt(freqvelmax).ToString
        End If
        '/*************************************/
        '  JCE:::: Aqui obtendrías los dos puntos mas.

        'labels(labels.Length - 2) = freqvelmin.ToString
        'labels(labels.Length - 1) = freqvelmax.ToString
        Dim sc As New NumericComparer(False)
        Array.Sort(labels, sc)

        '/************************************/



        Dim posLineaMin As Integer = 0
        For i = 0 To labels.Length - 2
            If CInt(freqvelmin) = CInt(labels(i)) Then
                posLineaMin = i + 1
            End If
        Next i

        If velmin <> 0 Then
            Dim threshHoldXMin As Double = posLineaMin
            Dim threshHoldLineMin As LineObj = New LineObj(Color.DarkCyan, threshHoldXMin, aisLineaMin, threshHoldXMin, aisLineaMax)
            myPane.GraphObjList.Add(threshHoldLineMin)
        End If



        Dim posLineaMax As Integer = 0
        For i = 0 To labels.Length - 2
            If CInt(freqvelmax) = CInt(labels(i)) Then
                posLineaMax = i + 1
            End If
        Next i

        If velmax <> 0 Then
            Dim threshHoldXMax As Double = posLineaMax
            Dim threshHoldLineMax As LineObj = New LineObj(Color.DarkOrange, threshHoldXMax, aisLineaMin, threshHoldXMax, aisLineaMax)
            myPane.GraphObjList.Add(threshHoldLineMax)
        End If


        Return labels
    End Function

    Protected Sub ZedGraphWeb2_RenderGraph(ByVal webObject As ZedGraph.Web.ZedGraphWeb, ByVal g As System.Drawing.Graphics, ByVal masterPane As ZedGraph.MasterPane) Handles ZedGraphWeb2.RenderGraph
        Dim miProyecto As  New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto") '******* TODO

        Dim hecho As Boolean = False

        Dim ggestcampa_cod As String
        ggestcampa_cod = miProyecto.prop_cod

        Dim lista_calculos As ArrayList = New ArrayList()
        Dim ldataset As ArrayList = New ArrayList()

        'Dim calculoSeleccionado As New AMC_Proyectos_pkg.CCalculos("1300000105", 2)
        'lista_calculos.Add(calculoSeleccionado)
        'Dim calculoSeleccionado2 As New AMC_Proyectos_pkg.CCalculos("1300000105", 1)
        'lista_calculos.Add(calculoSeleccionado2)

        lista_calculos = Session("LISTA_CALCULOS")

        Dim indice As Int32 = 0
        Dim LISTA_CALCULOS_AUX As New ArrayList()

        Dim dibujado As Boolean = False

        For Each elemento_calculo As AMC_Proyectos_pkg.CCalculos In lista_calculos

            Dim revision As OracleNumber
            'Dim ddlRevisiones As TextBox
            'ddlRevisiones = Master.Master.FindControl("ContentPlaceHolder1").FindControl("num_revision")
            ' '******* TODO
            'If Not ddlRevisiones Is Nothing Then
            '    revision = ddlRevisiones.Text
            'End If

            revision = elemento_calculo.prop_revision

            Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

            ' Get the GraphPane so we can work with it
            Dim myPane As GraphPane = masterPane(0)

            ' Set the title and axis labels        
            'myPane.XAxis.Title.Text = "Frecuencia [Hz]"
            myPane.XAxis.Title.Text = CType(GetLocalResourceObject("Frecuencia.Text"), String)

            'myPane.YAxis.Title.Text = "Transmisibilidad [dB]"
            myPane.YAxis.Title.Text = CType(GetLocalResourceObject("Transmisibilidad.Text"), String)

            'LA ESCALA LOGARITMICA ES DE BASE 10, NO SIRVE.
            'myPane.XAxis.Type = AxisType.Log

            'Dim idorden As Double 'NO ME DEJA UTILIZAR ORACLE NUMBER PORQUE FALLARIA LA OPERACION ^
            Dim rpm As Double
            Dim Frecnat As Double
            Dim D As Double

            '   Dim misCalculos As New AMC_Proyectos_pkg.CCalculos
            Dim datosRev As ArrayList = elemento_calculo.DameDatosRev(miProyecto.prop_cod, revision)
            Me.iddistribucion = datosRev(0)
            'Me.txtFecha.Text = String.Format(datosRev(1), "dd/MM/yyyy")
            'Me.txtObservaciones.Text = datosRev(2).ToString

            Dim comboNumOrden_Value As String = elemento_calculo.prop_idorden
            Dim txtRpm_Text As String = elemento_calculo.prop_rpm
            Dim txtMx_Text As String = elemento_calculo.prop_mx
            Dim txtMy_Text As String = elemento_calculo.prop_my

            elemento_calculo.cargar_datos(miProyecto.prop_cod, prop_iddistribucion, revision, ConfigurationManager.AppSettings("Grupo"), txtMx_Text, txtMy_Text, comboNumOrden_Value, txtRpm_Text, Session("idioma"), com)

            'idorden = misCalculos.prop_idorden
            rpm = elemento_calculo.prop_rpm
            Frecnat = elemento_calculo.prop_frecProp

            Dim miAmortig As New AMC_Proyectos_pkg.CCalculos.apoyo
            miAmortig.cargar_apoyos(iddistribucion, ConfigurationManager.AppSettings("Grupo"), miProyecto.prop_cod, revision, Session("idioma"), com)
            D = miAmortig.prop_sumaAmortig
            D = D / elemento_calculo.prop_apoyos.Count

            ' Make up some data points
            'Dim labels() As String = {"4", "5", "6,3", "8", "10", "12,5", "14,7", "16", "20", "25", _
            '"31,5", "40", "50", "63", "80", "100", "125", "160", "200"}

            '--------------------------------------------------------
            Dim pointsGraf() As String = {}
            Dim xAxisGraf() As Double = {}
            Dim freqGraf As Double = 0
            Dim indicePoint As Integer = 0
            Do While freqGraf <= 125
                ReDim Preserve pointsGraf(indicePoint)
                ReDim Preserve xAxisGraf(indicePoint)
                pointsGraf(indicePoint) = freqGraf.ToString
                xAxisGraf(indicePoint) = indicePoint + 1
                indicePoint = indicePoint + 1
                freqGraf = freqGraf + 0.5
            Loop
            '--------------------------------------------------------

            Dim labels() As String = {"2", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", _
                                      "18", "20", "25", "30", "40", "50", "63", "80", "100", "125"}
            'Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19}
            Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}


            '--------------------------------------------------------
            labels = pointsGraf
            xAxis = xAxisGraf

            '--------------------------------------------------------
            Dim trans(labels.Length) As Double
            Dim i As Integer = 0


            Dim tableDTrans As DataTable = New DataTable("tableDTrans")
            tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)))
            'tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)))
            tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("AislamientoTitulo.Text"), String)))
            tableDTrans.Columns.Add(New DataColumn("D"))
            'PARA TABLA %


            Dim cadenaprueba As String = ""
            For i = 0 To labels.Length - 1
                'trans(i) = Math.Sqrt((1 + (2 * D * CDbl(labels(i)) * idorden / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i)) * idorden) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) * idorden / Frecnat) ^ 2))
                'EL IDORDEN SOLO SE TIENE EN CUENTA EN AISLAMIENTO ESTIMADO, ( JON I)
                If Frecnat <> 0 Then
                    trans(i) = Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2))
                Else
                    trans(i) = 0
                End If

                If i Mod 16 = 1 Then
                    Dim row As DataRow = tableDTrans.NewRow()

                    row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                    row(CType(GetLocalResourceObject("AislamientoTitulo.Text"), String)) = FormatNumber(((1 - trans(i)) * 100), 2) & " %"
                    row("D") = FormatNumber(20 * Math.Log10(1 / (1 - ((1 - trans(i))))), 2) & " dB"
                    tableDTrans.Rows.Add(row)
                End If
            Next i





            'RECOJO LOS DATOS DE TRANSMISIBILIDAD PARA MOSTRARLOS EN PANTALLA Y EN PDF
            ldataset.Add(tableDTrans)
            Session("Ldataset") = ldataset

            GridView2.DataSource = tableDTrans
            GridView2.DataBind()



            Session("GridView2") = GridView2
            tablaAislamentiento.Add(GridView2)
            tablaAislamentiento.Add(GridView2)
            Session("LGridView2") = tablaAislamentiento ' Lo se lo se,.... no tengo tiempo de arreglar la chapu.
            hecho = True

            Dim oLineItem As LineItem

            '******************************************************************************
            Dim xAxisVac() As Double = {}
            Dim transVac() As Double = {}


            If Not dibujado Then
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMinGraf.Text"), String), xAxisVac, transVac, Color.DarkCyan, SymbolType.None)
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMaxGraf.Text"), String), xAxisVac, transVac, Color.DarkOrange, SymbolType.None)
            Else
                oLineItem = myPane.AddCurve("", xAxisVac, transVac, Color.DarkCyan, SymbolType.None)
                oLineItem = myPane.AddCurve("", xAxisVac, transVac, Color.DarkOrange, SymbolType.None)
            End If
            'crearLineasVelMinMax(labels, xAxis, trans, myPane, 1500, 2400)
            Dim txtVelMax_Text As String = elemento_calculo.prop_rpmmax
            Dim txtVelMin_Text As String = elemento_calculo.prop_rpmmin
            Dim nuevoslabels() As String = crearLineasVelMinMax(labels, xAxis, trans, myPane, CDbl(txtVelMin_Text), CDbl(txtVelMax_Text), False) ' todo 

            If nuevoslabels.Length > labels.Length Then
                labels = nuevoslabels
                ReDim Preserve xAxis(labels.Length - 1)
                xAxis(labels.Length - 1) = xAxis.GetUpperBound(0) + 1
                trans = recalcularTrans(labels, D, Frecnat)

            End If
            '******************************************************************************

            If Not dibujado Then
                oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("Transmisibilidad.Text"), String), xAxis, trans, Color.Green, SymbolType.None)
                dibujado = True
            Else
                oLineItem = myPane.AddCurve("", xAxis, trans, Color.Green, SymbolType.None)
            End If

            ' Set the XAxis labels
            myPane.XAxis.Scale.TextLabels = labels
            ' Set the YAxis to Text type
            myPane.XAxis.Type = AxisType.Text
            ' Draw the X tics at the labels
            myPane.XAxis.MajorTic.IsBetweenLabels = False

            myPane.YAxis.Type = AxisType.Text
            'myPane.YAxis.Scale.Min = 1
            'myPane.YAxis.Scale.Max = 100
            myPane.YAxis.Type = AxisType.Log
            'ZedGraphWeb1.AxisChanged = True
            'ZedGraphWeb1.DataBind()

            ' Fill the axis background with a color gradient
            myPane.Chart.Fill = New Fill(Color.White, Color.FromArgb(255, 255, 166), 45.0F)
            'myPane.Chart.Fill = New Fill(Color.White, Color.White, 45.0F)
            masterPane.AxisChange(g)
            'masterPane.GetImage.Save(Server.MapPath(".\\Images\\grafico_transmisibilidad.png"), ImageFormat.Png)

            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")
            Dim nombreGraf As String = "grafico_transmisibilidad_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & "_" & indice & ".png"
            'Dim nombreGraf2 As String = "grafico_aislamiento_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & "_" & indice & ".png"
            'masterPane.GetImage.Save(Server.MapPath(".\\Images\\" & nombreGraf), ImageFormat.Png)
            masterPane.GetImage.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)





            'JVC TODO. aqui me falta añadirle la ruta del documento.
            elemento_calculo.PROP_ruta_grafico_transmisibilidad = nombreGraf
            'elemento_calculo.PROP_ruta_grafico_aislamiento = nombreGraf2

            LISTA_CALCULOS_AUX.Add(elemento_calculo)
            Session("calculos") = elemento_calculo

            '/***************/
            ' // (apoyos,centros,calculo, centroX ,centroy,cliente)

            Dim vApoyos = elemento_calculo.prop_apoyos
            Dim vcentros = CAcentros.cargar_datos(prop_iddistribucion, miProyecto.prop_cod)
            Dim vcalculo = elemento_calculo
            Dim vcentroX = elemento_calculo.prop_xcdg
            Dim vcentroy = elemento_calculo.prop_ycdg

            generarGraficoApoyos(vApoyos, vcentros, vcalculo, vcentroX, vcentroy, Session("cliente"))


            '***************

            myPane.GraphObjList.Clear()
            oLineItem.Clear()
            indice = indice + 1
        Next

        Session("LISTA_CALCULOS") = LISTA_CALCULOS_AUX


        '  Server.Transfer("imprimirProyecto.aspx")

    End Sub

    Private Function recalcularTrans(ByVal labels() As String, ByVal D As Double, ByVal frecnat As Double) As Double()
        Dim tableDTrans As DataTable = New DataTable("tableDTrans")
        tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)))
        tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)))

        Dim trans(labels.Length - 1) As Double
        For i = 0 To labels.Length - 1

            trans(i) = Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2))
            'trans(i) = trans(i) * 100
            'cadenaprueba = cadenaprueba & vbCrLf & labels(i) & " Hz = " & x(i) * 100 & " %"
            If i <= 7 Then
                Dim row As DataRow = tableDTrans.NewRow()

                row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                row(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)) = FormatNumber(trans(i), 2) & " dB"
                tableDTrans.Rows.Add(row)
            Else
                If i Mod 2 = 1 Then
                    Dim row As DataRow = tableDTrans.NewRow()

                    row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                    row(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)) = FormatNumber(trans(i), 2) & " dB"
                    tableDTrans.Rows.Add(row)
                End If
            End If



        Next i
        Return trans
    End Function

    Private Function recalcularAis(ByVal labels() As String, ByVal D As Double, ByVal frecnat As Double) As Double()

        Dim ais(labels.Length - 1) As Double
        For i = 0 To labels.Length - 1

            ais(i) = 1 - Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2))
            ais(i) = ais(i) * 100


        Next i
        Return ais
    End Function


    Protected Sub GridView2_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowDataBound
        'no borrar este evento, tiene que estar
    End Sub


    '/******************  Para gráfico apoyos **********************/
    Public Function PuntosMinxMiny(centro As PointF, puntos() As PointF, centros() As PointF) As PointF

        'Buscar menor en eje x. y menor en eje y

        Dim minx As Double = centro.X
        Dim miny As Double = centro.Y

        For Each elemento As PointF In puntos
            If elemento.X < minx Then
                minx = elemento.X
            End If
            If elemento.Y < miny Then
                miny = elemento.Y
            End If
        Next

        For Each elemento As PointF In centros
            If elemento.X < minx Then
                minx = elemento.X
            End If
            If elemento.Y < miny Then
                miny = elemento.Y
            End If
        Next

        Return New Point(minx, miny)

    End Function

    Public Function TransformarCentro(centro As PointF, puntoMin As PointF) As PointF

        Dim minx As Double = puntoMin.X
        Dim miny As Double = puntoMin.Y

        If minx < 0 Then
            centro.X = centro.X - minx
        End If
        If miny < 0 Then
            centro.Y = centro.Y - miny
        End If
        Dim elementoAux As New PointF(centro.X, centro.Y)
        Return elementoAux

    End Function

    Public Function TransformarPuntos(puntos() As PointF, puntoMin As PointF) As PointF()

        'Buscar menor en eje x. y menor en eje y

        Dim minx As Double = puntoMin.X
        Dim miny As Double = puntoMin.Y


        'transformar los arrays.
        Dim resultado(puntos.Length - 1) As PointF

        If minx < 0 Or miny < 0 Then
            Dim ind As Int16 = 0
            For Each elemento As PointF In puntos
                If minx < 0 Then
                    elemento.X = elemento.X - minx
                End If
                If miny < 0 Then
                    elemento.Y = elemento.Y - miny
                End If
                Dim elementoAux As New PointF(elemento.X, elemento.Y)
                resultado.SetValue(elementoAux, ind)
                ind = ind + 1
            Next
        Else
            resultado = puntos
        End If

        Return resultado
    End Function

    Public Sub generarGraficoApoyos(ByVal vapoyos As Object, ByVal vcentros As Object, ByVal vcalculo As Object, ByVal vcentroX As Object, ByVal vcentroy As Object, ByVal vcliente As Object)

        ' Session("Apoyos") = vapoyos
        'Session("Centros") = vcentros
        'Session("calculos") = vcalculo
        'Session("centroX") = vcentroX
        'Session("centroY") = vcentroy
        'Session("cliente") = vcliente

        If Not vapoyos Is Nothing Then
            'If False Then


            Dim fuentePuntos = New Font("Arial", 11)
            Dim fuentePuntosCdg = New Font("Arial", 8)

            Dim misApoyos As ArrayList = vapoyos
            If misApoyos.Count > 0 Then



                Dim elemento As AMC_Proyectos_pkg.CCalculos.apoyo
                Dim calculo As New AMC_Proyectos_pkg.CCalculos
                calculo = vcalculo


                Dim puntos(0) As PointF
                If calculo.prop_carga_sn = "N" Then
                    Dim i As Integer = 0
                    ReDim puntos(misApoyos.Count - 1)
                    For Each elemento In misApoyos
                        puntos(i) = New PointF(Metodos.StringToOracleNumber(elemento.prop_x), Metodos.StringToOracleNumber(elemento.prop_y))
                        i = i + 1
                    Next
                Else
                    puntos(0) = New PointF(-1, -1)
                End If


                Dim limites = New RectangleF(0, 0, 363, 272)
                Dim margen = New RectangleF(20, 20, 363 - 40, 272 - 40)

                If (Not vcentros Is Nothing) Then


                    Dim misCentros As ArrayList = vcentros
                    Dim acentros As AMC_Proyectos_pkg.CAcentros
                    Dim z As Integer = 0
                    Dim puntosCdg(misCentros.Count - 1) As PointF
                    Dim textoPuntosCdg(misCentros.Count - 1) As String
                    For Each acentros In misCentros
                        puntosCdg(z) = New PointF(Metodos.StringToOracleNumber(acentros.prop_x), Metodos.StringToOracleNumber(acentros.prop_y))
                        textoPuntosCdg(z) = acentros.prop_nombre
                        z = z + 1
                    Next

                    Dim centro = New PointF(Metodos.StringToOracleNumber(vcentroX), Metodos.StringToOracleNumber(vcentroy))

                    'JVC. Para escalar los puntos
                    Dim puntoMin As PointF = PuntosMinxMiny(centro, puntos, puntosCdg)
                    centro = TransformarCentro(centro, puntoMin)
                    puntos = TransformarPuntos(puntos, puntoMin)
                    puntosCdg = TransformarPuntos(puntosCdg, puntoMin)
                    'FIN PARA ESCALAR LOS PUNTOS.

                    Dim grafico = AMC_GraficoPuntosSoporte.Grafico.Crear(limites, margen, centro, puntos, fuentePuntos, puntosCdg, fuentePuntosCdg, textoPuntosCdg)

                    Dim nombreGraf As String = "grafico_apoyos_" & vcliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss.fff tt") & ".png"
                    grafico.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)




                    calculo.PROP_ruta_grafico_apoyos = nombreGraf




                End If
            End If
        End If

    End Sub

    '/********************* fin para gráfico apoyos   **************/





    Public Class NumericComparer
        Implements IComparer
        Dim mText As Boolean = False
        Public Sub New(ByRef sorttype As NumericSort)
            mText = sorttype
        End Sub

        Public Enum NumericSort
            Textual = True
            Numerical = False
        End Enum

        ' Compare the two employees.
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
        Implements System.Collections.IComparer.Compare
            If mText = False Then
                Dim txtx As Double = CDbl(x)
                Dim txty As Double = CDbl(y)
                Select Case True
                    Case txtx < txty : Return -1
                    Case txtx = txty : Return 0
                    Case txtx > txty : Return 1
                End Select
            Else
                Dim txtx As String = CStr(x)
                Dim txty As String = CStr(y)
                Return String.Compare(txtx, txty)
            End If
            Return False
        End Function
    End Class
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        lblEmail.Text = Request.QueryString("mail")



    End Sub



    Protected Sub Button1_Click(sender As Object, e As System.EventArgs) Handles Button1.Click
        Server.Transfer("imprimirProyecto.aspx", False)

    End Sub




    Protected Sub Page_Unload(sender As Object, e As System.EventArgs) Handles Me.Unload
        'Button1_Click(Button1, e)
        If (lblEmail.Text <> "") Then
            Server.Transfer("imprimirProyecto.aspx?mail=" & lblEmail.Text, False)
        Else
            Server.Transfer("imprimirProyecto.aspx", False)
        End If

    End Sub
End Class



