﻿Imports System.Data.OracleClient
Imports System.Data
Imports System.Data.OleDb
Partial Class Seguimiento
    Inherits claseBase

    Private USRTMENSA_COD As String
    Private N_INFORME As OracleNumber
    Private N_SEQ As OracleNumber

    Public ReadOnly Property PROP_usrtmensa_cod_SEL() As String
        Get
            If Not IsNothing(Me.USRTMENSA_COD) Then
                Return Me.USRTMENSA_COD.ToString
            Else
                Return ""
            End If
        End Get
    End Property

    Public ReadOnly Property PROP_N_INFORME_SEL() As OracleNumber
        Get
            Return Me.N_INFORME
        End Get
    End Property

    Public ReadOnly Property PROP_N_SEQ_SEL() As OracleNumber
        Get
            Return Me.N_SEQ
        End Get
    End Property

    Protected Sub Page_Init(sender As Object, e As EventArgs) Handles Me.Init

        Dim codAgen As String = Request.QueryString("agen")
        Dim idioma As String = Request.QueryString("i")
        Dim codioUsuario As String = Request.QueryString("usuario")
        Dim perfil As String = Request.QueryString("perfil")
        Dim codcli As String = Request.QueryString("cli")
        Dim viendeasp As String = Request.QueryString("vdasp")

        If viendeasp = "1" Then
            Dim cli As New BCb2b.ggclipr(codcli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            Dim age As New BCb2b.gvagente(codioUsuario, ConfigurationManager.AppSettings("grupo"))
            Session("agente") = age
            Session("cliente") = cli

            Dim usuario As New BCb2b.CUsrnom(codioUsuario)
            Session("Usuario") = usuario
            Session("UsuarioB2B") = usuario
            Session("perfil_usuario") = perfil

            CodAge.Value = codAgen

            'ocultar menu de la master
            'Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("menu_master")
            Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("menu_master")
            menu_master.Visible = False

            'ocultar cliente y agente seleccionado
            'Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("bienvenida_menu")
            Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("bienvenida_menu")
            bienvenida_menu.Visible = False
        End If
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        div_lblerror.Visible = False

        Dim cli As New BCb2b.ggclipr()
        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            age = Session("agente")
        Else
            Dim ag As New BCb2b.CAgente(tboxSeguimientoggcliprCod.Text)
            age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
        End If
        If age.prop_COD <> "" Then
            CodAge.Value = age.prop_COD
        End If
        If Not Session("cliente") Is Nothing Then
            cli = Session("cliente")
            If Not Page.IsPostBack Then
                tboxSeguimientoggcliprCod.Text = cli.prop_COD
                tboxSeguimientoggclipr.Text = cli.prop_NOMBRE
            End If
        Else
            tboxSeguimientoggcliprCod.Text = ""
            tboxSeguimientoggclipr.Text = ""
        End If


        If (tboxSeguimientoggcliprCod.Text <> "" Or tboxSeguimientoRsocialCod.Text <> "") Then
            div_lblerror.Visible = False
        Else
            div_lblerror.Visible = True
        End If

        Dim seguimiento As New BCb2b.CUSRMail()
        If Not Page.IsPostBack Then

            PGVSeguimiento.VirtualItemCount = GetRowCount()
            BindPagingGrid()
        End If

        'Para lov
        Me.SetFocus(Me.tboxSeguimientoggclipr)
        'ShowLov(ImgSeguimientoLupaGGclipr, tboxSeguimientoggclipr, "tboxSeguimientoggclipr", age.prop_COD)
        'ShowLov(ImgSeguimientoLupaRsocial, tboxSeguimientoRsocial, "tboxSeguimientoRsocial", age.prop_COD)
        'ShowLov(ImgSeguimientoLupaTMensa, tboxSeguimientoTMensa, "tboxSeguimientoTMensa", age.prop_COD)

    End Sub
    Private Sub BindPagingGrid()
        PGVSeguimiento.DataSource = GetDataPage(PGVSeguimiento.PageIndex, PGVSeguimiento.PageSize, PGVSeguimiento.OrderBy)
        PGVSeguimiento.DataBind()
    End Sub
    Protected Sub PGVSeguimiento_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PGVSeguimiento.PageIndexChanging
        PGVSeguimiento.PageIndex = e.NewPageIndex
        BindPagingGrid()
    End Sub
    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList

        Dim vpagina_inicio As String = ((PGVSeguimiento.PageIndex) * PGVSeguimiento.PageSize) + 1
        Dim vpagina_fin As String = ((PGVSeguimiento.PageIndex + 1) * PGVSeguimiento.PageSize)

        Dim vf_inicio As OracleDateTime = OracleDateTime.Null
        If tboxSeguimientoFInicio.Text <> "" Then
            vf_inicio = CType(tboxSeguimientoFInicio.Text, OracleDateTime)
        End If
        Dim vf_fin As OracleDateTime = OracleDateTime.Null
        If TboxSeguimientoFFin.Text <> "" Then
            vf_fin = CType(TboxSeguimientoFFin.Text, OracleDateTime)
        End If
        Dim vn_informe As OracleNumber = OracleNumber.Null
        If tboxSeguimientoNInforme.Text <> "" Then
            vn_informe = CType(tboxSeguimientoNInforme.Text, OracleNumber)
        End If

        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            age = Session("agente")
        Else
            Dim ag As New BCb2b.CAgente(tboxSeguimientoggcliprCod.Text)
            age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
        End If

        Dim lista As ArrayList
        Dim seguimiento As New BCb2b.CUSRMail()
        lista = seguimiento.lista_mensajes_paginado(tboxSeguimientoggcliprCod.Text, age.prop_GGCLIPR_PROV, tboxSeguimientoRsocialCod.Text, tboxSeguimientoTMensaCod.Text, vf_inicio, vf_fin, vn_informe, tboxSeguimientoCuerpo.Text, tboxSeguimientoAsunto.Text, "", "", "", "", vpagina_inicio, vpagina_fin)
        Return lista
    End Function
    Private Function GetRowCount() As Integer
        Dim vf_inicio As OracleDateTime = OracleDateTime.Null
        If tboxSeguimientoFInicio.Text <> "" Then
            vf_inicio = CType(tboxSeguimientoFInicio.Text, OracleDateTime)
        End If
        Dim vf_fin As OracleDateTime = OracleDateTime.Null
        If TboxSeguimientoFFin.Text <> "" Then
            vf_fin = CType(TboxSeguimientoFFin.Text, OracleDateTime)
        End If
        Dim vn_informe As OracleNumber = OracleNumber.Null
        If tboxSeguimientoNInforme.Text <> "" Then
            vn_informe = CType(tboxSeguimientoNInforme.Text, OracleNumber)
        End If
        Dim seguimiento As New BCb2b.CUSRMail()

        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            age = Session("agente")
        Else
            Dim ag As New BCb2b.CAgente(tboxSeguimientoggcliprCod.Text)
            age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
        End If

        Dim total As Integer = seguimiento.lista_mensajes_cuantos(tboxSeguimientoggcliprCod.Text, age.prop_GGCLIPR_PROV, tboxSeguimientoRsocialCod.Text, tboxSeguimientoTMensaCod.Text, vf_inicio, vf_fin, vn_informe, tboxSeguimientoCuerpo.Text, "", "", tboxSeguimientoAsunto.Text, "", "")

        Return total
    End Function
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                        "height=" & height & "px," & _
                        "left='+((screen.width -" & width & ") / 2)+'," & _
                        "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub OpenPopUpScroll(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "scrollbars=yes,resizable=yes," & _
                        "width=" & width & "px," & _
                        "height=" & height & "px," & _
                        "left='+((screen.width -" & width & ") / 2)+'," & _
                        "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Sub ShowLov(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal dateControl As System.Web.UI.WebControls.WebControl, ByVal valor As String, Optional ByVal c1 As String = "", Optional ByVal c2 As String = "")
        OpenPopUp(opener, "lov.aspx?textbox=" & dateControl.ClientID & "&textbox2=" & valor & "&c1=" & c1 & "&c2=" & c2, "LOV", 400, 435)
    End Sub

    'Protected Sub btnSeguimientoCalcular_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnSeguimientoCalcular.Click
    '    PGVSeguimiento.VirtualItemCount = GetRowCount()
    '    BindPagingGrid()
    'End Sub

    Protected Sub btnSeguimientoCalcular_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSeguimientoCalcular.Click
        PGVSeguimiento.VirtualItemCount = GetRowCount()
        BindPagingGrid()
    End Sub

    Private Sub comprobar_formulario()
        If (tboxSeguimientoggcliprCod.Text <> "" Or tboxSeguimientoRsocialCod.Text <> "") Then
            lblerror.Visible = False
        Else
            lblerror.Visible = True
        End If
    End Sub
    Protected Sub ImgBSeguimientoGGclipr_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBSeguimientoGGclipr.Click
        Me.tboxSeguimientoggclipr.Text = ""
        Me.tboxSeguimientoggcliprCod.Text = ""
        comprobar_formulario()
    End Sub
    Protected Sub ImgSeguimientoLupaTMensa_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBTMensa.Click
        Me.tboxSeguimientoTMensa.Text = ""
        Me.tboxSeguimientoTMensaCod.Text = ""
        comprobar_formulario()
    End Sub

    Protected Sub ImgBRsocialCod_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBRsocialCod.Click
        Me.tboxSeguimientoRsocial.Text = ""
        Me.tboxSeguimientoRsocialCod.Text = ""
        comprobar_formulario()
    End Sub

    Protected Sub ImgBFinicio_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBFinicio.Click
        Me.tboxSeguimientoFInicio.Text = ""
        comprobar_formulario()
    End Sub

    Protected Sub ImgBFFin_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBFFin.Click
        Me.TboxSeguimientoFFin.Text = ""
        comprobar_formulario()
    End Sub

    Protected Sub ImgBAsunto_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBAsunto.Click
        Me.tboxSeguimientoAsunto.Text = ""
        comprobar_formulario()
    End Sub

    Protected Sub ImgBCuerpo_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBCuerpo.Click
        Me.tboxSeguimientoCuerpo.Text = ""
        comprobar_formulario()
    End Sub
    Protected Sub ImgBNInforme_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBNInforme.Click
        Me.tboxSeguimientoNInforme.Text = ""
        comprobar_formulario()
    End Sub
    'Protected Sub ImgBDestinos_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBDestinos.Click
    '    Me.tboxSeguimientoDestinos.Text = ""
    '    comprobar_formulario()
    'End Sub
    'Protected Sub ImgBContactos_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImgBContactos.Click
    '    Me.tboxSeguimientoContactos.Text = ""
    '    comprobar_formulario()
    'End Sub
    Protected Sub PGVSeguimiento_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles PGVSeguimiento.RowCommand
        Try
            Dim fila As GridViewRow
            fila = PGVSeguimiento.SelectedRow
            Dim ind As Integer
            Integer.TryParse(e.CommandArgument, ind)
            fila = PGVSeguimiento.Rows(ind)

            Dim Pkey As DataKeyArray = PGVSeguimiento.DataKeys
            Me.USRTMENSA_COD = Pkey.Item(ind).Item(0)
            Me.N_INFORME = CType(Pkey.Item(ind).Item(1).ToString, OracleNumber)
            Me.N_SEQ = CType(Pkey.Item(ind).Item(2).ToString, OracleNumber)

            If (e.CommandName = "ver") Then

                Server.Transfer("SeguimientoDetalle.aspx")
            End If
        Catch ex As Exception
            lblerror.Text = ex.Message.ToString
            div_lblerror.Visible = True
        End Try

    End Sub

    Protected Sub PGVSeguimiento_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles PGVSeguimiento.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then

            Dim Pkey As DataKeyArray = PGVSeguimiento.DataKeys
            Dim PROP_USRTMENSA_COD As String = Pkey.Item(e.Row.RowIndex).Item(0)
            Dim PROP_N_INFORME As String = Pkey.Item(e.Row.RowIndex).Item(1)
            Dim PROP_N_SEQ As String = Pkey.Item(e.Row.RowIndex).Item(2)

            Dim img_adjuntos As New HyperLink
            img_adjuntos = e.Row.FindControl("muestraDoc")

            Dim url As String = ConfigurationManager.AppSettings("pathB2BAMCSADocs")
            Dim documento As New BCb2b.CUsrmailDoc()
            Dim documentos As ArrayList

            documentos = documento.lista_documentos(PROP_USRTMENSA_COD, PROP_N_INFORME, PROP_N_SEQ, url)

            If documentos.Count > 0 Then
                img_adjuntos.Visible = True
            Else
                img_adjuntos.Visible = False
            End If
        End If
    End Sub
    Protected Sub PGVSeguimiento_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles PGVSeguimiento.SelectedIndexChanged
        Dim Pkey As DataKeyArray = PGVSeguimiento.DataKeys

        Me.USRTMENSA_COD = Pkey.Item(PGVSeguimiento.SelectedIndex).Item(0)
        Me.N_INFORME = Pkey.Item(PGVSeguimiento.SelectedIndex).Item(1)
        Me.N_SEQ = Pkey.Item(PGVSeguimiento.SelectedIndex).Item(2)
        Server.Transfer("SeguimientoDetalle.aspx")

    End Sub
End Class