﻿Imports System.IO
Imports System
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Diagnostics

Imports BCb2b.Enterlan
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports BCb2b
Imports System.Data.SqlClient

'para pasar a pdf.
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.text.html
Imports iTextSharp.text.html.simpleparser
Imports iTextSharp.tool.xml
Imports System.Timers

Imports System.Data.OracleClient
Imports System.Data.OleDb
Imports System.Runtime.InteropServices


Partial Class SeguimientoCrear
    Inherits claseBase
    Private USRTMENSA_COD As String
    Private N_INFORME As OracleNumber
    Private N_SEQ As OracleNumber
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()

    Public ReadOnly Property PROP_usrtmensa_cod_SEL() As String
        Get
            If Not IsNothing(Me.USRTMENSA_COD) Then
                Return Me.USRTMENSA_COD.ToString
            Else
                Return ""
            End If
        End Get
    End Property

    Public ReadOnly Property PROP_N_INFORME_SEL() As OracleNumber
        Get
            Return Me.N_INFORME
        End Get
    End Property

    Public ReadOnly Property PROP_N_SEQ_SEL() As OracleNumber
        Get
            Return Me.N_SEQ
        End Get
    End Property

    Protected Sub Page_Init(sender As Object, e As EventArgs) Handles Me.Init
        Dim codAgen As String = Request.QueryString("agen")
        Dim idioma As String = Request.QueryString("i")
        Dim codioUsuario As String = Request.QueryString("usuario")
        Dim perfil As String = Request.QueryString("perfil")
        Dim codcli As String = Request.QueryString("cli")
        Dim viendeasp As String = Request.QueryString("vdasp")

        If viendeasp = "1" Then
            Dim cli As New BCb2b.ggclipr(codcli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            Dim age As New BCb2b.gvagente(codioUsuario, ConfigurationManager.AppSettings("grupo"))
            Session("agente") = age

            If age.prop_COD = "" Then
                Dim age2 = New BCb2b.CAgente(codAgen)
            End If


            Session("cliente") = cli

            Dim usuario As New BCb2b.CUsrnom()

            If perfil = "DIS" Then
            Else
                usuario = New BCb2b.CUsrnom(codioUsuario)
            End If



            Session("Usuario") = usuario
            Session("UsuarioB2B") = usuario
            Session("perfil_usuario") = perfil

            CodAge.Value = codAgen

            'ocultar menu de la master
            'Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("menu_master")
            Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("menu_master")
            menu_master.Visible = False

            'ocultar cliente y agente seleccionado
            'Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("bienvenida_menu")
            Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("bienvenida_menu")
            bienvenida_menu.Visible = False
        End If
    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load

        Dim uti As New BCb2b.Utilities
        uti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))

        tboxSeguimientoggcliprCod.Attributes.Add("onkeydown", "document.getElementById('ctl00_ContentPlaceHolder1_tboxSeguimientoggcliprCod').submit();return false;")

        txt_n_informe.BackColor = Color.LightGray
        If Not Page.IsPostBack Then

            Dim age As New BCb2b.gvagente()
            If Not Session("agente") Is Nothing Then
                age = Session("agente")
            Else
                Dim ag As New BCb2b.CAgente(tboxSeguimientoggcliprCod.Text)
                age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
            End If

            If age.prop_COD <> "" Then
                CodAge.Value = age.prop_COD
            End If

            If Not Session("cliente") Is Nothing Then
                Dim CLI As New BCb2b.ggclipr()
                CLI = Session("cliente")
                tboxSeguimientoggcliprCod.Text = CLI.prop_COD
                tboxSeguimientoggclipr.Text = CLI.prop_NOMBRE
            Else
                tboxSeguimientoggcliprCod.Text = ""
                tboxSeguimientoggclipr.Text = ""
            End If


            'CARGAR CONTACTOS ASOCIADOS AL CLIENTE.
            Dim listaEmailsCli As New ArrayList
            Dim emails As New BCb2b.CEnvio_Emails()
            listaEmailsCli = emails.DameDestinatariosCliente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tboxSeguimientoggcliprCod.Text, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"))

            If listaEmailsCli.Count = 0 Then
                Dim emailcontactnulo As New BCb2b.CEnvio_Emails(GetLocalResourceObject("lblNoHayClisAsoc"), GetLocalResourceObject("lblNoHayClisAsoc"), GetLocalResourceObject("lblNoHayClisAsoc"), GetLocalResourceObject("lblNoHayClisAsoc"))
                listaEmailsCli.Add(emailcontactnulo)
                GVEmailCli.Enabled = False
            Else
                GVEmailCli.Enabled = True
            End If

            GVEmailCli.DataSource = listaEmailsCli
            GVEmailCli.DataBind()
        End If
    End Sub

    Protected Sub btnEnviar_Click(sender As Object, e As EventArgs) Handles btnEnviar.Click
        Dim vRESPTA_SN As String = ""

        Dim vF_LECTURA As OracleDateTime = OracleDateTime.Null
        Dim vF_RESPTA As OracleDateTime = OracleDateTime.Null
        Dim vF_VISUALIZ As OracleDateTime = OracleDateTime.Null

        Dim vT_PREV As OracleNumber = OracleNumber.Null
        Dim vUSTREFER_COD As String = ""
        Dim vUSREFER_COD As String = ""
        Dim vRTA_USRTMENSA_COD As String = ""
        Dim vRTA_N_INFORME As OracleNumber = OracleNumber.Null
        Dim vRTA_N_SEQ As OracleNumber = OracleNumber.Null
        Dim vAGR_USRTMENSA_COD As String = ""
        Dim vAGR_N_INFORME As OracleNumber = OracleNumber.Null
        Dim vAGR_N_SEQ As OracleNumber = OracleNumber.Null
        Dim vREFER As String = ""
        Dim vDESCRIP_REFER As String = ""
        Dim vTIP_VCAP As String = ""

        Dim cli As New BCb2b.ggclipr(tboxSeguimientoggcliprCod.Text, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
        Dim age As New BCb2b.gvagente()
        If Not Session("agente") Is Nothing Then
            age = Session("agente")
        Else
            Dim ag As New BCb2b.CAgente(tboxSeguimientoggcliprCod.Text)
            age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
        End If

        Dim nombre_age, cod_age As String
        nombre_age = age.prop_NOMBRE
        cod_age = age.prop_COD
        If age.prop_COD = "" Then
            Dim age2 = New BCb2b.CAgente(CodAge.Value)
            nombre_age = age2.prop_nombre
            cod_age = age2.prop_cod
        End If


        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vTIP_VC As String = ConfigurationManager.AppSettings("venta")

        Dim vGGCLIPR_COD As String = cli.prop_COD
        Dim vRSOCIAL_COD As String = cli.prop_RSOCIAL_COD

        Dim TIPOMENSAJE As String = ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI")
        Dim usrnomOri As String = ConfigurationManager.AppSettings("USUARIO_CREAR_SEGUI")
        Dim usrnomDES As String = ConfigurationManager.AppSettings("USUARIO_CREAR_SEGUI")
        Dim ASUNTO As String = txtAsunto.Text
        'Dim CUERPO As String = age.prop_NOMBRE & " (" & age.prop_COD & ") " & Now.Date & " > " & txtCuerpo.Text
        Dim cuerpo_a_anadir As String = nombre_age & " (" & cod_age & ") " & Now.Date & " > "

        Dim cuerpo_usrmail As String = cuerpo_a_anadir & Trim(txtContentAdicTxtPlano.Value)
        Dim cuerpo_usrmailhtml As String = cuerpo_a_anadir & txtContentAdicTxtHtml.Value

        If cuerpo_usrmail.Length > 4000 Then
            cuerpo_usrmail = cuerpo_usrmail.Substring(0, 4000)
        End If


        Dim todoOk As Integer = 0
        Dim vF_PREVISTA As OracleDateTime = OracleDateTime.Null
        If txtfPrev.Text <> "" Then
            vF_PREVISTA = CType(txtfPrev.Text, OracleDateTime)
        End If

        Try
            'Dim mensaje As New BCb2b.usrmail(TIPOMENSAJE, OracleNumber.Null, OracleNumber.Null, usrnomOri, usrnomDES, OracleDateTime.Null, "N", "N", CUERPO, OracleDateTime.Null, OracleDateTime.Null, OracleDateTime.Null, OracleDateTime.Null, OracleNumber.Null, "", "", PRSOCIAL_COD, "", OracleNumber.Null, OracleNumber.Null, "", OracleNumber.Null, OracleNumber.Null, OracleDateTime.Null, "N", "", "", ASUNTO, "ORI", "V", "", OracleDateTime.Null, "N", "", "", OracleNumber.Null, "", "", "", "")
            Dim mensaje As New BCb2b.usrmail(TIPOMENSAJE, OracleNumber.Null, OracleNumber.Null, usrnomOri, usrnomDES, OracleDateTime.Null, "N", "N", cuerpo_usrmail, OracleDateTime.Null, OracleDateTime.Null, OracleDateTime.Null, vF_PREVISTA, OracleNumber.Null, "", "", vRSOCIAL_COD, "", OracleNumber.Null, OracleNumber.Null, "", OracleNumber.Null, OracleNumber.Null, OracleDateTime.Null, "N", "", "", ASUNTO, "ORI", "", "", OracleDateTime.Null, "N", vEMPGRUPO_COD, vTIP_VC, vGGCLIPR_COD, "", "", "N", "")
            mensaje = mensaje.usrmail_insertar(False, vF_VISUALIZ, vF_LECTURA, vF_RESPTA, vT_PREV, vUSTREFER_COD, vUSREFER_COD, vRTA_USRTMENSA_COD, vRTA_N_INFORME, _
            vRTA_N_SEQ, vAGR_USRTMENSA_COD, vAGR_N_INFORME, vAGR_N_SEQ, vREFER, vDESCRIP_REFER, vTIP_VCAP, vEMPGRUPO_COD, vTIP_VC, Nothing)

            txt_n_informe.Text = mensaje.prop_N_INFORME
            txt_n_seq.Text = mensaje.prop_N_SEQ

            'INSERTAMOS EL HTML EN USRMAILHTML
            Dim txthtml As New BCb2b.usrmailhtml()
            txthtml.Inserta_Texto(TIPOMENSAJE, mensaje.prop_N_INFORME, mensaje.prop_N_SEQ, cuerpo_usrmailhtml)

            'ASIGNAR CONTACTOS
            Dim listaContactosChecksCli As New ArrayList
            listaContactosChecksCli = ObtenerContactosCliCheckeados(cli.prop_RSOCIAL_COD)
            Dim i As Integer = 0
            'ASIGNAR CONTACTOS CLI AL MENSAJE --> RAZON SOCIAL DEL CLIENTE
            For i = 0 To listaContactosChecksCli.Count - 1
                Dim cont As New BCb2b.CContactos()
                cont = listaContactosChecksCli.Item(i)
                mensaje.usrmailcon_inserta(TIPOMENSAJE, mensaje.prop_N_INFORME, mensaje.prop_N_SEQ, cli.prop_RSOCIAL_COD, cont.PROP_CONTACTIP_COD, cont.PROP_NOMBRE, cont.PROP_E_MAIL, "")
            Next i

            'MOSTRAR DIALOGO OFERTA BORRADA
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "MensajeCreado", "ShowDialog('" & GetLocalResourceObject("MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("MsgModalMensajeCreadoOk") & "','ok','',300);", True)


            txtAsunto.Enabled = False
            'txtCuerpo.Enabled = False
            txtfPrev.Enabled = False
            tboxSeguimientoggclipr.Enabled = False
            tboxSeguimientoggcliprCod.Enabled = False
            txtAsunto.BackColor = Color.LightGray
            'txtCuerpo.BackColor = Color.LightGray
            txtfPrev.BackColor = Color.LightGray
            tboxSeguimientoggclipr.BackColor = Color.LightGray
            tboxSeguimientoggcliprCod.BackColor = Color.LightGray
            PCFFPrev.Visible = False
            ImgSeguimientoLupaGGclipr.Visible = False


            btnEnviar.Visible = False
            btnVerDetalle.Visible = True
            btnNuevo.Visible = True
            GVEmailCli.Enabled = False

            lblerror.Visible = False
            lblerror.Text = ""

            Me.USRTMENSA_COD = ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI")
            Me.N_INFORME = CType(txt_n_informe.Text, OracleNumber)
            Me.N_SEQ = CType(txt_n_seq.Text, OracleNumber)

            Call EnviarConfirmacionVisitaCreada()

            Server.Transfer("SeguimientoDetalle.aspx")
        Catch ex As Exception

        End Try

    End Sub
    Private Sub EnviarConfirmacionVisitaCreada()
        Dim parametro As New BCb2b.CParametros()

        Dim agente As New BCb2b.gvagente()
        agente = Session("agente")

        Dim cli As New BCb2b.ggclipr()
        cli = Session("cliente")

        Dim host As String = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")
        Dim port As Int32 = CInt(ConfigurationManager.AppSettings("PUERTO_MAIL"))
        Dim user As String = ConfigurationManager.AppSettings("USU_MAIL")
        Dim password As String = ConfigurationManager.AppSettings("PASS_MAIL")
        Dim titulo As String = "AMCSA. " & agente.prop_NOMBRE.ToUpper & " (" & agente.prop_COD & ") " & " HA CREADO LA VISITA " & txt_n_informe.Text

        Dim CUERPO As String = ""
        CUERPO = "<table border=""1"" style=""width:70%;margin:10px !important;"">"
        CUERPO = CUERPO & "<tr><th colspan=""4"" bgcolor=""#0081C6"" style=""color:#ffffff;margin:10px !important;"">DETALLE MENSAJE</th></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Fecha</td><td colspan=""3"">" & txtfPrev.Text & "</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Razón Social</td><td>" & cli.prop_RSOCIAL_COD & "</td><td style=""font-weight:bold;"">Cliente</td><td>" & cli.prop_NOMBRE & " (" & cli.prop_COD & ")</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Asunto</td><td colspan=""3"">" & txtAsunto.Text & "</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Cuerpo</td><td colspan=""3"">" & txtContentAdicTxtHtml.Value & "</td></tr>"
        CUERPO = CUERPO & "</table>"

        'ENVIAR MAIL A OBSERVACION EVIG DE PROVEEDOR
        Dim obsProveedor As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), agente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("EVIS"))
        Dim mails As String = obsProveedor.PROP_COMENTARIO

        Dim mailing As New BCb2b.EnviarMail()
        Dim enviado As String = mailing.SendMail(host, port, user, password, ConfigurationManager.AppSettings("EmailFrom"), ConfigurationManager.AppSettings("EmailFrom"), user, mails, titulo, CUERPO, False, "")

    End Sub
    Protected Function ObtenerContactosCliCheckeados(ByVal rsocial_cod As String) As ArrayList
        Dim correosCliSel As New ArrayList
        Dim dt As New DataTable
        For Each row As GridViewRow In GVEmailCli.Rows
            If row.RowType = DataControlRowType.DataRow Then
                Dim chkRow As CheckBox = TryCast(row.Cells(0).FindControl("chkRow"), CheckBox)
                If chkRow.Checked Then

                    Dim Pkey As DataKey = GVEmailCli.DataKeys(row.RowIndex)

                    Dim tipocont As String = Pkey.Item("prop_tipocontacto") 'row.Cells(1).Text
                    Dim nombre As String = Pkey.Item("prop_nombrecontacto")  'row.Cells(2).Text
                    Dim correo As String = Pkey.Item("prop_destinatarios")  'row.Cells(3).Text

                    Dim cont As New BCb2b.CContactos(rsocial_cod, tipocont, nombre, conexion.cadena_conexion)
                    correosCliSel.Add(cont)
                End If
            End If
        Next
        Return correosCliSel
    End Function

    Protected Sub btnNuevo_Click(sender As Object, e As EventArgs) Handles btnNuevo.Click
        txtAsunto.Enabled = True
        'txtCuerpo.Enabled = True
        txtfPrev.Enabled = True
        tboxSeguimientoggclipr.Enabled = True
        tboxSeguimientoggcliprCod.Enabled = True
        txtAsunto.Text = ""
        'txtCuerpo.Text = ""
        txtfPrev.Text = ""
        txt_n_informe.Text = ""
        txt_n_seq.Text = ""
        GVEmailCli.Enabled = True

        Dim CLI As New BCb2b.ggclipr()
        CLI = Session("cliente")

        tboxSeguimientoggcliprCod.Text = CLI.prop_COD
        tboxSeguimientoggclipr.Text = CLI.prop_NOMBRE

        txtAsunto.BackColor = Color.White
        'txtCuerpo.BackColor = Color.White
        txtfPrev.BackColor = Color.White
        tboxSeguimientoggclipr.BackColor = Color.White
        tboxSeguimientoggcliprCod.BackColor = Color.White
        PCFFPrev.Visible = True
        ImgSeguimientoLupaGGclipr.Visible = True

        btnEnviar.Visible = True
        btnVerDetalle.Visible = False
        btnNuevo.Visible = False
    End Sub

    Protected Sub btnVerDetalle_Click(sender As Object, e As EventArgs) Handles btnVerDetalle.Click

        Me.USRTMENSA_COD = ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI")
        Me.N_INFORME = CType(txt_n_informe.Text, OracleNumber)
        Me.N_SEQ = CType(txt_n_seq.Text, OracleNumber)

        Server.Transfer("SeguimientoDetalle.aspx")
    End Sub
    'Protected Sub chkAsigCont_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)

    '    Dim dd As CheckBox = sender
    '    Dim objFila As GridViewRow = dd.Parent.Parent
    '    Dim valor As Boolean = dd.Checked

    '    If valor = True Then

    '        'prop_tipocontacto,prop_nombrecontacto,prop_destinatarios
    '        Dim tipoCont As HiddenField = objFila.FindControl("tCont")
    '        Dim nomCont As HiddenField = objFila.FindControl("nCont")

    '        Dim cli As New BCb2b.ggclipr(tboxSeguimientoggcliprCod.Text, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
    '        Dim cont As New BCb2b.CContactos(cli.prop_RSOCIAL_COD, tipoCont.Value, nomCont.Value, "")

    '        Dim mensaje As New BCb2b.usrmail()
    '        mensaje.usrmailcon_inserta(ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI"), txt_n_informe.Text, txt_n_seq.Text, cli.prop_RSOCIAL_COD, cont.PROP_CONTACTIP_COD, cont.PROP_NOMBRE, cont.PROP_E_MAIL, "")
    '    Else

    '    End If
    'End Sub

    Protected Sub tboxSeguimientoggcliprCod_TextChanged(sender As Object, e As EventArgs) Handles tboxSeguimientoggcliprCod.TextChanged

        If Session("tipo_usuario") = "SVT" Then
            Dim cli As New BCb2b.ggclipr(tboxSeguimientoggcliprCod.Text, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            tboxSeguimientoggclipr.Text = cli.prop_NOMBRE
        Else
            Dim cli As New BCb2b.ggclipr()
            tboxSeguimientoggclipr.Text = cli.DameCliDeAge(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), Session("agente").prop_cod, tboxSeguimientoggcliprCod.Text)
        End If
        If tboxSeguimientoggclipr.Text = "" Then
            tboxSeguimientoggclipr.Text = "No existe este cliente"
        End If

        'CARGAR CONTACTOS ASOCIADOS AL CLIENTE.
        Dim listaEmailsCli As New ArrayList
        Dim emails As New BCb2b.CEnvio_Emails()
        listaEmailsCli = emails.DameDestinatariosCliente(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tboxSeguimientoggcliprCod.Text, ConfigurationManager.AppSettings("CLASI_EMAIL_P"), "S", Session("idioma_spyro"))

        If listaEmailsCli.Count = 0 Then
            Dim emailcontactnulo As New BCb2b.CEnvio_Emails("", GetLocalResourceObject("lblNoHayClisAsoc"), "", "")
            listaEmailsCli.Add(emailcontactnulo)
            GVEmailCli.Enabled = False
        Else
            GVEmailCli.Enabled = True
        End If

        GVEmailCli.DataSource = listaEmailsCli
        GVEmailCli.DataBind()
        UPGVEmailCli.Update()
        UPtxtCli.Update()
    End Sub
End Class
