Imports CTI.Utilities.Log
Imports System.IO

Partial Class download
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            displayPDF(Session("pdfGenerado"))
        End If
    End Sub
    Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
        Me.Theme = Nothing
    End Sub
    Protected Sub displayPDF(filePath As String)
        Try
            Dim theFile As FileInfo = New FileInfo(filePath)
            Dim nombrefich As String = Path.GetFileName(filePath)

            'Si al obtener el nombre falla y llega vacio, ponemos uno nosotros con la extensin que traa.
            If filePath <> "" And nombrefich = "" Then
                Dim extension As String = Path.GetExtension(filePath)
                nombrefich = "PDF_GENERATED" & extension
            End If

            Response.Clear()
            Response.ContentType = "application/pdf"
            Response.AddHeader("content-disposition", "filename=" + nombrefich)
            Response.Flush()
            Response.WriteFile(theFile.FullName)
            Response.End()
        Catch ex As Exception
            Log.Error(ex, "[Imprimiendo documento. displayPDF] file = {file} ", filePath)
        End Try
    End Sub
End Class
