﻿
Partial Class pedido_reaprovisiona_aux
    Inherits claseBase

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vClasiEsDistrib As String = ConfigurationManager.AppSettings("ClasifDistrib")
        Dim vGgpedtipReapr As String = ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona")

        Dim accion As String = Request.QueryString("acc")
        'AMC_NE199. Reaprovisionamiento para distribuidores
        If Session("perfil_usuario") = "DIS" And Not Session("agente") Is Nothing Then
            Dim age As New BCb2b.gvagente()
            age = Session("agente")
            'Seleccionamos el cliente del proveedor logueado.
            Dim operac_usu As New operaciones_usuarios()
            Dim cod_cli_distrib As String = operac_usu.DameCodigoClienteDistribuidor(vEmpgrupoCod, vTipVc, age.prop_COD, vClasiEsDistrib)
            Dim cli As New BCb2b.ggclipr(cod_cli_distrib, vEmpgrupoCod, vTipVc)
            Session("cliente") = cli

            If accion = "CRE" Then 'CREAR
                Session("lineasPedido") = New List(Of BCb2b.CLineaPedidoOff)
                'cogemos los datos de del pedido que estamos modificando , en caso de que no estemos modificando no creamos esto.
                Dim cabecera As New BCb2b.CCabeceraPedido(cli, vEmpCod, vGgpedtipReapr, ConfigurationManager.AppSettings("ESTADO_INTERMEDIO"), _
                                                          ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), _
                                                          age.prop_COD, "", "", "", cli.prop_RSOCCONDI_DEF)
                Session("cabeceraPed") = cabecera

                Dim lineasPedidoModificar As List(Of BCb2b.CLineaPedidoOff)
                Dim pedi As New BCb2b.CLineaPedido()
                Dim param As New BCb2b.CParametros()
                lineasPedidoModificar = pedi.lista_lineas_reaprovisiona(cabecera, vEmpgrupoCod, vEmpCod, vTipVc, cli.prop_COD, ConfigurationManager.AppSettings("CLASI_ALMACEN"), FormatDateTime(Now.Date, DateFormat.ShortDate), ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona") & "," & ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona_amc"))

                lineasPedidoModificar = GestionaLineasReaprov(cabecera, lineasPedidoModificar)

                Session("lineasPedido") = lineasPedidoModificar

                Session("cabecera") = Nothing
                Session("calculos") = Nothing
                Session("es_reaprovision") = "S"
                Response.Redirect("CrearPedido.aspx")
            ElseIf accion = "CON" Then 'CONSULTA
                Dim c As New CTI.Utilities.MD5.MD5Checker()
                Response.Redirect(c.GetUrlHashed("~/PedidoConsulta.aspx?serie=" & ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona")))
            End If
        Else
            Dim c As New CTI.Utilities.MD5.MD5Checker()
            Response.Redirect(c.GetUrlHashed("~/PedidoConsulta.aspx?serie=" & ConfigurationManager.AppSettings("tipo_pedido_reaprovisiona")))
        End If
    End Sub
    Private Function GestionaLineasReaprov(ByVal pCabecera As BCb2b.CCabeceraPedido, ByVal listado_lineas As List(Of BCb2b.CLineaPedidoOff)) As List(Of BCb2b.CLineaPedidoOff)
        'DE MOMENTO QUITAMOS LAS LINEAS DE ARTICULOS DE TIRAS.
        Dim listado_aux As New List(Of BCb2b.CLineaPedidoOff)
        For Each lin As BCb2b.CLineaPedidoOff In listado_lineas
            If Not ES_ART_TIRAS_O_ROLLOS(lin.prop_empgrupo_cod, lin.prop_GAART_COD) Then
                listado_aux.Add(lin)
            End If
        Next
        Return listado_aux
    End Function
    Private Function ES_ART_TIRAS_O_ROLLOS(ByVal pEmpgrupoCod As String, ByVal pGaartCod As String) As Boolean
        Dim clasi_tira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
        Dim clasi As New BCb2b.gaartclasi(pEmpgrupoCod, pGaartCod, clasi_tira)
        Return (clasi.prop_GACLASIF_COD = "S")
    End Function
End Class
