Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration

Partial Class LOV_clasificaciones
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then
            'Dim el_Agente As String = ""
            Try
                control.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                control.Value = ""
            End Try
            Try
                control01.Value = Request.QueryString("c1").ToString()
                'TextBox1.Text = control01.Value
                If control01.Value.Contains("(no_existe)") = True Then
                    TextBox1.Text = Replace(control01.Value, "(no_existe)", "")
                End If

            Catch ex As Exception
                control01.Value = ""
            End Try
            Try
                control1.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                control1.Value = ""
            End Try
            Try
                control2.Value = Request.QueryString("textbox3").ToString()
            Catch ex As Exception
                control2.Value = ""
            End Try
            'Try
            '    el_Agente = Request.QueryString("agen").ToString()
            'Catch ex As Exception
            '    el_Agente = ""
            'End Try


            'sql = calcula_Sql(control1.Value)
            sql = calcula_Sql()
            Me.SetFocus(Me.TextBox1)


            conn.ConnectionString = conexion.cadena_conexion
            If control01.Value.Contains("(no_existe)") = False Then
                sql = sql.Replace("<SUSTITUIR>", TextBox1.Text)
            Else
                sql = sql.Replace("<SUSTITUIR>", "")
            End If

            Dim respuesta As String
            Dim lista As New ArrayList
            lista.Clear()
            Try
                Dim valores As New BCb2b.CCargarLov()
                lista = valores.lista_lov(sql)
            Catch escep As Exception
                respuesta = escep.Message()
            Finally
                GVBusqueda.DataSource = lista
                GVBusqueda.DataBind()
            End Try


        End If
    End Sub

    Public Function calcula_Sql() As String


        Dim EMPRESAGRUPO As String = ConfigurationManager.AppSettings("Grupo")
        Dim clasifCargas As String = ConfigurationManager.AppSettings("KZ")
        Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        Dim IDIOMA_aux As String = Session("idioma")

        Dim idioma As String = ""
        'todo: coger idioma spyro.
        Select Case IDIOMA_aux
            Case "de-DE"
                idioma = "ALE"
            Case "it-IT"
                idioma = "IT"
            Case "es-ES"
                idioma = "CAS"
            Case "en-GB"
                idioma = "ING"
            Case "fr-FR"
                idioma = "FRA"
            Case Else
                idioma = "ING"
        End Select


        Dim cargamax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")
        Dim PUBLICO As String = ConfigurationManager.AppSettings("clasif_publico")
        Dim valor_publico As String = ConfigurationManager.AppSettings("clasif_valor")


        ' sql = " SELECT GAART.COD,  GAARTCLASI.VALOR, "

        sql = " select * from ( "
        sql = sql & " SELECT GAART.COD,  '' as valor, "
        ' Codigo para mostrar segn el idioma
        sql = sql & " nvl( (SELECT gaartdescr.descrip "
        sql = sql & " FROM gaartdescr, GGOBSTIP "
        sql = sql & " WHERE  "
        sql = sql & "   GAARTDESCR.GGOBSTIP_COD = GGOBSTIP.COD AND "
        sql = sql & "   GAARTDESCR.TIP_VC = GGOBSTIP.TIP_VCAP AND "
        sql = sql & "   GGOBSTIP.COD = '" & obstip_articulo_idiomas & "'"
        sql = sql & "   AND     gaartdescr.gaart_cod = gaart.cod "
        sql = sql & "   AND idiomas_cod = '" & idioma & "' "
        sql = sql & "  AND tip_vc = GGOBSTIP.TIP_VCAP "
        sql = sql & "   AND ggobstip_cod = '" & obstip_articulo_idiomas & "'"
        sql = sql & "   AND empgrupo_cod = '" & EMPRESAGRUPO & "') , gaart.descrip) as descrip "


        'sql = sql & "  , (SELECT   gaartclasi2.valor "
        'sql = sql & "       FROM      gaartclasi gaartclasi2"
        'sql = sql & "      WHERE gaart.cod = gaartclasi2.gaart_cod "
        'sql = sql & "      AND      gaart.empgrupo_cod = gaartclasi2.empgrupo_cod"
        'sql = sql & "      AND      gaartclasi2.gaclatip_cod = '" & cargamax & "'"
        'sql = sql & "     AND      gaart.cod <> '*'          "
        'sql = sql & "     AND      gaart.empgrupo_cod = '" & EMPRESAGRUPO & "') as CARGA "


        'fin segn el idioma
        'sql = sql & " FROM GAART, GAARTCLASI "
        'sql = sql & " WHERE GAART.COD = GAARTCLASI.GAART_COD  "
        'sql = sql & " AND GAART.EMPGRUPO_COD=GAARTCLASI.EMPGRUPO_COD "
        'sql = sql & " AND GAARTCLASI.GACLATIP_COD='" & PUBLICO & "' "
        'sql = sql & " AND GAART.COD <> '*' "
        'sql = sql & " AND gaartclasi.GACLASIF_COD = '" & valor_publico & "' "
        'sql = sql & " AND (upper(GAART.COD)	LIKE '%<SUSTITUIR>%' "
        'sql = sql & " OR upper(GAART.DESCRIP) LIKE '%<SUSTITUIR>%') "
        'sql = sql & " and gaart.EMPGRUPO_COD ='" & EMPRESAGRUPO & "' "
        'sql = sql & " order by gaart.cod "


        sql = sql & "    FROM GAART  WHERE "
        sql = sql & " GAART.COD <> '*'  AND"

        sql = sql & "  gaart.EMPGRUPO_COD ='" & EMPRESAGRUPO & "' and "
        sql = sql & "  ( gaart.F_VIGENCIA <= sysdate or gaart.f_vigencia is null) and "
        sql = sql & "  ( gaart.F_BAJA > sysdate or gaart.F_BAJA is null) "

        sql = sql & " ) "
        sql = sql & " WHERE (upper(COD)	LIKE '%<SUSTITUIR>%'  OR upper(DESCRIP) LIKE '%<SUSTITUIR>%')   "
        sql = sql & " order by cod "

        Return sql
    End Function

    Public Sub dgBusquedaCommand(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            ' Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            '   Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                '   Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            'If V3 = "" Then
            '    V3 = ""
            'End If
            'If V3 = "&nbsp;" Then
            '    V3 = ""
            'End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            script(2) = V1
            script(3) = "';"
            script(4) = ""

            script(5) = "opener.document.getElementById('" + control1.Value + "').value ='"
            'script(5) = ""
            'opener.document.getElementById('ctl00_ContentPlaceHolder1_BulkEditGridView1_ctl02_lbldescrip_art')

            script(6) = V2
            script(7) = "';"
            ' script(6) = ""
            ' script(7) = ""
            script(8) = ""
            script(9) = ""
            'script(10) = "window.opener.document.forms[0]." + control2.Value + ".focus();"
            script(10) = "window.opener.document.forms[0]." + control1.Value + ".onchange();window.opener.document.forms[0]." + control1.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control.Value + "Cod.value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control.Value + "Cod.focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Public Sub dgBusquedaCommandANTE(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            If V3 = "" Then
                V3 = ""
            End If
            If V3 = "&nbsp;" Then
                V3 = ""
            End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            'script(2) = V2
            script(2) = V1
            script(3) = "';"
            script(4) = "window.opener.document.forms[0]." + control1.Value + ".value ='"
            script(5) = V2
            script(6) = "';"
            script(7) = "window.opener.document.forms[0]." + control2.Value + ".value ='"
            script(8) = V3
            script(9) = "';"
            script(10) = "window.opener.document.forms[0]." + control1.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control1.Value + ".value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control1.Value + ".focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Protected Sub GVBusqueda_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GVBusqueda.PageIndexChanged

        Dim lista As New ArrayList
        lista.Clear()
        Dim valores As New BCb2b.CCargarLov()
        sql = calcula_Sql()
        sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
        lista = valores.lista_lov(sql)
        GVBusqueda.DataSource = lista

        'GVBusqueda.CurrentPageIndex = e.NewPageIndex
        GVBusqueda.PageIndex = e.NewPageIndex
        GVBusqueda.DataBind()
    End Sub

    'Protected Sub btnbuscar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnbuscar.Click
    '    conn.ConnectionString = conexion.cadena_conexion

    '    sql = calcula_Sql()

    '    sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
    '    Dim respuesta As String
    '    Dim lista As New ArrayList
    '    lista.Clear()
    '    Try
    '        Dim valores As New BCb2b.CCargarLov()
    '        lista = valores.lista_lov(sql)
    '    Catch escep As Exception
    '        respuesta = escep.Message()
    '    Finally
    '        'DGBusqueda.CurrentPageIndex = 0
    '        GVBusqueda.DataSource = lista
    '        GVBusqueda.DataBind()
    '    End Try
    'End Sub
    Protected Sub GVBusqueda_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVBusqueda.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            'Any script to handle your event
            e.Row.Cells(0).Attributes.Add("onclick", "javascript:onGridViewCheckBoxClick('" + e.Row.Cells(1).Text + "','" + e.Row.Cells(2).Text + "','" & control1.Value & "','" & control.Value & "');return false;")
        End If
    End Sub
End Class
