﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb

Partial Class LOV_descuentos_esp
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_descuentos_esp))

        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, "Aceptar")
        mensaje.CrearModalConfirm(Me, "DarDeBajaDescuento", "Confirmar", "Dar de baja", "Si", "No")
        mensaje.CrearModalConfirm(Me, "InsertarDescuento", "Confirmar", "Insertar descuento", "Si", "No")
        mensaje.CrearModalConfirm(Me, "ModificarDescuento", "Confirmar", "Modificar descuento", "Si", "No")

        txtDescuento.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")

        If Not Page.IsPostBack Then
            'GGCLIPR_COD
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("cli").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try

            'GAART_COD
            Try
                hdn_gaart_cod.Value = Request.QueryString("art").ToString()
            Catch ex As Exception
                hdn_gaart_cod.Value = ""
            End Try

            'CANT
            Try
                hdn_cant.Value = Request.QueryString("cant").ToString()
            Catch ex As Exception
                hdn_cant.Value = ""
            End Try

            'DESCUENTO
            Try
                hdn_desc.Value = Request.QueryString("desc").ToString()
            Catch ex As Exception
                hdn_desc.Value = ""
            End Try

            'SERIE
            Try
                hdn_tipo.Value = Request.QueryString("tipo").ToString()
            Catch ex As Exception
                hdn_tipo.Value = ""
            End Try

            'OPCION: si llega "esp" es relacion cliente articulo, si llega "fam" es por familia.
            Try
                hdn_opcion.Value = Request.QueryString("op").ToString()
            Catch ex As Exception
                hdn_opcion.Value = ""
            End Try

            If hdn_opcion.Value = "esp" Then
                fila_articulo.Visible = True
                fila_familia.Visible = False

                Dim art_aux As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), hdn_gaart_cod.Value)
                Dim dd As String = art_aux.descripcion_idiomas(ConfigurationManager.AppSettings("obstip_articulo_idiomas"), Session("idioma_spyro"))
                If dd <> "" Then
                    If (dd = "Null") Then
                        dd = art_aux.prop_descrip
                    End If
                End If
                lblgaart_cod.Text = hdn_gaart_cod.Value
                lblgaart_desc.Text = dd
            ElseIf hdn_opcion.Value = "fam" Then
                fila_articulo.Visible = False
                fila_familia.Visible = True

                Dim clasi As New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), hdn_gaart_cod.Value, "FAM")
                lblfam_cod.Text = clasi.prop_GACLASIF_COD
                lblfam_desc.Text = clasi.prop_VALOR
            End If


            Dim cli As New BCb2b.ggclipr(hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            lblggclipr_cod.Text = cli.prop_COD
            lblggclipr_desc.Text = cli.prop_NOMBRE

            CargarDescuentos()

            txtFechaDesde.Text = Now.ToShortDateString
            txtDescuento.Text = hdn_desc.Value.ToString
        End If
    End Sub
    Private Function conectar(ByVal usuario As String, ByVal password As String, ByVal bd As String) As IDbConnection
        If String.IsNullOrEmpty(bd) Then
            Return Nothing
        End If

        Dim b As New OleDbConnectionStringBuilder
        b.Provider = "MSDAORA.1"
        b("user id") = usuario
        b("password") = password
        b.DataSource = bd

        Dim conexion As IDbConnection = New OleDbConnection(b.ConnectionString)

        Try
            conexion.Open()
        Catch ex As Exception
            conexion.Dispose()
            Return Nothing
        End Try
        Return conexion
    End Function

    Protected Sub btninsertar_Click(sender As Object, e As EventArgs) Handles btninsertar.Click
        Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        Dim nom_agen As String = ""
        If Not Session("agente") Is Nothing Then
            Dim age As New BCb2b.gvagente()
            age = Session("agente")
            nom_agen = age.prop_NOMBRE
        Else
            Dim usuario As New BCb2b.CUsrnom()
            If Not Session("usuario") Is Nothing Then
                usuario = Session("usuario")
            End If
            nom_agen = usuario.PROP_COD
        End If

        Dim obser As String = nom_agen & " " & Date.Now & " - " & txtDescuento.Text & " " & hdn_tipo.Value

        Dim mensajeinfo As String = ""
        Dim mensajeerror As String = ""

        Dim fecha_desde As Nullable(Of DateTime) = Nothing
        Dim fecha_hasta As Nullable(Of DateTime) = Nothing
        If txtFechaDesde.Text <> "" Then
            fecha_desde = CDate(txtFechaDesde.Text)
        End If

        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""

        Dim tipo_descuento As String = ""
        If hdn_opcion.Value = "fam" Then
            tipo_descuento = "DPG"
        ElseIf hdn_opcion.Value = "esp" Then
            tipo_descuento = "DCP"
        End If

        Try
            If hdn_opcion.Value = "fam" Then
                AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, lblfam_cod.Text, lblfam_cod.Text, lblfam_cod.Text, txtFechaDesde.Text, Nothing, 0, txtDescuento.Text, mensajeinfo, mensajeerror)
            ElseIf hdn_opcion.Value = "esp" Then
                AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, "", "", "", txtFechaDesde.Text, Nothing, 0, txtDescuento.Text, mensajeinfo, mensajeerror)
            End If

            transaccion.Commit()
            transaccion.Dispose()

            If mensajeerror <> "" Then
                'MOSTRAR DIALOGO ERROR MODIFICANDO PRECIO.
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "DescuentoInsErr", "ShowDialog('" & "Atencion" & "','" & mensajeerror & "','err_red','',300);", True)
            Else
                'MOSTRAR DIALOGO DE PRECIO INSERTADO
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "DescuentoInsOk", "ShowDialog('" & "Correcto" & "','" & "DescuentoCrearo" & "','ok','',300);", True)
            End If

            CargarDescuentos()

            'txtFechaDesde.Text = ""
            txtDescuento.Text = ""
        Catch ex As Exception
            transaccion.Rollback()
            transaccion.Dispose()
            'MOSTRAR DIALOGO ERROR
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "PrecioInsErr", "ShowDialog('" & "Atencion" & "','[Error Insert Price] " & ex.Message & "','err_rojo','',300);", True)
        End Try
    End Sub

    Protected Sub btncancelar_Click(sender As Object, e As EventArgs) Handles btncancelar.Click
        'txtFechaDesde.Text = ""
        txtDescuento.Text = ""

        CargarDescuentos()
    End Sub
    Private Sub CargarDescuentos()
        Dim respuesta As String
        Dim listado_descuentos As New ArrayList
        Try
            'Dim valores As New BCb2b.Precios_especiales()
            'lista = valores.lista_precio_ofer(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, hdn_gaart_cod.Value)

            Dim tipo_descuento As String = ""
            If hdn_opcion.Value = "fam" Then
                tipo_descuento = "DPG"
            ElseIf hdn_opcion.Value = "esp" Then
                tipo_descuento = "DCP"
            End If

            Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
            Dim transaccion As IDbTransaction
            transaccion = conexionole.BeginTransaction

            If hdn_opcion.Value = "fam" Then
                listado_descuentos = AMC_NE029_PKG.AMC_NE029_PKG.DAME_DESCUENTOS_FILTRO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, "COM", Session("idioma_spyro"), hdn_ggclipr_cod.Value, "45", hdn_gaart_cod.Value, "", "", "", "FAM", lblfam_cod.Text, "", Nothing, Nothing)
            ElseIf hdn_opcion.Value = "esp" Then
                listado_descuentos = AMC_NE029_PKG.AMC_NE029_PKG.DAME_DESCUENTOS_FILTRO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, "COM", Session("idioma_spyro"), hdn_ggclipr_cod.Value, "45", hdn_gaart_cod.Value, "", "", "", "", "", "", Nothing, Nothing)
            End If
        Catch escep As Exception
            respuesta = escep.Message()
        Finally
            RPTDescuentos.DataSource = listado_descuentos
            RPTDescuentos.DataBind()
            UPDescuentos.Update()
        End Try
    End Sub

    Protected Sub RPTDescuentos_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles RPTDescuentos.RowCommand
        If e.CommandName <> "Page" Then
            Try
                Dim fila As GridViewRow
                fila = RPTDescuentos.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = RPTDescuentos.Rows(ind)

                Dim f_desde As Label = fila.FindControl("lblf_desde")
                Dim tboxdescuento As TextBox = fila.FindControl("tboxdescuento")

                Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                Dim transaccion As IDbTransaction
                transaccion = conexionole.BeginTransaction

                Dim nom_agen As String = ""
                If Not Session("agente") Is Nothing Then
                    Dim age As New BCb2b.gvagente()
                    age = Session("agente")
                    nom_agen = age.prop_NOMBRE
                Else
                    Dim usuario As New BCb2b.CUsrnom()
                    If Not Session("usuario") Is Nothing Then
                        usuario = Session("usuario")
                    End If
                    nom_agen = usuario.PROP_COD
                End If

                Dim obser As String = nom_agen & " " & Date.Now & " - " & tboxdescuento.Text & " " & hdn_tipo.Value

                Dim mensajeinfo As String = ""
                Dim mensajeerror As String = ""

                Dim fecha_desde As Nullable(Of DateTime) = Nothing
                If f_desde.Text <> "" Then
                    fecha_desde = CDate(f_desde.Text)
                End If

                Dim tipo_descuento As String = ""
                If hdn_opcion.Value = "fam" Then
                    tipo_descuento = "DPG"
                ElseIf hdn_opcion.Value = "esp" Then
                    tipo_descuento = "DCP"
                End If
                Try
                    Select Case e.CommandName
                        Case "guardar"
                            If hdn_opcion.Value = "fam" Then
                                AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, lblfam_cod.Text, lblfam_cod.Text, lblfam_cod.Text, txtFechaDesde.Text, Nothing, 0, txtDescuento.Text, mensajeinfo, mensajeerror)
                            ElseIf hdn_opcion.Value = "esp" Then
                                AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, "", "", "", txtFechaDesde.Text, Nothing, 0, txtDescuento.Text, mensajeinfo, mensajeerror)
                            End If
                        Case "baja"
                            obser = obser & " BAJA"
                            If hdn_opcion.Value = "fam" Then
                                AMC_NE098_PKG.AMC_NE098_PKG.ELIMINAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, lblfam_cod.Text, lblfam_cod.Text, lblfam_cod.Text, txtFechaDesde.Text, 0, mensajeinfo, mensajeerror)
                            ElseIf hdn_opcion.Value = "esp" Then
                                AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, "", "", "", txtFechaDesde.Text, Nothing, 0, txtDescuento.Text, mensajeinfo, mensajeerror)
                            End If
                    End Select

                    transaccion.Commit()
                    transaccion.Dispose()

                    If mensajeerror <> "" Then
                        'MOSTRAR DIALOGO ERROR MODIFICANDO PRECIO.
                        ScriptManager.RegisterStartupScript(Me, Me.GetType(), "PrecioModErr", "ShowDialog('" & "Atencion" & "','" & mensajeerror & "','err_red','',300);", True)
                    Else
                        Select Case e.CommandName
                            Case "guardar"
                                'MOSTRAR DIALOGO DE PRECIO MODIFICADO
                                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "PrecioModOk", "ShowDialog('" & "Correcto" & "','" & "Modificado" & "','ok','',300);", True)
                            Case "baja"
                                'MOSTRAR DIALOGO DE PRECIO DE BAJA
                                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "PrecioBajaOk", "ShowDialog('" & "Correcto" & "','" & "Baja" & "','ok','',300);", True)
                        End Select
                    End If

                    CargarDescuentos()
                Catch ex As Exception
                    transaccion.Rollback()
                    transaccion.Dispose()
                End Try
            Catch ex As Exception
                lblerror.Text = ex.Message.ToString
            End Try
        End If


    End Sub

    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        'CERRAMOS ACTUAL
        Dim script(3) As String
        script(0) = "<script>"
        script(1) = "self.close();"
        script(2) = "</" + "script>"
        Dim KK As String = Join(script, "")
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub
End Class
