﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb

Partial Class LOV_gest_prec_desc
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load

        'ESTO PARA EVITAR EL ERROR DEL __DOPOSTBACK()
        ClientScript.GetPostBackEventReference(Me, String.Empty)

        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_gest_prec_desc))

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "ConfirmarAccion", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "lblConfAccion"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))
        mensaje.CrearModalConfirm(Me, "BorrarPrecEsp", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetLocalResourceObject("lblElimPrecEsp"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))
        mensaje.CrearModalConfirm(Me, "BorrarDescEsp", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetLocalResourceObject("lblElimDescEsp"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))
        mensaje.CrearModalConfirm(Me, "BorrarDescFam", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetLocalResourceObject("lblElimDescFam"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))


        If Not Page.IsPostBack Then
            'GGCLIPR_COD
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("cli").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try

            'GAART_COD
            Try
                hdn_gaart_cod.Value = Request.QueryString("art").ToString()
            Catch ex As Exception
                hdn_gaart_cod.Value = ""
            End Try

            'CANT
            Try
                hdn_cant.Value = Request.QueryString("cant").ToString()
            Catch ex As Exception
                hdn_cant.Value = ""
            End Try

            'PRECIO
            Try
                hdn_prec.Value = Request.QueryString("prec").ToString()
            Catch ex As Exception
                hdn_prec.Value = ""
            End Try

            'DESCUENTO
            Try
                hdn_desc.Value = Request.QueryString("desc").ToString()
            Catch ex As Exception
                hdn_desc.Value = ""
            End Try

            'SERIE
            Try
                hdn_serie.Value = Request.QueryString("tipo").ToString()
            Catch ex As Exception
                hdn_serie.Value = ""
            End Try

            liPrecEsp.Attributes.Add("onmouseup", "chkSel('" & rbtnPrecEsp.ClientID & "');return false;")
            liDescEsp.Attributes.Add("onmouseup", "chkSel('" & rbtnDescEsp.ClientID & "');return false;")
            liDescFam.Attributes.Add("onmouseup", "chkSel('" & rbtnDescFam.ClientID & "');return false;")
            liNada.Attributes.Add("onmouseup", "chkSel('" & rbtnNada.ClientID & "');return false;")

            Dim clasi As New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), hdn_gaart_cod.Value, ConfigurationManager.AppSettings("fam"))
            lblValorFamilia.Text = GetLocalResourceObject("lblFamiliaResource1") & " " & clasi.prop_GACLASIF_COD & " - " & clasi.prop_VALOR & "."
            hdn_cod_familia.Value = clasi.prop_GACLASIF_COD

            'INDICO EN LOS TEXTOS EL PRECIO QUE SE VA A INSERTAR
            If hdn_prec.Value <> "" Then
                lblPrecEspValorNuevo.Text = GetLocalResourceObject("lblNuevoResource1") & " " & FormatNumber(hdn_prec.Value, 2)
            End If

            lblDescEspValorNuevo.Text = GetLocalResourceObject("lblNuevoResource1") & " " & hdn_desc.Value & "%"
            lblDescFamValorNuevo.Text = GetLocalResourceObject("lblNuevoResource1") & " " & hdn_desc.Value & "%"

            lblArtActual1.Text = GetLocalResourceObject("lblArticuloResource1") & " " & hdn_gaart_cod.Value & "."
            lblArtActual2.Text = GetLocalResourceObject("lblArticuloResource1") & " " & hdn_gaart_cod.Value & "."

            lblCliActual1.Text = GetLocalResourceObject("lblClienteResource1") & " " & hdn_ggclipr_cod.Value & "."
            lblCliActual2.Text = GetLocalResourceObject("lblClienteResource1") & " " & hdn_ggclipr_cod.Value & "."
        End If
        GESTIONAR_HABILITADOS()
    End Sub
    Private Sub INSERTAR_DESCUENTO(Optional ByVal p_es_dto_fam As Boolean = False)
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        Dim nom_agen As String = ""
        If Not Session("agente") Is Nothing Then
            Dim age As New BCb2b.gvagente()
            age = Session("agente")
            nom_agen = age.prop_NOMBRE
        Else
            Dim usuario As New BCb2b.CUsrnom()
            If Not Session("usuario") Is Nothing Then
                usuario = Session("usuario")
            End If
            nom_agen = usuario.PROP_COD
        End If

        Dim obser As String = nom_agen & " " & Date.Now & " - " & hdn_desc.Value & " " & hdn_serie.Value

        Dim mensajeinfo As String = ""
        Dim mensajeerror As String = ""

        Dim fecha_desde As Nullable(Of DateTime) = Nothing
        fecha_desde = Now.Date

        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""

        Dim articulo_aux As String = hdn_gaart_cod.Value
        Dim familia_aux As String = hdn_cod_familia.Value

        Dim tipo_descuento As String = ""
        Dim tipoFAM As String = ConfigurationManager.AppSettings("fam")
        If p_es_dto_fam Then
            articulo_aux = "*"
            tipo_descuento = ConfigurationManager.AppSettings("DTO_FAMILIA")
        Else
            familia_aux = "*"
            tipoFAM = "*"
            tipo_descuento = ConfigurationManager.AppSettings("DTO_CLIART")
        End If

        Try
            AMC_NE098_PKG.AMC_NE098_PKG.INSERTAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), tipo_descuento, hdn_ggclipr_cod.Value, articulo_aux, tipoFAM, familia_aux, familia_aux, fecha_desde, Nothing, 0, hdn_desc.Value, mensajeinfo, mensajeerror)

            transaccion.Commit()
            transaccion.Dispose()

            If mensajeerror <> "" Then
                'MOSTRAR DIALOGO ERROR MODIFICANDO PRECIO.
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "DescuentoInsErr", "ShowDialog('" & "Atencion" & "','" & mensajeerror & "','err_red','',300);", True)
            Else
                'MOSTRAR DIALOGO DE PRECIO INSERTADO
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "DescuentoInsOk", "ShowDialog('" & "Correcto" & "','" & "DescuentoCrearo" & "','ok','',300);", True)
            End If


            'txtFechaDesde.Text = ""
            hdn_desc.Value = ""
        Catch ex As Exception
            transaccion.Rollback()
            transaccion.Dispose()
            'MOSTRAR DIALOGO ERROR
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "PrecioInsErr", "ShowDialog('" & "Atencion" & "','[Error Insert Price] " & ex.Message & "','err_rojo','',300);", True)
        End Try
    End Sub
    Private Sub GESTIONAR_HABILITADOS()
        lblPrecEspActual.Text = ""
        lblDescEspActual.Text = ""
        lblDescFamActual.Text = ""
        rbtnDescFam.Enabled = True

        'OBTENGO LOS PRECIOS ESPECIALES PARA ESTE ARTICULO Y OBTENGO EL PRECIO PARA LA CANTIDAD PEDIDA.
        Dim lista_precios_esp As New ArrayList
        Dim valores As New BCb2b.Precios_especiales()
        Try
            lista_precios_esp = valores.lista_precio_ofer(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, hdn_gaart_cod.Value)
        Catch ex As Exception
        End Try

        Dim prec_aux As Double = -1
        Dim fecha_aux As New Date
        For Each prec_esp As BCb2b.Precios_especiales In lista_precios_esp
            If prec_esp.PROP_DESDE = hdn_cant.Value And CDate(prec_esp.PROP_F_DESDE) <= CDate(Now.Date.ToShortDateString) Then
                If prec_aux = -1 Then
                    fecha_aux = prec_esp.PROP_F_DESDE
                    prec_aux = prec_esp.PROP_PRECIO
                End If
            End If
        Next

        'OBTENGO DESCUENTOS ESPECIALES
        Dim descuentos_esp As New BCb2b.GGDTOESCAL()
        descuentos_esp.OBTENER_DESC_ART_VIGENTE(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, ConfigurationManager.AppSettings("DTO_CLIART"))

        Dim descuentos_fam As New BCb2b.GGDTOESCAL()
        descuentos_fam.OBTENER_DESC_FAM_VIGENTE(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("fam"), hdn_cod_familia.Value, ConfigurationManager.AppSettings("DTO_FAMILIA"))

        If descuentos_fam.PROP_DTO_VALOR <> "Null" Then
            lblDescFamActual.Text = GetLocalResourceObject("lblActualResource1") & " " & descuentos_fam.PROP_DTO_VALOR & "%"
            hdn_desc_fam_f_desde.Value = descuentos_fam.PROP_F_DESDE
            IBtnBorrarDescFam.Visible = True
        Else
            IBtnBorrarDescFam.Visible = False
        End If

        If descuentos_esp.PROP_DTO_VALOR <> "Null" Then
            lblDescEspActual.Text = GetLocalResourceObject("lblActualResource1") & " " & descuentos_esp.PROP_DTO_VALOR & "%"
            hdn_desc_esp_f_desde.Value = descuentos_esp.PROP_F_DESDE
            liDescFam.Attributes.Add("class", "listado-item-disabled")
            lblDescFamValorNuevo.Visible = False
            lblDescFamActual.Visible = False
            rbtnDescFam.Enabled = False
            liDescFam_hijo.Visible = False
            IBtnBorrarDescEsp.Visible = True
            IBtnBorrarDescFam.Visible = False
        Else
            IBtnBorrarDescEsp.Visible = False
            lblDescFamValorNuevo.Visible = True
            lblDescFamActual.Visible = True
            liDescFam.Attributes.Add("class", "listado-item")
            liDescFam_hijo.Visible = True
        End If

        'SI TIENE PRECIO ESPECIAL, DESC ESPECIAL Y DESC FAMILIA DESHABILITADOS
        If prec_aux <> -1 Then
            lblPrecEspActual.Text = GetLocalResourceObject("lblActualResource1") & " " & FormatNumber(prec_aux, 2)
            liDescEsp.Attributes.Add("class", "listado-item-disabled")
            lblDescEspValorNuevo.Visible = False
            lblDescEspActual.Visible = False
            liDescEsp_hijo.Visible = False
            rbtnDescEsp.Enabled = False
            IBtnBorrarDescEsp.Visible = False

            liDescFam.Attributes.Add("class", "listado-item-disabled")
            lblDescFamValorNuevo.Visible = False
            IBtnBorrarDescFam.Visible = False
            lblDescFamActual.Visible = False
            liDescFam_hijo.Visible = False
            rbtnDescFam.Enabled = False
            IBtnBorrarPrecEsp.Visible = True
        Else
            IBtnBorrarPrecEsp.Visible = False
        End If
    End Sub
    Protected Sub IBtnBorrarDescEsp_Click(sender As Object, e As ImageClickEventArgs) Handles IBtnBorrarDescEsp.Click
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""
        Try
            AMC_NE098_PKG.AMC_NE098_PKG.ELIMINAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("DTO_CLIART"), hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, "*", "*", "*", hdn_desc_esp_f_desde.Value, 0, mensaje_info, mensaje_error)
            transaccion.Commit()
        Catch ex As Exception
            transaccion.Rollback()
        Finally
            transaccion.Dispose()
        End Try
        GESTIONAR_HABILITADOS()
    End Sub
    Protected Sub IBtnBorrarDescFam_Click(sender As Object, e As ImageClickEventArgs) Handles IBtnBorrarDescFam.Click
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexionole.BeginTransaction

        Dim mensaje_info As String = ""
        Dim mensaje_error As String = ""
        Try
            AMC_NE098_PKG.AMC_NE098_PKG.ELIMINAR_DTO(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("DTO_FAMILIA"), hdn_ggclipr_cod.Value, "*", ConfigurationManager.AppSettings("fam"), hdn_cod_familia.Value, hdn_cod_familia.Value, hdn_desc_fam_f_desde.Value, 0, mensaje_info, mensaje_error)
            transaccion.Commit()
        Catch ex As Exception
            transaccion.Rollback()
        Finally
            transaccion.Dispose()
        End Try
        GESTIONAR_HABILITADOS()
    End Sub
    Protected Sub IBtnBorrarPrecEsp_Click(sender As Object, e As ImageClickEventArgs) Handles IBtnBorrarPrecEsp.Click
        ABRIR_VENTANA_PRECIOS_ESP()
    End Sub
    Private Sub ABRIR_VENTANA_PRECIOS_ESP()
        Dim url As String = "lov_precios_esp.aspx?cli=" + hdn_ggclipr_cod.Value + "&art=" & hdn_gaart_cod.Value & "&cant=" & hdn_cant.Value & "&prec=" & hdn_prec.Value & "&tipo=" & hdn_serie.Value
        Dim ancho As String = "750"
        Dim alto As String = "500"
        Dim atributos_ventana As String = "width=" + ancho + "px,height=" + alto + "px,left='+((screen.width -" + ancho + ") / 2)+',top='+ (screen.height - " + alto + ") / 2+'"

        'CERRAMOS ACTUAL
        Dim script(4) As String
        script(0) = "<script>"
        script(1) = "window.open('" + url + "','LOV','" + atributos_ventana + "');"
        script(2) = "self.close();"
        script(3) = "</" + "script>"
        Dim KK As String = Join(script, "")
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub
    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        If rbtnPrecEsp.Checked Then
            ABRIR_VENTANA_PRECIOS_ESP()
        ElseIf rbtnDescEsp.Checked Then
            INSERTAR_DESCUENTO(False)
        ElseIf rbtnDescFam.Checked Then
            INSERTAR_DESCUENTO(True)
        End If

        'CERRAMOS ACTUAL
        Dim script(3) As String
        script(0) = "<script>"
        script(1) = "self.close();"
        script(2) = "</" + "script>"
        Dim KK As String = Join(script, "")
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub
End Class
