﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data.OleDb
Partial Class LOV_prevs_resumen
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Public vCantAux As Double = 0
    Public vAConsumir As Double = 0
    Public vTerminado As Boolean = False
    Public vDatosCalculados As Boolean = False
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load

        'ESTO PARA EVITAR EL ERROR DEL __DOPOSTBACK()
        ClientScript.GetPostBackEventReference(Me, String.Empty)

        Ajax.Utility.RegisterTypeForAjax(GetType(LOV_prevs_resumen))

        If Not Page.IsPostBack Then
            'GGCLIPR_COD
            Try
                hdn_ggclipr_cod.Value = Request.QueryString("cli").ToString()
            Catch ex As Exception
                hdn_ggclipr_cod.Value = ""
            End Try

            'GAART_COD
            Try
                hdn_gaart_cod.Value = Request.QueryString("art").ToString()
            Catch ex As Exception
                hdn_gaart_cod.Value = ""
            End Try

            'CANT_CTL
            Try
                hdn_cant_ctl.Value = Request.QueryString("cantctl").ToString()
            Catch ex As Exception
                hdn_cant_ctl.Value = ""
            End Try

            'CANT
            Try
                hdn_cant.Value = Request.QueryString("cant").ToString()
            Catch ex As Exception
                hdn_cant.Value = ""
            End Try

            'N_LIN
            Try
                hdn_n_lin.Value = Request.QueryString("nlin").ToString()
            Catch ex As Exception
                hdn_n_lin.Value = ""
            End Try

            If hdn_cant.Value <> "" Then
                vAConsumir = CDbl(hdn_cant.Value)

                CargarPrevisiones()
            End If
        End If
    End Sub

    Private Sub CargarPrevisiones()
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")

        Dim param As New BCb2b.CParametros()
        Dim series_prevision As String = param.dame_param(ConfigurationManager.AppSettings("PARAM_SERIE_PREVISIONES"))
        Dim lista_lineas_prev As New ArrayList
        Dim ofe As New BCb2b.COferta_lin()
        lista_lineas_prev = ofe.lista_lineas_filtro_in(vEmpgrupoCod, vEmpCod, vTipVc, series_prevision, "", hdn_ggclipr_cod.Value, hdn_gaart_cod.Value, "N", "F_ENTRPREV ASC")
        GVResumen.DataSource = lista_lineas_prev
        GVResumen.DataBind()

        Dim cadena As String = GetLocalResourceObject("TxtTienePrevisiones")
        cadena = cadena.Replace("{1}", hdn_ggclipr_cod.Value)
        cadena = cadena.Replace("{2}", lista_lineas_prev.Count)
        cadena = cadena.Replace("{3}", hdn_gaart_cod.Value.ToUpper)
        lblHayPrevs.Text = cadena
        lblCantSoli.Text = hdn_cant.Value
    End Sub
    Public Function ObtenerCUni1LinEnPedido(ByVal pGgofetipCod As String, ByVal pNOfe As String, ByVal pNLin As String) As Double
        'Obtengo de cada línea de pedido lo que ya ha pedido de antes asociado a una linea de oferta.
        Dim c_uni1 As Double = 0
        Dim listaLineasPed As List(Of BCb2b.CLineaPedidoOff) = Session("lineasPedido")
        For Each linea As BCb2b.CLineaPedidoOff In listaLineasPed
            If linea.prop_GAART_COD.ToUpper = hdn_gaart_cod.Value.ToUpper Then
                If linea.prop_GGOFETIP_COD.ToUpper = pGgofetipCod.ToUpper And linea.prop_GGOFELIN_N_OFE = pNOfe And linea.prop_GGOFELIN_N_LIN = pNLin Then
                    c_uni1 += CDbl(linea.prop_C_UNI1)
                End If
            End If
        Next
        Return c_uni1
    End Function
    Private Function ObtenerLineasAConfirmar(ByVal linActual As BCb2b.CLineaPedidoOff) As List(Of BCb2b.CLineaPedidoOff)
        Dim listado As New List(Of BCb2b.CLineaPedidoOff)
        Dim vNLinAux As Integer = 1
        Dim cli As New BCb2b.ggclipr(hdn_ggclipr_cod.Value, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
        For Each fila As GridViewRow In GVResumen.Rows
            Dim lblConfirm As Label = fila.FindControl("lblConfirm")
            If CDbl(lblConfirm.Text) > 0 Then
                Dim vGgofetipCod As String = GVResumen.DataKeys(fila.RowIndex)("prop_ggofetip_cod")
                Dim vNOfe As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_ofe")
                Dim vNLin As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_lin")

                Dim tipo_obs As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
                Dim idioma As String = Session("idioma_spyro")

                Dim vCUni1 As Double = CDbl(lblConfirm.Text)
                Dim vPrPrecio As Double = 0
                Dim art_prec As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), linActual.prop_GAART_COD)

                vPrPrecio = CDbl(art_prec.calcula_precio_b2b(cli, vCUni1))

                Dim LINEAPED As New BCb2b.CLineaPedidoOff(linActual.prop_empgrupo_cod, linActual.prop_EMP_COD, linActual.prop_TIP_VC, linActual.prop_GGPEDTIP_COD, _
                                                          linActual.prop_N_PEDIDO, vNLinAux, linActual.prop_GAART_COD, linActual.prop_DESCRIP, vCUni1.ToString, _
                                                          vPrPrecio.ToString, linActual.prop_F_ENTRPREV, linActual.prop_F_ENTRCONF, linActual.prop_GGCLIPR_COD, _
                                                          linActual.prop_descuento_B2B, linActual.prop_plazo, True, False, vGgofetipCod, vNOfe, vNLin)

                listado.Add(LINEAPED)
                vNLinAux += 1
            End If
        Next
        Return listado
    End Function
    Private Function QuitarLineaActual(ByVal listaLineasPed As List(Of BCb2b.CLineaPedidoOff), ByVal linActual As BCb2b.CLineaPedidoOff) As List(Of BCb2b.CLineaPedidoOff)
        Dim listado_aux As New List(Of BCb2b.CLineaPedidoOff)
        For Each linea In listaLineasPed
            If linea.prop_N_LIN <> linActual.prop_N_LIN Then
                listado_aux.Add(linea)
            End If
        Next
        Return listado_aux
    End Function
    Private Sub ReorganizarNLin(ByRef listaLineasPed As List(Of BCb2b.CLineaPedidoOff))
        Dim lista_aux As New List(Of BCb2b.CLineaPedidoOff)
        Dim i As Integer = 1
        For Each linea As BCb2b.CLineaPedidoOff In listaLineasPed
            linea.asignarNlin = i
            lista_aux.Add(linea)
            i += 1
        Next
        listaLineasPed = lista_aux
    End Sub
    Protected Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        If Not vDatosCalculados Then
            'ACEPTA LAS LINEAS QUE SE VAN A CONSUMIR.
            Dim listaLineasPed As List(Of BCb2b.CLineaPedidoOff) = Session("lineasPedido")
            Dim indice As Int32 = listaLineasPed.FindIndex(Function(x) x.prop_N_LIN = hdn_n_lin.Value)
            Dim linActual As BCb2b.CLineaPedidoOff = listaLineasPed(indice)

            'POR LO TANTO SUPRIMIMOS LA LINEA ACTUAL INTRODUCIDA
            listaLineasPed = QuitarLineaActual(listaLineasPed, linActual)

            'E INSERTAMOS LAS LINEAS DESGLOSADAS EN EL PEDIDO DE LAS PREVISIONES CON SU TRAZABILIDAD.
            Dim listadoLineasConf As List(Of BCb2b.CLineaPedidoOff) = ObtenerLineasAConfirmar(linActual)
            listaLineasPed.AddRange(listadoLineasConf)

            ReorganizarNLin(listaLineasPed)

            Session("lineasPedido") = listaLineasPed

            vDatosCalculados = True
        End If

        'ACTUALIZAMOS PAGINA PADRE Y CERRAMOS ACTUAL
        Dim script(3) As String
        script(0) = "<script>"
        script(1) = "window.opener.location.reload(true); window.close();"
        script(2) = "</" + "script>"
        Dim KK As String = Join(script, "")
        ClientScript.RegisterClientScriptBlock(Me.GetType, "Cerrar", Join(script, ""))
    End Sub
    Private Function EsUltimaLinea(ByVal fila As GridViewRow) As Boolean
        Dim es_ultima As Boolean = False

        Dim vGgofetipCod As String = GVResumen.DataKeys(fila.RowIndex)("prop_ggofetip_cod")
        Dim vNOfe As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_ofe")
        Dim vNLin As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_lin")

        Dim vGgofetipCod_Ult As String = GVResumen.DataKeys(GVResumen.Rows.Count - 1)("prop_ggofetip_cod")
        Dim vNOfeUlt As String = GVResumen.DataKeys(GVResumen.Rows.Count - 1)("prop_n_ofe")
        Dim vNLinUlt As String = GVResumen.DataKeys(GVResumen.Rows.Count - 1)("prop_n_lin")

        If vGgofetipCod = vGgofetipCod_Ult And vNOfe = vNOfeUlt And vNLin = vNLinUlt Then
            es_ultima = True
        End If
        Return es_ultima
    End Function
    Protected Sub GVResumen_PreRender(sender As Object, e As EventArgs) Handles GVResumen.PreRender
        If hdn_cant.Value <> "" Then
            Dim vCantPedida As Double = CDbl(hdn_cant.Value)
            For Each fila As GridViewRow In GVResumen.Rows
                'prop_ggofetip_cod,prop_n_ofe,prop_n_lin
                Dim vGgofetipCod As String = GVResumen.DataKeys(fila.RowIndex)("prop_ggofetip_cod")
                Dim vNOfe As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_ofe")
                Dim vNLin As String = GVResumen.DataKeys(fila.RowIndex)("prop_n_lin")

                Dim lblConfirm As Label = fila.FindControl("lblConfirm")

                Dim vCUni1LinEnPedido As Double = ObtenerCUni1LinEnPedido(vGgofetipCod, vNOfe, vNLin)

                Dim vCUni1 As Double = GVResumen.DataKeys(fila.RowIndex)("prop_c_uni1")
                Dim vCServ1 As Double = GVResumen.DataKeys(fila.RowIndex)("prop_c_serv1")
                Dim vCantPendiLin As Double = vCUni1 - vCServ1 - vCUni1LinEnPedido

                'PARA CALCULAR LA CANTIDAD A CONFIRMAR.
                lblConfirm.Text = "0"
                If vAConsumir < vCantPendiLin Then
                    If Not vTerminado Then
                        lblConfirm.Text = vAConsumir.ToString
                    End If
                Else
                    If Not vTerminado Then
                        lblConfirm.Text = vCantPendiLin
                    End If
                End If

                vAConsumir -= vCantPendiLin

                'SI ES ULTIMA FILA Y AUN QUEDA POR CONSUMIR, SE SUMA A LA ULTIMA LINEA.
                If EsUltimaLinea(fila) And Not vTerminado And CDbl(vAConsumir) > 0 Then
                    vCantPendiLin = (CDbl(lblConfirm.Text) + CDbl(vAConsumir))
                    lblConfirm.Text = vCantPendiLin.ToString
                End If

                'LAS LINEAS QUE SE VAN A CONFIRMAR COMPLETAMENTE EN ROJO Y PARCIALMENTE EN AMARILLO.
                vCantAux += vCantPendiLin
                If vCantAux > vCantPedida Then
                    If Not vTerminado Then
                        fila.CssClass = "aviso-warning"
                    End If
                    vTerminado = True
                ElseIf vCantAux <= vCantPedida Then
                    If Not vTerminado Then
                        fila.CssClass = "aviso-danger"
                    End If
                    If vCantAux = vCantPedida Then
                        vTerminado = True
                    End If
                End If

                If lblConfirm.Text = "0" Then 'SI NO CONSUME NADA DE LA LINEA, QUE OCULTE LA LINEA.
                    fila.CssClass = "oculto"
                End If
            Next
        End If
    End Sub
End Class
