﻿Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Web.Mail
Imports AMC_Proyectos_pkg
Imports System.Data.OracleClient

Imports System.Web.Security
Imports System.Runtime.InteropServices
Imports System.Security.Principal

Imports System.Web
Imports System.Collections
Imports System.Configuration
Imports System.Net
Imports System.Diagnostics
Imports System.Data
Imports System.Data.OleDb
Imports BCb2b

Partial Class Proyectos_MasterPageCliProyectos
    Inherits System.Web.UI.MasterPage

    Private ggestcampa_cod As String
    Private descrip As String
    Private f_desde As Date
    Private f_hasta As Date
    Private ggestado_cod As String
    Private responsable As String
    Private contacto As String
    Private n_revision As Integer

    '' para ftp

    Dim LOGON32_LOGON_INTERACTIVE As Integer = 2
    Dim LOGON32_PROVIDER_DEFAULT As Integer = 0

    Dim impersonationContext As WindowsImpersonationContext

    Declare Function LogonUserA Lib "advapi32.dll" (ByVal lpszUsername As String, _
                            ByVal lpszDomain As String, _
                            ByVal lpszPassword As String, _
                            ByVal dwLogonType As Integer, _
                            ByVal dwLogonProvider As Integer, _
                            ByRef phToken As IntPtr) As Integer

    Declare Auto Function DuplicateToken Lib "advapi32.dll" ( _
                            ByVal ExistingTokenHandle As IntPtr, _
                            ByVal ImpersonationLevel As Integer, _
                            ByRef DuplicateTokenHandle As IntPtr) As Integer

    Declare Auto Function RevertToSelf Lib "advapi32.dll" () As Long
    Declare Auto Function CloseHandle Lib "kernel32.dll" (ByVal handle As IntPtr) As Long

    Private Sub undoImpersonation()
        Try
            impersonationContext.Undo()
        Catch ex As Exception
            'error en undoImpersonation por error en FTP
        End Try
    End Sub
    Private Function impersonateValidUser(ByVal userName As String, _
      ByVal domain As String, ByVal password As String) As Boolean

        Dim tempWindowsIdentity As WindowsIdentity
        Dim token As IntPtr = IntPtr.Zero
        Dim tokenDuplicate As IntPtr = IntPtr.Zero
        impersonateValidUser = False

        If RevertToSelf() Then
            If LogonUserA(userName, domain, password, LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, token) <> 0 Then
                If DuplicateToken(token, 2, tokenDuplicate) <> 0 Then
                    tempWindowsIdentity = New WindowsIdentity(tokenDuplicate)
                    impersonationContext = tempWindowsIdentity.Impersonate()
                    If Not impersonationContext Is Nothing Then
                        impersonateValidUser = True
                    End If
                End If
            End If
        End If
        If Not tokenDuplicate.Equals(IntPtr.Zero) Then
            CloseHandle(tokenDuplicate)
        End If
        If Not token.Equals(IntPtr.Zero) Then
            CloseHandle(token)
        End If
    End Function

    Public Sub uploadFileUsingFTP(ByVal CompleteFTPPath As String, ByVal subdirectorios As String, ByVal NombreFichero As String, ByVal CompleteLocalPath As String, Optional ByVal UName As String = "", Optional ByVal PWD As String = "")

        Try


            crearDirectorioFTP(CompleteFTPPath, subdirectorios, UName, PWD)
            'CompleteFTPPath no tiene el nombre del fichero.
            Dim reqObj As FtpWebRequest = WebRequest.Create(CompleteFTPPath & "/" & subdirectorios & "/" & NombreFichero)

            'fin crear Directorio:
            reqObj.Method = WebRequestMethods.Ftp.UploadFile

            reqObj.Credentials = New NetworkCredential(UName, PWD)

            Dim directorio As String = ""

            Dim bFile() As Byte = System.IO.File.ReadAllBytes(CompleteLocalPath & "/" & NombreFichero)

            Dim clsStream As System.IO.Stream = reqObj.GetRequestStream()
            clsStream.Write(bFile, 0, bFile.Length)
            clsStream.Close()
            clsStream.Dispose()

        Catch ex As Exception
            'Error al hacer el FTP.
        End Try
    End Sub
    Public Function TratarFicheroDescarga(ByVal rutaCompleta As String) As String


        Dim rutaBaseFTP1 As String = ConfigurationManager.AppSettings("rutaBaseFTP1")
        Dim rutaBaseFTP2 As String = ConfigurationManager.AppSettings("rutaBaseFTP2")
        Dim dirVirtual As String = ConfigurationManager.AppSettings("dirVirtual")
        Dim dirRaizApp As String = ConfigurationManager.AppSettings("dirRaizApp")

        Dim resultado As String = rutaCompleta
        Try

            resultado = resultado.Replace(rutaBaseFTP1, dirVirtual)
            resultado = resultado.Replace(rutaBaseFTP2, dirVirtual)
            resultado = resultado.Replace(dirRaizApp, "")
            resultado = resultado.Replace("\", "/")



            If (resultado.Length = 0) Then
                'Si la  Foto no existe entonces cargo por defecto
                resultado = Server.MapPath("~/Proyectos/Images/SinFoto.png")
            End If

            'resultado = "~/" & resultado

            'If resultado.Contains(":") Then
            'Return ""
            'Else
            Return resultado
            'End If
        Catch ex As Exception
            'Lblerror.Text = "[CalcularRuta]" & ex.Message.ToString
            'Lblerror.Text = CType(GetLocalResourceObject("CalcularRuta.Text"), String) & " " & ex.Message.ToString
        End Try
        Return ""
    End Function
    Public Sub crearDirectorioFTP(ByVal rutaFTP As String, ByVal directorio As String, ByVal usuario As String, ByVal clave As String)

        Try
            ' El MKDir hace directorios de uno en uno si la ruta es 111/222 y la ruta 111 no existe todavía va a dar error
            ' hay que hacerlo por pasos, primero la 111
            ' luego la 222
            ' y luego dejamos el fichero.



            Dim listaDirectoriosAux As String() = directorio.Split("/")

            Dim directorioBase As String = rutaFTP

            For i = 0 To listaDirectoriosAux.Length - 1

                Try


                    Dim myftprequest As System.Net.FtpWebRequest
                    Dim myResponse As System.Net.FtpWebResponse

                    directorioBase = directorioBase & "/" & listaDirectoriosAux(i)
                    Dim strm As Stream

                    myftprequest = FtpWebRequest.Create(New Uri(directorioBase))

                    'myftprequest.KeepAlive = False

                    myftprequest.Method = System.Net.WebRequestMethods.Ftp.MakeDirectory

                    myftprequest.Credentials = New NetworkCredential(usuario, clave)

                    myftprequest.UseBinary = True

                    myResponse = myftprequest.GetResponse()

                    myResponse = myftprequest.GetResponse()

                    strm = myResponse.GetResponseStream()

                    strm.Close()

                    myResponse.Close()

                Catch ex As Exception
                    '  Lblerror.Visible = True
                    ' Lblerror.Text = "El error1 es:::" & ex.Message.ToString
                End Try

            Next
        Catch ex As Exception
            ' Throw New Exception("El error es:::" & ex.Message.ToString)
            'Lblerror.Visible = True
            'Lblerror.Text = Lblerror.Text & "El error es:::" & ex.Message.ToString
        End Try


    End Sub
    Private Sub MakeDirectoryIfExists(ByVal NewDirectory As String)
        ' Lblerror.Visible = False
        ' Try

        If Not Directory.Exists(NewDirectory) Then
            Directory.CreateDirectory(NewDirectory)
        End If
        ' Catch _ex As IOException
        '
        '       'Lblerror.Text = "[CrearDirectorio] " & _ex.Message
        '     lblError.Text = CType(GetLocalResourceObject("CrearDirectorio.Text"), String) & " " & _ex.Message
        '      lblError.Visible = True
        '    End Try
    End Sub

    'local....
    Public Function subirFichero(ByVal nombreComponenteUpload As String, ByVal accion As String) As String()

        'El logo se llamarán como el código de proyecto.

        ' Try

        Dim ruta_upload As String = ConfigurationManager.AppSettings("rutaUpload")
        Dim host_ftp As String = ConfigurationManager.AppSettings("host_ftp")
        Dim usuario_ftp As String = ConfigurationManager.AppSettings("usuario_ftp")
        Dim pass_ftp As String = ConfigurationManager.AppSettings("pass_ftp")
        Dim dominio_ftp As String = ConfigurationManager.AppSettings("dominio_ftp")

        Dim rutaBaseFTPUpload As String = ConfigurationManager.AppSettings("rutaBaseFTPUpload")
        Dim nombreFichero As String = ""
        Dim resultado(2) As String
        resultado(1) = ""
        resultado(0) = ""


        Dim subdirectorios As String = ConfigurationManager.AppSettings("subDirecFichB2B") & Session("cliente").prop_cod & "/"


        Dim rutaUploadLocal As String = ConfigurationManager.AppSettings("ruta_fisica_docs") & subdirectorios
        Dim rutaSpyro As String = rutaBaseFTPUpload & subdirectorios.Replace("/", "\")
        resultado(0) = rutaSpyro


        Dim sName As String = buscar_imagen.FileName
        Dim sExt As String = Path.GetExtension(sName)



        If buscar_imagen.HasFile Then

            'Try

            Me.MakeDirectoryIfExists(rutaUploadLocal)
            buscar_imagen.SaveAs(rutaUploadLocal & Session("proyecto").prop_cod & sExt)

            ''-------------------------------------------------------------------------
            'Dim imgruta As String = rutaUploadLocal & Session("proyecto").prop_cod & sExt

            'Dim originalimg As System.Drawing.Image
            'originalimg = System.Drawing.Image.FromStream(buscar_imagen.FileContent)

            'If originalimg.Width > 280 And originalimg.Height > 140 Then
            '    'disminuir
            '    Dim porcentDif1, porcentDif2 As Double
            '    porcentDif1 = originalimg.Width * 100 / 280
            '    porcentDif2 = originalimg.Height * 100 / 140

            '    Dim redimAPorcen As Integer = CInt((porcentDif1 + porcentDif2) / 2)
            '    Dim anchoImgNueva As Integer = (originalimg.Width * 100 / redimAPorcen)
            '    Dim altoImgNueva As Integer = (originalimg.Height * 100 / redimAPorcen)

            '    Dim tamanio As New Size(anchoImgNueva, altoImgNueva)
            '    'Dim imagen As New Bitmap(New Bitmap(imgruta), tamanio)
            '    Dim imagen As New Bitmap(originalimg, tamanio)
            '    imagen.Save(imgruta)
            'Else
            '    buscar_imagen.SaveAs(imgruta)
            'End If


            ''----------------------------------------------------------------------------

            resultado(1) = Session("proyecto").prop_cod & sExt

            'System.Threading.Thread.Sleep(100)
            impersonateValidUser(usuario_ftp, dominio_ftp, pass_ftp)
            Me.uploadFileUsingFTP(host_ftp, subdirectorios, resultado(1), rutaUploadLocal, usuario_ftp, pass_ftp)
            undoImpersonation()
            Return resultado

            'Catch ex As Exception
            ' lblError.Visible = True
            ' lblError.Text = lblError.Text & ex.Message.ToString
            'End Try
        Else

            If (accion = "I") Then
                'lblError.Visible = True
                'Lblerror.Text = Lblerror.Text & "Debe seleccionar un archivo"
                'lblError.Text = lblError.Text & " " & CType(GetLocalResourceObject("SelArchivo.Text"), String) 'OJOOOOOOOOOOOOOOOOOOOOOO
            End If
        End If



        Return resultado


        '  Catch ex As Exception

        ' End Try

    End Function

    ''fin para ftp
    Public ReadOnly Property PROP_ggestcampa_cod() As String
        Get
            Return Me.ggestcampa_cod
        End Get
    End Property
    Public ReadOnly Property PROP_descrip() As String
        Get
            Return Me.descrip
        End Get
    End Property
    Public ReadOnly Property PROP_f_desde() As Date
        Get
            Return Me.f_desde
        End Get
    End Property
    Public ReadOnly Property PROP_f_hasta() As String
        Get
            Return Me.f_hasta
        End Get
    End Property
    Public ReadOnly Property PROP_ggestado_cod() As String
        Get
            Return Me.ggestado_cod
        End Get
    End Property
    Public ReadOnly Property PROP_responsable() As String
        Get
            Return Me.responsable
        End Get
    End Property
    Public ReadOnly Property PROP_contacto() As String
        Get
            Return Me.contacto
        End Get
    End Property

    Public ReadOnly Property PROP_revision() As Integer
        Get
            Return Me.n_revision
        End Get
    End Property

    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub

    Public Shared Sub ShowCalendar(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_series.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&cod_agen=" & cod_agen, "LOV", 450, 450)

    End Sub

    Public Shared Sub ShowCalendar_traza(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal tboxTipo As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String, ByVal codigo_cliente As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_documento.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&tbtipo=" & tboxTipo.ClientID & "&cod_agen=" & cod_agen & "&cod_cli=" & codigo_cliente, "LOV", 450, 650)

    End Sub

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init

        'Page.Form.DefaultButton = btn_nada.UniqueID
        If Session("cliente") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If
        If Session("proyecto") Is Nothing Then
            'Response.Redirect("lista_proyectos.aspx")
        End If




        'If Not Page.IsPostBack Then
        Try


            '  Dim origen As proyecto
            '  origen = CType(Context.Handler, proyecto)

            'Me.ggestado_cod = origen.PROP_ggestado_cod
            'lblProyecto.Text = origen.PROP_ggestcampa_cod
            'lblDescrip.Text = origen.PROP_descrip
            'lblf_desde.Text = origen.PROP_f_desde
            'lblf_hasta.Text = origen.PROP_f_hasta
            'lbl_estado.Text = origen.PROP_ggestado_cod

            Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
            miProyecto = Session("proyecto")

            lblProyecto.Text = miProyecto.prop_cod
            lblDescrip.Text = miProyecto.prop_descrip
            lblComentario.Text = miProyecto.prop_comentario
            lbl_responsable.Text = miProyecto.prop_responsable
            lbl_contacto.Text = miProyecto.prop_contacto

            Dim tengo_permiso As Boolean = AMC_Proyectos_pkg.CProyectos.dame_responsable_bd(miProyecto.prop_cod, ConfigurationManager.AppSettings("USUARIO_WEB"), Session("tipo_usuario"), ConfigurationManager.AppSettings("TIP_ROL_INGENIERO"))

            'ANTES NO DEJABAMOS HACER NADA SI NO ERA EDITABLE, VAMOS A DEJAR DUPLICAR.
            If Session("editarNOeditar") = False Or Not tengo_permiso Then '
                editarProy.Visible = False
                'nuevaRev.Visible = False
                mostrar.Enabled = False
            Else
                editarProy.Visible = True
                nuevaRev.Visible = True
                mostrar.Enabled = True
            End If
            nuevaRev.Visible = True

            'ESTO ES PARA QUE NO ESCRIBA LA PALABRA NULL EN PANTALLA
            If miProyecto.prop_f_desde = "Null" Then
                lblf_desde.Text = ""
            Else
                lblf_desde.Text = miProyecto.prop_f_desde
            End If

            If miProyecto.prop_f_hasta = "Null" Then
                lblf_hasta.Text = ""
            Else
                lblf_hasta.Text = miProyecto.prop_f_hasta
            End If

            'lbl_estado.Text = miProyecto.prop_estado


            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")


            'Dim nom_imagen As String = TratarFicheroDescarga(documento.prop_path_fic)

            'amc_ne026, aqui obteníamos la imagen del logo del proy, ahora de la ficha de cliente.
            ' Dim nom_img As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
            Dim nom_img As String = New BCb2b.CGGCLIPRGRA(ConfigurationManager.AppSettings("GRUPO"), "V", cliente.prop_COD, ConfigurationManager.AppSettings("LOGO"), "").PROP_PATH_FIC 'OBTENEMOS EL PATH DEL FICHERO

            Dim nom_imagen As String = TratarFicheroDescarga(nom_img)

            mostrar.ImageUrl = nom_imagen

            'mostrar.ImageUrl = BuscarFoto()
            'mostrar.ToolTip = "Para cambiar de imagen del proyecto pulse aquí."
            mostrar.ToolTip = CType(GetLocalResourceObject("ImagenMostrar.Text"), String)
            'editarProy.ToolTip = "Para editar la descripcion y el comentario del proyecto pulse aquí."
            editarProy.ToolTip = CType(GetLocalResourceObject("EditarProy.Text"), String)
            mostrar.DataBind()

            lblCodCli.Text = cliente.prop_NOMBRE
            lblPoblacion.Text = cliente.PROP_DIR_social.PROP_POBLAC_NOM
            lblTelefono.Text = cliente.PROP_DIR_social.PROP_TELEFONOS
            lblFax.Text = cliente.PROP_DIR_social.PROP_TELEFAX

            If miProyecto.prop_cod <> "" Then
                PanelProyecto.Visible = True
                Dim revisiones As ArrayList
                revisiones = AMC_Proyectos_pkg.CProyectos.dame_revisiones_proyecto(miProyecto.prop_cod)

                'Session("RevisionSel") = revisiones.Count.ToString

                If revisiones.Count.ToString = "0" Then
                    If revisiones.Count <> 0 Then
                        ddl_revisiones.Text = revisiones(revisiones.Count - 1).prop_observaciones.ToString
                        num_revision.Text = revisiones.Count
                        lbln_revision.Text = revisiones.Count
                        'DDL_revisiones.DataBind()
                        Session("RevisionSel") = revisiones.Count.ToString
                    End If
                Else
                    If Session("RevisionSel") = "" Then
                        ddl_revisiones.Text = revisiones(revisiones.Count - 1).prop_observaciones.ToString
                        num_revision.Text = revisiones.Count
                        lbln_revision.Text = revisiones.Count
                        Session("RevisionSel") = num_revision.Text 'JVC AÑADO ESTO PARA QUE NO DE CASCORRO.
                    Else
                        ddl_revisiones.Text = revisiones(Session("RevisionSel") - 1).prop_observaciones.ToString
                        num_revision.Text = Session("RevisionSel")
                        lbln_revision.Text = Session("RevisionSel")
                    End If


                End If
            Else
                PanelProyecto.Visible = False
            End If

            If Session("PaginaActual") = "nuevo_proyectoWizard" Then
                mostrar.Enabled = False
            Else
                mostrar.Enabled = True
            End If

            'div_oferta_asociada.Visible = False
        Catch ex As Exception
            'Throw New Exception("[Error en MasterInterior_Init] " & ex.Message.ToString)
            'lblError.Text = "[Error en MasterInterior_Init] " & ex.Message.ToString
            'lblError.Text = CType(GetLocalResourceObject("ErrorMaster.Text"), String) & " " & ex.Message.ToString
            'lblError.Visible = True
        End Try
        'End If
    End Sub

    'Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    '    'activaIdioma(Session("idioma"))
    '    If Session("PaginaActual") <> "editarApoyos" Then


    '        'Page.Form.DefaultButton = btn_nada.UniqueID
    '        'Page.Form.DefaultFocus = btn_nada.UniqueID

    '        'btn_clas.OnClientClick = "SetTargetSelf()"
    '        'btn_con.OnClientClick = "SetTargetSelf()"
    '        'btn_graf.OnClientClick = "SetTargetSelf()"
    '        'btn_calc.OnClientClick = "SetTargetSelf()"
    '        'mostrar.OnClientClick = "SetTargetMe()"
    '        'editarProy.OnClientClick = "SetTargetMe()"
    '        'verRev.OnClientClick = "SetTargetMe()"
    '        'nuevaRev.OnClientClick = "SetTargetMe()"
    '        mostrar.OnClientClick = "SetTargetSelf()"
    '        editarProy.OnClientClick = "SetTargetSelf()"
    '        verRev.OnClientClick = "SetTargetSelf()"
    '        nuevaRev.OnClientClick = "SetTargetSelf()"

    '        panLogo.Visible = False


    '        If Session("cliente") Is Nothing Then
    '            Response.Redirect("lista_proyectos.aspx")
    '        End If
    '        If Session("proyecto") Is Nothing Then
    '            'Response.Redirect("lista_proyectos.aspx")
    '        End If

    '        If Not Page.IsPostBack Then
    '            'CARGAR IDIOMAS DESDE PARAMETRO B2B_IDIOMAS
    '            'DDLIdidomas.Items.Clear()
    '            Dim listaIdiomas As New ArrayList
    '            Dim listaIdiomasFinal As New ArrayList
    '            Dim idiomasL As New BCb2b.idiomas
    '            listaIdiomas = idiomasL.listado_idiomas_param_b2b_idiomas(ConfigurationManager.AppSettings("B2B_IDIOMAS"))
    '            Dim i As Integer = 0
    '            For i = 0 To listaIdiomas.Count - 1
    '                Dim idi As New BCb2b.idiomas()
    '                idi = listaIdiomas.Item(i)
    '                Dim idifinal As New BCb2b.idiomas()
    '                idifinal.dameDatosIdioma(idi.prop_idioma, idi.prop_idioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_IDIOMAS"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_IDIOMAS"))
    '                listaIdiomasFinal.Add(idifinal)
    '            Next i
    '            'DDLIdidomas.DataSource = listaIdiomasFinal
    '            'DDLIdidomas.DataTextField = "prop_descrip"
    '            'DDLIdidomas.DataValueField = "prop_culture"
    '            'DDLIdidomas.DataBind()

    '            If (Not Session("idioma") Is Nothing) Then
    '                'DDLIdidomas.SelectedValue = Session("idioma")
    '            End If
    '            Dim usuario As New BCb2b.CUsrnom()
    '            Dim usuario_age As New BCb2b.gvagente()
    '            If Not Session("usuario") Is Nothing Then
    '                Dim cod_usu As String = ""
    '                If Session("perfil_usuario") = "DIS" Then
    '                    Dim age As New BCb2b.gvagente()
    '                    age = Session("agente")
    '                    'OBTENGO EL CLIENTE DEL DISTRIBUIDOR EL CUAL TIENE SU USUARIO Y PASSWORD.
    '                    Dim cli As New BCb2b.ggclipr()
    '                    Dim cod_cli As String = cli.DameCliDeRSocial(ConfigurationManager.AppSettings("grupo"), age.prop_COD, ConfigurationManager.AppSettings("compra"))
    '                    Dim clasi_USU As New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, ConfigurationManager.AppSettings("ClasifLogin"))
    '                    cod_usu = clasi_USU.PROP_VALOR
    '                Else
    '                    usuario = Session("usuario")
    '                    cod_usu = usuario.PROP_COD
    '                End If
    '                Call IdentificarUsuarioLogeado(cod_usu)
    '            Else
    '                'Response.Redirect("~/Expirado.aspx")
    '                Response.Redirect("../~/Expirado.aspx")
    '            End If



    '            Try


    '                '  Dim origen As proyecto
    '                '  origen = CType(Context.Handler, proyecto)

    '                'Me.ggestado_cod = origen.PROP_ggestado_cod
    '                'lblProyecto.Text = origen.PROP_ggestcampa_cod
    '                'lblDescrip.Text = origen.PROP_descrip
    '                'lblf_desde.Text = origen.PROP_f_desde
    '                'lblf_hasta.Text = origen.PROP_f_hasta
    '                'lbl_estado.Text = origen.PROP_ggestado_cod

    '                Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
    '                miProyecto = Session("proyecto")

    '                lblProyecto.Text = miProyecto.prop_cod
    '                lblDescrip.Text = miProyecto.prop_descrip
    '                lbl_responsable.Text = miProyecto.prop_responsable
    '                lbl_contacto.Text = miProyecto.prop_contacto

    '                lblemail.Text = New BCb2b.ggcampaobs(miProyecto.prop_cod, "V", ConfigurationManager.AppSettings("OCAL")).PROP_OBSER

    '                'ESTO ES PARA QUE NO ESCRIBA LA PALABRA NULL EN PANTALLA
    '                If miProyecto.prop_f_desde = "Null" Then
    '                    lblf_desde.Text = ""
    '                Else
    '                    lblf_desde.Text = miProyecto.prop_f_desde
    '                End If
    '                If miProyecto.prop_f_hasta = "Null" Then
    '                    lblf_hasta.Text = ""
    '                Else
    '                    lblf_hasta.Text = miProyecto.prop_f_hasta
    '                End If

    '                'lbl_estado.Text = miProyecto.prop_estado

    '                Dim cliente As BCb2b.ggclipr
    '                cliente = Session("cliente")

    '                'Dim nom_imagen As String = TratarFicheroDescarga(documento.prop_path_fic)
    '                'Dim nom_img As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
    '                'Dim nom_imagen As String = TratarFicheroDescarga(nom_img)
    '                'mostrar.ImageUrl = nom_imagen


    '                'amc_ne026, aqui obteníamos la imagen del logo del proy, ahora de la ficha de cliente.
    '                ' Dim nom_img As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
    '                Dim nom_img As String = New BCb2b.CGGCLIPRGRA(ConfigurationManager.AppSettings("GRUPO"), "V", cliente.prop_COD, ConfigurationManager.AppSettings("LOGO"), "").PROP_PATH_FIC 'OBTENEMOS EL PATH DEL FICHERO
    '                Dim nom_imagen As String = TratarFicheroDescarga(nom_img)
    '                mostrar.ImageUrl = nom_imagen

    '                'AMC_PR015 - MOSTRAR SI EXISTE LA CLASIFICACIÓN DONDE SE GUARDA EL CÓDIGO DE PROYECTO ANTES DE LA MIGRACIÓN.
    '                lblValorCodAnt.Text = AMC_Proyectos_pkg.CProyectos.dame_ggclasifCod_ggcampaclasi(miProyecto.prop_cod, Session("idioma"), ConfigurationManager.AppSettings("PROYANT"))
    '                lblValorCodAnt.Visible = (lblValorCodAnt.Text <> "")
    '                lblTitCodAnt.Visible = (lblValorCodAnt.Text <> "")

    '                'mostrar.ImageUrl = BuscarFoto()
    '                mostrar.DataBind()

    '                lblCodCli.Text = cliente.prop_NOMBRE
    '                lblPoblacion.Text = cliente.PROP_DIR_social.PROP_POBLAC_NOM
    '                lblTelefono.Text = cliente.PROP_DIR_social.PROP_TELEFONOS
    '                lblFax.Text = cliente.PROP_DIR_social.PROP_TELEFAX

    '                If miProyecto.prop_cod <> "" Then
    '                    Dim revisiones As ArrayList
    '                    revisiones = AMC_Proyectos_pkg.CProyectos.dame_revisiones_proyecto(miProyecto.prop_cod)


    '                    If revisiones.Count.ToString = "0" Then
    '                        If revisiones.Count <> 0 Then
    '                            ddl_revisiones.Text = revisiones(revisiones.Count - 1).prop_observaciones.ToString
    '                            num_revision.Text = revisiones.Count
    '                            'DDL_revisiones.DataBind()
    '                            Session("RevisionSel") = revisiones.Count.ToString
    '                        End If
    '                    Else
    '                        If Session("RevisionSel") = "" Then
    '                            ddl_revisiones.Text = revisiones(revisiones.Count - 1).prop_observaciones.ToString
    '                            num_revision.Text = revisiones.Count
    '                        Else
    '                            ddl_revisiones.Text = revisiones(Session("RevisionSel") - 1).prop_observaciones.ToString
    '                            num_revision.Text = Session("RevisionSel")
    '                        End If


    '                    End If

    '                End If



    '                'CAMBIAR COLOR DE FONDO DE LOS BOTONES ONMOUSEOVER

    '                'btn_clas.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222';document.getElementById('submenu').style.display = 'none';")
    '                'btn_clas.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'btn_clas.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")


    '                'btn_graf.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222';document.getElementById('submenu').style.display = 'none';")
    '                'btn_graf.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'btn_graf.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")

    '                'btn_calc.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222';document.getElementById('submenu').style.display = 'inline'")
    '                'btn_calc.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'btn_calc.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")

    '                'btn_con.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222';document.getElementById('submenu').style.display = 'none';")
    '                'btn_con.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'btn_con.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")

    '                'nuevocalcmenu.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222'")
    '                'nuevocalcmenu.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'nuevocalcmenu.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")

    '                'vercalcmenu.Attributes.Add("onmouseover", "this.style.backgroundColor='#B22222'")
    '                'vercalcmenu.Attributes.Add("onmouseout", "this.style.backgroundColor='#6E8CA4'")
    '                'vercalcmenu.Attributes.Add("onmousedown", "this.style.backgroundColor='green'")


    '                If Session("PaginaActual") = "nuevo_proyectoWizard" Or Session("PaginaActual") = "nueva_revisionWizard" Then
    '                    mostrar.Enabled = False
    '                    lblTextoCodigo.Visible = False
    '                Else
    '                    mostrar.Enabled = True
    '                    lblTextoCodigo.Visible = True
    '                End If

    '                'esta linea es para mostrar el boton de nueva revision o no. solo se tiene que ver en calculos.
    '                'If Session("PaginaActual") <> "calculos" Or Session("editarNOeditar") = False Then
    '                '    nuevaRev.Visible = False
    '                'Else
    '                '    nuevaRev.Visible = True
    '                'End If
    '                If (Session("PaginaActual") <> "calculos" And Session("PaginaActual") <> "clasificaciones" And Session("PaginaActual") <> "graficos" And Session("PaginaActual") <> "ver_calculos") Or Session("editarNOeditar") = False Then
    '                    nuevaRev.Visible = False
    '                    'verRev.Visible = False
    '                Else
    '                    nuevaRev.Visible = True
    '                    verRev.Visible = True
    '                End If



    '            Catch ex As Exception
    '                'Throw New Exception("[Error en Master Interior]" & ex.Message.ToString)
    '                'lblError.Text = "[Error en Master Interior]" & ex.Message.ToString
    '                'lblError.Text = CType(GetLocalResourceObject("ErrorMasterLoad.Text"), String) & " " & ex.Message.ToString
    '                'lblError.Visible = True
    '            End Try
    '        End If
    '    End If
    'End Sub

    Protected Sub img_enviar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles img_enviar.Click

        'AMC_NE026. Que la imagen no se guarde como logo proyecto sino como logo cliente.
        If buscar_imagen.HasFile Then

            'Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
            'miProyecto = Session("proyecto")

            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")


            '//**********************
            '(0) ruta spyro
            '(1) nombrefichero
            Dim resultado As String() = Me.subirFichero("buscar_imagen", "I")


            'Dim logo_proy As String = miProyecto.obtener_logo_proy(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"))
            'Dim documento As New AMC_Proyectos_pkg.CProyectos.Grafico_Documento(miProyecto.prop_cod, ConfigurationManager.AppSettings("LOGO"), resultado(1), "")

            'en graficos y documentos de proyecto.
            'If logo_proy <> "" Then
            '    'COPIADO DE GRAFICOS Y DOCUMENTOS.
            '    AMC_Proyectos_pkg.CProyectos.actualiza_grafico(documento, ConfigurationManager.AppSettings("LOGO"), resultado(0) & resultado(1))
            'Else
            '    'COPIADO DE GRAFICOS Y DOCUMENTOS.
            '    AMC_Proyectos_pkg.CProyectos.inserta_grafico(documento, resultado(0))
            'End If

            'En gráficos y documentos de cliente.

            'If logo_proy <> "" Then
            '    'COPIADO DE GRAFICOS Y DOCUMENTOS.

            '    Dim grafCliente As New BCb2b.CGGCLIPRGRA(ConfigurationManager.AppSettings("grupo"), "V", Session("cliente").prop_cod, ConfigurationManager.AppSettings("LOGO"), resultado(0) & resultado(1), resultado(0) & resultado(1), Nothing, Nothing, "observ 1")
            '    grafCliente.GGCLIPRGRA_ACTUALIZAR("IM")

            'Else
            'COPIADO DE GRAFICOS Y DOCUMENTOS.
            'AMC_Proyectos_pkg.CProyectos.inserta_grafico(documento, resultado(0))

            Dim grafCliente As New BCb2b.CGGCLIPRGRA(ConfigurationManager.AppSettings("grupo"), "V", Session("cliente").prop_cod, ConfigurationManager.AppSettings("LOGO"), resultado(0) & resultado(1), resultado(0) & resultado(1), Nothing, Nothing, "observ 2")
            grafCliente.GGCLIPRGRA_ACTUALIZAR("IM")

            'End If

            Dim rutaNuevoLogo As String = TratarFicheroDescarga(resultado(0) & resultado(1))

            '/*************************************************************************************************************/

            mostrar.ImageUrl = rutaNuevoLogo

            mostrar.Dispose()
            mostrar.DataBind()
            buscar_imagen.Visible = False
            img_enviar.Visible = False
            mostrar.Visible = True
            img_cancelar.Visible = False

        Else
            RFVbuscar_imagen.IsValid = False
        End If



    End Sub


    Protected Function ValidaExtension(ByVal sExtension As String) As Boolean
        Select Case sExtension.ToLower
            'Case ".jpg", ".jpeg", ".png", ".gif", ".bmp"
            Case ".png"
                Return True
            Case Else
                Return False
        End Select
    End Function

    Protected Sub mostrar_elementos(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles mostrar.Click
        buscar_imagen.Visible = True
        img_enviar.Visible = True
        'mostrar.Visible = False
        img_cancelar.Visible = True
        panLogo.Visible = True
    End Sub

    Protected Sub nuevaRev_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles nuevaRev.Click
        If Session("ClasisObliConValor") = True Then
            Server.Transfer("nueva_revisionWizard.aspx")
        Else
            'Mensaje("Faltan clasificaciones por dar valor")
            Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
        End If

    End Sub

    Protected Sub verRev_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles verRev.Click
        If Session("ClasisObliConValor") = True Then
            Server.Transfer("ver_revisiones.aspx")
        Else
            'Mensaje("Faltan clasificaciones por dar valor")
            Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
        End If

    End Sub

    Protected Sub editarProy_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles editarProy.Click
        Server.Transfer("modificar_proyecto.aspx")
    End Sub

    Protected Sub btonEditar_Click1(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs)

    End Sub

    Private Sub Mensaje(ByVal mensaje As String)
        Dim scriptMsj As New System.Text.StringBuilder
        scriptMsj.Append("<script language='javascript'>")
        scriptMsj.Append("window.alert('")
        scriptMsj.Append(mensaje)
        scriptMsj.Append("')</script>")


        Page.ClientScript.RegisterStartupScript(Me.GetType(), "MENSAJE", scriptMsj.ToString)


    End Sub

    Protected Sub cancelar_upload(ByVal sender As Object, ByVal e As System.EventArgs) Handles img_cancelar.Click
        buscar_imagen.Visible = False
        img_enviar.Visible = False
        'mostrar.Visible = True
        img_cancelar.Visible = False
        Label3.Visible = False
        a_ocultar.Visible = False
    End Sub

    Protected Sub CambiarlogoLabel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CambiarlogoLabel.Click
        buscar_imagen.Visible = True
        img_enviar.Visible = True
        'mostrar.Visible = False
        img_cancelar.Visible = True
        panLogo.Visible = True
        Label3.Visible = True
        a_ocultar.Visible = True
    End Sub



    Protected Overrides Sub AddedControl(control As System.Web.UI.Control, index As Integer)

        If (Request.ServerVariables("http_user_agent").IndexOf("Safari", StringComparison.CurrentCultureIgnoreCase) <> -1) Then
            Me.Page.ClientTarget = "uplevel"
        End If

        MyBase.AddedControl(control, index)


    End Sub

    'Protected Sub DDLIdidomas_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLIdidomas.SelectedIndexChanged
    '    Session("idioma") = DDLIdidomas.SelectedValue
    '    Page.Response.Redirect(Page.Request.Url.ToString(), True)
    'End Sub


    Private Function conectar(ByVal usuario As String, ByVal password As String, ByVal bd As String) As IDbConnection
        If String.IsNullOrEmpty(bd) Then
            Return Nothing
        End If

        Dim b As New OleDbConnectionStringBuilder
        b.Provider = "MSDAORA.1"
        b("user id") = usuario
        b("password") = password
        b.DataSource = bd

        Dim conexion As IDbConnection = New OleDbConnection(b.ConnectionString)

        Try
            conexion.Open()
        Catch ex As Exception
            conexion.Dispose()
            Return Nothing
        End Try
        Return conexion
    End Function
    Public Sub IdentificarUsuarioLogeado(ByVal usu_logueado As String)
        Dim usuario As New BCb2b.CUsrnom()
        Dim codUsuario As String = ""

        Dim USER As String = ""
        Dim PASSWORD As String = ""
        If usu_logueado <> "" Then
            usuario = New BCb2b.CUsrnom(usu_logueado)
            If Not usuario.PROP_COD Is Nothing Then
                Session("usuario") = usuario
                codUsuario = usuario.PROP_COD

                USER = usuario.PROP_COD
                PASSWORD = usuario.PROP_PASSWORD
            Else
                codUsuario = usu_logueado
                Dim clasi_USU As New BCb2b.CGGCLICLASI()
                Dim clasi_PASS As New BCb2b.CGGCLICLASI()
                If Not Session("agente") Is Nothing Then
                    'DISTRIBUIDORES
                    Dim age As New BCb2b.gvagente()
                    age = Session("agente")
                    'OBTENGO EL CLIENTE DEL DISTRIBUIDOR EL CUAL TIENE SU USUARIO Y PASSWORD.
                    Dim cli As New BCb2b.ggclipr()
                    Dim cod_cli As String = cli.DameCliDeRSocial(ConfigurationManager.AppSettings("grupo"), age.prop_COD, ConfigurationManager.AppSettings("compra"))
                    clasi_USU = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, ConfigurationManager.AppSettings("ClasifLogin"))
                    clasi_PASS = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, ConfigurationManager.AppSettings("ClasifPass"))
                Else
                    'CLIENTES
                    clasi_USU = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), Session("cliente").prop_cod, ConfigurationManager.AppSettings("ClasifLogin"))
                    clasi_PASS = New BCb2b.CGGCLICLASI(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), Session("cliente").prop_cod, ConfigurationManager.AppSettings("ClasifPass"))
                End If

                USER = clasi_USU.PROP_VALOR
                PASSWORD = clasi_PASS.PROP_VALOR
            End If
        End If

        Dim perfil_usu As String = ""
        Try
            If Not codUsuario Is Nothing Then
                Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                Dim transaccion_perfil_usu As IDbTransaction
                transaccion_perfil_usu = conexionole.BeginTransaction
                Dim usu As New BCb2b.CUsuarios()
                Try
                    perfil_usu = usu.DamePerfilUsuario(AMC_B2B_PKG.AMC_B2B_PKG.DAME_PERFILES(transaccion_perfil_usu, ConfigurationManager.AppSettings("grupo"), USER.ToUpper, PASSWORD.ToUpper))
                    transaccion_perfil_usu.Commit()
                Catch ex As Exception
                    transaccion_perfil_usu.Rollback()
                End Try
                transaccion_perfil_usu.Dispose()
            End If
        Catch ex As Exception
            'perfil_usu = "DISTRIBUIDOR"
        End Try

        'If codUsuario = "AITORLOPETEGI" Then
        '    perfil_usu = "SUPERVENTAS"
        'End If

        'Session("ver_clientes")
        'T = TODOS
        'A = comisionistas
        'J = con agente jefe
        'C = proveedor
        Dim tipo_usuario As String = ""
        'Try
        Select Case perfil_usu
            Case "CLIENTE"
                tipo_usuario = "CL"
            Case "AGENTE"
                Session("ver_clientes") = "A"
                codUsuario = usuario.PROP_NOMBRE
                tipo_usuario = "AG"
            Case "DISTRIBUIDOR"
                tipo_usuario = "DIS"
                Session("ver_clientes") = "A"
            Case "INGENIERO"
                Session("ver_clientes") = "T"
                codUsuario = usuario.PROP_COD
                tipo_usuario = "ING"
            Case "SUPERVENTAS"
                Session("ver_clientes") = "T"
                tipo_usuario = "SVT"
            Case "SUPERCOMPRAS"
                tipo_usuario = "SCP"
            Case Else
                tipo_usuario = "AG"
                Session("ver_clientes") = "A"
        End Select
        'Catch ex As Exception
        '    'por aqui entraria desde ofertas
        '    codUsuario = Session("usuario")
        'End Try

        Session("tipo_usuario") = tipo_usuario
        Session("perfil_usuario") = tipo_usuario

        'sra comento
        'If Not codUsuario Is Nothing And tipo_usuario <> "" Then
        '    'ESTO CAMBIAR EL TEXTO SEGUN EL TIPO DE USUARIO
        '    'MIRAR LOCALRESOURCES TipoUsuING, TipoUsuCL, TipoUsuAG
        '    'Ok, ESTO SI HUBIERAMOS UNIFICADOS, PORQUE AGENTE , SUPERAGENTE Y DISTRIBUIDOR SON TODOS AGENTE, NO HARÍA FALTA HACER
        '    'TODA ESTA GESTION!!!!!JVC!!!!!!

        '    lblAgente.Text = GetLocalResourceObject("TipoUsu_" & tipo_usuario.ToUpper) & " "

        '    If Session("cliente") Is Nothing Then
        '        lblNombreCliente.Text = GetLocalResourceObject("NoCliSelec") 'Sin cliente seleccionado.
        '        If Not Session("agente") Is Nothing Then
        '            Dim agente As New BCb2b.gvagente()
        '            agente = Session("agente")
        '            lblNombreAgente.Text = agente.prop_NOMBRE
        '        End If
        '    Else
        '        Dim cli As New BCb2b.ggclipr()
        '        cli = Session("cliente")
        '        lblNombreCliente.Text = cli.prop_NOMBRE
        '        Dim perfiles As New BCb2b.USUARIOS_B2B()
        '        perfiles.Administrar_Permisos_Perfiles(tipo_usuario)
        '        If perfiles.prop_TIPO_PERFIL = 0 Then
        '            'If tipo_usuario = "ING" Then
        '            lblNombreAgente.Text = codUsuario
        '        Else
        '            If Not Session("agente") Is Nothing Then
        '                Dim age As New BCb2b.gvagente()
        '                age = Session("agente")
        '                lblNombreAgente.Text = age.prop_NOMBRE
        '            Else
        '                If perfiles.prop_TIPO_PERFIL <> 2 Then
        '                    Dim age2 = New BCb2b.CAgente(cli.prop_GVAGENTE_COD)
        '                    lblNombreAgente.Text = age2.prop_nombre
        '                Else
        '                    'ES CLIENTE
        '                    lblNombreAgente.Text = cli.prop_NOMBRE
        '                    lbltitSeleccionarCliente.Visible = False
        '                    lblNombreCliente.Visible = False
        '                End If
        '            End If
        '        End If
        '    End If
        'fin sra comento

        'ESTO QUEDARIA ASI--> Bienvenido Ingeniero: IGOR o Bienvenido Agente: Sebastian Wuttke
        'Else
        'lblNombreAgente.Visible = False
        'lblAgente.Visible = False
        'lbltitSeleccionarCliente.Visible = False
        'lblNombreCliente.Visible = False
        'End If

        'lblNombreAgente.Text = perfil_usu
    End Sub

    Protected Sub verProyectos_Click(sender As Object, e As ImageClickEventArgs) Handles verProyectos.Click
        Response.Redirect("lista_proyectos.aspx")
    End Sub
    Protected Sub caracteristicas_Click(sender As Object, e As ImageClickEventArgs) Handles caracteristicas.Click
        If Session("PaginaActual") <> "nuevo_proyectoWizard" Then
            If Session("ClasisObliConValor") = True Then
                Dim ggestcampa_cod As String = lblProyecto.Text
                Dim descripcion As String = lblDescrip.Text
                Dim f_desde As String = lblf_desde.Text
                Dim f_hasta As String = lblf_hasta.Text
                Dim responsable As String = lbl_responsable.Text
                Dim contacto As String = lbl_contacto.Text
                'Dim estado As String = lbl_estado.Text
                'Dim revision As Integer = DDL_revisiones.SelectedItem.Value

                Me.ggestcampa_cod = ggestcampa_cod
                Me.descrip = descripcion
                Me.f_desde = Metodos.StringToDate(f_desde)
                Me.f_hasta = Metodos.StringToDate(f_hasta)
                Me.responsable = responsable
                Me.contacto = contacto
                'Me.ggestado_cod = estado
                'Me.n_revision = revision
                Response.Redirect("clasificaciones.aspx")
            Else
                'Mensaje("Faltan clasificaciones por dar valor")
                Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
            End If
        Else
            'Mensaje("Debe finalizar el asistente de nuevo proyecto")
            Mensaje(CType(GetLocalResourceObject("Mensaje2.Text"), String))
        End If
    End Sub
    Protected Sub documentos_Click(sender As Object, e As ImageClickEventArgs) Handles documentos.Click
        If Session("PaginaActual") <> "nuevo_proyectoWizard" Then

            If Session("ClasisObliConValor") = True Then
                Dim ggestcampa_cod As String = lblProyecto.Text
                Dim descripcion As String = lblDescrip.Text
                Dim f_desde As String = lblf_desde.Text
                Dim f_hasta As String = lblf_hasta.Text
                Dim responsable As String = lbl_responsable.Text
                Dim contacto As String = lbl_contacto.Text
                'Dim estado As String = lbl_estado.Text
                'Dim revision As Integer = DDL_revisiones.SelectedItem.Value

                Me.ggestcampa_cod = ggestcampa_cod
                Me.descrip = descripcion
                Me.f_desde = Metodos.StringToDate(f_desde)
                Me.f_hasta = Metodos.StringToDate(f_hasta)
                Me.responsable = responsable
                Me.contacto = contacto
                'Me.ggestado_cod = estado
                'Me.n_revision = revision
                Response.Redirect("graficos_documentos.aspx")
            Else
                'Mensaje("Faltan clasificaciones por dar valor")
                Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
            End If
        Else
            'Mensaje("Debe finalizar el asistente de nuevo proyecto")
            Mensaje(CType(GetLocalResourceObject("Mensaje2.Text"), String))
        End If
    End Sub
    Protected Sub verCalculo_Click(sender As Object, e As ImageClickEventArgs) Handles verCalculo.Click
        If Session("PaginaActual") <> "nuevo_proyectoWizard" Then
            If Session("ClasisObliConValor") = True Then
                Response.Redirect("ver_revisiones.aspx")
            Else
                'Mensaje("Faltan clasificaciones por dar valor")
                Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
            End If
        Else

            Mensaje(CType(GetLocalResourceObject("Mensaje2.Text"), String))
        End If
    End Sub
    Protected Sub nuevoCalculo_Click(sender As Object, e As ImageClickEventArgs) Handles nuevoCalculo.Click
        If Session("PaginaActual") <> "nuevo_proyectoWizard" Then
            If Session("ClasisObliConValor") = True Then
                Response.Redirect("nueva_revisionWizard.aspx")
            Else
                'Mensaje("Faltan clasificaciones por dar valor")
                Mensaje(CType(GetLocalResourceObject("Mensaje1.Text"), String))
            End If
        Else
            Mensaje(CType(GetLocalResourceObject("Mensaje2.Text"), String))
        End If
    End Sub

    Protected Sub ImgBtnVerOfe_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBtnVerOfe.Click
        'Dim ggofetip_cod As String = hdn_ggofetip_cod.Value
        'Dim ggofelin_n_ofe As String = hdn_ggofetip_n_ofe.Value

        'If ggofetip_cod <> "" And ggofelin_n_ofe <> "" Then
        '    Session("N_OFE") = ggofelin_n_ofe
        '    Session("OPOR") = ggofelin_n_ofe
        '    Session("TIPO_OFE") = ggofetip_cod
        '    Session("OPOR_SERIE") = ggofetip_cod
        '    Session("GRUPO_OFE") = ConfigurationManager.AppSettings("grupo")
        '    Session("EMPRESA_OFE") = ConfigurationManager.AppSettings("empresa")

        '    Response.Redirect("~/OfertaDetalle.aspx")
        'End If
    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load


        'JVC: INCI-877784
        datosCli.visible = True
        If (Session("cliente") Is Nothing) Then
            datosCli.visible = False
        End If

        If Not Session("calculos") Is Nothing And Session("PaginaActual") = "calculos" Then
            Dim calc As New AMC_Proyectos_pkg.CCalculos()
            calc = Session("calculos")

            '    hdn_ggofetip_cod.Value = calc.prop_GGOFETIP_COD
            '    hdn_ggofetip_n_ofe.Value = calc.prop_N_OFE_REV

            '    If calc.prop_GGOFETIP_COD <> "" And calc.prop_N_OFE_REV <> "" Then
            '        div_oferta_asociada.Visible = True
            '    Else
            div_oferta_asociada.Visible = False
            '    End If
        End If
    End Sub
End Class