﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Data.OracleClient

'Imports System.Data
'Imports System.Data.SqlClient
'Imports System.Data.OracleClient
'Imports System.Configuration
'Imports System.Globalization
'Imports System.Threading

Partial Class _OfertasConsulta
    Inherits claseBase
    Private Nofe As String
    Private TIPOofe As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.Nofe
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOofe
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Session("lineasPedido") = New List(Of BCb2b.CLineaPedidoOff)
        Session("lineasOferta") = New List(Of BCb2b.COferta_linOff)
        Session("cabeceraPed") = Nothing
        Session("cabecera") = Nothing

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "BorrarOferta", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("ElimOferta.Text"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"))

        ShowLupaArticulo(IBArticulo, txtArticuloCod, txtArticulo)

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

        If perfiles.prop_TIPO_PERFIL = 2 Then 'cli
            Label2.CssClass = "oculto"
            checkboxTODOS.CssClass = "oculto"
        End If


        If (Not Session("cliente") Is Nothing) Or perfiles.prop_TIPO_PERFIL = 0 Then
            'If (Not Session("cliente") Is Nothing) Or Session("tipo_usuario") = "ING" Or Session("tipo_usuario") = "SVT" Then
            If Not IsPostBack Then
                If Session("cliente") Is Nothing Then '(Session("tipo_usuario") = "ING" Or Session("tipo_usuario") = "SVT") And 
                    checkboxTODOS.Checked = True
                    checkboxTODOS.Enabled = False
                Else
                    Dim cli As New BCb2b.ggclipr()
                    cli = Session("cliente")

                    'Datos de la cabecera.
                    lblNombreCli.Text = cli.prop_NOMBRE
                    'If Session("cliente").prop_portes_pd = "P" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesPagadosDescrip.Text").ToString()
                    'ElseIf Session("cliente").prop_portes_pd = "D" Then
                    '    lblPortes.Text = GetLocalResourceObject("lblPortesDebidosDescrip.Text").ToString()
                    'End If
                    lblRSocial.Text = cli.prop_RSOCIAL_COD

                    Dim traduc As New BCb2b.CSPTRADDATOS()
                    lblAgencia.Text = traduc.DameTraduccion(ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("ING_SPYRO"), cli.prop_GGMENVIO_COD)
                    If lblAgencia.Text = "" Then
                        lblAgencia.Text = cli.prop_GGMENVIO_desc
                    End If
                    'lblAgencia.Text = Session("cliente").prop_GGMENVIO_COD
                    'lblAgencia.Text = Session("cliente").prop_GGMENVIO_desc
                End If


                GRUPO = ConfigurationManager.AppSettings("GRUPO")
                EMPRESA = ConfigurationManager.AppSettings("EMPRESA")

                'Dim lista_series As New BCb2b.CSeries()
                'DDLSerie.DataSource = lista_series.SeriesOferta(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("grupo"))

                Dim tipo_oferta As New BCb2b.CGGOfetip()
                Dim CODIGOS_NO As String = ""

                Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_OFER_VISUALIZAR"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                Dim CODIGOS_SI As String = ""

                'AMC_NE235. OBTENEMOS LA SERIE DE LA URL POR SI VIENE DEL PUNTO DE MENU OFERTAS DE PREVISION.
                Dim series_oprevs As String = ""
                If Not Request.Form("series_oprevs") Is Nothing Then
                    series_oprevs = Request.Form("series_oprevs")
                End If
                hdn_series_oprevs.Value = series_oprevs

                CODIGOS_SI = series_oprevs
                If series_oprevs = "" Then
                    CODIGOS_SI = PARAMETRO.prop_VALOR
                End If

                Dim listado As ArrayList = tipo_oferta.listado_SerieOferta(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CODIGOS_SI, CODIGOS_NO, GetLocalResourceObject("todas.Text").ToString(), "", Session("cadena_conexion"), Session("idioma_spyro"))
                DDLSerie.DataSource = listado
                DDLSerie.DataBind()

                'DE UN PARAMETRO SPYRO
                Dim PARAMETRO_GRUPO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_CLASI_LISTADO_OFERTAS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                Dim GRUPO_CLIENTE As String = PARAMETRO_GRUPO.prop_VALOR

                Dim cggclasif As New BCb2b.CGGCLASIF()
                Dim listado2 As ArrayList = cggclasif.listado_clasificaciones_todas(ConfigurationManager.AppSettings("venta"), GRUPO_CLIENTE, "SI", "NO", GetLocalResourceObject("todas.Text").ToString(), GetLocalResourceObject("sin_grupo.Text").ToString(), Session("idioma_spyro"))
                DDLGrupo.DataSource = listado2
                DDLGrupo.DataBind()

                GVOfertas.VirtualItemCount = GetRowCount()
                BindPagingGrid()
            End If
        Else
            If (Not Session("rsocial") Is Nothing) Then
                If Not IsPostBack Then
                    'Datos de la cabecera.
                    lblNombreCli.Text = Session("rsocial").prop_nombre
                    lblRSocial.Text = Session("rsocial").prop_rsocial_cod

                    Dim tipo_oferta As New BCb2b.CGGOfetip()
                    Dim CODIGOS_NO As String = ""

                    'Dim UTIL As New UTILITIES()
                    Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_OFER_VISUALIZAR"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                    Dim CODIGOS_SI As String = PARAMETRO.prop_VALOR
                    Dim listado As ArrayList = tipo_oferta.listado_SerieOferta(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), CODIGOS_SI, CODIGOS_NO, GetLocalResourceObject("todas.Text").ToString(), "", Session("cadena_conexion"))
                    DDLSerie.DataSource = listado
                    DDLSerie.DataBind()
                    'DE UN PARAMETRO SPYRO
                    Dim PARAMETRO_GRUPO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_CLASI_LISTADO_OFERTAS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                    Dim GRUPO_CLIENTE As String = PARAMETRO_GRUPO.prop_VALOR
                    Dim cggclasif As New BCb2b.CGGCLASIF()
                    Dim listado2 As ArrayList = cggclasif.listado_clasificaciones_todas(ConfigurationManager.AppSettings("venta"), GRUPO_CLIENTE, "SI", "NO", GetLocalResourceObject("todas.Text").ToString(), GetLocalResourceObject("sin_grupo.Text").ToString())
                    DDLGrupo.DataSource = listado2
                    DDLGrupo.DataBind()

                End If
            Else
                If (Not Session("agente") Is Nothing) Then
                    'Response.Redirect("SelCliente.aspx", False)
                    Response.Redirect("BusquedaClientes.aspx", False)
                Else
                    Response.Redirect("index.aspx", False)
                End If
            End If
        End If

    End Sub


    Protected Sub btnBuscar_Click(sender As Object, e As EventArgs) Handles btnBuscar.Click
        GVOfertas.VirtualItemCount = GetRowCount()
        BindPagingGrid()
    End Sub

    'Protected Sub btonVerOfertas_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btonVerOfertas.Click


    '    Dim elemento As New BCb2b.COferta_Cab()
    '    GridView1.VirtualItemCount = GetRowCount()
    '    BindPagingGrid()


    'End Sub

    Protected Sub GVOfertas_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GVOfertas.PageIndexChanging
        GVOfertas.PageIndex = e.NewPageIndex
        BindPagingGrid()
    End Sub

    Protected Sub GVOfertas_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GVOfertas.RowCommand
        If e.CommandName <> "Page" Then
            Try
                Dim fila As GridViewRow
                fila = GVOfertas.SelectedRow
                Dim ind As Integer
                Integer.TryParse(e.CommandArgument, ind)
                fila = GVOfertas.Rows(ind)

                Dim Pkey As DataKeyArray = GVOfertas.DataKeys

                Dim DetalleGrupo As String = Pkey.Item(ind).Item(0)
                Dim DetalleEmpresa As String = Pkey.Item(ind).Item(1)
                Dim tipo_ofe As String = Pkey.Item(ind).Item(2)
                Dim n_oferta As String = Pkey.Item(ind).Item(3) 'NUMOFERTA
                Dim DetalleTIPVC As String = Pkey.Item(ind).Item(4)


                Me.Nofe = n_oferta
                Me.TIPOofe = tipo_ofe
                Me.GRUPO = DetalleGrupo
                Me.EMPRESA = DetalleEmpresa
                Me.TIPVC = DetalleTIPVC

                Session("GRUPO_OFE") = DetalleGrupo
                Session("EMPRESA_OFE") = DetalleEmpresa
                Session("TIPO_OFE") = tipo_ofe
                Session("N_OFE") = n_oferta

                If (e.CommandName = "ver") Then

                    'Server.Transfer("OfertaDetalle.aspx")
                    Response.Redirect("OfertaDetalle.aspx")

                ElseIf (e.CommandName = "revisar") Then

                    'cargar la oferta a revisar??

                    Dim GGOFECAB_GGOFETIP_COD As String = tipo_ofe
                    Dim GGOFECAB_N_OFE As String = n_oferta

                    Session("lineasOferta") = New List(Of BCb2b.COferta_linOff)
                    'CARGAMOS LAS LINEAS REALES DE LA OFERTA, EN EL GRID O AQUI.
                    'cogemos los datos de la oferta que estamos modificando , en caso de que no estemos modificando no creamos esto.
                    Dim cabecera As New BCb2b.COferta_Cab(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), GGOFECAB_GGOFETIP_COD, GGOFECAB_N_OFE)
                    Session("cabecera") = cabecera

                    'observacion defecto
                    Dim obs As New BCb2b.CObs_oferta(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOofe, Me.Nofe, System.Configuration.ConfigurationManager.AppSettings("Obs_defecto_Ofertas"))
                    Session("cabecera").prop_observacion_Defecto = obs.prop_OBSER

                    'observacion de pie
                    Dim PARAMETRO_pie As New BCb2b.empparam(ConfigurationManager.AppSettings("AMC_OFER_OBS_PIE"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
                    Dim PARAM_OBS_pie As String = PARAMETRO_pie.prop_VALOR
                    'Dim ggOFEobs As New BCb2b.CObs_oferta()
                    Dim ggOFEobs_pie As New BCb2b.CObs_oferta(Me.GRUPO, Me.EMPRESA, Me.TIPVC, Me.TIPOofe, Me.Nofe, PARAM_OBS_pie)
                    Session("cabecera").prop_observacion_pie = ggOFEobs_pie.prop_OBSER

                    Dim lineasOfertaModificar As List(Of BCb2b.COferta_linOff)
                    Dim ofer As New BCb2b.COferta_linOff()
                    lineasOfertaModificar = ofer.lista_lineas_modificar(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), GGOFECAB_GGOFETIP_COD, GGOFECAB_N_OFE)
                    Session("lineasOferta") = lineasOfertaModificar

                    Response.Redirect("crearOferta.aspx")


                ElseIf (e.CommandName = "eliminar") Then
                    '  If MsgBox(GetLocalResourceObject("ElimOferta.Text"), MsgBoxStyle.YesNo, GetLocalResourceObject("TituAtencion.Text")) = MsgBoxResult.Yes Then

                    Dim conexion As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
                    Dim transaccion As IDbTransaction
                    transaccion = conexion.BeginTransaction

                    'AQUI ELIMINAREMOS LA OFERTA
                    Dim msginfo, msgerror As String
                    msgerror = ""
                    msginfo = ""

                    CS_B2B_OFE_PKG.CS_B2B_OFE_PKG.BORRAR_REVISION(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), Me.TIPOofe, Me.Nofe, "S", msginfo, msgerror)
                    transaccion.Commit()
                    conexion.Close()
                    conexion.Dispose()

                    'MOSTRAR DIALOGO OFERTA BORRADA
                    ScriptManager.RegisterStartupScript(Me, Me.GetType(), "BorrarOferta", "ShowDialog('" & GetLocalResourceObject("MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("MsgModalBorrarOfertaOk") & "','ok','OfertasConsulta.aspx',300);", True)


                    'Server.Transfer("OfertasConsulta.aspx")
                    'Response.Redirect("OfertasConsulta.aspx", False)
                    'End If
                Else
                    If (e.CommandName <> "Page") Then

                        Response.Redirect("OfertaDetalle.aspx", False)

                    End If
                End If

            Catch ex As Exception
                lblerror.Text = ex.Message.ToString
            End Try
        End If
    End Sub

    'Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
    '    Dim clientScript As String
    '    Dim windowAttribs As String
    '    windowAttribs = "width=" & width & "px," & _
    '                "height=" & height & "px," & _
    '                "left='+((screen.width -" & width & ") / 2)+'," & _
    '                "top='+ (screen.height - " & height & ") / 2+'"
    '    clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
    '    opener.Attributes.Add("onClick", clientScript)
    'End Sub

    'Public Shared Sub ShowLupaCliente(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal cliControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripCLI As System.Web.UI.WebControls.TextBox)
    '    OpenPopUp(opener, "lov_clientes.aspx?textbox=" & cliControl.ClientID & "&textbox2=" & lblDescripCLI.ClientID, "LOV", 410, 600)
    'End Sub

    Protected Sub GVOfertas_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GVOfertas.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim Pkey As DataKeyArray = GVOfertas.DataKeys
            Dim DetalleGrupo As String = Pkey.Item(e.Row.RowIndex).Item(0)
            Dim DetalleEmpresa As String = Pkey.Item(e.Row.RowIndex).Item(1)
            Dim tipo_ofe As String = Pkey.Item(e.Row.RowIndex).Item(2)
            Dim n_oferta As String = Pkey.Item(e.Row.RowIndex).Item(3) 'NUMOFERTA
            Dim DetalleTIPVC As String = Pkey.Item(e.Row.RowIndex).Item(4)

            Dim conexionole As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
            Dim transaccion_RevModif As IDbTransaction
            transaccion_RevModif = conexionole.BeginTransaction

            Dim RevEsModificable As String = "N"
            Dim elemento As New BCb2b.GGOFECAB()
            Dim cuantos As OracleNumber = elemento.dame_revisiones_oferta_cuantos(DetalleGrupo, DetalleEmpresa, DetalleTIPVC, n_oferta, tipo_ofe, conexion.cadena_conexion)
            RevEsModificable = CS_B2B_OFE_PKG.CS_B2B_OFE_PKG.OFERTA_MODIFICABLE(transaccion_RevModif, DetalleGrupo, DetalleEmpresa, DetalleTIPVC, tipo_ofe, n_oferta, cuantos)
            transaccion_RevModif.Commit()
            conexionole.Close()
            conexionole.Dispose()

            'SOLO SE PUEDEN EDITAR LAS QUE SON DE TIPO OFEW Y QUE SEAN MODIFICABLES
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If (RevEsModificable = "S") And tipo_ofe = ConfigurationManager.AppSettings("serieOferta") Then
                e.Row.Cells(10).CssClass = e.Row.Cells(10).CssClass.Replace("oculto", "") 'CAMPO EDITAR
                e.Row.Cells(11).CssClass = e.Row.Cells(11).CssClass.Replace("oculto", "") 'CAMPO ELIMINAR
            End If
        End If
    End Sub
    Private Function GetColumnIndexByName(ByVal row As GridViewRow, ByVal columnName As String) As Integer
        Dim columnIndex As Integer = 0
        Dim encontrado As Boolean = False
        Dim cell As DataControlFieldCell
        Dim cell2 As New BoundField

        For Each cell In row.Cells
            If TypeOf cell.ContainingField Is BoundField Then
                If CType(cell.ContainingField, BoundField).DataField.Equals(columnName) Then
                    encontrado = True
                    Exit For
                End If
                columnIndex = columnIndex + 1
            End If
        Next
        If encontrado = False Then
            columnIndex = -1
        End If
        Return columnIndex
    End Function

    Private Sub BindPagingGrid()
        GVOfertas.DataSource = GetDataPage(GVOfertas.PageIndex, GVOfertas.PageSize, GVOfertas.OrderBy)
        GVOfertas.DataBind()

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

        If perfiles.prop_TIPO_PERFIL = 2 Then 'cli
            GVOfertas.Columns(10).Visible = False 'editar
            GVOfertas.Columns(11).Visible = False 'eliminar
        End If
    End Sub

    Private Function GetRowCount() As Integer

        Dim elemento As New BCb2b.GGOFECAB()

        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vemp_COD As String = ConfigurationManager.AppSettings("empresa")
        Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
        Dim vggofetip_cod As String = DDLSerie.SelectedValue
        Dim vggcligrupo_cod As String = DDLGrupo.SelectedValue

        Dim vf_inicio As String = tboxFdesde.Text
        Dim vf_fin As String = tboxFHasta.Text

        'Dim vn_ofe As OracleNumber = OracleNumber.Null
        Dim vn_ofe As String = ""
        If (tboxNOferta.Text <> "") Then
            vn_ofe = tboxNOferta.Text
        End If

        'Dim vcodcli As OracleNumber = OracleNumber.Parse(Session("cliente").prop_COD)
        Dim vcodcli As String = ""
        If Not Session("cliente") Is Nothing Then 'CAMBIADO PORQUE SI ES INGENIERO NO HAY CLI.
            vcodcli = Session("cliente").prop_COD
        End If


        Dim vhist_sn As String = "S"
        If (checkboxHistorico.Checked) Then
            vhist_sn = "N"
        End If
        Dim vtodos_sn As String = "N"
        If (checkboxTODOS.Checked) Then
            vtodos_sn = "S"
        End If
        Dim FILTRO_CLIENTE As String = ConfigurationManager.AppSettings("FiltroCliente")
        Dim VAGENTE As String
        If Not Session("AGENTE") Is Nothing Then
            VAGENTE = Session("AGENTE").prop_cod()
            If Session("AGENTE").PROP_COD <> "" Then
                FILTRO_CLIENTE = Session("ver_clientes")
            End If
        Else

            VAGENTE = ""

            'TODO: JCE. ESTO NO TIENE SENTIDO QUE ESTE AQUI. SI EL IF PREGUNTA SI LA SESSION DE AGENTE NO ES NOTHING
            'Y ENTRA POR EL ELSE ESTO VA A PETAR SIEMPRE YA QUE ES NOTHING!.
            'If Session("AGENTE").PROP_COD <> "" Then
            '    FILTRO_CLIENTE = Session("ver_clientes")
            'End If

            'HE COPIADO ESTA LINEA YA QUE ESTA EN EL GETDATAPAGE Y TANTO EL GETROWCOUNT COMO EL GETDATAPAGE DEBEN ESTAR IGUAL..
            FILTRO_CLIENTE = Session("ver_clientes")
        End If
        Dim vsuref As String = tboxSuRef.Text
        Dim vpublicos_sn As String = ConfigurationManager.AppSettings("publico") 'PONIA PUBLICOS
        Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_OFER_VISUALIZAR"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)

        Dim VSERIES_SI As String = hdn_series_oprevs.Value
        If hdn_series_oprevs.Value = "" Then
            VSERIES_SI = PARAMETRO.prop_VALOR
        End If

        Dim VSERIES_NO As String = ""
        Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")

        Dim vgrupo_empr_param As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_CLASI_LISTADO_OFERTAS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
        Dim vgrupo_empr As String = vgrupo_empr_param.prop_VALOR

        Dim gaart_cod As String = txtArticuloCod.Text
        'PUESTO POR JCE PARA PRUEBAS--S
        'If VSERIES_SI = Nothing Then
        'VSERIES_SI = "%"
        'End If
        '-----------------------------

        'Dim total As OracleNumber = elemento.lista_cabeceras_ofertas_cuantos(vEMPGRUPO_COD, vemp_COD, vtip_vc, vggofetip_cod, vn_ofe, vcodcli, vhist_sn, vtodos_sn, Session("cadena_conexion"), vpublicos_sn, vf_inicio, vf_fin, FILTRO_CLIENTE, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum)
        Dim total As Integer = elemento.lista_cabeceras_ofertas_cuantos_int(vEMPGRUPO_COD, vemp_COD, vtip_vc, vggofetip_cod, vn_ofe, vcodcli, vhist_sn, vtodos_sn, Session("cadena_conexion"), vpublicos_sn, vf_inicio, vf_fin, FILTRO_CLIENTE, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref, vggcligrupo_cod, vgrupo_empr, gaart_cod)

        Return total
    End Function


    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList

        Dim elemento As New BCb2b.GGOFECAB()

        Dim vEMPGRUPO_COD As String = ConfigurationManager.AppSettings("grupo")
        Dim vemp_COD As String = Session("empresa").prop_cod 'ConfigurationManager.AppSettings("empresa")
        Dim vtip_vc As String = ConfigurationManager.AppSettings("venta")
        Dim vggofetip_cod As String = DDLSerie.SelectedValue
        Dim vggcligrupo_cod As String = DDLGrupo.SelectedValue

        'Dim vn_ofe As OracleNumber = OracleNumber.Null
        Dim vn_ofe As String = ""
        If (tboxNOferta.Text <> "") Then
            vn_ofe = tboxNOferta.Text
        End If
        'Dim vcodcli As OracleNumber = OracleNumber.Parse(Session("cliente").prop_COD)
        Dim vcodcli As String = ""
        If Not Session("cliente") Is Nothing Then ' CAMBIADO PORQUE SI ES INGENIERO NO HAY CLI
            vcodcli = Session("cliente").prop_COD
        End If

        Dim vhist_sn As String = "S"
        If (checkboxHistorico.Checked) Then
            vhist_sn = "N"
        End If
        Dim vtodos_sn As String = "N"
        If (checkboxTODOS.Checked) Then
            vtodos_sn = "S"
        End If
        Dim vpublicos_sn As String = ConfigurationManager.AppSettings("publicos")
        Dim vpagina_inicio As String = ((GVOfertas.PageIndex) * GVOfertas.PageSize) + 1
        Dim vpagina_fin As String = ((GVOfertas.PageIndex + 1) * GVOfertas.PageSize)
        Dim vordenado_por As String = "F_OFE DESC,N_OFE DESC"
        Dim vidiomas_cod As String = Session("idiomas")
        Dim tipo_observacion_idioma As String = ConfigurationManager.AppSettings("cod_obs_idioma")
        Dim vf_inicio As String = tboxFdesde.Text
        Dim vf_fin As String = tboxFHasta.Text
        Dim filtro_cliente As String = ConfigurationManager.AppSettings("FiltroCliente")

        Dim vsuref As String = tboxSuRef.Text

        Dim lista As ArrayList

        Dim VAGENTE As String
        If Not Session("AGENTE") Is Nothing Then
            VAGENTE = Session("AGENTE").prop_cod()
            If Session("AGENTE").PROP_COD <> "" Then
                filtro_cliente = Session("ver_clientes")
            End If
        Else
            VAGENTE = ""
            filtro_cliente = Session("ver_clientes")
        End If

        Dim vgrupo_empr As String = "GRUPO"

        Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("B2B_OFER_VISUALIZAR"), vEMPGRUPO_COD, vemp_COD, Session("USUARIOB2B").PROP_COD)
        Dim VSERIES_SI As String = hdn_series_oprevs.Value
        If hdn_series_oprevs.Value = "" Then
            VSERIES_SI = PARAMETRO.prop_VALOR
        End If

        Dim VSERIES_NO As String = ""
        Dim vfiltro_docum As String = ConfigurationManager.AppSettings("Filtro_documentos")

        Dim gaart_cod As String = txtArticuloCod.Text

        lista = elemento.lista_cabecera_oferta_paginado_strings(vEMPGRUPO_COD, vemp_COD, vtip_vc, vggofetip_cod, vn_ofe, vcodcli, vhist_sn, vtodos_sn, vpagina_inicio, vpagina_fin, vordenado_por, Session("cadena_conexion"), vpublicos_sn, vidiomas_cod, tipo_observacion_idioma, vf_inicio, vf_fin, filtro_cliente, VAGENTE, VSERIES_SI, VSERIES_NO, vfiltro_docum, vsuref, vggcligrupo_cod, vgrupo_empr, gaart_cod)
        Return lista
    End Function


    ':::: fin nuevo desarrollo
    Private Function conectar(ByVal usuario As String, ByVal password As String, ByVal bd As String) As IDbConnection
        If String.IsNullOrEmpty(bd) Then
            Return Nothing
        End If

        Dim b As New OleDbConnectionStringBuilder
        b.Provider = "MSDAORA.1"
        b("user id") = usuario
        b("password") = password
        b.DataSource = bd

        Dim conexion As IDbConnection = New OleDbConnection(b.ConnectionString)

        Try
            conexion.Open()
        Catch ex As Exception
            conexion.Dispose()
            Return Nothing
        End Try
        Return conexion
    End Function
    Protected Sub BorrarOferta_Click(sender As Object, e As ImageClickEventArgs)
        Dim img As New ImageButton
        img = sender

        Dim TipOfe As String = img.CommandName 'AQUI TRAIGO EL TIPO DE OFERTA
        Dim N_Ofe As String = img.CommandArgument 'AQUI TRAIGO EL NUMERO DE OFERTA

        '   If MsgBox(GetLocalResourceObject("ElimOferta.Text"), MsgBoxStyle.YesNo, GetLocalResourceObject("TituAtencion.Text")) = MsgBoxResult.Yes Then

        Dim conexion As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion As IDbTransaction
        transaccion = conexion.BeginTransaction

        If TipOfe <> "" And N_Ofe <> "" Then
            'AQUI ELIMINAREMOS LA OFERTA
            Dim msginfo, msgerror As String
            msgerror = ""
            msginfo = ""
            Try

                CS_B2B_OFE_PKG.CS_B2B_OFE_PKG.BORRAR_REVISION(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), TipOfe, N_Ofe, "S", msginfo, msgerror)
                transaccion.Commit()
                conexion.Close()
                conexion.Dispose()
                ' Server.Transfer("OfertaDetalle.aspx")
                Response.Redirect("OfertasConsulta.aspx")
            Catch ex As Exception
                ' MsgBox("Error en Borrar Rev: " & ex.Message.ToString & " " & msgerror)
            End Try

            'End If
        End If
    End Sub
    Protected Sub BorrarOfertaSel(ByVal TipOfe As String, ByVal N_Ofe As String)

        'If MsgBox(GetLocalResourceObject("ElimOferta.Text"), MsgBoxStyle.YesNo, GetLocalResourceObject("TituAtencion.Text")) = MsgBoxResult.Yes Then

        '    Dim conexion As IDbConnection = conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        '    Dim transaccion As IDbTransaction
        '    transaccion = conexion.BeginTransaction

        '    If TipOfe <> "" And N_Ofe <> "" Then
        '        'AQUI ELIMINAREMOS LA OFERTA
        '        Dim msginfo, msgerror As String
        '        msgerror = ""
        '        msginfo = ""
        '        Try

        '            CS_B2B_OFE_PKG.CS_B2B_OFE_PKG.BORRAR_OFERTA(transaccion, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), TipOfe, N_Ofe, msginfo, msgerror)
        '            transaccion.Commit()
        '            conexion.Close()
        '            conexion.Dispose()
        '            ' Server.Transfer("OfertaDetalle.aspx")
        '            Response.Redirect("OfertasConsulta.aspx")
        '        Catch ex As Exception
        '            MsgBox("Error en Borrar Rev: " & ex.Message.ToString & " " & msgerror)
        '        End Try

        '    End If
        'End If
    End Sub
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox)
        'OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 400, 450)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID, "LOV", 410, 630)
    End Sub

    Protected Sub txtArticuloCod_TextChanged(sender As Object, e As EventArgs) Handles txtArticuloCod.TextChanged
        If txtArticuloCod.Text <> "" Then
            Dim descrip_aux As String = ""
            Dim vggobstip_cod As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
            Dim idioma As New BCb2b.idiomas()
            idioma.dameIdioma(Session("cultura"))
            Dim articulo_prueba As New BCb2b.CArticulo()
            Try
                articulo_prueba = New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), txtArticuloCod.Text.ToUpper)
                Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, idioma.prop_idioma, ConfigurationManager.AppSettings("ING_SPYRO"))
                If dd <> "" Then
                    If (dd <> "Null") Then
                        descrip_aux = dd
                    Else
                        descrip_aux = articulo_prueba.prop_descrip
                    End If
                Else
                    descrip_aux = articulo_prueba.prop_descrip
                End If

            Catch ex As Exception
                descrip_aux = ""
            End Try
            txtArticulo.Text = descrip_aux
        Else
            txtArticulo.Text = ""
        End If
    End Sub

    Protected Sub ImgBTART_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTART.Click
        txtArticulo.Text = ""
        txtArticuloCod.Text = ""
    End Sub

    Protected Sub ImgBTFDesde_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFDesde.Click
        tboxFdesde.Text = ""
    End Sub

    Protected Sub ImgBTFHasta_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTFHasta.Click
        tboxFHasta.Text = ""
    End Sub
End Class
