﻿Imports System.Data.OracleClient
Imports System.Globalization
Imports System.Data
Imports AMC_Proyectos_pkg.CProyectos


Partial Class clasificaciones
    ' Inherits System.Web.UI.Page
    Inherits claseBase

    Private ggestcampa_cod As String
    Private descrip As String
    Private f_desde As Date
    Private f_hasta As Date
    Private ggestado_cod As String
    Private n_revision As Integer


    Public ReadOnly Property PROP_ggestcampa_cod() As String
        Get
            Return Me.ggestcampa_cod
        End Get
    End Property
    Public ReadOnly Property PROP_descrip() As String
        Get
            Return Me.descrip
        End Get
    End Property
    Public ReadOnly Property PROP_f_desde() As Date
        Get
            Return Me.f_desde
        End Get
    End Property
    Public ReadOnly Property PROP_f_hasta() As String
        Get
            Return Me.f_hasta
        End Get
    End Property
    Public ReadOnly Property PROP_ggestado_cod() As String
        Get
            Return Me.ggestado_cod
        End Get
    End Property

    Public ReadOnly Property PROP_revision() As Integer
        Get
            Return Me.n_revision
        End Get
    End Property

    Private Sub Set_Focus(ByVal caja As String)
        Dim strScript As String
        strScript = "<script language=javascript> document.all('" & caja & "').focus() </script>"
        RegisterStartupScript("focus", strScript)
    End Sub

    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub

    Public Shared Sub ShowLupaClasificacion(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal dateControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_clasificaciones.aspx?textbox=" & dateControl.ClientID, "LOV", 400, 450)
    End Sub

    Public Shared Sub ShowLupaTipoClasificacion(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal dateControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_tipoclasificaciones.aspx?textbox=" & dateControl.ClientID, "LOV", 400, 450)
    End Sub
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '  Set_Focus("ImgClasisOK")

        ' imgAyuda.Visible = True

        If Session("editarNOeditar") = False Then
            GVClasificaciones.Enabled = False
        Else
            GVClasificaciones.Enabled = True
        End If

        If Not Page.IsPostBack Then

            Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
            miProyecto = Session("proyecto")

            Dim lista_clasificaciones As ArrayList
            lista_clasificaciones = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi(miProyecto.prop_cod, Session("idioma_spyro"))
            Dim lista_clasif_obligatorias As ArrayList
            lista_clasif_obligatorias = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi_obligatorias(miProyecto.prop_cod, Session("idioma_spyro"))
            If lista_clasif_obligatorias.Count > 0 Then
                LB_Obligatorias.DataSource = lista_clasif_obligatorias
                LB_Obligatorias.DataBind()
                LB_Obligatorias.Visible = True
                lblAviso.Visible = True
            End If
            '  GVClasificaciones.DataSource = lista_clasificaciones
            GVClasificaciones.DataSource = lista_clasificaciones
            GVClasificaciones.DataBind()
            'Dim i As Integer = 0
            'For i = 0 To GVClasificaciones.Rows.Count - 1
            '    If GVClasificaciones.Rows.Count > 1 And i < GVClasificaciones.Rows.Count - 1 Then
            '        If CType(GVClasificaciones.Rows(i).FindControl("ddlggclatipCod"), DropDownList).SelectedValue = "" Then
            '            GVClasificaciones.Rows(i + 1).Enabled = False
            '            GVClasificaciones.Rows(i + 1).BackColor = System.Drawing.ColorTranslator.FromHtml("#BDBDBD")

            '            GVClasificaciones.Rows(i + 1).ToolTip = CType(GetLocalResourceObject("Ayuda_Clasi1.Text"), String)
            '            'GVClasificaciones.Rows(i + 1).ToolTip = "Para poder editar esta clasificación debe dar valor a la clasificación superior a ésta."
            '        Else
            '            GVClasificaciones.Rows(i + 1).Enabled = True
            '            GVClasificaciones.Rows(i + 1).BackColor = Nothing
            '        End If
            '    End If
            'Next i

            'imgAyuda.ToolTip = "Las filas con fondo de color gris estan bloqueadas." & vbNewLine & "Para desbloquearlas hay que dar valor a la fila superior de la bloqueada siguiendo un orden."
            'imgAyuda.ToolTip = CType(GetLocalResourceObject("Ayuda_Clasi2.Text"), String) & vbNewLine & CType(GetLocalResourceObject("Ayuda_Clasi3.Text"), String)


            Session("GGCLATIP") = ""
            Session("CodSel") = ""
        End If
        ComprobarSiClasisConValor()
        'esta linea es para mostrar el boton de nueva revision o no. solo se tiene que ver en calculos.
        Session("PaginaActual") = "clasificaciones"

    End Sub


    Public Function getValores(ByVal tipVc As String, ByVal ggclatipCod As String) As ArrayList

        Dim clasif As New BCb2b.CGGCLASIF()
        Dim resultado As New ArrayList

        Dim CLASIFdEFECTO As New BCb2b.CGGCLASIF("V", "", "", ConfigurationManager.AppSettings("seleccione"), "", "", "", "", "")
        resultado.Add(CLASIFdEFECTO)

        resultado.AddRange(clasif.listado_clasificaciones_campanas(tipVc, ggclatipCod, Session("proyecto").prop_cod))

        Return resultado

    End Function


    Public Function dimeSiVisible(clatipPad As String, clasifPad As String, clasifActual As String, valorActual As String) As Boolean

        'metodo que controlará en que casos se visualizará el panel de añadir valores a clasificacion de clientes para ggestcampa.

        Dim valor As Boolean = False
        If (clatipPad = ConfigurationManager.AppSettings("MARCAMOTOR") And _
            clasifPad = ConfigurationManager.AppSettings("VALORMARCAMOTOR") And _
            clasifActual = ConfigurationManager.AppSettings("MODELMOTOR") And _
            valorActual = "") Then

            valor = True
        End If
        Return valor

    End Function

    Protected Sub GVClasificaciones_RowDataBound(sender As Object, e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GVClasificaciones.RowDataBound

        If e.Row.RowType = DataControlRowType.DataRow Then

            Dim ddlggclatipCod As DropDownList = e.Row.FindControl("ddlggclatipCod")
            Dim HFClatip As HiddenField = e.Row.FindControl("HFClatip")
            Dim ImgAlerta As Image = e.Row.FindControl("ImgAlerta")
            Dim tipVc As String = "V"
            Dim ggclatipCod As String = DataBinder.Eval(e.Row.DataItem, "prop_clatip_cod")
            HFClatip.Value = ggclatipCod
            ddlggclatipCod.DataSource = getValores(tipVc, ggclatipCod)
            ddlggclatipCod.DataTextField = "prop_DESCRIP"
            ddlggclatipCod.DataValueField = "prop_COD"
            'NOTA: AQUI QUIERO RECUPERAR EL PANEL DEL TEXBOX DE EDITAR'
            'PRIMERO PARA PONERLE VISIBLE O NO 
            'Y LUEGO PARA PONERLE LA ACCION GUARDAR AL DOCUMENTO.
            Dim valorDefecto As String = AMC_Proyectos_pkg.CProyectos.dame_ggclasifCod_ggcampaclasi(Session("proyecto").prop_cod, Session("idioma_spyro"), ggclatipCod)
            If (valorDefecto <> "") Then
                ddlggclatipCod.SelectedValue = valorDefecto
                ImgAlerta.Visible = False
            Else
                ' ddlggclatipCod.SelectedValue = " "
                ImgAlerta.Visible = True
                'e.Row.BackColor = System.Drawing.ColorTranslator.FromHtml("#BDBDBD")
                e.Row.CssClass = "warning_clasi"
                e.Row.ToolTip = CType(GetLocalResourceObject("Ayuda_Clasi1.Text"), String)
                SetFocus(ddlggclatipCod) 'Si no hay ponemos el foco para que sepan a donde tienen que ir.
            End If
            'aqui controlamos el panel para introducir nuevos valores para la clasificacion.
          
            Dim panNuevoVAl As Panel = e.Row.FindControl("panNuevoVAl")
            If e.Row.RowIndex > 0 Then
                Dim prewRow As GridViewRow = Me.GVClasificaciones.Rows(e.Row.RowIndex - 1)
                Dim ddlggclatipCodPrev As DropDownList = prewRow.FindControl("ddlggclatipCod")
                Dim HFClatipPrev As HiddenField = prewRow.FindControl("HFClatip")
                Dim clasificacionPadre As String = ""
                Dim valorClasiPadre As String = ""

                clasificacionPadre = HFClatipPrev.Value
                valorClasiPadre = ddlggclatipCodPrev.SelectedValue

                Dim clasifActual As String = ggclatipCod

                panNuevoVAl.Visible = dimeSiVisible(clasificacionPadre, valorClasiPadre, clasifActual, valorDefecto)
            Else
                panNuevoVAl.Visible = false
            End If
            'fin panel

            ddlggclatipCod.DataBind()
        End If
    End Sub
  




    Protected Sub Editar(ByVal sender As Object, ByVal e As GridViewEditEventArgs) Handles GVClasificaciones.RowEditing

        btnInsertarClasif.Visible = False

        Dim fila As GridViewRow
        fila = GVClasificaciones.Rows(e.NewEditIndex)
        'Para poner el Grid View en modo de edición.
        'GVDocumentos1.EditIndex = e.NewEditIndex
        Dim ggclatip_cod = GVClasificaciones.DataKeys(fila.RowIndex)(0)

        'Dim ggclatip As String = fila.Cells(1).Text
        Dim clatip_descrip = fila.Cells(2).Text

        Dim valor = Replace(fila.Cells(3).Text, "&nbsp;", "")

        Dim GGCLASIF_COD As String = "" 'JVC: RECUPERAR EL CÓDIGO DE ALGUNA MANERAA.

        Dim codlibre_sn As String
        Dim Cggclatip = New BCb2b.CGGCLATIP(ConfigurationManager.AppSettings("Venta"), ggclatip_cod)
        codlibre_sn = Cggclatip.prop_CODLIBRE_SN

        Dim l_linea_aux As New ArrayList
        Dim linea_aux As New AMC_Proyectos_pkg.CProyectos.Ggcampaclasi(Session("proyecto").prop_cod, ConfigurationManager.AppSettings("Venta"), _
                                                                       ggclatip_cod, GGCLASIF_COD, clatip_descrip, valor, "", "", Session("idioma_spyro"))

        l_linea_aux.Add(linea_aux)

        'bindeo el formview
        FormView1.ChangeMode(FormViewMode.Edit)
        FormView1.DataSource = l_linea_aux
        FormView1.DataBind()
        FormView1.Visible = True
        FormView1.Enabled = True

    End Sub



    Protected Sub formview1_prerender(ByVal sender As Object, ByVal e As System.EventArgs) Handles FormView1.PreRender

        If FormView1.CurrentMode = FormViewMode.Edit Then
            Dim IBclasificacion As New System.Web.UI.WebControls.Image
            IBclasificacion = CType(FormView1.FindControl("IBclasificacion"), System.Web.UI.WebControls.Image)

            Dim txtggclatip_cod As New System.Web.UI.WebControls.TextBox
            txtggclatip_cod = CType(FormView1.FindControl("txtggclatip_cod"), System.Web.UI.WebControls.TextBox)
            txtggclatip_cod.Text = txtggclatip_cod.Text

            Dim txtvalor_E As New System.Web.UI.WebControls.TextBox
            txtvalor_E = CType(FormView1.FindControl("txtvalor_E"), System.Web.UI.WebControls.TextBox)

            Session("GGCLATIP") = txtggclatip_cod.Text
            ShowLupaClasificacion(IBclasificacion, txtvalor_E)
        End If

        If FormView1.CurrentMode = FormViewMode.Insert Then

            Dim IBtipoclasificacion As New System.Web.UI.WebControls.Image
            IBtipoclasificacion = CType(FormView1.FindControl("IBtipoclasificacion"), System.Web.UI.WebControls.Image)

            Dim IBclasificacion As New System.Web.UI.WebControls.Image
            IBclasificacion = CType(FormView1.FindControl("IBclasificacion"), System.Web.UI.WebControls.Image)

            Dim txtggclatip_descrip As New System.Web.UI.WebControls.TextBox
            txtggclatip_descrip = CType(FormView1.FindControl("txtggclatip_descrip_I"), System.Web.UI.WebControls.TextBox)
            txtggclatip_descrip.Text = txtggclatip_descrip.Text

            Dim txtvalor_I As New System.Web.UI.WebControls.TextBox
            txtvalor_I = CType(FormView1.FindControl("txtvalor_I"), System.Web.UI.WebControls.TextBox)

            ShowLupaTipoClasificacion(IBtipoclasificacion, txtggclatip_descrip)
            ShowLupaClasificacion(IBclasificacion, txtvalor_I)
        End If

    End Sub

    Protected Sub btnInsertarClasif_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles btnInsertarClasif.Click
        FormView1.ChangeMode(FormViewMode.Insert)
        FormView1.Visible = True
        FormView1.Enabled = True
        btnInsertarClasif.Visible = True
    End Sub


    Private Function ComprobarSiClasisConValor() As Boolean
        Dim i As Integer = 0
        Dim saber As Boolean = False
        For i = 0 To GVClasificaciones.Rows.Count - 1
            If CType(GVClasificaciones.Rows(i).FindControl("ddlggclatipCod"), DropDownList).SelectedValue = "" Then
                Session("ClasisObliConValor") = False
                saber = True
                ' imgAyuda.Visible = True
                'ImgClasisOK.Visible = False
                lblClasisOK.Visible = False
            End If
        Next i
        If saber = False Then
            Session("ClasisObliConValor") = True
            'imgAyuda.Visible = False

            'ImgClasisOK.Visible = True
            lblClasisOK.Visible = True

        End If

        'esto es para que no se mueva el foco arriba todo el rato al cambiar una clasi.
        Lblerror.Focus()
        Return False
    End Function

    Private Function AsignarClasis() As String


        Dim i As Integer = 0
        For i = 0 To GVClasificaciones.Rows.Count - 1
            If GVClasificaciones.Rows.Count > 1 And i < GVClasificaciones.Rows.Count - 1 Then
                If CType(GVClasificaciones.Rows(i).FindControl("ddlggclatipCod"), DropDownList).SelectedValue = "" Then
                    GVClasificaciones.Rows(i + 1).Enabled = False
                    GVClasificaciones.Rows(i + 1).BackColor = System.Drawing.ColorTranslator.FromHtml("#BDBDBD")
                    GVClasificaciones.Rows(i + 1).ToolTip = CType(GetLocalResourceObject("Ayuda_Clasi1.Text"), String)
                Else
                    GVClasificaciones.Rows(i + 1).Enabled = True
                    GVClasificaciones.Rows(i + 1).BackColor = Nothing
                End If
            End If
        Next i
        Return ""

    End Function
    Protected Sub imgAyuda_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs)

    End Sub

    Protected Sub btnCancelar_E_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        btnInsertarClasif.Visible = True
        FormView1.ChangeMode(FormViewMode.ReadOnly)
        FormView1.Visible = False
        FormView1.Enabled = False
    End Sub

    Protected Sub btnActualizar_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        'Aquí actualizamos el registro.
        Dim txtggclatip_cod As New System.Web.UI.WebControls.TextBox
        txtggclatip_cod = CType(FormView1.FindControl("txtggclatip_cod"), System.Web.UI.WebControls.TextBox)
        txtggclatip_cod.Text = txtggclatip_cod.Text

        Dim txtvalor_E As New System.Web.UI.WebControls.TextBox
        txtvalor_E = CType(FormView1.FindControl("txtvalor_E"), System.Web.UI.WebControls.TextBox)
        txtvalor_E.Text = txtvalor_E.Text

        Dim codlibre_sn As String
        Dim Cggclatip = New BCb2b.CGGCLATIP(ConfigurationManager.AppSettings("Venta"), txtggclatip_cod.Text)
        codlibre_sn = Cggclatip.prop_CODLIBRE_SN

        Dim p_valor As String
        Dim p_ggclasif_cod As String

        If codlibre_sn = "N" Then
            p_valor = Nothing
            If Session("CodSel") <> Nothing Then
                p_ggclasif_cod = Session("CodSel")
            Else
                p_ggclasif_cod = txtvalor_E.Text
            End If
            Session("GGCLASIF_PAD") = p_ggclasif_cod
        Else
            p_valor = txtvalor_E.Text
            p_ggclasif_cod = Nothing
        End If

        AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(Session("proyecto").prop_cod, "PRY", txtggclatip_cod.Text, "*", p_ggclasif_cod, _
                                                        "*", p_valor, ConfigurationManager.AppSettings("Venta"))

        AMC_Proyectos_pkg.CProyectos.crea_ggclasif_obligatorias(Session("proyecto").prop_cod, "PRY", Nothing, "S")

        FormView1.Dispose()
        FormView1.Visible = False

        Dim lista_clasificaciones As ArrayList
        lista_clasificaciones = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi(Session("proyecto").prop_cod, Session("idioma_spyro"))

        GVClasificaciones.DataSource = lista_clasificaciones
        GVClasificaciones.DataBind()

        Dim i As Integer = 0
        For i = 0 To GVClasificaciones.Rows.Count - 1
            If GVClasificaciones.Rows.Count > 1 And i < GVClasificaciones.Rows.Count - 1 Then
                If CType(GVClasificaciones.Rows(i).FindControl("ddlggclatipCod"), DropDownList).SelectedValue = "" Then
                    GVClasificaciones.Rows(i + 1).Enabled = False
                    GVClasificaciones.Rows(i + 1).BackColor = System.Drawing.ColorTranslator.FromHtml("#BDBDBD")
                    GVClasificaciones.Rows(i + 1).ToolTip = CType(GetLocalResourceObject("Ayuda_Clasi1.Text"), String)
                Else
                    GVClasificaciones.Rows(i + 1).Enabled = True
                    GVClasificaciones.Rows(i + 1).BackColor = Nothing
                End If
            End If
        Next i



        ComprobarSiClasisConValor()
        btnInsertarClasif.Visible = True
    End Sub

    Protected Sub btnAceptar_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        'Aquí actualizamos el registro.
        'Dim txtggclatip_cod As New System.Web.UI.WebControls.TextBox
        'txtggclatip_cod = CType(FormView1.FindControl("txtggclatip_cod"), System.Web.UI.WebControls.TextBox)
        'txtggclatip_cod.Text = txtggclatip_cod.Text

        Dim txtvalor_I As New System.Web.UI.WebControls.TextBox
        txtvalor_I = CType(FormView1.FindControl("txtvalor_I"), System.Web.UI.WebControls.TextBox)
        txtvalor_I.Text = txtvalor_I.Text

        Dim codlibre_sn As String
        Dim Cggclatip = New BCb2b.CGGCLATIP(ConfigurationManager.AppSettings("Venta"), Session("GGCLATIP"))
        codlibre_sn = Cggclatip.prop_CODLIBRE_SN

        Dim p_valor As String
        Dim p_ggclasif_cod As String

        If codlibre_sn = "N" Then
            p_valor = Nothing
            If Session("CodSel") <> Nothing Then
                p_ggclasif_cod = Session("CodSel")
            Else
                p_ggclasif_cod = txtvalor_I.Text
            End If
        Else
            p_valor = txtvalor_I.Text
            p_ggclasif_cod = Nothing
        End If

        AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(Session("proyecto").prop_cod, "PRY", Session("GGCLATIP"), "*", p_ggclasif_cod, _
                                                        "*", p_valor, ConfigurationManager.AppSettings("Venta"))

        FormView1.Dispose()
        FormView1.Visible = False

        Dim lista_clasificaciones As ArrayList
        lista_clasificaciones = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi(Session("proyecto").prop_cod, Session("idioma_spyro"))


        Session("GGCLATIP") = ""
        Session("CodSel") = ""

        GVClasificaciones.DataSource = lista_clasificaciones
        GVClasificaciones.DataBind()
    End Sub




    Protected Sub btnCancelar_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        btnInsertarClasif.Visible = True
        FormView1.ChangeMode(FormViewMode.ReadOnly)
        FormView1.Visible = False
        FormView1.Enabled = False
    End Sub





    'Protected Sub guardarValorClasix(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim btn As Button = DirectCast(sender, Button)
    '    Dim row As GridViewRow = TryCast(btn.NamingContainer, GridViewRow)
    '    If row IsNot Nothing Then

    '        Dim ggclatip = row.Cells(1).Text
    '        ggclatip = CType(row.FindControl("HFClatip"), HiddenField).Value
    '        Dim ggclasif = CType(row.FindControl("ddlggclatipCod"), DropDownList).SelectedValue
    '        Dim valor = CType(row.FindControl("ddlggclatipCod"), DropDownList).SelectedItem.Text

    '        Dim clasificacionModelo As New BCb2b.CGGCLASIF("V", "MODELMOTOR", "prujvcC", "prujvcD", Nothing, "V", "MARCAMOTOR", "01", "N")
    '        clasificacionModelo.ggclasif_insertar()

    '    End If


    'End Sub

    Protected Sub prueba(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim ddl As DropDownList = DirectCast(sender, DropDownList)
        Dim row As GridViewRow = TryCast(ddl.NamingContainer, GridViewRow)

        If row IsNot Nothing Then



            Dim ggclatip = row.Cells(1).Text
            ggclatip = CType(row.FindControl("HFClatip"), HiddenField).Value
            Dim ggclasif = CType(row.FindControl("ddlggclatipCod"), DropDownList).SelectedValue
            Dim valor = CType(row.FindControl("ddlggclatipCod"), DropDownList).SelectedItem.Text


            If valor = ConfigurationManager.AppSettings("seleccione") Then
                valor = ""
            End If
            AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(Session("proyecto").prop_cod, "PRY", ggclatip, "*", ggclasif, "*", valor, ConfigurationManager.AppSettings("Venta"))


            AMC_Proyectos_pkg.CProyectos.crea_ggclasif_obligatorias(Session("proyecto").prop_cod, "PRY", Nothing, "S")


            Dim lista_clasificaciones As ArrayList
            lista_clasificaciones = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi(Session("proyecto").prop_cod, Session("idioma_spyro"))

            GVClasificaciones.DataSource = lista_clasificaciones
            GVClasificaciones.DataBind()


            ComprobarSiClasisConValor()


        End If
    End Sub


    Protected Sub guardarValorClasi(ByVal sender As System.Object, ByVal e As System.EventArgs)


        Dim btn As Button = DirectCast(sender, Button)
        Dim row As GridViewRow = TryCast(btn.NamingContainer, GridViewRow)

        If row IsNot Nothing Then
            Dim ggclatipcod = row.Cells(1).Text
            ggclatipcod = CType(row.FindControl("HFClatip"), HiddenField).Value
            Dim valor As TextBox = CType(row.FindControl("tboxValorNuevo"), TextBox)

            Dim tipVc As String = "V"
            Dim sigCodigo As New BCb2b.CGGCLASIF()

            'JVC. AQUI HABRÍA QUE CONGER EL VALOR SELECCIONADO EN EL COMBO DE LA LÍNEA SUPERIOR. COMO POR AHORA SIEMPRE VA A SER PARA EL MISMO LO DEJO ASÍ.
            'SI HUBIERA QUE HACER PARA VARIOS HABRÍA QUE HACER ESE CÁLCULO.
            Dim clasifPadre As String = ConfigurationManager.AppSettings("VALORMARCAMOTOR")

            Dim ggclasifCod As String = sigCodigo.siguienteCodigo(tipVc, ggclatipcod, clasifPadre)
            Dim valorClasif As String = valor.Text
            Dim defectoSN As String = "N"

            InsertarValorEnClasif(tipVc, ggclatipcod, ggclasifCod, valorClasif, defectoSN, clasifPadre)

            AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(Session("proyecto").prop_cod, "PRY", ggclatipcod, "*", ggclasifCod, "*", valorClasif, ConfigurationManager.AppSettings("Venta"))
            AMC_Proyectos_pkg.CProyectos.crea_ggclasif_obligatorias(Session("proyecto").prop_cod, "PRY", Nothing, "S")

            Dim lista_clasificaciones As ArrayList
            lista_clasificaciones = AMC_Proyectos_pkg.CProyectos.dame_ggcampaclasi(Session("proyecto").prop_cod, Session("idioma_spyro"))

            GVClasificaciones.DataSource = lista_clasificaciones
            GVClasificaciones.DataBind()

            ComprobarSiClasisConValor()
        End If
    End Sub

    Public Sub InsertarValorEnClasif(tipVc As String, ggclatipCod As String, ggclasifCod As String, valor As String, defectoSN As String, valorClasifPadre As String)

        Dim clasificacionModelo As New BCb2b.CGGCLASIF()
        clasificacionModelo.ggclasif_insertar(tipVc, ggclatipCod, ggclasifCod, valor, Nothing, "N")

    End Sub

End Class


