﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Security.Principal
Imports System.Net
Imports System.Diagnostics

Partial Class IntegracionViejos
    Inherits System.Web.UI.Page



    Public Function clasificacionesDefecto(codProy As String, vggclatipCod As String, Vggclasif_cod As String, valor As String) As String

        Dim vlog As String = ""
        Try

            Dim Cggclatip = New BCb2b.CGGCLATIP("V", vggclatipCod)

            AMC_Proyectos_pkg.CProyectos.actualiza_ggclasif(codProy, "PRY", vggclatipCod, "*", Vggclasif_cod, "*", valor, "V")
            vlog = "Actualizada clasificacion (" & vggclatipCod & "," & Vggclasif_cod & "," & valor & " ) <br>"
            Return vlog

        Catch ex As Exception
            Return "Error Actualizando clasificacion  (" & vggclatipCod & "," & Vggclasif_cod & "," & valor & " ) <br>" & ex.Message.ToString
        End Try


    End Function




    Public Function crearProy(vcliente_COD As OracleNumber, vtxtComentario As String) As String

        Dim grupo, empresa, tip_vc, descProyecto As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")
        tip_vc = ConfigurationManager.AppSettings("Venta")



        descProyecto = vtxtComentario
        If descProyecto = "" Or Nothing Then
            descProyecto = "Proyecto Integrado "
        End If

        Dim cod_proy As String

        Dim proyect As New AMC_Proyectos_pkg.CProyectos()
        'EN AMC EL TIPO DE PROYECTO "TIPO_PROY" ES "PRY_FIJO"
        proyect = proyect.ggestcampa_crear_nuevo(grupo, empresa, tip_vc, ConfigurationManager.AppSettings("TipoProyCreacion"), "1", vcliente_COD, "", descProyecto, vtxtComentario, ConfigurationManager.AppSettings("USUARIO_WEB"))
        cod_proy = proyect.prop_cod

        Return cod_proy

    End Function


    Public Function actualizarCentros(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE ACENTROS SET IDESTUDIO=:P1 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarCentros" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return verror
    End Function



    Public Function datosDistribucion(ByVal idEstudioViejo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " select * from adistribucion  "
        sql2 = sql2 & " WHERE IDESTUDIO = :P1 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        Dim rdr2 As OracleDataReader
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioViejo)

        Dim observaciones As String = ""


        Try
            conn2.Open()
            rdr2 = cmd2.ExecuteReader()
            If rdr2.Read = True Then
                If (Not rdr2.GetOracleString(rdr2.GetOrdinal("observaciones")).IsNull) Then
                    observaciones = rdr2.GetOracleString(rdr2.GetOrdinal("observaciones"))
                End If
            End If
            Return observaciones
        Catch ex As Exception
            vError = "Error datosDistribucion" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function

    Public Function actualizarDistribucion(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String



        Dim observaciones As String = datosDistribucion(idEstudioViejo)
        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE adistribucion SET IDESTUDIO=:P1, observaciones = :p3 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)
        cmd2.Parameters.AddWithValue("P3", observaciones & Chr(10) & " [Imported]" & idEstudioViejo.ToString)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarDistribucion" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function


    Public Function actualizarEstudios(ByVal idEstudioViejo As OracleNumber, ByVal idEstudioNuevo As OracleNumber) As String


        Dim vError As String = ""
        Dim conn2 As New OracleConnection()
        Dim conexion2 As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command2 As New OracleDataAdapter()
        Dim sql2 As String

        sql2 = " UPDATE aestudios SET IDESTUDIO=:P1 "
        sql2 = sql2 & " WHERE IDESTUDIO = :P2 "


        conn2.ConnectionString = conexion2.cadena_conexion
        Dim cmd2 As New OracleCommand(sql2, conn2)
        'Dim rdr As OracleDataReader

        cmd2.Parameters.AddWithValue("P1", idEstudioNuevo)
        cmd2.Parameters.AddWithValue("P2", idEstudioViejo)

        Try
            conn2.Open()
            cmd2.ExecuteNonQuery()
        Catch ex As Exception
            vError = "Error actualizarEstudios" & " " & ex.Message
        Finally
            conn2.Close()
        End Try

        Return vError
    End Function
    Public Function insertar_MarcaExportado(ByVal cod_proyecto As String, ByVal texto As String, ByVal tipoObs As String) As String
        Dim conn As New OracleConnection()
        Dim sql As String = ""
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()

        Dim Lista_apoyos As New ArrayList

        conn.ConnectionString = conexion.cadena_conexion
        sql = " INSERT INTO ggcampaobs(GGESTCAMPA_COD,TIP_VC,GGOBSTIP_COD,OBSER) "
        sql = sql & " VALUES (:P1,'V', :P2, :P3) "

        Dim cmd As New OracleCommand(sql, conn)
        cmd.Parameters.AddWithValue("P1", cod_proyecto)
        cmd.Parameters.AddWithValue("P2", tipoObs)
        cmd.Parameters.AddWithValue("P3", texto)
        Dim vlog As String = ""
        vlog = " [insertar_MarcaExportado] ( " & cod_proyecto & "," & tipoObs & "," & texto & " )"
        Try
            conn.Open()
            cmd.ExecuteNonQuery()
            Return vlog

        Catch ex As Exception
            'Throw New Exception("[insertar_MarcaExportado] " & ex.Message.ToString)
            Return "[insertar_MarcaExportado] " & ex.Message.ToString
        Finally
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If
            cmd.Dispose()
            conn.Dispose()

        End Try
    End Function
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        Dim command As New OracleDataAdapter()
        Dim sql As String

        Dim vIDESTUDIO As OracleNumber
        Dim vIDCLIENTE As OracleNumber
        Dim vOBSERVACIONES As String
        Dim vIDAUTOR As OracleNumber

        'Fin variables para estudios.
        'variables para proyecto
        Dim vcodProy As String

        sql = "	SELECT * from aestudios WHERE IDESTUDIO >2307 AND IDESTUDIO <2307 "
        sql = sql & " and idcliente not in 55874 "


        'Migrar los que se han integrado mal del cliente elcos.
        sql = "      select idestudio,idestudioviejo,( select IDESTUDIO from  Aestudios_120410 where idestudio = idestudioviejo) as vIDESTUDIO, "
        sql = sql & " ( select IDCLIENTE from  Aestudios_120410 where idestudio = idestudioviejo) as IDCLIENTE, "
        sql = sql & " ( select OBSERVACIONES from  Aestudios_120410 where idestudio = idestudioviejo) as OBSERVACIONES, "
        sql = sql & " ( select IDAUTOR from  Aestudios_120410 where idestudio = idestudioviejo) as IDAUTOR from ( "
        sql = sql & " select iddistribucion,idestudio,replace(SUBSTR(observaciones,instr ( observaciones,'[Imported]'  )),'[Imported]','')  as idestudioviejo "
        sql = sql & " from adistribucion where idestudio in ( "
        sql = sql & " SELECT ggestcampa_cod as cod FROM GGCAMPAOBS WHERE GGOBSTIP_COD='INTE' AND ggestcampa_cod like '12%' and GGESTCAMPA_COD IN "
        sql = sql & " (   SELECT COD FROM GGESTCAMPA   "
        sql = sql & " WHERE COD IN (SELECT GGESTCAMPA_COD FROM GGCAMPACLI   "
        sql = sql & " WHERE EMPGRUPO_COD = 'AMC'  "
        sql = sql & " AND EMP_COD = '0001' and ggclipr_cod in (55724) "
        sql = sql & " and ggestcampa_cod = '1205572406' "
        sql = sql & " ) "
        sql = sql & " ) "
        sql = sql & " )"
        sql = sql & " and observaciones like '%Imported%' "
        sql = sql & " ) a "
        sql = sql & " where rownum <= 90 "



        'sql = "	SELECT * from aestudios WHERE IDESTUDIO =256 "

        conn.ConnectionString = conexion.cadena_conexion
        Dim cmd As New OracleCommand(sql, conn)
        Dim rdr2 As OracleDataReader

        Dim vlog As String = "  "

        Try
            conn.Open()
            rdr2 = cmd.ExecuteReader()
            Do While rdr2.Read = True

                If (Not rdr2.GetOracleNumber(rdr2.GetOrdinal("IDESTUDIO")).IsNull) Then
                    vIDESTUDIO = rdr2.GetOracleNumber(rdr2.GetOrdinal("IDESTUDIO"))
                    vIDCLIENTE = rdr2.GetOracleNumber(rdr2.GetOrdinal("IDCLIENTE"))
                    vOBSERVACIONES = rdr2.GetOracleString(rdr2.GetOrdinal("OBSERVACIONES")).ToString.Trim
                    vIDAUTOR = rdr2.GetOracleNumber(rdr2.GetOrdinal("IDAUTOR"))
                    vlog = vlog & " ID Estudio a tratar::: (" & vIDESTUDIO.ToString & "," & vIDCLIENTE.ToString & "," & vOBSERVACIONES & ") <br>"



                    'Creamos el nuevo proyectos correspondiente a estudio.
                    vcodProy = crearProy(vIDCLIENTE, vOBSERVACIONES)
                    vlog = vlog & " Proyecto creado::: (" & vcodProy & ") <br>"
                    'metemos las clasificaciones por defecto.
                    Dim vggclatipCod As String = ""
                    Dim Vggclasif_cod As String = ""
                    Dim valor As String = ""
                    vggclatipCod = "COMBUSTIBL"
                    Vggclasif_cod = "9"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    vggclatipCod = "MARCAMOTOR"
                    Vggclasif_cod = "99"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    vggclatipCod = "MODELMOTOR"
                    Vggclasif_cod = "99001"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    vggclatipCod = "MODMAQUINA"
                    Vggclasif_cod = "99990001"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    vggclatipCod = "NUM_CILIND"
                    Vggclasif_cod = "00"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    vggclatipCod = "TIPMAQUINA"
                    Vggclasif_cod = "9999"
                    vlog = vlog & clasificacionesDefecto(vcodProy, vggclatipCod, Vggclasif_cod, valor)
                    'Lo marcamos con integrado desde el b2b.
                    vlog = vlog & insertar_MarcaExportado(vcodProy, "Integrado::" & vIDESTUDIO.ToString, "INTE")

                    Dim vlogAux = ""


                    'Modificamos tanto centros como distribución y estudios (así esa tabla nos queda de referencia).
                    vlogAux = actualizarCentros(vIDESTUDIO, vcodProy)
                    vlog = vlog & "actualizarCentros::: (" & vIDESTUDIO.ToString & "," & vcodProy & ") " & vlogAux & "   <br>"
                    vlogAux = actualizarDistribucion(vIDESTUDIO, vcodProy)
                    vlog = vlog & " actualizarDistribucion::: (" & vIDESTUDIO.ToString & "," & vcodProy & ") " & vlogAux & " <br>"
                    vlogAux = actualizarEstudios(vIDESTUDIO, vcodProy)
                    vlog = vlog & " actualizarEstudios::: (" & vIDESTUDIO.ToString & "," & vcodProy & ") " & vlogAux & " <br>"


                    'Borramos Aestudio???? (NO por ahora)

                End If
            Loop

            Label1.Text = vlog

        Catch ex As Exception
            'Throw New Exception("Error al integrar::: " & ex.Message.ToString)
            Label1.Text = vlog & "<BR>" & ex.Message.ToString
        Finally
            If conn.State = ConnectionState.Open Then
                conn.Close()
            End If
            cmd.Dispose()
            conn.Dispose()
        End Try


    End Sub




   

End Class
