Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Partial Class LOV_clasificaciones
    ' Inherits System.Web.UI.Page
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String


    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then
            'Dim el_Agente As String = ""
            Try
                control.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                control.Value = ""
            End Try
            Try
                control1.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                control1.Value = ""
            End Try
            Try
                control2.Value = Request.QueryString("textbox3").ToString()
            Catch ex As Exception
                control2.Value = ""
            End Try
            'Try
            '    el_Agente = Request.QueryString("agen").ToString()
            'Catch ex As Exception
            '    el_Agente = ""
            'End Try

            'filtro
            Try
                TextBox1.Text = Request.QueryString("fil").ToString()
            Catch ex As Exception
                TextBox1.Text = ""
            End Try


            'sql = calcula_Sql(control1.Value)
            sql = calcula_Sql()
            Me.SetFocus(Me.TextBox1)


            conn.ConnectionString = conexion.cadena_conexion
            sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
            Dim respuesta As String
            Dim lista As New ArrayList
            lista.Clear()
            Try
                Dim valores As New BCb2b_AMC.CCargarLov()
                lista = valores.lista_lov_amc_carga_radio(sql)
            Catch escep As Exception
                respuesta = escep.Message()
            Finally
                DGBusqueda.DataSource = lista
                DGBusqueda.DataBind()
            End Try


        End If
    End Sub

    Public Function calcula_Sql() As String


        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("Grupo")
        Dim vClasiRigidez As String = ConfigurationManager.AppSettings("KZ")
        Dim vGgobstipCod As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        Dim vIdioma As String = Session("idioma_spyro")
        Dim vCargaMax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")

        sql = " SELECT * FROM ( "
        sql = sql & "       SELECT GAART.COD, "

        'CDIGO SQL PARA COLUMNA LA DESCRIPCIN DEL IDIOMA.
        sql = sql & BCb2b.CArticulo.sql_gaart_descrip_idioma(vEmpgrupoCod, vGgobstipCod, vIdioma, ConfigurationManager.AppSettings("ING_SPYRO")) & "," 'DESCRIP

        'CARGA
        sql = sql & "       (SELECT GAARTCLASI.VALOR "
        sql = sql & "       FROM    GAARTCLASI "
        sql = sql & "       WHERE   GAART.COD               = GAARTCLASI.GAART_COD AND "
        sql = sql & "               GAART.EMPGRUPO_COD      = GAARTCLASI.EMPGRUPO_COD AND "
        sql = sql & "               GAARTCLASI.GACLATIP_COD = '" & vCargaMax & "' AND "
        sql = sql & "               GAART.COD               <> '*' AND "
        sql = sql & "               GAART.EMPGRUPO_COD      = '" & vEmpgrupoCod & "') AS CARGA, "

        'RIGIDEZ
        sql = sql & "       (SELECT GAARTCLASI.VALOR "
        sql = sql & "       FROM    GAARTCLASI "
        sql = sql & "       WHERE   GAART.COD               = GAARTCLASI.GAART_COD AND "
        sql = sql & "               GAART.EMPGRUPO_COD      = GAARTCLASI.EMPGRUPO_COD AND "
        sql = sql & "               GAARTCLASI.GACLATIP_COD = '" & vClasiRigidez & "' AND "
        sql = sql & "               GAART.COD               <> '*' AND "
        sql = sql & "               GAART.EMPGRUPO_COD      = '" & vEmpgrupoCod & "') AS RIGIDEZ "

        sql = sql & "       FROM GAART "
        sql = sql & "       WHERE "
        sql = sql & "       GAART.EMPGRUPO_COD ='" & vEmpgrupoCod & "' AND "

        'VIGENTE Y NO HISTRICO
        sql = sql & "       (GAART.F_VIGENCIA IS NULL OR GAART.F_VIGENCIA <= SYSDATE)  AND "
        sql = sql & "       (GAART.F_BAJA IS NULL OR GAART.F_BAJA > SYSDATE)  AND "
        sql = sql & "       GAART.HIST_SN <>'S' "
        sql = sql & " ) "
        sql = sql & " WHERE "
        sql = sql & " COD <> '*' AND "
        sql = sql & " (UPPER(COD)	LIKE '%<SUSTITUIR>%' OR UPPER(DESCRIP) LIKE '%<SUSTITUIR>%') AND "

        'QUE TENGA LAS CLASIS
        sql = sql & " CARGA IS NOT NULL AND "
        sql = sql & " RIGIDEZ IS NOT NULL "

        'ORDEN
        sql = sql & " ORDER BY COD "
        Return sql
    End Function

    Public Sub dgBusquedaCommand(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            If V3 = "" Then
                V3 = ""
            End If
            If V3 = "&nbsp;" Then
                V3 = ""
            End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            script(2) = V1
            script(3) = "';"
            script(4) = ""
            script(5) = ""
            script(6) = ""
            script(7) = ""
            script(8) = ""
            script(9) = ""
            script(10) = "window.opener.document.forms[0]." + control.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control.Value + "Cod.value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control.Value + "Cod.focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Public Sub dgBusquedaCommandANTE(ByVal sender As Object, ByVal e As DataGridCommandEventArgs)

        Try
            Dim VALOR0 As TableCell = e.Item.Cells(0)
            Dim VALOR1 As TableCell = e.Item.Cells(1)
            Dim VALOR2 As TableCell = e.Item.Cells(2)
            Dim VALOR3 As TableCell = e.Item.Cells(3)

            Dim V0 As String = VALOR0.Text
            Dim V1 As String = VALOR1.Text
            Dim V2 As String = VALOR2.Text
            Dim V3 As String = VALOR3.Text

            If e.CommandSource.CommandName = "Edit" Then
                Session("codSel") = V1
                Session("descripSel") = V2
                Session("radioSel") = V3
            End If

            ' Este ser el bueno a partir de ahora espero
            Dim script(16) As String
            If V1 = "" Then
                V1 = ""
            End If
            If V1 = "&nbsp;" Then
                V1 = ""
            End If
            If V2 = "" Then
                V2 = ""
            End If
            If V2 = "&nbsp;" Then
                V2 = ""
            End If
            If V3 = "" Then
                V3 = ""
            End If
            If V3 = "&nbsp;" Then
                V3 = ""
            End If
            'Si importan las minusculas.

            script(1) = "<script>window.opener.document.forms[0]." + control.Value + ".value ='"
            'script(2) = V2
            script(2) = V1
            script(3) = "';"
            script(4) = "window.opener.document.forms[0]." + control1.Value + ".value ='"
            script(5) = V2
            script(6) = "';"
            script(7) = "window.opener.document.forms[0]." + control2.Value + ".value ='"
            script(8) = V3
            script(9) = "';"
            script(10) = "window.opener.document.forms[0]." + control1.Value + ".focus();"

            If (V1 = "") Then
                script(11) = "';window.opener.document.forms[0]." + control.Value + "Cod.value ='"
                script(12) = V1
                script(13) = "';"
                script(14) = "window.opener.document.forms[0]." + control.Value + "Cod.focus();"
            End If

            script(15) = "self.close();"
            script(16) = "</" + "script>"
            Dim KK As String = Join(script, "")
            RegisterClientScriptBlock("test", Join(script, ""))
        Catch ex As Exception
            Dim kk As String = ex.Message.ToString
        End Try

    End Sub


    Protected Sub DGBusqueda_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles DGBusqueda.PageIndexChanged

        Dim lista As New ArrayList
        lista.Clear()
        Dim valores As New BCb2b_AMC.CCargarLov()
        sql = calcula_Sql()
        sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
        lista = valores.lista_lov_amc_carga_radio(sql)
        DGBusqueda.DataSource = lista

        DGBusqueda.CurrentPageIndex = e.NewPageIndex
        DGBusqueda.DataBind()
    End Sub

    Protected Sub btnbuscar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnbuscar.Click
        conn.ConnectionString = conexion.cadena_conexion

        sql = calcula_Sql()

        sql = sql.Replace("<SUSTITUIR>", TextBox1.Text.ToUpper)
        Dim respuesta As String
        Dim lista As New ArrayList
        lista.Clear()
        Try
            Dim valores As New BCb2b_AMC.CCargarLov()
            lista = valores.lista_lov_amc_carga_radio(sql)
        Catch escep As Exception
            respuesta = escep.Message()
        Finally
            DGBusqueda.CurrentPageIndex = 0
            DGBusqueda.DataSource = lista
            DGBusqueda.DataBind()
        End Try
    End Sub

End Class
