﻿Imports System.Data.OracleClient
Imports AMC_Proyectos_pkg
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports BCb2b.Metodos
Imports System.Web.Mail
Imports System.Diagnostics
Imports System.IO
Imports System.Collections.Generic
Imports System.Data.OleDb
Imports BCb2b
Imports CTI.Utilities.Log
Partial Class distribucion
    Inherits claseBase

    Private NPED As String
    Private TIPOPED As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private email As String
    Dim CR As New CrystalDecisions.CrystalReports.Engine.ReportDocument

    Public ReadOnly Property PROP_email() As String
        Get
            Return Me.email
        End Get
    End Property
    Public ReadOnly Property PROP_N_PEDIDO_SEL() As String
        Get
            Return Me.NPED
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_PED_SEL() As String
        Get
            Return Me.TIPOPED
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Dim ruta As String
    Public Property PROP_ruta() As String
        Get
            Return Me.ruta
        End Get
        Set(value As String)
            Me.ruta = value
        End Set
    End Property
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub setTarget(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal siNo As Boolean)

        Dim clientScript As String

        If True Then
            clientScript = "document.forms[0].target = '_blank';"
        Else
            clientScript = "document.forms[0].target = '_self';"
        End If
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowCalendar(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_series.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&cod_agen=" & cod_agen, "LOV", 450, 450)

    End Sub
    Public Shared Sub ShowCalendar_traza(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal tboxTipo As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String, ByVal codigo_cliente As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_documento.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&tbtipo=" & tboxTipo.ClientID & "&cod_agen=" & cod_agen & "&cod_cli=" & codigo_cliente, "LOV", 450, 650)

    End Sub

    Private iddistribucion As OracleNumber
    Public Property prop_iddistribucion() As OracleNumber
        Get
            Return Me.iddistribucion
        End Get
        Set(ByVal value As OracleNumber)
            Me.iddistribucion = value
            Session("iddistribucion") = value
        End Set
    End Property
    Private Function GestionaRevisionCalc() As OracleNumber
        Dim txtRevision As TextBox
        txtRevision = Master.Master.FindControl("ContentPlaceHolder1").FindControl("num_revision")

        'NOTA. Si por algun motivo no se ha generado la revisión, lo que hacemos es que le genere una revisión.
        If Session("RevisionSel").ToString = "" Or Not Integer.Parse(Session("RevisionSel").ToString) > 0 Then
            Server.Transfer("nueva_revisionWizard.aspx")
        Else
            txtRevision.Text = Session("RevisionSel").ToString
        End If

        Session("RevisionSel") = txtRevision.Text
        lbln_revision.Text = txtRevision.Text

        Return CType(txtRevision.Text, OracleNumber)
    End Function
    Private Sub CompruebaVariablesSesion()
        If Session("cliente") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If
        If Session("proyecto") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If
    End Sub
    Private Sub GESTIONA_CENTRO(ByVal pCalculo As CCalculos)
        Dim valores(2) As String
        If Not Page.IsPostBack Then
            valores(0) = txtXCDG.Text
            valores(1) = txtYCDG.Text
            valores(2) = txtPCDG.Text

            If valores(0) <> "" And pCalculo.prop_carga_sn = "N" Then
                valores = Session("ValoresCentros")
                If valores(0) <> "" And valores(1) <> "" And valores(2) <> "" Then
                    txtXCDG.Text = valores(0).ToString
                    txtYCDG.Text = valores(1).ToString
                    txtPCDG.Text = valores(2).ToString
                End If
            Else
                'txtPCDG.Text = datosRev(4).ToString
                'txtXCDG.Text = datosRev(5).ToString
                'txtYCDG.Text = datosRev(6).ToString

                txtPCDG.Text = pCalculo.prop_pcdg
                txtXCDG.Text = pCalculo.prop_xcdg
                txtYCDG.Text = pCalculo.prop_ycdg
            End If
        Else
            valores(0) = ""
            valores(1) = ""
            valores(2) = ""
        End If

        If txtPCDG.Text = "Null" Then
            txtPCDG.Text = 0
        End If
        If txtXCDG.Text = "Null" Then
            txtXCDG.Text = 0
        End If
        If txtYCDG.Text = "Null" Then
            txtYCDG.Text = 0
        End If

        Session("centroX") = txtXCDG.Text
        Session("centroY") = txtYCDG.Text
        Session("ValoresCentros") = valores
    End Sub
    'Private Sub GestionaUnidades(ByVal pUnidad As String, ByVal pCargasSN As String)

    'End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(distribucion))

        btnCalcular.OnClientClick = "SetTargetSelf()"

        'HABILITAMOS LOS MENSAJES MODALES
        Dim vUti As New BCb2b.Utilities
        vUti.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        vUti.CrearModalConfirm(Me, "ActuRigidez", GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "ConfirmarActualizar"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        CompruebaVariablesSesion()

        Dim vRevision As OracleNumber = GestionaRevisionCalc()

        Dim vProyecto As New AMC_Proyectos_pkg.CProyectos()
        vProyecto = Session("proyecto")

        Dim vCalculo As New AMC_Proyectos_pkg.CCalculos()
        Dim vDatosCalc As ArrayList = vCalculo.DameDatosRev(vProyecto.prop_cod, vRevision)
        Me.iddistribucion = vDatosCalc(0)

        Session("iddistribucion") = Me.iddistribucion
        If Page.IsPostBack Then
            lbln_revision.Text = vCalculo.prop_revision

            Dim vCargaSn As String = ""
            If txt_Cargas.Text = CType(GetLocalResourceObject("TextoCarga.Text"), String) Then
                vCargaSn = "S"
            Else
                vCargaSn = "N"
            End If

            If txtFecha.Text = "" Then
                txtFecha.Text = String.Format(vDatosCalc(1), "dd/MM/yyyy")
            End If

            actualizarCabecera(StringToOracleNumber(vCalculo.prop_iddistribucion), StringToOracleNumber(vProyecto.prop_cod), StringToOracleNumber(txtPCDG.Text), _
                                     StringToOracleNumber(txtXCDG.Text), StringToOracleNumber(txtYCDG.Text), StringToOracleNumber(txtMx.Text), _
                                     StringToOracleNumber(txtMy.Text), StringToOracleNumber(txtRpm.Text), StringToOracleNumber(comboNumOrden.Value), _
                                     StringToOracleNumber(Session("RevisionSel")), CType(txtFecha.Text, Date), txtObservaciones.Text, vCargaSn, StringToOracleNumber(txtVelMin.Text), StringToOracleNumber(txtVelMax.Text), StringToOracleNumber(txtNMaquinas.Text))

            Session("calculos") = vCalculo
        End If

        cargarDatosPagina()

        vCalculo = Session("calculos")
        ShowLupaClasificacion(Me.btnCDG, vCalculo.prop_iddistribucion, vProyecto.prop_cod, txtPCDG.ClientID, txtXCDG.ClientID, txtYCDG.ClientID)

        div_lblRigidezRecalculo.Visible = False
        GESTIONA_SI_ES_EDITABLE()

        'esta linea es para mostrar el boton de nueva revision o no. solo se tiene que ver en calculos.
        Session("PaginaActual") = "calculos"

    End Sub
    Private Sub GESTIONA_CONTROLES_PERFIL()
        If Not Session("perfil_usuario") Is Nothing Then
            txtNMaquinas.Enabled = True
            txtNMaquinas.Visible = True
            Label26.Visible = True
            btnReportCalculation.Visible = False

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing, svt
                btnReportCalculation.Visible = True
            ElseIf perfiles.prop_TIPO_PERFIL = 2 Then 'cliente
                txtNMaquinas.Enabled = False
                txtNMaquinas.Visible = False
                Label26.Visible = False
            End If
        End If
    End Sub
    Private Function TIENE_OFE() As Boolean
        Dim vTiene As Boolean = False
        Dim calculo As New AMC_Proyectos_pkg.CCalculos()
        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If Not Session("calculos") Is Nothing Then
            calculo = Session("calculos")
            If calculo.prop_GGOFETIP_COD <> "" And calculo.prop_N_OFE_REV <> "" Then
                vTiene = True
            ElseIf txtSerieOfe.Text <> "" And txtNOfe.Text <> "" And perfiles.prop_TIPO_PERFIL <> 2 Then '<> CLI
                vTiene = True
            End If
        End If
        Return vTiene
    End Function
    Private Sub GESTIONA_SI_ES_EDITABLE()
        If Session("editarNOeditar") = False Or TIENE_OFE() Then
            txtFecha.Enabled = False
            btnEditarApoyos.Visible = False
            txtObservaciones.Enabled = False
            txtPCDG.Enabled = False
            txtXCDG.Enabled = False
            txtYCDG.Enabled = False
            comboNumOrden.Attributes.Add("disabled", "disabled")
            txtRpm.Enabled = False
            txtVelMin.Enabled = False
            txtVelMax.Enabled = False
            txtMx.Enabled = False
            txtMy.Enabled = False
            Literal3.Visible = False
            div_Literal3.Visible = False
            btnCalcular.Visible = False
        Else
            txtFecha.Enabled = True
            txtObservaciones.Enabled = True
            txtPCDG.Enabled = True
            txtXCDG.Enabled = True
            txtYCDG.Enabled = True
            comboNumOrden.Attributes.Add("enabled", "enabled")
            txtRpm.Enabled = True
            txtVelMin.Enabled = True
            txtVelMax.Enabled = True
            txtMx.Enabled = True
            txtMy.Enabled = True
            btnEditarApoyos.Visible = True
            Literal3.Visible = True
            div_Literal3.Visible = True
            btnCalcular.Visible = True
        End If
    End Sub
    Public Shared Sub ShowLupaClasificacion(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal iddistribucion As String, ByVal idestado As String, ByVal c1 As String, ByVal c2 As String, ByVal c3 As String)
        OpenPopUp(opener, "CDG.aspx?dist=" & iddistribucion & "&est=" & idestado & "&c1=" & c1 & "&c2=" & c2 & "&c3=" & c3, "LOV", 500, 450)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.WebControl, ByVal art_desControl As System.Web.UI.WebControls.WebControl, ByVal art_radioControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_radioControl.ClientID, "LOV", 600, 450)
    End Sub
    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)

        If (e.Row.RowType = DataControlRowType.DataRow) Then

            Dim fila As GridViewRow
            fila = e.Row
            Dim mifila As Integer = fila.RowIndex.ToString

            Dim Pkey As DataKeyArray = GVApoyos.DataKeys

            Dim gaart_cod As String = Pkey.Item(mifila).Item(1) 'codido articulo
            Dim carga As String = Pkey.Item(mifila).Item(6) 'carga

            Dim supera_carga_max As Boolean = New CCalculos.operacionesCalculos().supera_carga_max(gaart_cod, ConfigurationManager.AppSettings("grupo"), carga)

            Dim lblcarga As WebControls.Label = e.Row.FindControl("lblcarga")
            Dim lblcargaMax As WebControls.Label = e.Row.FindControl("lblcargaMax")

            If supera_carga_max = True Then
                lblcarga.ForeColor = System.Drawing.Color.Red
                lblcargaMax.ForeColor = System.Drawing.Color.Red
                lblcarga.ToolTip = GetLocalResourceObject("CargaSuperada")
                lblcargaMax.ToolTip = GetLocalResourceObject("CargaSuperada")
            End If


            Dim lbBorrar As ImageButton = e.Row.FindControl("lbBorrar")
            Dim hyp_e_catalog As HyperLink = e.Row.FindControl("hyp_e_catalog")

            lbBorrar.Attributes.Add("onclick", "javascript:return " & CType(GetLocalResourceObject("Preg_elim.Text"), String) & " " & e.Row.RowIndex + 1 & "?')")
            'HyperLink1.NavigateUrl = "http://ecatalog.amcsa.es/item.aspx?code=" & e.Row.Cells(1).Text & "&lang=" & tratarIdiomaCatalogo()
            hyp_e_catalog.NavigateUrl = "http://www.mecanocaucho.com/" & tratarIdiomaCatalogo() & "/itemsearch/" & gaart_cod & "/"

        End If

    End Sub
    Public Function tratarIdiomaCatalogo() As String
        'E-catalogo
        'http://www.mecanocaucho.com/en-GB/itemsearch/135181/

        Select Case Session("idioma")
            Case ConfigurationManager.AppSettings("CAS")
                Return ConfigurationManager.AppSettings("CUL_CAS")
            Case ConfigurationManager.AppSettings("FRA")
                Return ConfigurationManager.AppSettings("CUL_FRA")
            Case ConfigurationManager.AppSettings("ING")
                Return ConfigurationManager.AppSettings("CUL_ING")
            Case ConfigurationManager.AppSettings("ALE")
                Return ConfigurationManager.AppSettings("CUL_ALE")
            Case ConfigurationManager.AppSettings("ITA")
                Return ConfigurationManager.AppSettings("CUL_ITA")
            Case Else
                Return ConfigurationManager.AppSettings("CUL_ING")
        End Select

    End Function
    Protected Sub ZedGraphWeb1_RenderGraph(ByVal webObject As ZedGraph.Web.ZedGraphWeb, ByVal g As System.Drawing.Graphics, ByVal masterPane As ZedGraph.MasterPane) Handles ZedGraphWeb1.RenderGraph
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
        Try
            Dim ggestcampa_cod As String
            ggestcampa_cod = miProyecto.prop_cod

            Dim revision As OracleNumber
            Dim ddlRevisiones As TextBox
            ddlRevisiones = Master.Master.FindControl("ContentPlaceHolder1").FindControl("num_revision")
            If Not ddlRevisiones Is Nothing Then
                revision = ddlRevisiones.Text
            End If

            Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

            Dim myPane As GraphPane = masterPane(0)
            myPane.XAxis.Title.Text = CType(GetLocalResourceObject("Frecuencia.Text"), String) 'Frecuencia [Hz]
            myPane.YAxis.Title.Text = CType(GetLocalResourceObject("Aislamiento.Text"), String) 'Aislamiento [dB]

            Dim rpm As Double
            Dim Frecnat As Double
            Dim D As Double

            misCalculos.cargar_datos(miProyecto.prop_cod, prop_iddistribucion, revision, ConfigurationManager.AppSettings("Grupo"), txtMx.Text, txtMy.Text, comboNumOrden.Value, txtRpm.Text, Session("idioma"), com)

            rpm = misCalculos.prop_rpm
            Frecnat = misCalculos.prop_frecProp

            Dim miAmortig As New AMC_Proyectos_pkg.CCalculos.apoyo
            miAmortig.cargar_apoyos(iddistribucion, ConfigurationManager.AppSettings("Grupo"), miProyecto.prop_cod, revision, Session("idioma"), com)
            D = miAmortig.prop_sumaAmortig
            D = D / misCalculos.prop_apoyos.Count

            Dim pointsGraf() As String = {}
            Dim xAxisGraf() As Double = {}
            Dim freqGraf As Double = 0
            Dim indicePoint As Integer = 0
            Do While freqGraf <= 125
                ReDim Preserve pointsGraf(indicePoint)
                ReDim Preserve xAxisGraf(indicePoint)
                pointsGraf(indicePoint) = freqGraf.ToString
                xAxisGraf(indicePoint) = indicePoint + 1
                indicePoint = indicePoint + 1
                freqGraf = freqGraf + 0.5
            Loop

            Dim labels() As String = {"2", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "18", "20", "25", "30", "40", "50", "63", "80", "100", "125"}
            Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}

            labels = pointsGraf
            xAxis = xAxisGraf

            Dim ais(labels.Length) As Double
            Dim i As Integer = 0

            Dim cadenaprueba As String = ""
            For i = 0 To labels.Length - 1
                ais(i) = 1 - Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2))
                ais(i) = (ais(i) * 100)
            Next i

            Dim oLineItem As LineItem

            Dim xAxisVac() As Double = {}
            Dim aisVac() As Double = {}
            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMinGraf.Text"), String), xAxisVac, aisVac, Color.DarkCyan, SymbolType.None)
            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMaxGraf.Text"), String), xAxisVac, aisVac, Color.DarkOrange, SymbolType.None)
            Dim nuevoslabels() As String = crearLineasVelMinMax(labels, xAxis, ais, myPane, CDbl(txtVelMin.Text), CDbl(txtVelMax.Text), True)

            If nuevoslabels.Length > labels.Length Then
                labels = nuevoslabels
                ReDim Preserve xAxis(labels.Length - 1)
                xAxis(labels.Length - 1) = xAxis.GetUpperBound(0) + 1
                ais = recalcularAis(labels, D, Frecnat)
            End If

            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("Aislamiento.Text"), String), xAxis, ais, Color.Blue, SymbolType.None)
            myPane.XAxis.Scale.TextLabels = labels
            myPane.XAxis.Type = AxisType.Text
            myPane.XAxis.MajorTic.IsBetweenLabels = False
            myPane.YAxis.Scale.Min = 10
            myPane.YAxis.Scale.Max = 100
            myPane.YAxis.Type = AxisType.Log
            myPane.Chart.Fill = New Fill(Color.White, Color.FromArgb(255, 255, 166), 45.0F)
            masterPane.AxisChange(g)

            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")
            Dim nombreGraf As String = "grafico_aislamiento_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".png"
            Dim nombreGraf2 As String = "grafico_transmisibilidad_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".png"
            masterPane.GetImage.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)

            misCalculos.PROP_ruta_grafico_aislamiento = nombreGraf
            misCalculos.PROP_ruta_grafico_transmisibilidad = nombreGraf2

            Me.PROP_ruta = nombreGraf & " -- " & nombreGraf2

            Session("calculos") = misCalculos
            Session("graf_aislam") = nombreGraf
        Catch ex As Exception
            Log.Error(ex, "[distribucion.ZedGraphWeb1_RenderGraph] proyecto = {@proyecto} calculo = {@calculo}", miProyecto, misCalculos)
        End Try
    End Sub

    Private Function crearLineasVelMinMax(ByVal labels() As String, ByVal xAsis() As Double, ByVal ais() As Double, ByVal myPane As GraphPane, ByVal velmin As Double, ByVal velmax As Double, ByVal esAislamiento As Boolean) As String()
        Dim aisLineaMax As Double = myPane.YAxis.Scale.Max
        Dim aisLineaMin As Double = myPane.YAxis.Scale.Min

        If aisLineaMin = 0 And aisLineaMin = 0 Then
            Dim aisY() As Double = {0}
            For i = 0 To labels.Length - 1
                If i = 0 Then
                    aisLineaMax = ais(i)
                    aisLineaMin = aisLineaMax
                End If
                If ais(i) >= aisLineaMax Then
                    aisLineaMax = ais(i)
                ElseIf ais(i) < aisLineaMin Then
                    aisLineaMin = ais(i)
                End If
            Next i
        End If

        Dim logaritmic(16) As Double
        logaritmic(0) = 0.0000000010000000000000001
        logaritmic(1) = 0.00000001
        logaritmic(2) = 0.000000099999999999999995
        logaritmic(3) = 0.00000099999999999999995
        logaritmic(4) = 0.000010000000000000001
        logaritmic(5) = 0.0001
        logaritmic(6) = 0.001
        logaritmic(7) = 0.01
        logaritmic(8) = 0.10000000000000001
        logaritmic(9) = 1
        logaritmic(10) = 10
        logaritmic(11) = 100
        logaritmic(12) = 1000
        logaritmic(13) = 10000
        logaritmic(14) = 100000
        logaritmic(15) = 1000000
        logaritmic(16) = 10000000

        Dim hayNegat As Boolean = False
        For i = 0 To logaritmic.Length - 2
            If aisLineaMin > CDbl(logaritmic(i)) And aisLineaMin <= CDbl(logaritmic(i + 1)) Then
                aisLineaMin = CDbl(logaritmic(i))
            ElseIf aisLineaMin < 0 Then
                hayNegat = True
            End If

            If aisLineaMax > CDbl(logaritmic(i)) And aisLineaMax <= CDbl(logaritmic(i + 1)) Then
                aisLineaMax = CDbl(logaritmic(i + 1))
            End If
        Next i

        'EN EL AISLAMIENTO SOLO INTERESAN LOS VALORES ENTRE 10 Y 100 (JON I)
        If aisLineaMax > 100 Then
            aisLineaMax = 100
        End If
        If esAislamiento = True Then
            If aisLineaMin < 10 Then
                aisLineaMin = 10
            End If
        End If

        '------------------------------------------------------------------------------------------
        'ESTE CODIGO MAS QUE NADA ES PARA EL AISLAMIENTO YA QUE TIENE VALORES NEGATIVOS
        'LO QUE HACE ES CALCULAR EL VALOR MINIMO DE LOS POSITIVOS PARA PODER CALCULAR LA ALTURA DE LA
        'LINEA VERTICAL DE LAS VELOCIDADES.
        If hayNegat = True Then
            Dim z As Integer = 0
            'AQUI HAGO UN ARRAY CON LOS VALORES POSITIVOS
            Dim arrayPosit() As Double = {}
            For i = 0 To labels.Length - 2
                If CDbl(ais(i)) > 0 Then
                    ReDim Preserve arrayPosit(z)
                    arrayPosit(z) = CDbl(ais(i))
                End If
            Next i
            'AQUI CALCULO EL POSITIVO MENOR
            Dim positivMenor As Double = 0
            For i = 0 To arrayPosit.Length - 1
                If i = 0 Then
                    positivMenor = arrayPosit(i)
                End If
                If arrayPosit(i) < positivMenor Then
                    positivMenor = arrayPosit(i)
                End If
            Next i
            'AQUI AVERIGUO CUAL ES SU ESCALA LOGARITMICA MAS CERCANA
            For i = 0 To logaritmic.Length - 2
                If positivMenor > CDbl(logaritmic(i)) And positivMenor <= CDbl(logaritmic(i + 1)) Then
                    aisLineaMin = CDbl(logaritmic(i))
                End If
            Next i
        End If
        '---------------------------------------------------------------------------------------

        Dim freqvelmin As Double = velmin / 60
        Dim freqvelmax As Double = velmax / 60

        Dim result As String() = Array.FindAll(labels, Function(s) s.Contains(CInt(freqvelmin)))
        If result.Length = 0 Then
            ReDim Preserve labels(labels.Length)
            labels(labels.Length - 1) = CInt(freqvelmin).ToString
        End If

        Dim result2 As String() = Array.FindAll(labels, Function(s) s.Contains(CInt(freqvelmax)))
        If result2.Length = 0 Then
            ReDim Preserve labels(labels.Length)
            labels(labels.Length - 1) = CInt(freqvelmax).ToString
        End If

        Dim sc As New NumericComparer(False)
        Array.Sort(labels, sc)

        Dim posLineaMin As Integer = 0
        For i = 0 To labels.Length - 2
            If CInt(freqvelmin) = CInt(labels(i)) Then
                posLineaMin = i + 1
            End If
        Next i

        If velmin <> 0 Then
            Dim threshHoldXMin As Double = posLineaMin
            Dim threshHoldLineMin As LineObj = New LineObj(Color.DarkCyan, threshHoldXMin, aisLineaMin, threshHoldXMin, aisLineaMax)
            myPane.GraphObjList.Add(threshHoldLineMin)
        End If


        Dim posLineaMax As Integer = 0
        For i = 0 To labels.Length - 2
            If CInt(freqvelmax) = CInt(labels(i)) Then
                posLineaMax = i + 1
            End If
        Next i

        If velmax <> 0 Then
            Dim threshHoldXMax As Double = posLineaMax
            Dim threshHoldLineMax As LineObj = New LineObj(Color.DarkOrange, threshHoldXMax, aisLineaMin, threshHoldXMax, aisLineaMax)
            myPane.GraphObjList.Add(threshHoldLineMax)
        End If

        Return labels
    End Function


    Protected Sub ZedGraphWeb2_RenderGraph(ByVal webObject As ZedGraph.Web.ZedGraphWeb, ByVal g As System.Drawing.Graphics, ByVal masterPane As ZedGraph.MasterPane) Handles ZedGraphWeb2.RenderGraph
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
        Try
            Dim ggestcampa_cod As String
            ggestcampa_cod = miProyecto.prop_cod

            Dim vRevision As OracleNumber = GestionaRevisionCalc()

            Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

            Dim myPane As GraphPane = masterPane(0)
            myPane.XAxis.Title.Text = CType(GetLocalResourceObject("Frecuencia.Text"), String) 'Frecuencia [Hz]
            myPane.YAxis.Title.Text = CType(GetLocalResourceObject("Transmisibilidad.Text"), String) 'Transmisibilidad [dB]

            Dim rpm As Double
            Dim Frecnat As Double
            Dim D As Double

            misCalculos.cargar_datos(miProyecto.prop_cod, prop_iddistribucion, vRevision, ConfigurationManager.AppSettings("Grupo"), txtMx.Text, txtMy.Text, comboNumOrden.Value, txtRpm.Text, Session("idioma"), com)
            rpm = misCalculos.prop_rpm
            Frecnat = misCalculos.prop_frecProp

            Dim miAmortig As New AMC_Proyectos_pkg.CCalculos.apoyo()
            miAmortig.cargar_apoyos(iddistribucion, ConfigurationManager.AppSettings("Grupo"), miProyecto.prop_cod, vRevision, Session("idioma"), com)
            D = miAmortig.prop_sumaAmortig
            D = D / misCalculos.prop_apoyos.Count

            Dim pointsGraf() As String = {}
            Dim xAxisGraf() As Double = {}
            Dim freqGraf As Double = 0
            Dim indicePoint As Integer = 0
            Do While freqGraf <= 125
                ReDim Preserve pointsGraf(indicePoint)
                ReDim Preserve xAxisGraf(indicePoint)
                pointsGraf(indicePoint) = freqGraf.ToString
                xAxisGraf(indicePoint) = indicePoint + 1
                indicePoint = indicePoint + 1
                freqGraf = freqGraf + 0.5
            Loop

            Dim labels() As String = {"2", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "18", "20", "25", "30", "40", "50", "63", "80", "100", "125"}
            Dim xAxis() As Double = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}

            labels = pointsGraf
            xAxis = xAxisGraf

            Dim trans(labels.Length) As Double
            Dim i As Integer = 0


            Dim tableDTrans As DataTable = New DataTable("tableDTrans")
            tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)))
            tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("AislamientoTitulo.Text"), String)))
            tableDTrans.Columns.Add(New DataColumn("D"))

            Dim cadenaprueba As String = ""
            For i = 0 To labels.Length - 1
                'EL IDORDEN SOLO SE TIENE EN CUENTA EN AISLAMIENTO ESTIMADO (JON I)
                If Frecnat <> 0 Then
                    trans(i) = Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / Frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / Frecnat) ^ 2))
                Else
                    trans(i) = 0
                End If

                If i Mod 16 = 1 Then
                    Dim row As DataRow = tableDTrans.NewRow()
                    row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                    row(CType(GetLocalResourceObject("AislamientoTitulo.Text"), String)) = FormatNumber(((1 - trans(i)) * 100), 2) & " %"
                    row("D") = FormatNumber(20 * Math.Log10(1 / (1 - ((1 - trans(i))))), 2) & " dB"
                    tableDTrans.Rows.Add(row)
                End If
            Next i

            GridView2.DataSource = tableDTrans
            GridView2.DataBind()
            Session("GridView2") = GridView2

            Dim oLineItem As LineItem

            Dim xAxisVac() As Double = {}
            Dim transVac() As Double = {}
            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMinGraf.Text"), String), xAxisVac, transVac, Color.DarkCyan, SymbolType.None)
            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("TextoRpmMaxGraf.Text"), String), xAxisVac, transVac, Color.DarkOrange, SymbolType.None)
            Dim nuevoslabels() As String = crearLineasVelMinMax(labels, xAxis, trans, myPane, CDbl(txtVelMin.Text), CDbl(txtVelMax.Text), False)
            If nuevoslabels.Length > labels.Length Then
                labels = nuevoslabels
                ReDim Preserve xAxis(labels.Length - 1)
                xAxis(labels.Length - 1) = xAxis.GetUpperBound(0) + 1
                trans = recalcularTrans(labels, D, Frecnat)
            End If

            oLineItem = myPane.AddCurve(CType(GetLocalResourceObject("Transmisibilidad.Text"), String), xAxis, trans, Color.Green, SymbolType.None)

            myPane.XAxis.Scale.TextLabels = labels
            myPane.XAxis.Type = AxisType.Text
            myPane.XAxis.MajorTic.IsBetweenLabels = False
            myPane.YAxis.Type = AxisType.Text
            myPane.YAxis.Type = AxisType.Log
            myPane.Chart.Fill = New Fill(Color.White, Color.FromArgb(255, 255, 166), 45.0F)
            masterPane.AxisChange(g)

            Dim cliente As BCb2b.ggclipr
            cliente = Session("cliente")
            Dim nombreGraf As String = "grafico_transmisibilidad_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".png"
            Dim nombreGraf2 As String = "grafico_aislamiento_" & cliente.prop_COD & "_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".png"
            masterPane.GetImage.Save(ConfigurationManager.AppSettings("rutaPDFmail") & "_" & nombreGraf, ImageFormat.Png)
            misCalculos.PROP_ruta_grafico_transmisibilidad = nombreGraf
            misCalculos.PROP_ruta_grafico_aislamiento = nombreGraf2
            Session("calculos") = misCalculos

            Session("graf_transm") = nombreGraf
        Catch ex As Exception
            Log.Error(ex, "[distribucion.ZedGraphWeb2_RenderGraph] proyecto = {@proyecto} calculo = {@calculo}", miProyecto, misCalculos)
        End Try
    End Sub

    Private Function recalcularTrans(ByVal labels() As String, ByVal D As Double, ByVal frecnat As Double) As Double()
        Dim tableDTrans As DataTable = New DataTable("tableDTrans")
        tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)))
        tableDTrans.Columns.Add(New DataColumn(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)))

        Dim trans(labels.Length - 1) As Double
        For i = 0 To labels.Length - 1

            trans(i) = Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2))
            
            If i <= 7 Then
                Dim row As DataRow = tableDTrans.NewRow()
                row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                row(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)) = FormatNumber(trans(i), 2) & " dB"
                tableDTrans.Rows.Add(row)
            Else
                If i Mod 2 = 1 Then
                    Dim row As DataRow = tableDTrans.NewRow()
                    row(CType(GetLocalResourceObject("FrecuenciaTitulo.Text"), String)) = labels(i) & " Hz"
                    row(CType(GetLocalResourceObject("TransmisibilidadTitulo.Text"), String)) = FormatNumber(trans(i), 2) & " dB"
                    tableDTrans.Rows.Add(row)
                End If
            End If
        Next i
        Return trans
    End Function

    Private Function recalcularAis(ByVal labels() As String, ByVal D As Double, ByVal frecnat As Double) As Double()
        Dim ais(labels.Length - 1) As Double
        For i = 0 To labels.Length - 1
            ais(i) = 1 - Math.Sqrt((1 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2) / ((1 - ((CDbl(labels(i))) ^ 2 / frecnat ^ 2)) ^ 2 + (2 * D * CDbl(labels(i)) / frecnat) ^ 2))
            ais(i) = ais(i) * 100
        Next i
        Return ais
    End Function

    Protected Sub btnCalcular_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCalcular.Click
        Dim vProyecto As New AMC_Proyectos_pkg.CProyectos()
        vProyecto = Session("proyecto")

        Dim vCalculo As New AMC_Proyectos_pkg.CCalculos()
        vCalculo = Session("calculos")
        Try
            cargarDatosPagina()

            '---------ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
            Dim uti As New BCb2b.Utilities()
            Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
            vCalculo.Gestiona_UsuResp_CreMod_Calculo(vCalculo.prop_idestudio, vCalculo.prop_iddistribucion, vCalculo.prop_revision, cod_usuario.ToUpper)
            '---------FIN ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
        Catch ex As Exception
            Log.Error(ex, "[distribucion.btnCalcular_Click] proyecto = {@proyecto} calculo = {@calculo}", vProyecto, vCalculo)
        End Try

        If Session("generar_informe") = True Then
            Server.Transfer("servicios.aspx?d=1")
        End If
    End Sub
    Private Sub actualizarCabecera(ByVal iddistribucion As String, ByVal ggestcampa_cod As OracleNumber, _
                                   ByVal txtPCDG As OracleNumber, ByVal txtXCDG As OracleNumber, ByVal txtYCDG As OracleNumber, _
                                   ByVal txtMx As OracleNumber, ByVal txtMy As OracleNumber, ByVal txtRpm As OracleNumber, _
                                   ByVal comboNumOrden As OracleNumber, ByVal revision As OracleNumber, ByVal txtFecha As Date, _
                                   ByVal txtObservaciones As String, ByVal carga As String, ByVal txtVelMin As OracleNumber, _
                                   ByVal txtVelMax As OracleNumber, ByVal nMaquinas As OracleNumber)
        Dim proyecto As New CProyectos

        Try
            proyecto.actualizar_Cabecera(iddistribucion, ggestcampa_cod, txtPCDG, txtXCDG, txtYCDG, txtMx, _
                                                txtMy, txtRpm, comboNumOrden, revision, txtFecha, txtObservaciones, _
                                                carga, txtVelMin, txtVelMax, nMaquinas)
        Catch ex As Exception
            Log.Error(ex, "[distribucion.actualizarCabecera]  calculo = {calculo} proyecto = {proyecto} pcdg = {pcdg} xcdg = {xcdg} ycdg = {ycdg} mx = {mx} my = {my} rpm = {rpm} n_orden = {n_orden} rev = {rev} fecha = {fecha} obs = {obs} v_carga = {v_carga} vel_min = {vel_min} vel_max = {vel_max} n_maq = {n_maq} ", iddistribucion, ggestcampa_cod, txtPCDG, txtXCDG, txtYCDG, txtMx, txtMy, txtRpm, comboNumOrden, revision, txtFecha, txtObservaciones, carga, txtVelMin, txtVelMax, nMaquinas)
        End Try
    End Sub
    Private Sub GESTIONA_OFERTA_CALC(ByVal vCalculo As CCalculos)
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVC As String = ConfigurationManager.AppSettings("venta")

        'CARGAMOS DATOS DE LA OFERTA EN CASO DE TENERLA. AMC_NE109
        txtSerieOfe.Text = vCalculo.prop_GGOFETIP_COD
        txtNOfe.Text = vCalculo.prop_N_OFE_REV
        'txtNRev.Text = calculos.prop_N_REVISION

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

        If txtSerieOfe.Text <> "" And txtNOfe.Text <> "" And perfiles.prop_TIPO_PERFIL <> 2 Then '<> CLI
            lnkVerOferta.Text = vCalculo.prop_GGOFETIP_COD & "-" & vCalculo.prop_N_OFE_REV & " / Rev: " & vCalculo.prop_N_REVISION
            lnkVerOferta.Visible = True
            lbloferta.Visible = True
            btnCrearOferta.Text = GetLocalResourceObject("btnRevisarOfertaResource1.Text")
            'txtTieneOfe.Value = "S"

            Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
            Dim transaccion_RevModif As IDbTransaction
            transaccion_RevModif = conexionole.BeginTransaction
            Dim RevEsModificable As String = "N"
            RevEsModificable = CS_B2B_OFE_PKG.CS_B2B_OFE_PKG.OFERTA_MODIFICABLE(transaccion_RevModif, vEmpgrupoCod, vEmpCod, vTipVc, vCalculo.prop_GGOFETIP_COD, vCalculo.prop_N_OFE_REV, vCalculo.prop_N_REVISION)
            transaccion_RevModif.Commit()
            conexionole.Close()
            conexionole.Dispose()
            Dim veroferta As New ImageButton
            veroferta = Master.Master.FindControl("ContentPlaceHolder1").FindControl("ImgBtnVerOfe")
            Dim lblOfertaasoc As New WebControls.Label
            lblOfertaasoc = Master.Master.FindControl("ContentPlaceHolder1").FindControl("lblOfertaasoc")
            If RevEsModificable = "N" Then 'SI LA OFE NO ES MODIF
                If Session("editarNOeditar") = False Then 'SI NO TIENES PERMISOS NO PUEDES VER NI CREAR
                    btnCrearOferta.Visible = False
                    lnkVerOferta.Visible = False
                    lbloferta.Visible = False
                    veroferta.Visible = False
                    lblOfertaasoc.Visible = False
                Else
                    btnCrearOferta.Visible = False 'SI LOS TIENES,PODRAS VER PERO NO CREAR
                    lnkVerOferta.Visible = True
                    lbloferta.Visible = True
                    veroferta.Visible = True
                    lblOfertaasoc.Visible = True
                End If
            Else
                If Session("editarNOeditar") = False Then 'SI NO TIENES PERMISOS NO PUEDES VER NI CREAR
                    btnCrearOferta.Visible = False
                    lnkVerOferta.Visible = False
                    lbloferta.Visible = False
                    veroferta.Visible = False
                    lblOfertaasoc.Visible = False
                Else
                    btnCrearOferta.Visible = True 'SI LOS TIENES,PODRAS VER y CREAR
                    lnkVerOferta.Visible = True
                    lbloferta.Visible = True
                    veroferta.Visible = True
                    lblOfertaasoc.Visible = True
                End If
            End If
        Else
            lnkVerOferta.Text = ""
            lnkVerOferta.Visible = False
            lbloferta.Visible = False
            btnCrearOferta.Text = GetLocalResourceObject("btnCrearOfertaResource1.Text")

            Dim veroferta As New ImageButton
            veroferta = Master.Master.FindControl("ContentPlaceHolder1").FindControl("ImgBtnVerOfe")
            veroferta.Visible = False

            Dim lblOfertaasoc As New WebControls.Label
            lblOfertaasoc = Master.Master.FindControl("ContentPlaceHolder1").FindControl("lblOfertaasoc")
            lblOfertaasoc.Visible = False

            If Session("editarNOeditar") = False Or perfiles.prop_TIPO_PERFIL = 2 Then ' CLI
                btnCrearOferta.Visible = False
            Else
                btnCrearOferta.Visible = True
            End If
        End If
    End Sub
    Private Sub CARGAR_CALCULO(ByVal pGgestcampaCod As String, ByVal pRevision As OracleNumber)
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vCalculo As New AMC_Proyectos_pkg.CCalculos()

        Dim vDatosCalc As ArrayList = vCalculo.DameDatosRev(pGgestcampaCod, pRevision)
        Me.iddistribucion = vDatosCalc(0)
        txtFecha.Text = String.Format(vDatosCalc(1), "dd/MM/yyyy")
        txtObservaciones.Text = vDatosCalc(2).ToString

        Session("iddistribucion") = Me.iddistribucion
        Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
        comboNumOrden.Value = vDatosCalc(10).ToString 'Jce. pruebas orden que no carga bien!

        'JVC: ñapa: a ver si esto soluciona que no llege el nombre de la imagen al enviar esto al pdf.
        Dim ruta1 As String = ""
        Dim ruta2 As String = ""
        Dim ruta3 As String = ""
        If Not Session("calculos") Is Nothing Then
            ruta1 = Session("calculos").PROP_ruta_grafico_aislamiento
            ruta2 = Session("calculos").PROP_ruta_grafico_apoyos
            ruta3 = Session("calculos").PROP_ruta_grafico_transmisibilidad
        End If

        vCalculo.cargar_datos(pGgestcampaCod, prop_iddistribucion, pRevision, vEmpgrupoCod, txtMx.Text, txtMy.Text, comboNumOrden.Value, txtRpm.Text, Session("idioma"), com)
        vCalculo.PROP_ruta_grafico_aislamiento = ruta1
        vCalculo.PROP_ruta_grafico_apoyos = ruta2
        vCalculo.PROP_ruta_grafico_transmisibilidad = ruta3

        GESTIONA_DATOS_CALC(vCalculo, vDatosCalc)
        GESTIONA_CENTRO(vCalculo) 'GESTIONA PCDG,YCDG,XCDG.
        GESTIONA_UNIDADES_CALC(vCalculo)
        GESTIONA_OFERTA_CALC(vCalculo) 'CARGAMOS DATOS DE LA OFERTA EN CASO DE TENERLA. AMC_NE109

        Session("calculos") = vCalculo

        GESTIONA_APOYOS(vCalculo) 'COMPROBAMOS SI HA CAMBIADO ALGUNA RIGIDEZ, ETC.
        GESTIONA_GRAFICOS(vCalculo)
        GESTIONA_CONTROLES_PERFIL() 'MOSTRAR Y OCULTAR CONTROLES SEGUN PERFIL.
        Session("Centros") = CAcentros.cargar_datos(Me.iddistribucion, pGgestcampaCod)
    End Sub
    Private Sub GESTIONA_DATOS_CALC(ByVal pCalculo As CCalculos, ByVal pDatosCalc As ArrayList)

        If pDatosCalc(7).ToString = "Null" Then
            txtMx.Text = "0"
        Else
            txtMx.Text = pDatosCalc(7).ToString
        End If

        If pDatosCalc(8).ToString = "Null" Then
            txtMy.Text = "0"
        Else
            txtMy.Text = pDatosCalc(8).ToString
        End If

        'txtRpm.Text = calculos.prop_rpm.ToString()
        If pDatosCalc(9).ToString = "Null" Then
            txtRpm.Text = "0"
        Else
            txtRpm.Text = pDatosCalc(9).ToString
        End If

        'PROBLEMA CON EL DRIVER, NO INTERPRETA EL 0,
        Dim VALORORDEN As String = pDatosCalc(10).ToString
        If VALORORDEN.StartsWith(",") Then
            VALORORDEN = "0" & VALORORDEN
        End If
        comboNumOrden.Value = VALORORDEN


        If pDatosCalc(11).ToString = "Null" Then
            txtVelMin.Text = "0"
        Else
            txtVelMin.Text = pDatosCalc(11).ToString
        End If

        If pDatosCalc(12).ToString = "Null" Then
            txtVelMax.Text = "0"
        Else
            txtVelMax.Text = pDatosCalc(12).ToString
        End If

        If pDatosCalc(13).ToString = "Null" Then
            txtNMaquinas.Text = "1"
        Else
            txtNMaquinas.Text = pDatosCalc(13).ToString
        End If

        txtGiro0X.Text = pCalculo.prop_giroOx.ToString() & " º"
        txtGiro0Y.Text = pCalculo.prop_giroOy.ToString() & " º"
        txtFleche.Text = pCalculo.prop_fleche.ToString()
        txtFrecProp.Text = pCalculo.prop_frecProp.ToString() & " Hz"
        txtAislamiento.Text = pCalculo.prop_aislamiento.ToString() & " %"
        txtRatio.Text = pCalculo.prop_ratio.ToString() & " %"

        txtGiro0X.Style("text-align") = "center"
        txtGiro0Y.Style("text-align") = "center"
        txtFleche.Style("text-align") = "center"
        txtFrecProp.Style("text-align") = "center"
        txtAislamiento.Style("text-align") = "center"
        txtRatio.Style("text-align") = "center"
    End Sub
    Protected Sub cargarDatosPagina()
        Dim vProyecto As New AMC_Proyectos_pkg.CProyectos()
        vProyecto = Session("proyecto")
        Dim vRevision As OracleNumber = GestionaRevisionCalc()
        CARGAR_CALCULO(vProyecto.prop_cod, vRevision)
    End Sub
    Private Sub GESTIONA_GRAFICOS(ByVal pCalculo As CCalculos)
        Dim haycentros As Boolean = False
        Dim hayapoyos As Boolean = False
        If txtXCDG.Text = "0" And txtYCDG.Text = "0" And txtPCDG.Text = "0" Then
            haycentros = False
        Else
            haycentros = True
        End If
        If pCalculo.prop_apoyos.Count = 0 Then
            'btn_crearPedidoLogin.Enabled = False
            btnImprimir.Enabled = False
            hayapoyos = False
        Else
            'btn_crearPedidoLogin.Enabled = True
            btnImprimir.Enabled = True
            hayapoyos = True
        End If

        Dim vMostrarGraficos As Boolean = False
        If pCalculo.prop_carga_sn = "S" Then
            vMostrarGraficos = (hayapoyos = True) 'Si son cargas, con que tenga apoyos suficiente.
        ElseIf pCalculo.prop_carga_sn = "N" Then
            vMostrarGraficos = (hayapoyos = True And haycentros = True) 'Si son coordenadas, tiene que tener apoyos y centros.
        End If
        If Not vMostrarGraficos Then
            ImageGraf.Visible = False
            ZedGraphWeb1.Visible = False
            ZedGraphWeb2.Visible = False
            GridView2.Visible = False

            labelGrafs.Visible = True
            div_labelGrafs.Visible = True
            btn_enviarEmail.Visible = False
            btnImprimir.Visible = False

            'esto es porque a dar a calcular va a servicios.aspx y se genera el pdf para mandar por email y si no hay centros o apoyos casca.
            Session("generar_informe") = False
        Else
            If pCalculo.prop_carga_sn = "N" Then
                ImageGraf.Visible = True
            End If
            ZedGraphWeb1.Visible = True
            ZedGraphWeb2.Visible = True
            GridView2.Visible = True

            labelGrafs.Visible = False
            div_labelGrafs.Visible = False
            btn_enviarEmail.Visible = True
            btnImprimir.Visible = True

            'esto es porque a dar a calcular va a servicios.aspx y se genera el pdf para mandar por email y si no hay centros o apoyos casca.
            Session("generar_informe") = True
        End If
    End Sub
    Protected Sub GridView2_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowDataBound
        'no borrar este evento, tiene que estar
    End Sub
    Protected Sub btnEditarApoyos_Click(sender As Object, e As System.EventArgs) Handles btnEditarApoyos.Click
        'cargarDatosPagina()
        Response.Redirect("editarApoyosMaster.aspx")
    End Sub
    Protected Sub Page_LoadComplete(sender As Object, e As System.EventArgs) Handles Me.LoadComplete
        Session("GridView") = GVApoyos
        div_lblerror.Visible = False
    End Sub

    Protected Sub btnCrearOferta_Click(sender As Object, e As EventArgs) Handles btnCrearOferta.Click
        Dim cli As New BCb2b.ggclipr()
        cli = Session("cliente")

        'Obtenemos el codigo del calculo actual
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")
        Dim rev_actual As String = Session("RevisionSel")
        Dim datosRev As ArrayList = miCalculo.DameDatosRev(miProyecto.prop_cod, rev_actual)
        Dim idestudio As OracleNumber = datosRev(0)

        Dim lineasAux As New List(Of BCb2b.COferta_linOff)
        Dim cabecera As New BCb2b.COferta_Cab()
        If txtSerieOfe.Text = "" And txtNOfe.Text = "" Then
            'SI NO TIENE OFERTA ASOCIADA ES QUE ES OFER NUEVA Y CARGAMOS LAS LINEAS DE LOS APOYOS Y VAMOS A CREAR OFE

            Dim age As New BCb2b.gvagente()
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'svt ing
                Dim usuario As New BCb2b.CUsrnom(Session("usuario").prop_cod)
                age = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                'age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
            ElseIf perfiles.prop_TIPO_PERFIL = 1 Then 'dis y age
                If Session("perfil_usuario") = "DIS" Then
                    age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                Else
                    Dim usuario As New BCb2b.CUsrnom(Session("usuario").prop_cod)
                    age = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                End If
            End If

            Session("agente") = age


            'AMC_NE203. Agrupar apoyos iguales.
            Dim apoyos As New CCalculos.apoyo()
            lineasAux = apoyos.obtener_apoyos_agrupados(miCalculo.prop_iddistribucion_number, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("serieOferta"), cli.prop_COD, age, Session("idioma"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"), ConfigurationManager.AppSettings("OBPZ"))
            'FIN AMC_NE203. Agrupar apoyos iguales.

            '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
            Dim param As New BCb2b.CParametros()
            Dim valor_param_fp As String = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
            '-----------------------------------------------

            cabecera = New BCb2b.COferta_Cab(cli, ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("serieOferta"), _
              ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), _
              ConfigurationManager.AppSettings("historico_sn"), age.prop_COD, "", "", cli.prop_RSOCDIR_ENV, "", valor_param_fp, "")
        Else
            'SI TIENE OFERTA ASOCIADA CARGAMOS LA CABECERA Y VAMOS A CREAR OFE
            cabecera = New BCb2b.COferta_Cab(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), txtSerieOfe.Text, CInt(txtNOfe.Text))


            Dim oferaux As New BCb2b.COferta_linOff()
            lineasAux = oferaux.lista_lineas_modificar_proy(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), cabecera.prop_serie, cabecera.prop_N_OFE, idestudio)
        End If

        Dim listado_calculos As New ArrayList
        listado_calculos.Add(miCalculo)

        cabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
        Session("cabecera") = cabecera
        Session("lineasOferta") = lineasAux
        Response.Redirect("~/CrearOferta.aspx")
    End Sub

    Protected Sub lnkVerOferta_Click(sender As Object, e As EventArgs) Handles lnkVerOferta.Click
        Session("N_OFE") = txtNOfe.Text
        Session("TIPO_OFE") = txtSerieOfe.Text
        Session("EMPRESA_OFE") = ConfigurationManager.AppSettings("empresa")
        Session("GRUPO_OFE") = ConfigurationManager.AppSettings("grupo")
        Response.Redirect("~/OfertaDetalle.aspx")
    End Sub

    Protected Sub lnk_recalc_apoyos_Click(sender As Object, e As EventArgs) Handles lnk_recalc_apoyos.Click
        Dim calculos_ori As New AMC_Proyectos_pkg.CCalculos()
        calculos_ori = Session("calculos")
        Dim calculos_dup As New AMC_Proyectos_pkg.CCalculos()

        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        'DUPLICO EL DE LA RIGIDEZ OBSOLETA EN UNO NUEVO
        Session("iddistribucion") = calculos_ori.prop_iddistribucion_number
        Dim iddistribucion As OracleNumber = Session("iddistribucion")
        calculos_dup.duplicarCalculo(calculos_ori.prop_iddistribucion, miProyecto.prop_cod, calculos_ori.prop_observaciones, CType(Now.Date, OracleDateTime), calculos_ori.PROP_unidadrev, False)

        'AL OBSOLETO LE PONEMOS " (ORIGINAL) " Y CON ESTADO "B" PARA DIFERENCIARLO DEL DUPLICADO (JON I)
        calculos_ori.modificar_datos_calculo(calculos_ori.prop_idestudio, calculos_ori.prop_iddistribucion, calculos_ori.prop_revision, calculos_ori.prop_fecha, calculos_ori.prop_observaciones & " (ORIGINAL)", calculos_ori.prop_carga_sn, calculos_ori.PROP_unidadrev, ConfigurationManager.AppSettings("GGESTADO_CALCULO_OCULTO"))

        '---------ASIGNAMOS USUARIO DE MODIFICACION AL CALCULO DUPLICADO. AMC_NE184------------
        Dim uti As New BCb2b.Utilities()
        Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
        calculos_dup.Gestiona_UsuResp_CreMod_Calculo(calculos_dup.prop_idestudio, calculos_dup.prop_iddistribucion, calculos_dup.prop_revision, cod_usuario.ToUpper)
        '---------FIN ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------

        Session("RevisionSel") = calculos_dup.prop_revision

        Server.Transfer("distribucion.aspx")
    End Sub

    Protected Sub btnReportCalculation_Click(sender As Object, e As EventArgs) Handles btnReportCalculation.Click
        Dim calc As New AMC_Proyectos_pkg.CCalculos()
        Try
            calc = Session("calculos")

            calc.GenerarGraficoSoportes(ConfigurationManager.AppSettings("grupo"), calc.prop_idestudio.ToString(), Session("idioma_spyro"), "COM", ConfigurationManager.AppSettings("rutaGraficosCalculos"))
            'calc.GenerarGraficosTransmisibilidad(ConfigurationManager.AppSettings("grupo"), calc.prop_idestudio.ToString(), Session("idioma_spyro"), "COM", ConfigurationManager.AppSettings("rutaGraficosCalculos"))

            AbrirModalReport(calc.prop_iddistribucion, Session("idioma"))
        Catch ex As Exception
            Log.Error(ex, "Error generando los Graficos para el calculo {@calculo}", calc)
        End Try
    End Sub
    Private Sub AbrirModalReport(codCalculo As String, idioma As String)
        Dim rutaAsistenteVibrationReport = ConfigurationManager.AppSettings("rutaAsistenteVibrationReport")

        Dim sb As New StringBuilder()
        sb.AppendLine("<script language='javascript' type='text/javascript'>")
        sb.AppendLine(String.Format("  window.open('{0}/{1}/{2}', 'MsgWindow', 'width=1000, height=800, location=no, menubar=no, status=no, toolbar=no, scrollbars=yes');", rutaAsistenteVibrationReport, codCalculo, idioma))
        sb.AppendLine("</script>")
        ClientScript.RegisterStartupScript(Me.GetType(), "btnOpen", sb.ToString())
    End Sub

    Private Sub GESTIONA_SI_CARGAS_O_COORDENADAS(ByVal pSonCargasSN As String)
        'AMC_NE263. JCE. 28/10/2016. Modificaciones a cálculo cuando son cargas.
        If pSonCargasSN = "S" Then
            ImageGraf.Visible = False 'ocultamos grafico de soportes.
            GridView2.CssClass = "gridviewFreqCargas" 'cambios estilo de tabla de frecuencias para que ocupe el ancho de los graficos.
            txtPCDG.Enabled = False
            txtXCDG.Enabled = False
            txtXCDG.Visible = False
            txtYCDG.Enabled = False
            txtYCDG.Visible = False
            Label12.Visible = False 'ocultamos los label tambien
            Label13.Visible = False
            Labelunidad1.Visible = False
            Labelunidad2.Visible = False
            btnCDG.Visible = False

            txt_Cargas.Text = CType(GetLocalResourceObject("TextoCarga.Text"), String)
            GVApoyos.Columns(4).Visible = False
            GVApoyos.Columns(5).Visible = False
            txtGiro0X.Text = "-"
            txtGiro0Y.Text = "-"
            txtFleche.Text = "-"
        ElseIf pSonCargasSN = "N" Then
            ImageGraf.Visible = True 'mostramos grafico de soportes.
            GridView2.CssClass = "gridviewFreq" 'cambios estilo de tabla de frecuencias para que ocupe el ancho de un grafico.
            txtPCDG.Enabled = True
            txtXCDG.Enabled = True
            txtXCDG.Visible = True
            txtYCDG.Enabled = True
            txtYCDG.Visible = True
            Label12.Visible = True 'mostramos los label tambien
            Label13.Visible = True
            Labelunidad1.Visible = True
            Labelunidad2.Visible = True
            btnCDG.Visible = True

            txt_Cargas.Text = CType(GetLocalResourceObject("TextoCoordenada.Text"), String)
            GVApoyos.Columns(4).Visible = True
            GVApoyos.Columns(5).Visible = True
        End If
    End Sub
    Private Sub GESTIONA_APOYOS(ByVal pCalculo As CCalculos)
        'Si puedo editar y no hay apoyos le mandamos a editarApoyosMaster.
        If pCalculo.prop_apoyos.Count <= 0 Then
            Response.Redirect("editarApoyosMaster.aspx")
            'Server.Transfer("editarApoyosMaster.aspx")
        Else
            'SI TIENE APOYOS, COMPROBAMOS SI SE HAN CAMBIADO SUS VALORES DE KZ (RADIO) DESDE QUE SE HIZO EL CALCULO.
            Dim se_ha_cambiado_rigidez As Boolean = False
            Dim calc As New CCalculos.operacionesCalculos()
            For Each apoyo As CCalculos.apoyo In pCalculo.prop_apoyos
                Dim valor_radio_apoyo As String = calc.OBTENER_RADIO_AAPOYO(pCalculo.prop_iddistribucion, apoyo.prop_idapoyo, apoyo.prop_idarticulo)
                Dim valor_radio_clasi As String = calc.RADIO(apoyo.prop_idarticulo, ConfigurationManager.AppSettings("grupo"))
                If valor_radio_apoyo <> "" And valor_radio_clasi <> "" Then
                    If FormatNumber(valor_radio_apoyo, 1) <> FormatNumber(valor_radio_clasi, 1) Then
                        se_ha_cambiado_rigidez = True
                    End If
                Else
                    se_ha_cambiado_rigidez = True
                End If
            Next

            'Y SI SE HA CAMBIADO, MOSTRAMOS UN MENSAJE EN PANTALLA CON OPCION A RECALCULAR.
            If se_ha_cambiado_rigidez Then
                If Session("editarNOeditar") = False Or TIENE_OFE() Then
                    div_lblRigidezRecalculo.Visible = False
                Else
                    div_lblRigidezRecalculo.Visible = True
                End If
            End If
        End If

        Session("Apoyos") = pCalculo.prop_apoyos
        GVApoyos.DataSource = pCalculo.prop_apoyos
        GVApoyos.DataBind()
    End Sub
    Private Sub GESTIONA_UNIDADES_CALC(ByVal pCalculo As CCalculos)
        Labelunidad1.Text = pCalculo.PROP_unidadrev
        Labelunidad2.Text = pCalculo.PROP_unidadrev

        Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(pCalculo.PROP_unidadrev)
        LabelunidadPeso1.Text = uni_calc.prop_peso
        Session("UnidadMedida") = pCalculo.PROP_unidadrev 'ESTA LINEA SOLO ES PARA QUE EN EL CDG APAREZCA EN LA MISMA UNIDAD
        Session("MostrarCargas") = pCalculo.prop_carga_sn

        GVApoyos.Columns(3).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource4.HeaderText"), String), "(N/mm)", "(" & uni_calc.prop_rigidez & ")")
        GVApoyos.Columns(4).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource5.HeaderText"), String), "(m)", "(" & pCalculo.PROP_unidadrev & ")")
        GVApoyos.Columns(5).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource6.HeaderText"), String), "(m)", "(" & pCalculo.PROP_unidadrev & ")")
        GVApoyos.Columns(6).HeaderText = Replace(CType(GetLocalResourceObject("BoundFieldResource7.HeaderText"), String), "(kg)", "(" & uni_calc.prop_peso & ")")

        'AMC_NE263. JCE. 28/10/2016. Modificaciones cuando el calculo son cargas.
        GESTIONA_SI_CARGAS_O_COORDENADAS(pCalculo.prop_carga_sn)

        GVApoyos.DataBind()
    End Sub
    Protected Sub btnImprimir_Click(sender As Object, e As EventArgs) Handles btnImprimir.Click
        cargarDatosPagina()

        Dim url As String = "servicios.aspx"
        Dim sc As String = " w = 800; "
        sc = sc & " h = 600; "
        sc = sc & " if (window.screen) { "
        sc = sc & " w = window.screen.availWidth; "
        sc = sc & " h = window.screen.availHeight; "
        sc = sc & "  }"
        sc = sc & " window.open('" & url & "','newwin','width='+w+',height='+h+',top=0,left=0,toolbar=no,location=0,status=no,titlebar=no,menubar=no');"

        ClientScript.RegisterStartupScript(Me.GetType(), "script", sc, True)
    End Sub
End Class


