﻿Imports System.Data.OracleClient
Imports AMC_Proyectos_pkg
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports BCb2b
Imports BCb2b.Metodos
Imports System.Web.Mail
Imports System.Diagnostics
Imports System.IO
Imports CTI.Utilities.Log
Partial Class editarApoyosMaster
    Inherits claseBase
    <Ajax.AjaxMethod()> _
    Public Function Comprobar_Si_Art_Tiene_Todo_Necesario(ByVal cod_Art As String, ByVal texto_faltan_clasis As String) As String
        cod_Art = cod_Art.ToUpper
        Dim mensaje_faltan As String = ""

        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        'COMPROBAMOS QUE TIENEN LAS SIGUIENTES CLASIS:
                        'CARGA
                        'D
                        'KZ
                        'KDYN
                        Dim clasi As New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), cod_Art, ConfigurationManager.AppSettings("CARGA"))
                        AÑADE_SI_NO_VALOR(mensaje_faltan, ConfigurationManager.AppSettings("CARGA"), clasi.prop_VALOR)
                        'LA D NO ES NECESARIO CONTROLAR PORQUE SINO TIENE VALOR COGE 0.05 POR DEFECTO Y LA MAYORIA NO LO TIENE.
                        'clasi = New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), cod_Art, "D")
                        'AÑADE_SI_NO_VALOR(mensaje_faltan, "D", clasi.prop_VALOR)
                        clasi = New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), cod_Art, ConfigurationManager.AppSettings("KZ"))
                        AÑADE_SI_NO_VALOR(mensaje_faltan, ConfigurationManager.AppSettings("KZ"), clasi.prop_VALOR)
                        clasi = New BCb2b.gaartclasi(ConfigurationManager.AppSettings("grupo"), cod_Art, ConfigurationManager.AppSettings("KDYN"))
                        AÑADE_SI_NO_VALOR(mensaje_faltan, ConfigurationManager.AppSettings("KDYN"), clasi.prop_VALOR)
                    End If
                End If
            Catch ex As Exception
                Log.Error(ex, "[editarApoyosMaster.Comprobar_Si_Art_Tiene_Todo_Necesario] art = {art}", cod_Art)
            End Try
        End If
        If mensaje_faltan <> "" Then
            texto_faltan_clasis = texto_faltan_clasis & " " & mensaje_faltan
        Else
            texto_faltan_clasis = ""
        End If
        Return texto_faltan_clasis
    End Function
    Private Sub AÑADE_SI_NO_VALOR(ByRef cadena As String, ByVal clasi As String, ByVal valor As String)
        If valor = "" Then
            If cadena <> "" Then
                cadena = cadena & ","
            End If
            cadena = cadena & clasi
        End If
    End Sub
    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArt(ByVal cod_Art As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        Return articulo_prueba.prop_descrip
                    Else
                        Return " "
                    End If
                Else
                    Return "Artículo no valido"
                End If

            Catch ex As Exception
                Log.Error(ex, "[editarApoyosMaster.Obtener_DescripArt] art = {art}", cod_Art)
                Return "Artículo no valido"
            End Try
        Else
            Return " "
        End If

    End Function
    <Ajax.AjaxMethod()> _
    Public Function ValidaCodigoArticulo(ByVal cod_Art As String) As String
        cod_Art = BCb2b.Utilities.LimpiarTexto(cod_Art)

        'cod_Art = Trim(cod_Art).ToUpper
        'cod_Art = Regex.Replace(cod_Art, "\t|\n|\r", "")
        'cod_Art = Trim(cod_Art).ToUpper

        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod = "" Then
                    Return "Invalid"
                Else
                    Return articulo_prueba.prop_cod
                End If

            Catch ex As Exception
                Log.Error(ex, "[editarApoyosMaster.ValidaCodigoArticulo] art = {art}", cod_Art)
                Return "Invalid"
            End Try
        Else
            Return ""
        End If

    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_DescripArtIdioma(ByVal cod_Art As String, ByVal vggobstip_cod As String, ByVal vcodigo_idioma As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, vcodigo_idioma)
                If dd <> "" Then
                    If (dd <> "Null") Then
                        Return dd
                    Else
                        Return articulo_prueba.prop_descrip
                    End If
                Else
                    Return "Invalid"
                End If

            Catch ex As Exception
                Log.Error(ex, "[editarApoyosMaster.Obtener_DescripArtIdioma] art = {art} obs_cod = {obs_cod} idioma = {idioma} ", cod_Art, vggobstip_cod, vcodigo_idioma)
                Return "Invalid"
            End Try
        Else
            Return " "
        End If

    End Function

    <Ajax.AjaxMethod()> _
    Public Function usuarioValido(ByVal usrnom As String, ByVal usrpass As String, ByVal Sesion_usuario As String) As String
        Dim Usuario As New BCb2b.CUsuarios(usrnom, _
                                           usrpass, _
                                           ConfigurationManager.AppSettings("grupo"), _
                                           ConfigurationManager.AppSettings("Venta"), _
                                           ConfigurationManager.AppSettings("usrnom"), _
                                           ConfigurationManager.AppSettings("usrpass"))
        If Not Usuario.es_vacio() Then
            If (Usuario.prop_LOGIN.CompareTo(Sesion_usuario) = 0) Then
                'If (Usuario.prop_LOGIN.CompareTo("CELMA") = 0) Then

                Return "S"
            Else
                Return "N"
            End If
        Else
            Return "N"
        End If
        Return "S"

    End Function
    <Ajax.AjaxMethod()> _
    Public Function transfiereme() As String
        ' Dado un codigo artículo calculo precios y descuentos para
        ' cantidad 1.
        'btn_crearPedido.Attributes.Add("onclick", "javascript:document.forms[0].target='_blank';")
        'Server.Transfer("verPedido.aspx")
        'btn_crearPedido.Attributes.Add("onclick", "javascript:document.forms[0].target='_self';")
        Return ""
    End Function


    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Obtener_RadioArt(ByVal idapoyo As String, ByVal cod_Art As String) As String
        ' Dado un codigo artículo calculo precios y descuentos para
        ' cantidad 1.

        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
            Try
                Dim calculo As New CCalculos.operacionesCalculos()

                miCalculo = Session("calculos")

                'YA NO OBTENEMOS DE LA CLASI SINO DEL APOYO
                'Dim radio_art As String = calculo.RADIO(cod_Art, ConfigurationManager.AppSettings("grupo"))
                Dim radio_art As String = calculo.OBTENER_RADIO_AAPOYO(miCalculo.prop_iddistribucion, CInt(idapoyo), cod_Art)
                If radio_art = "" Then
                    'SI ESTA INSERTANDO Y NO HAY VALOR PARA ESE APOYO LO COJO DE LA CLASI
                    radio_art = calculo.RADIO(cod_Art, ConfigurationManager.AppSettings("grupo"))
                End If

                If radio_art <> "" Then
                    'CONVERTIR UNIDADES
                    Dim uni_calc As New CUnidades_Calculos()
                    Dim uni_ori As String = uni_calc.DameUnidadCalculo(miCalculo.prop_iddistribucion, miCalculo.prop_idestudio)
                    Dim uni_calc_ori As New CUnidades_Calculos(uni_ori)
                    Dim uni_dest As String = uni_calc_ori.prop_uni_def
                    Dim uni_calc_dest As New CUnidades_Calculos(uni_dest)
                    Dim radio_dest As String = uni_calc_dest.prop_rigidez
                    Dim radio_ori As String = uni_calc_ori.prop_rigidez

                    uni_calc.ConvertirUnidad(radio_dest, radio_art, radio_ori)
                    Return radio_art
                Else
                    Return ""
                End If
            Catch ex As Exception
                Log.Error(ex, "[editarApoyosMaster.Obtener_RadioArt] art = {art} apoyo = {apoyo} calculo = {@calculo} ", cod_Art, idapoyo, miCalculo)
                Return ""
            End Try
        Else
            Return ""
        End If
    End Function

    Public Shared Sub ShowLupaClasificacion(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal iddistribucion As String, ByVal idestado As String, ByVal c1 As String, ByVal c2 As String, ByVal c3 As String)
        OpenPopUp(opener, "CDG.aspx?dist=" & iddistribucion & "&est=" & idestado & "&c1=" & c1 & "&c2=" & c2 & "&c3=" & c3, "LOV", 500, 450)
    End Sub
    Protected Sub SaveButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SaveButton.Click
        Dim kk As String = ""
        ' HFGuardado.Value = "True"



        'If Session("estoyGuardando") = True Then

        '    guardarCabecera()
        '    'Session("calculos") = miCalculo

        '    'Redirijimos a distribucion.
        '    Response.Redirect("distribucion.aspx")

        'End If

        Session("estoyGuardando") = True



        Mensaje("Data Saved!")

        InsertarResponsableModificacion()
        ' guardarCabecera()

        'Session("calculos") = miCalculo

        'Redirijimos a distribucion.

        'Response.Redirect("distribucion.aspx")

    End Sub

    Private iddistribucion As OracleNumber
    Public Property prop_iddistribucion() As OracleNumber
        Get
            Return Me.iddistribucion
        End Get
        Set(ByVal value As OracleNumber)
            Me.iddistribucion = value
            Session("iddistribucion") = value
        End Set
    End Property

    Private estoyGuardando As Boolean
    Public Property prop_estoyGuardando() As Boolean
        Get
            Return Me.estoyGuardando
        End Get
        Set(ByVal value As Boolean)
            Me.estoyGuardando = value
            Session("estoyGuardando") = value
        End Set
    End Property

    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(editarApoyosMaster))

        ShowLupaArticulo(IBarticuloInsertar, tbxCodigoArticulo, lbldescripcionARticulo, tbxradioarticulo)
        Response.Cache.SetCacheability(HttpCacheability.NoCache)

        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")

        Session("iddistribucion") = miCalculo.prop_iddistribucion

        SaveButton.Visible = True
        'If miCalculo.prop_total_apoyos.Count <= 0 Then
        'SaveButton.Visible = False
        'End If

        Labelunidad1.Text = miCalculo.PROP_unidadrev
        Labelunidad2.Text = miCalculo.PROP_unidadrev

        Session("UnidadMedida") = miCalculo.PROP_unidadrev

        If Not Page.IsPostBack Then



            txtFecha.Text = miCalculo.prop_fecha
            txtObservaciones.Text = miCalculo.prop_observaciones
            txtPCDG.Text = miCalculo.prop_pcdg
            txtXCDG.Text = miCalculo.prop_xcdg
            txtYCDG.Text = miCalculo.prop_ycdg

            comboNumOrden.Value = miCalculo.prop_idorden
            txtRpm.Text = miCalculo.prop_rpm
            txtVelMin.Text = miCalculo.prop_rpmmin
            txtVelMax.Text = miCalculo.prop_rpmmax
            txtMx.Text = miCalculo.prop_mx
            txtMy.Text = miCalculo.prop_my
            'txtNMaquinas.Text = miCalculo.PROP_n_maquinas
            'TLM 05/12/2016
            'Ajuste temporal. NO encuentra la propiedad n_maquinas. La pongo a 1 hasta generar la propiedad
            txtNMaquinas.Text = "1"
        End If

        Dim uni_calc As New AMC_Proyectos_pkg.CUnidades_Calculos(miCalculo.PROP_unidadrev)

        LabelunidadPeso1.Text = uni_calc.prop_peso
        lbln_revision.Text = miCalculo.prop_revision

        BulkEditGridView1.Columns(4).HeaderText = Replace(CType(GetLocalResourceObject("TemplateFieldResource5.HeaderText"), String), "(N/mm)", "(" & uni_calc.prop_rigidez & ")")
        BulkEditGridView1.Columns(5).HeaderText = Replace(CType(GetLocalResourceObject("TemplateFieldResource6.HeaderText"), String), "(m)", "(" & miCalculo.PROP_unidadrev & ")")
        BulkEditGridView1.Columns(6).HeaderText = Replace(CType(GetLocalResourceObject("TemplateFieldResource7.HeaderText"), String), "(m)", "(" & miCalculo.PROP_unidadrev & ")")
        BulkEditGridView1.Columns(7).HeaderText = Replace(CType(GetLocalResourceObject("TemplateFieldResource8.HeaderText"), String), "(kg)", "(" & uni_calc.prop_peso & ")")

        'metodos ajax
        ShowLupaClasificacion(Me.btnCDG, miCalculo.prop_iddistribucion, miCalculo.prop_idestudio, txtPCDG.ClientID, txtXCDG.ClientID, txtYCDG.ClientID)
        tbxCodigoArticulo.Attributes.Add("onBlur", "javascript:dame_xx('" & tboxNApoyo.ClientID & "','" + tbxCodigoArticulo.ClientID + "', '" + lbldescripcionARticulo.ClientID + "','" + tbxradioarticulo.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma_spyro") + "','" & GetLocalResourceObject("MsgNoExistArt") & "','" & GetLocalResourceObject("MsgFaltanClasisCalc") & "')")
        'Me.SetFocus(tboxCuantos.ClientID)
        tboxCuantos.Focus() ' jvc, ojo descomentalo luego comento esto!!!!!!!

        If Session("cliente") Is Nothing Then
            Response.Redirect("nohaycli.aspx")
        End If
        If Session("proyecto") Is Nothing Then
            Response.Redirect("lista_proyectos.aspx")
        End If

        'si son cargas no meten ni CDG ni pueden editar el PCDG porque deberia ser la suma de las cargas de los apoyos.
        If miCalculo.prop_carga_sn = "S" Then
            txtPCDG.Enabled = False
            txtXCDG.Enabled = False
            txtXCDG.Visible = False
            txtYCDG.Enabled = False
            txtYCDG.Visible = False
            Label12.Visible = False 'ocultamos los label tambien
            Label13.Visible = False
            Labelunidad1.Visible = False
            Labelunidad2.Visible = False
            btnCDG.Visible = False
        ElseIf miCalculo.prop_carga_sn = "N" Then
            txtPCDG.Enabled = True
            txtXCDG.Enabled = True
            txtXCDG.Visible = True
            txtYCDG.Enabled = True
            txtYCDG.Visible = True
            Label12.Visible = True 'mostramos los label tambien
            Label13.Visible = True
            Labelunidad1.Visible = True
            Labelunidad2.Visible = True
            btnCDG.Visible = True
        End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        txtNMaquinas.Enabled = True
        txtNMaquinas.Visible = True
        Label26.Visible = True
        If perfiles.prop_TIPO_PERFIL = 2 Then 'cliente
            txtNMaquinas.Enabled = False
            txtNMaquinas.Visible = False
            Label26.Visible = False
        End If

        Session("PaginaActual") = "editarApoyos"
    End Sub

    Private Sub actualizarCabecera(ByVal iddistribucion As String, ByVal ggestcampa_cod As OracleNumber, _
                               ByVal txtPCDG As OracleNumber, ByVal txtXCDG As OracleNumber, ByVal txtYCDG As OracleNumber, _
                               ByVal txtMx As OracleNumber, ByVal txtMy As OracleNumber, ByVal txtRpm As OracleNumber, _
                               ByVal comboNumOrden As OracleNumber, ByVal revision As OracleNumber, ByVal txtFecha As Date, _
                               ByVal txtObservaciones As String, ByVal carga As String, ByVal txtVelMin As OracleNumber, _
                               ByVal txtVelMax As OracleNumber, ByVal nMaquinas As OracleNumber)
        Dim proyecto As New CProyectos

        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")

        Try
            proyecto.actualizar_Cabecera(iddistribucion, ggestcampa_cod, txtPCDG, txtXCDG, txtYCDG, txtMx, _
                                                txtMy, txtRpm, comboNumOrden, revision, txtFecha, txtObservaciones, _
                                                carga, txtVelMin, txtVelMax, nMaquinas)
        Catch ex As Exception
            Log.Error(ex, "[editarApoyosMaster.actualizarCabecera]  calculo = {calculo} proyecto = {proyecto} pcdg = {pcdg} xcdg = {xcdg} ycdg = {ycdg} mx = {mx} my = {my} rpm = {rpm} n_orden = {n_orden} rev = {rev} fecha = {fecha} obs = {obs} v_carga = {v_carga} vel_min = {vel_min} vel_max = {vel_max} n_maq ={n_maq} ", iddistribucion, ggestcampa_cod, txtPCDG, txtXCDG, txtYCDG, txtMx, txtMy, txtRpm, comboNumOrden, revision, txtFecha, txtObservaciones, carga, txtVelMin, txtVelMax, nMaquinas)
        End Try


    End Sub
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.WebControl, ByVal art_desControl As System.Web.UI.WebControls.WebControl, ByVal art_radioControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & art_desControl.ClientID & "&textbox3=" & art_radioControl.ClientID, "LOV", 600, 600)
    End Sub

    Protected Sub BulkEditGridView1_RowCreated(sender As Object, e As GridViewRowEventArgs) Handles BulkEditGridView1.RowCreated

    End Sub

    Protected Sub BulkEditGridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles BulkEditGridView1.RowDataBound

        If (e.Row.RowType = DataControlRowType.DataRow) Then

            Dim cargas As Boolean = False

            Dim tboxX As TextBox
            Dim tboxy As TextBox
            Dim tboxCarga As TextBox
            Dim tboxCodigoArt As TextBox
            Dim tboxDescripART As TextBox
            Dim tboxRadio_art As TextBox
            Dim lblborrar As IButtonControl
            Dim lblIdApoyo As System.Web.UI.WebControls.Label

            Dim lblDescripART As System.Web.UI.WebControls.Label
            Dim lblRadio_art As System.Web.UI.WebControls.Label

            Dim ibLupaArt As ImageButton

            tboxX = e.Row.FindControl("tboxX")
            tboxy = e.Row.FindControl("tboxY")
            tboxCarga = e.Row.FindControl("tboxCarga")
            tboxCodigoArt = e.Row.FindControl("tboxGaartCod")
            tboxDescripART = e.Row.FindControl("descrip_art")
            tboxRadio_art = e.Row.FindControl("tboxRadio_art")

            lblDescripART = e.Row.FindControl("lbldescrip_art")
            lblRadio_art = e.Row.FindControl("lblRadio_art")

            ibLupaArt = e.Row.FindControl("IBarticulo")

            lblborrar = e.Row.FindControl("lbBorrar")

            lblIdApoyo = e.Row.FindControl("lblIdApoyo")

            cargas = (Session("calculos").prop_carga_sn = "S")
            If cargas Then
                tboxX.Enabled = False
                tboxy.Enabled = False
                tboxCarga.Enabled = True


                BulkEditGridView1.Columns(5).Visible = False ' x e y no visibles
                BulkEditGridView1.Columns(6).Visible = False ' x e y no visibles
                BulkEditGridView1.Columns(7).Visible = True  ' cargas  visibles

            Else
                tboxX.Enabled = True
                tboxy.Enabled = True
                tboxCarga.Enabled = False

                BulkEditGridView1.Columns(5).Visible = True ' x e y  visibles
                BulkEditGridView1.Columns(6).Visible = True ' x e y  visibles
                BulkEditGridView1.Columns(7).Visible = False  ' cargas no visibles

            End If

            'Datos del artículo:
            Dim EMPRESAGRUPO As String = ConfigurationManager.AppSettings("Grupo")
            Dim clasifCargas As String = ConfigurationManager.AppSettings("KZ")
            Dim obstip_articulo_idiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
            Dim IDIOMA As String = Session("idioma")
            Dim cargamax As String = ConfigurationManager.AppSettings("ggclatip_carga_max")


            Dim p_com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

            If tboxCodigoArt.Text <> "" Then
                Dim ART As New BCb2b.gaart(EMPRESAGRUPO, tboxCodigoArt.Text)
                Dim descripcionArtIdioma As String
                descripcionArtIdioma = ART.descripcion_idiomas(p_com, Session("idioma_spyro"))
                If descripcionArtIdioma = "" Then
                    descripcionArtIdioma = ART.prop_DESCRIP
                End If
                tboxDescripART.Text = descripcionArtIdioma
                lblDescripART.Text = descripcionArtIdioma


                'YA NO COGEMOS EL VALOR DEL RADIO DE LA CLASIFICACION SINO DE LA COLUMNA RADIO DE AAPOYOS
                'Dim vRadio As String = New CCalculos.operacionesCalculos().RADIO(tboxCodigoArt.Text, EMPRESAGRUPO)
                'tboxRadio_art.Text = vRadio
                'lblRadio_art.Text = vRadio

                Dim vAmortig As String = New CCalculos.operacionesCalculos().AMORTIGUACION(tboxCodigoArt.Text, EMPRESAGRUPO)

            Else
                tboxDescripART.Text = ""
                lblDescripART.Text = ""
                tboxRadio_art.Text = ""
                lblRadio_art.Text = ""
            End If

            'fin datos del artículo
            'PONEMOS AJAX 
            tboxCodigoArt.Attributes.Add("onkeypress", "javascript: return disableEnterKey(event);")

            'SI DEJAMOS CAMBIAR LA K ES ESTA LIN
            tboxCodigoArt.Attributes.Add("onblur", "javascript:dame_xx('" & lblIdApoyo.ClientID & "','" + tboxCodigoArt.ClientID + "', '" + lblDescripART.ClientID + "','" + lblRadio_art.ClientID + "','" + tboxRadio_art.ClientID + "','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma_spyro") + "','" & GetLocalResourceObject("MsgNoExistArt") & "','" & GetLocalResourceObject("MsgFaltanClasisCalc") & "')")

            'tboxCodigoArt.Attributes.Add("onblur", "javascript:dame_xx('" & lblIdApoyo.ClientID & "','" + tboxCodigoArt.ClientID + "', '" + lblDescripART.ClientID + "','" + lblRadio_art.ClientID + "','','" + ConfigurationManager.AppSettings("obstip_articulo_idiomas") + "','" + Session("idioma") + "','" & GetLocalResourceObject("MsgNoExistArt") & "','" & GetLocalResourceObject("MsgNoRadio") & "')")

            'lblborrar.Attributes.Add("onclick", "javascript:return " & CType(GetLocalResourceObject("Preg_elim.Text"), String) & " " & e.Row.RowIndex + 1 & "?')")

            ShowLupaArticulo(ibLupaArt, tboxCodigoArt, lblDescripART, lblRadio_art)



        End If
    End Sub

    Protected Sub BulkEditGridView1_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles BulkEditGridView1.RowCommand
        'Dim DesigCode As String = GridView1.Rows(e.RowIndex).Cells(1).Text
        '1. salvo y luego borro, a ver...
        BulkEditGridView1.Save()
        If e.CommandName = "Borrar" Then
            Dim miApoyo As New AMC_Proyectos_pkg.CCalculos.apoyo
            Dim numeroApoyo As Integer = e.CommandArgument

            Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
            misCalculos = Session("calculos")

            miApoyo.eliminar_apoyos(misCalculos.prop_iddistribucion, numeroApoyo, misCalculos)

            Dim grupo As String = ConfigurationManager.AppSettings("grupo")
            Dim idioma As String = Session("idioma")
            Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")


            misCalculos.setApoyos(miApoyo.cargar_apoyos(misCalculos.prop_iddistribucion, grupo, misCalculos.prop_idestudio, misCalculos.prop_revision, idioma, com))
            Session("Calculos") = misCalculos

            BulkEditGridView1.DataBind()

        End If
    End Sub

    Protected Sub btnAnadirApoyos_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAnadirApoyos.Click
        Dim iddistribucion As OracleNumber = Session("iddistribucion").ToString
        Dim idapoyo As OracleNumber = OracleNumber.Null
        Dim idarticulo As String = ""
        Try
            Dim numeroApoyos As OracleNumber = tboxNApoyos.Text
            idarticulo = tbxCodigoArticulo.Text

            Dim x As String = "0"
            Dim y As String = "0"
            Dim carga As String = "0"
            Dim radio As String = "0"

            Dim i As Integer = 0
            For i = 0 To numeroApoyos - 1
                Dim apoyo As New AMC_Proyectos_pkg.CCalculos.apoyo()
                apoyo.introducir_apoyos(iddistribucion, idarticulo, x, y, carga, radio)
            Next

            BulkEditGridView1.DataBind()
        Catch ex As Exception
            Log.Error(ex, "[editarApoyosMaster.btnAnadirApoyos_Click] iddistri = {iddistri} apoyo = {apoyo} art = {art} ", iddistribucion, idapoyo, idarticulo)
        End Try


    End Sub

    Public Class NumericComparer
        Implements IComparer
        Dim mText As Boolean = False
        Public Sub New(ByRef sorttype As NumericSort)
            mText = sorttype
        End Sub

        Public Enum NumericSort
            Textual = True
            Numerical = False
        End Enum

        ' Compare the two employees.
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
        Implements System.Collections.IComparer.Compare
            If mText = False Then
                Dim txtx As Double = CDbl(x)
                Dim txty As Double = CDbl(y)
                Select Case True
                    Case txtx < txty : Return -1
                    Case txtx = txty : Return 0
                    Case txtx > txty : Return 1
                End Select
            Else
                Dim txtx As String = CStr(x)
                Dim txty As String = CStr(y)
                Return String.Compare(txtx, txty)
            End If
            Return False
        End Function
    End Class


    Public Sub guardarCabecera()
        Dim miCalculo As New AMC_Proyectos_pkg.CCalculos()
        miCalculo = Session("calculos")
        Dim revision As OracleNumber
        Dim ddlRevisiones As TextBox
        ddlRevisiones = Master.Master.FindControl("ContentPlaceHolder1").FindControl("num_revision")
        If Not ddlRevisiones Is Nothing Then
            revision = ddlRevisiones.Text
        End If

        Dim grupo As String = ConfigurationManager.AppSettings("grupo")
        Dim idioma As String = Session("idioma")
        Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")

        Dim miApoyo As New AMC_Proyectos_pkg.CCalculos.apoyo
        Dim listado_apoyos As New ArrayList
        listado_apoyos = miApoyo.cargar_apoyos(miCalculo.prop_iddistribucion, grupo, miCalculo.prop_idestudio, miCalculo.prop_revision, idioma, com)

        'JCE. 22/11/2016. Si son cargas, no se permite meter ni centros ni pcdg,xcda,ycda. por lo tanto el pcdg es la suma de las cargas introducidas en los apoyos.
        If miCalculo.prop_carga_sn = "S" Then
            txtPCDG.Text = ObtenerPesoTotalApoyos(listado_apoyos)
        End If

        miCalculo.setApoyos(listado_apoyos)

        actualizarCabecera(StringToOracleNumber(miCalculo.prop_iddistribucion), StringToOracleNumber(miCalculo.prop_idestudio), StringToOracleNumber(txtPCDG.Text), _
                                    StringToOracleNumber(txtXCDG.Text), StringToOracleNumber(txtYCDG.Text), StringToOracleNumber(txtMx.Text), _
                                    StringToOracleNumber(txtMy.Text), StringToOracleNumber(txtRpm.Text), StringToOracleNumber(comboNumOrden.Value), _
                                    StringToOracleNumber(revision), CDate(txtFecha.Text), txtObservaciones.Text, miCalculo.prop_carga_sn, StringToOracleNumber(txtVelMin.Text), StringToOracleNumber(txtVelMax.Text), StringToOracleNumber(txtNMaquinas.Text))

        Session("calculos") = miCalculo

        BulkEditGridView1.DataBind()
    End Sub
    Private Function ObtenerPesoTotalApoyos(ByVal listado_apoyos As ArrayList) As Double
        Dim peso_total As Double = 0
        For Each apoyo As CCalculos.apoyo In listado_apoyos
            peso_total += apoyo.prop_carga
        Next
        Return peso_total
    End Function
    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Ajax.Utility.RegisterTypeForAjax(GetType(editarApoyosMaster))

        InsertarResponsableModificacion()
        ' guardarCabecera()

        'Session("calculos") = miCalculo

        'Redirijimos a distribucion.

        If (BulkEditGridView1.Rows.Count() > 0) Then
            Dim miApoyo As New AMC_Proyectos_pkg.CCalculos.apoyo
            Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
            misCalculos = Session("calculos")
            miApoyo.eliminar_apoyos_vacios(misCalculos.prop_iddistribucion, misCalculos)

            Response.Redirect("distribucion.aspx")
        End If
    End Sub

    Protected Sub IBAdd_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles IBAdd.Click
        GuardarLineas(True)

        Dim numeroApoyos As OracleNumber = tboxCuantos.Text

        Dim iddistribucion As OracleNumber = Session("iddistribucion").ToString
        Dim idapoyo As OracleNumber = OracleNumber.Null
        Dim idarticulo As String = ""
        Dim x As String = "0"
        Dim y As String = "0"
        Dim carga As String = "0"
        Dim radio As String = "0"

        Dim i As Integer = 0
        Dim apoyo As New AMC_Proyectos_pkg.CCalculos.apoyo()
        For i = 0 To numeroApoyos - 1
            apoyo.introducir_apoyos(iddistribucion, idarticulo, x, y, carga, radio)
        Next

        Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
        misCalculos = Session("calculos")

        Dim grupo As String = ConfigurationManager.AppSettings("grupo")
        Dim idioma As String = Session("idioma")
        Dim com As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")


        misCalculos.setApoyos(apoyo.cargar_apoyos(misCalculos.prop_iddistribucion, grupo, misCalculos.prop_idestudio, misCalculos.prop_revision, idioma, com))
        Session("Calculos") = misCalculos

        SaveButton.Visible = True

        BulkEditGridView1.DataBind()

        tboxCuantos.Text = ""
    End Sub

    Protected Sub Page_SaveStateComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SaveStateComplete
        If (Page.IsPostBack And (Session("estoyGuardando") = "True")) Then
            guardarCabecera()
            If (BulkEditGridView1.Rows.Count() > 0) Then
                Dim miApoyo As New AMC_Proyectos_pkg.CCalculos.apoyo
                Dim misCalculos As New AMC_Proyectos_pkg.CCalculos()
                misCalculos = Session("calculos")
                miApoyo.eliminar_apoyos_vacios(misCalculos.prop_iddistribucion, misCalculos)

                Response.Redirect("distribucion.aspx")
            End If
        End If
    End Sub

    Protected Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload
        Session("estoyGuardando") = False
    End Sub

    Protected Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
        GuardarLineas(False)
    End Sub

    Protected Sub ImageButton3_Click(sender As Object, e As System.Web.UI.ImageClickEventArgs) Handles ImageButton3.Click
        GuardarLineas(True)
    End Sub

    Private Sub InsertarResponsableModificacion()
        Dim micalculo As New AMC_Proyectos_pkg.CCalculos()
        micalculo = Session("calculos")

           '---------ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
        Dim uti As New BCb2b.Utilities()
        Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
        micalculo.Gestiona_UsuResp_CreMod_Calculo(micalculo.prop_idestudio, micalculo.prop_iddistribucion, micalculo.prop_revision, cod_usuario.ToUpper)
        '---------FIN ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------ '---------FIN ASIGNAMOS USUARIO DE MODIFICACION. AMC_NE184------------
    End Sub
    Private Sub GuardarLineas(ByVal pInsertarResponsable As Boolean)
        lblGuardando.Visible = True
        lblGuardando.Text = Now()
        BulkEditGridView1.Save()
        guardarCabecera()
        If pInsertarResponsable Then
            InsertarResponsableModificacion()
        End If
    End Sub
End Class
