﻿Imports System.Data.OracleClient
Imports BCb2b

Partial Class proyecto
    Inherits claseBase

    Private ggestcampa_cod As String
    Private descrip As String
    Private f_desde As Date
    Private f_hasta As Date
    Private responsable As String
    Private contacto As String
    Private nom_cli As String
    Private cod_cli As String


    Public ReadOnly Property PROP_ggestcampa_cod() As String
        Get
            Return Me.ggestcampa_cod
        End Get
    End Property
    Public ReadOnly Property PROP_descrip() As String
        Get
            Return Me.descrip
        End Get
    End Property
    Public ReadOnly Property PROP_responsable() As String
        Get
            Return Me.responsable
        End Get
    End Property
    Public ReadOnly Property PROP_contacto() As String
        Get
            Return Me.contacto
        End Get
    End Property
    Public ReadOnly Property PROP_f_desde() As Date
        Get
            Return Me.f_desde
        End Get
    End Property
    Public ReadOnly Property PROP_f_hasta() As String
        Get
            Return Me.f_hasta
        End Get
    End Property
    Public ReadOnly Property PROP_nom_cli() As String
        Get
            Return Me.nom_cli
        End Get
    End Property
    Public ReadOnly Property PROP_cod_cli() As String
        Get
            Return Me.cod_cli
        End Get
    End Property

    Public Shared Sub ShowCalendar(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_series.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&cod_agen=" & cod_agen, "LOV", 450, 450)

    End Sub

    Public Shared Sub ShowCalendar_traza(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal tboxOrigen As System.Web.UI.WebControls.WebControl, ByVal tip As System.Web.UI.WebControls.WebControl, ByVal tboxTipo As System.Web.UI.WebControls.WebControl, ByVal cod_agen As String, ByVal codigo_cliente As String)

        Dim kk As New System.Web.UI.WebControls.DropDownList
        kk = CType(tip, System.Web.UI.WebControls.DropDownList)
        Dim valor_tip As String = kk.SelectedValue

        OpenPopUp(opener, "lov_documento.aspx?textbox=" & tboxOrigen.ClientID & "&textbox2=" & valor_tip & "&tbtipo=" & tboxTipo.ClientID & "&cod_agen=" & cod_agen & "&cod_cli=" & codigo_cliente, "LOV", 450, 650)

    End Sub

    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Page.Form.DefaultFocus = filtrarLista.ClientID
        Page.Form.DefaultButton = filtrarLista.UniqueID

        'JVC.12062012.NOTA: Comprobamos que el cliente existe, si  está a null ponemos la variable de session a nothing para
        'que no dé el casque que está dando hasta ahora.


        If Not Page.IsPostBack Then
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            'Dim grupo, empresa As String

            Dim cod_agen0 As String
            Dim cod_idioma As String
            Dim cod_usuario As String
            Dim cod_cliente As String
            Dim cod_vdasp As String
            Dim tipo_usuario As String

            cod_vdasp = Trim(Request.Form("vdasp"))

            'se esta recargando esta página
            Dim cliente As New BCb2b.ggclipr()
            If Not Session("cliente") Is Nothing Then
                cliente = Session("cliente")
                cod_cliente = cliente.prop_COD
            Else
                cod_cliente = ""
            End If
            bsc_Cliente.Text = cod_cliente

            'Viene del formulario ASP
            If cod_vdasp = "1" Then
                cod_agen0 = Trim(Request.Form("agente"))
                cod_idioma = Trim(Request.Form("idioma"))
                cod_usuario = Trim(Request.Form("usuario"))
                cod_cliente = Trim(Request.Form("cliente"))
                tipo_usuario = Trim(Request.Form("tipousuario"))

                ' Session("idioma") = ConfigurationManager.AppSettings(cod_idioma)
                Session("idioma") = cod_idioma
                Session("tipo_usuario") = tipo_usuario
                Session("perfil_usuario") = tipo_usuario

                Dim usuario As New BCb2b.CUsrnom(cod_usuario)
                Session("Usuario") = usuario
                Session("UsuarioB2B") = usuario
                Session("Empresa") = New BCb2b.Cempresa(ConfigurationManager.AppSettings("EMPRESA"))
                perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
                If perfiles.prop_TIPO_PERFIL = 1 Then 'AG y DIS
                    'Session("Usuario") = cod_usuario
                    Session("CodAgente") = cod_agen0
                    'If (Session("tipo_usuario") = "AG" Or Session("tipo_usuario") = "DIS") Then
                    Dim agente As BCb2b.gvagente = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                    Session("agente") = agente
                    If (Session("CodAgente") = "") Then
                        Response.Redirect("~/Expirado.aspx")
                    End If
                Else
                    Session("agente") = Nothing
                    Session("CodAgente") = ""
                End If


            Else


                Dim idioma As String = Session("idioma")
                'cod_agen0 = Trim(Request.Form("agente"))
                cod_idioma = idioma
                'cod_usuario = Trim(Request.Form("usuario"))

                Try


                Catch ex As Exception
                    perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
                    If perfiles.prop_TIPO_PERFIL <> 0 Then '<> ING y SVT
                        Response.Redirect("~/Expirado.aspx")
                    End If

                    'If Session("tipo_usuario") <> ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then
                    '    Server.Transfer("nohaycli.aspx")
                    'End If
                End Try

            End If
            'SI EL USUARIO NO ES ADMINISTRADOR, SI EL COD_CLIENTE ES "" QUE MUESTRE LA VENTANA DE NOHAYCLI.ASPX

            cabeceraCliente.Visible = False
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL <> 0 Then '<> ING y SVT
                lblCodCli.Text = cliente.prop_NOMBRE
                lblPoblacion.Text = cliente.PROP_DIR_social.PROP_POBLAC_NOM
                lblTelefono.Text = cliente.PROP_DIR_social.PROP_TELEFONOS
                lblFax.Text = cliente.PROP_DIR_social.PROP_TELEFAX
                'ImgBTCli.Visible = False

                perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
                If perfiles.prop_TIPO_PERFIL = 2 Then 'CLIENTE
                    cabeceraCliente.Visible = True
                    bsc_Cliente.Enabled = False
                    IBcliente.Visible = False
                    ImgBTCli.Visible = False
                End If

                If (cliente.prop_COD <> "") Then
                    Session("cliente") = cliente
                Else
                    Session("CLIENTE") = Nothing
                End If
            End If

            Dim respuesta As String
            Dim lista_proyectos As New ArrayList
            lista_proyectos.Clear()

            If bsc_Cliente.Text <> "" Then
                Try
                    GridView2.VirtualItemCount = GetRowCount()
                    BindPagingGrid()

                Catch escep As Exception
                    respuesta = escep.Message()
                    lblError.Text = respuesta
                End Try
            End If



            'esta linea es para mostrar el boton de nueva revision o no. solo se tiene que ver en calculos.
            Session("EstoyEnCalculos") = False

            ShowLupaClientes(IBcliente, bsc_Cliente)

            CARGAR_CLASIFICACIONES()
        End If
    End Sub

    Public Shared Sub ShowLupaClientes(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal cliControl As System.Web.UI.WebControls.WebControl)
        OpenPopUp(opener, "lov_clientes.aspx?textbox=" & cliControl.ClientID, "LOV", 400, 600)
    End Sub
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub



    Protected Sub GridView2_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles GridView2.PageIndexChanging
        'If bsc_Cliente.Text <> "" Then
        Dim respuesta As String
        Dim lista_proyectos As New ArrayList
        lista_proyectos.Clear()

        Dim grupo, empresa, venta As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")
        venta = ConfigurationManager.AppSettings("Venta")

        'ESTO SIRVE PARA SABER SI LOS CLIS QUE HA METIDO EN LA CAJA PERTENECEN AL AGENTE QUE SE A LOGUEADO, SOLO MOSTRARIA LOS QUE SON SUYOS EN CASO DE ERROR
        Dim spliter As String = ","
        Dim tablaClis() As String = bsc_Cliente.Text.Split(spliter)
        Dim listaClisAceptada As String = ""

        Dim Items As New ArrayList
        Dim cliente As New BCb2b.ggclipr
        Dim CONNAUX As New OracleConnection(ConfigurationManager.AppSettings("Conexion_b2b"))

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL = 1 Then 'AG y DIS
            'If Session("tipo_usuario") = "AG" Or Session("tipo_usuario") = "DIS" Then
            Items = cliente.listado_Clientes(CONNAUX, ConfigurationManager.AppSettings("grupo"), "", "", "", "A", ConfigurationManager.AppSettings("venta"), Metodos.StringToOracleNumber(Session("CodAgente")))
        ElseIf perfiles.prop_TIPO_PERFIL = 0 Then
            Items = cliente.listado_Clientes(CONNAUX, ConfigurationManager.AppSettings("grupo"), "", "", "", "T", ConfigurationManager.AppSettings("venta"), Metodos.StringToOracleNumber(Session("CodAgente")))
        End If

        If bsc_Cliente.Text.Contains(",") = False And bsc_Cliente.Text <> "" Then
            Dim cli As New BCb2b.ggclipr(bsc_Cliente.Text, grupo, venta)
            Session("cliente") = cli
        ElseIf bsc_Cliente.Text.Contains(",") = True And bsc_Cliente.Text <> "" Then


            Dim i As Integer = 0
            Dim k As Integer = 0
            For i = 0 To tablaClis.Length - 1
                For k = 0 To Items.Count - 1
                    Dim cli As New BCb2b.ggclipr
                    cli = Items(k)
                    If cli.prop_COD = tablaClis(i) And IsNumeric(tablaClis(i)) = True Then
                        listaClisAceptada = listaClisAceptada & tablaClis(i) & ","
                    End If
                Next k

            Next i
            If listaClisAceptada <> "" Then
                listaClisAceptada = Mid(listaClisAceptada, 1, listaClisAceptada.Length - 1)
            End If

            bsc_Cliente.Text = listaClisAceptada
        End If



        Try
            GridView2.PageIndex = e.NewPageIndex
            GridView2.VirtualItemCount = GetRowCount()
            BindPagingGrid()

        Catch escep As Exception
            respuesta = escep.Message()
        Finally


        End Try


    End Sub

    Protected Sub GridView2_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView2.RowDataBound
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            Dim lbBorrar As ImageButton = e.Row.FindControl("lbBorrar")

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ING y SVT
                'If Session("tipo_usuario") = ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then
                lbBorrar.Attributes.Add("onclick", "javascript:return " & "confirm('" & CType(GetLocalResourceObject("EliminarProy.Text"), String) & " " & DataBinder.Eval(e.Row.DataItem, "prop_cod") + "?')")
            Else
                If e.Row.Cells(3).Text = ConfigurationManager.AppSettings("USUARIO_WEB") Then
                    lbBorrar.Attributes.Add("onclick", "javascript:return " & "confirm('" & CType(GetLocalResourceObject("EliminarProy.Text"), String) & " " & DataBinder.Eval(e.Row.DataItem, "prop_cod") + "?')")
                Else
                    lbBorrar.Visible = False
                End If
            End If

            If perfiles.prop_TIPO_PERFIL <> 0 Then '<> ing y svt
                GridView2.Columns(8).Visible = False 'elim
            End If
        End If
    End Sub

    Protected Sub GridView2_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles GridView2.RowDeleting
        Dim fila As GridViewRow
        fila = GridView2.Rows(e.RowIndex)
        Dim mifila As Integer = fila.RowIndex.ToString

        Dim Pkey As DataKeyArray = GridView2.DataKeys

        'Dim cod_proyecto As String = GridView2.Rows(mifila).Cells(1).Text

        Dim cod_proyecto As String = Pkey.Item(mifila).Item(0) 'codigo de proy

        AMC_Proyectos_pkg.CProyectos.cambiar_estado_proy(cod_proyecto, ConfigurationManager.AppSettings("GGESTADO_PROY_OCULTO"))

        Dim respuesta As String
        Dim lista_proyectos As New ArrayList
        lista_proyectos.Clear()

        Dim grupo, empresa As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")

        Try
            BindPagingGrid()
        Catch escep As Exception
            respuesta = escep.Message()

        End Try

    End Sub

    Protected Sub GridView2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView2.SelectedIndexChanged
        Try
            Dim fila As GridViewRow
            fila = GridView2.SelectedRow

            Dim grupo As String = ConfigurationManager.AppSettings("Grupo")

            Dim Pkey As DataKeyArray = GridView2.DataKeys

            Dim ggestcampa_cod As String = Pkey.Item(GridView2.SelectedIndex).Item(0)
            Dim descripcion As String = Pkey.Item(GridView2.SelectedIndex).Item(1)
            Dim responsable As String = Pkey.Item(GridView2.SelectedIndex).Item(2)
            If responsable = ConfigurationManager.AppSettings("USUARIO_WEB") Then
                Session("EsProyectoWeb") = "S"
            Else
                Session("EsProyectoWeb") = "N"
            End If
            Dim contacto As String = Pkey.Item(GridView2.SelectedIndex).Item(3)
            Dim f_desde As String = Pkey.Item(GridView2.SelectedIndex).Item(4)
            '  Dim f_hasta As String = fila.Cells(6).Text
            Dim nom_cli As String = Pkey.Item(GridView2.SelectedIndex).Item(5)
            Dim cod_cli As String = Pkey.Item(GridView2.SelectedIndex).Item(6)

            Dim cli As New BCb2b.ggclipr(cod_cli, grupo, "V")
            Session("cliente") = cli
            Session("idioma") = ConfigurationManager.AppSettings(cli.prop_IDIOMAS_COD) 'Cambiamos el idioma de la navegación al idioma del cliente asociado al proyecto seleccionado.
            Session("idioma_spyro") = cli.prop_IDIOMAS_COD

            Me.ggestcampa_cod = ggestcampa_cod
            Me.descrip = descripcion
            Me.f_desde = f_desde
            Me.f_hasta = f_hasta
            Me.responsable = responsable
            Me.contacto = contacto
            Me.nom_cli = nom_cli
            Me.cod_cli = cod_cli
            'Me.ggestado_cod = estado


            Dim proyect = New AMC_Proyectos_pkg.CProyectos(grupo, ggestcampa_cod)
            Session("proyecto") = proyect

            Dim editarNOeditar As Boolean = AMC_Proyectos_pkg.CProyectos.dame_responsable_bd(ggestcampa_cod, ConfigurationManager.AppSettings("USUARIO_WEB"), Session("tipo_usuario"), ConfigurationManager.AppSettings("TIP_ROL_INGENIERO"))

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                editarNOeditar = True
            End If

            Session("editarNOeditar") = editarNOeditar


            Session("RevisionSel") = ""
            lblError.Visible = True

            lblError.Text = cli.prop_COD & "::::" & proyect.prop_cod
            Server.Transfer("Clasificaciones.aspx")
            'Response.Redirect("Clasificaciones.aspx")
        Catch ex As Exception
            lblError.Visible = True
            lblError.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub btnNuevoProy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnNuevoProy.Click


        Session("proyecto") = New AMC_Proyectos_pkg.CProyectos()

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL = 0 Then 'ING y SVT
            'If Session("tipo_usuario") = ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then
            Session("cliente") = New BCb2b.ggclipr()
        Else

            ' Dim codigoCli As OracleNumber = Metodos.StringToOracleNumber(bsc_Cliente.Text)
            ' If (Not codigoCli = OracleNumber.Null) Then
            Dim cliente As New BCb2b.ggclipr(bsc_Cliente.Text, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
            Session("cliente") = cliente
            'End If
            End If

            Server.Transfer("nuevo_proyectoWizard.aspx")
    End Sub

    Protected Sub FiltrarListaProys_OnClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles filtrarLista.Click


        'If bsc_Cliente.Text <> "" Then
        Dim respuesta As String
        Dim lista_proyectos As New ArrayList
        lista_proyectos.Clear()

        Dim grupo, empresa, venta As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")
        venta = ConfigurationManager.AppSettings("Venta")

        'ESTO SIRVE PARA SABER SI LOS CLIS QUE HA METIDO EN LA CAJA PERTENECEN AL AGENTE QUE SE A LOGUEADO, SOLO MOSTRARIA LOS QUE SON SUYOS EN CASO DE ERROR
        Dim spliter As String = ","
        Dim tablaClis() As String = bsc_Cliente.Text.Split(spliter)
        Dim listaClisAceptada As String = ""
        Dim listaCliRechazada As String = ""

        Dim Items As New ArrayList
        Dim cliente As New BCb2b.ggclipr
        Dim CONNAUX As New OracleConnection(ConfigurationManager.AppSettings("Conexion_b2b"))

        'ESTO ESTABA DESCOMENTADO Y LOS ITEMS YA NO SE USAN,  YA QUE LO DE ABAJO ESTA COMENTADO
        'If Session("tipo_usuario") = "AG" Or Session("tipo_usuario") = "DIS" Then
        '    Items = cliente.listado_Clientes(CONNAUX, ConfigurationManager.AppSettings("grupo"), "", "", "", "A", ConfigurationManager.AppSettings("venta"), AMC_Proyectos_pkg.Metodos.StringToOracleNumber(Session("CodAgente")))
        'ElseIf Session("tipo_usuario") = ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then
        '    Items = cliente.listado_Clientes(CONNAUX, ConfigurationManager.AppSettings("grupo"), "", "", "", "T", ConfigurationManager.AppSettings("venta"), AMC_Proyectos_pkg.Metodos.StringToOracleNumber(Session("CodAgente")))
        'End If

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL <> 2 Then 'CL
            'If Session("tipo_usuario") <> "CL" Then
            Session("CLIENTE") = Nothing
            'PARA QUE QUIERO ESTO.

            'bsc_Cliente.Text = bsc_Cliente.Text & ","
            'If bsc_Cliente.Text.Contains(",") = False And bsc_Cliente.Text <> "" And IsNumeric(bsc_Cliente.Text) Then
            '    'y si el cliente NO LE PERTENECE QUE??? JAJAS???
            '    Dim cli As New BCb2b.ggclipr(bsc_Cliente.Text, grupo, venta)
            '    Session("cliente") = cli
            'ElseIf bsc_Cliente.Text.Contains(",") = False And bsc_Cliente.Text <> "" And IsNumeric(bsc_Cliente.Text) = False Then
            '    bsc_Cliente.Text = ""
            'ElseIf bsc_Cliente.Text.Contains(",") = True And bsc_Cliente.Text <> "" Then


            '    Dim i As Integer = 0
            '    Dim k As Integer = 0
            '    For i = 0 To tablaClis.Length - 1
            '        Dim hay As Boolean = False
            '        For k = 0 To Items.Count - 1
            '            Dim cli As New BCb2b.ggclipr
            '            cli = Items(k)
            '            If cli.prop_COD = tablaClis(i) And IsNumeric(tablaClis(i)) = True Then
            '                listaClisAceptada = listaClisAceptada & tablaClis(i) & ","
            '                hay = True
            '                Exit For
            '            End If
            '        Next k
            '        If Not hay Then
            '            listaCliRechazada = listaCliRechazada & tablaClis(i) & ","
            '        End If
            '    Next i

            '    If listaClisAceptada <> "" Then
            '        listaClisAceptada = Mid(listaClisAceptada, 1, listaClisAceptada.Length - 1)
            '    End If

            '    'If listaCliRechazada.Trim <> "" Then
            '    '    listaCliRechazada = Mid(listaCliRechazada, 1, listaCliRechazada.Length - 1) ' JVC. INTENTADO ÑAPEAR ESTO.
            '    '    lblClienteInvalido.Text = listaCliRechazada
            '    '    lblClienteInvalidoTit.Visible = True
            '    'End If

            '    bsc_Cliente.Text = listaClisAceptada
            'End If
        End If
        Try
            GridView2.PageIndex = 0
            GridView2.VirtualItemCount = GetRowCount()
            BindPagingGrid()

            If perfiles.prop_TIPO_PERFIL = 0 Then 'ING y SVT
                'If Session("tipo_usuario") = ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then

                GridView2.PageIndex = 0
                GridView2.VirtualItemCount = GetRowCount()
                BindPagingGrid()
            Else
                lista_proyectos.Clear()
            End If
        Catch escep As Exception
            respuesta = escep.Message()
        Finally

        End Try




    End Sub
    Private Function OBTENER_FILTRO_CLASIS() As ArrayList
        Dim lista_filtro_clasi As New ArrayList
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi1"), ddl_marcamotor.SelectedValue)
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi2"), ddl_modelmotor.SelectedValue)
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi3"), ddl_num_cilind.SelectedValue)
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi4"), ddl_combustibl.SelectedValue)
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi5"), ddl_tipmaquina.SelectedValue)
        GUARDA_FILTRO_CLASI(lista_filtro_clasi, ConfigurationManager.AppSettings("posclasi6"), ddl_modmaquina.SelectedValue)

        If lista_filtro_clasi.Count > 0 Then
            'si tiene filtros cambiamos imagen del filtro.
            btnFiltroAvanz.Attributes.Add("style", "float: right;background: url(../Content/images/delete-filter.png) no-repeat;background-color:lightgray;width: 115px;text-align: right;")
        Else
            'sino, dejamos el original.
            btnFiltroAvanz.Attributes.Add("style", "float: right;background: url(../Content/images/filter.png) no-repeat;background-color:lightgray;width: 115px;text-align: right;")
        End If

        Return lista_filtro_clasi
    End Function
    Private Sub GUARDA_FILTRO_CLASI(ByRef lista As ArrayList, ByVal ggclatipCod As String, ByVal ggclasifCod As String)
        If ggclasifCod <> "" Then
            lista.Add(New AMC_Proyectos_pkg.CProyectos.Ggcampaclasi("", ConfigurationManager.AppSettings("venta"), ggclatipCod, ggclasifCod, "", "", "", "", ""))
        End If
    End Sub
    Private Function GetRowCount() As Integer
        Dim cod_cliente As String = bsc_Cliente.Text
        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL = 2 Then 'CLI
            'If Session("tipo_usuario") = "CL" Then
            If bsc_Cliente.Text = "" Then
                Dim cliente As New BCb2b.ggclipr
                cliente = New BCb2b.ggclipr()
                cliente = Session("cliente")
                If Not (cliente Is Nothing) Then
                    cod_cliente = cliente.prop_COD
                    bsc_Cliente.Text = cod_cliente
                End If
            End If
        End If


        Dim grupo, empresa As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")

        Dim lista_filtro As New ArrayList
        lista_filtro = OBTENER_FILTRO_CLASIS()

        Return AMC_Proyectos_pkg.CProyectos.dame_cuantos_proyectos_filtrada(cod_cliente, grupo, empresa, bsc_codproy.Text, bsc_descripproy.Text, bsc_responsable.Text, bsc_contacto.Text, bsc_FechaDesde.Text, bsc_FechaHasta.Text, Session("CodAgente"), perfiles.prop_TIPO_PERFIL, lista_filtro)
    End Function

    Protected Sub GridView2_Sorting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewSortEventArgs) Handles GridView2.Sorting

        BindPagingGrid()
    End Sub
    Private Sub BindPagingGrid()

        GridView2.DataSource = GetDataPage(GridView2.PageIndex, GridView2.PageSize, GridView2.OrderBy)
        GridView2.DataBind()

    End Sub
    Private Function GetDataPage(ByVal pageIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String) As ArrayList

        Dim cod_cliente As String = bsc_Cliente.Text

        Dim grupo As String = ConfigurationManager.AppSettings("Grupo")
        Dim empresa As String = ConfigurationManager.AppSettings("Empresa")

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

        Dim lista_filtro As New ArrayList
        lista_filtro = OBTENER_FILTRO_CLASIS()

        Dim lista As New ArrayList
        lista = AMC_Proyectos_pkg.CProyectos.dame_lista_proyectos_filtrada_paginada(cod_cliente, grupo, empresa, bsc_codproy.Text, bsc_descripproy.Text, bsc_responsable.Text, bsc_contacto.Text, bsc_FechaDesde.Text, bsc_FechaHasta.Text, ((GridView2.PageIndex) * GridView2.PageSize) + 1, ((GridView2.PageIndex + 1) * GridView2.PageSize), Session("CodAgente"), perfiles.prop_TIPO_PERFIL, lista_filtro, ConfigurationManager.AppSettings("PROYANT"))

        Return lista
    End Function

    Protected Sub BorrarSeleccionProys_OnClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles borrarSeleccion.Click

        Dim perfiles As New BCb2b.USUARIOS_B2B()
        perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If perfiles.prop_TIPO_PERFIL <> 2 Then 'CLI
            'If Session("tipo_usuario") <> "CL" Then
            bsc_codproy.Text = ""
            Session("cliente") = Nothing 'JVC PONGO ESTO A NOTHING.
        End If

        bsc_descripproy.Text = ""
        bsc_responsable.Text = ""
        bsc_contacto.Text = ""
        bsc_FechaDesde.Text = ""
        bsc_FechaHasta.Text = ""

        If perfiles.prop_TIPO_PERFIL <> 2 Then 'CL
            'If Session("tipo_usuario") <> "CL" Then
            bsc_Cliente.Text = ""
            lblCodCli.Text = ""
            lblPoblacion.Text = ""
            lblTelefono.Text = ""
            lblFax.Text = ""
            GridView2.DataSource = Nothing
            GridView2.DataBind()


        Else


            Dim grupo As String = ConfigurationManager.AppSettings("Grupo")
            Dim empresa As String = ConfigurationManager.AppSettings("Empresa")


            Dim respuesta As String
            Dim lista_proyectos As New ArrayList
            lista_proyectos.Clear()

            Try
                GridView2.PageIndex = 0
                GridView2.VirtualItemCount = GetRowCount()
                BindPagingGrid()
            Catch escep As Exception
                respuesta = escep.Message()
                lblError.Text = respuesta
            End Try
        End If


    End Sub

    Protected Sub ImgBTCli_Click(sender As Object, e As ImageClickEventArgs) Handles ImgBTCli.Click
        bsc_Cliente.Text = ""
    End Sub

    Protected Sub IBTFDesde_Click(sender As Object, e As ImageClickEventArgs) Handles IBTFDesde.Click
        bsc_FechaDesde.Text = ""
    End Sub

    Protected Sub IBTFHasta_Click(sender As Object, e As ImageClickEventArgs) Handles IBTFHasta.Click
        bsc_FechaHasta.Text = ""
    End Sub

    Private Sub CARGAR_CLASIFICACIONES()
        Dim tipVc As String = ConfigurationManager.AppSettings("venta")

        Dim clasi_marcamotor As String = ConfigurationManager.AppSettings("posclasi1")
        Dim clasi_modelmotor As String = ConfigurationManager.AppSettings("posclasi2")
        Dim clasi_num_cilind As String = ConfigurationManager.AppSettings("posclasi3")
        Dim clasi_combustibl As String = ConfigurationManager.AppSettings("posclasi4")
        Dim clasi_tipmaquina As String = ConfigurationManager.AppSettings("posclasi5")
        Dim clasi_modmaquina As String = ConfigurationManager.AppSettings("posclasi6")

        traducir_clatip_proy(tipVc, lbl_marcamotor, lbl_marcamotor_obs, clasi_marcamotor, Session("idioma_spyro"))
        traducir_clatip_proy(tipVc, lbl_modelmotor, lbl_modelmotor_obs, clasi_modelmotor, Session("idioma_spyro"))
        traducir_clatip_proy(tipVc, lbl_num_cilind, lbl_num_cilind_obs, clasi_num_cilind, Session("idioma_spyro"))
        traducir_clatip_proy(tipVc, lbl_combustibl, lbl_combustibl_obs, clasi_combustibl, Session("idioma_spyro"))
        traducir_clatip_proy(tipVc, lbl_tipmaquina, lbl_tipmaquina_obs, clasi_tipmaquina, Session("idioma_spyro"))
        traducir_clatip_proy(tipVc, lbl_modmaquina, lbl_modmaquina_obs, clasi_modmaquina, Session("idioma_spyro"))

        ddl_marcamotor.DataSource = getValores(tipVc, clasi_marcamotor)
        'ddl_modelmotor.DataSource = getValores(tipVc, clasi_modelmotor) 'NO CARGAR DE INICIO, HAY MUCHOS
        ddl_modelmotor.Enabled = False
        'ddl_modelmotor.BackColor = Drawing.Color.LightGray

        ddl_num_cilind.DataSource = getValores(tipVc, clasi_num_cilind)
        ddl_combustibl.DataSource = getValores(tipVc, clasi_combustibl)
        ddl_tipmaquina.DataSource = getValores(tipVc, clasi_tipmaquina)
        ' ddl_modmaquina.DataSource = getValores(tipVc, clasi_modmaquina) 'NO CARGAR DE INICIO, HAY MUCHOS
        ddl_modmaquina.Enabled = False
        'ddl_modmaquina.BackColor = Drawing.Color.LightGray

        configureDllClasi(ddl_marcamotor)
        'configureDllClasi(ddl_modelmotor)
        configureDllClasi(ddl_num_cilind)
        configureDllClasi(ddl_combustibl)
        configureDllClasi(ddl_tipmaquina)
        'configureDllClasi(ddl_modmaquina)
    End Sub
    Private Sub traducir_clatip_proy(ByVal tipVc As String, ByVal lbldescrip As Label, ByVal lblobser As Label, ByVal ggclatipCod As String, ByVal idioma As String)
        Dim descrip, obser As String
        descrip = ""
        obser = ""
        AMC_Proyectos_pkg.CProyectos.Ggcampaclasi.traducir_ggclatip_proy(tipVc, ggclatipCod, idioma, descrip, obser)
        lbldescrip.Text = descrip
        lblobser.Text = obser
    End Sub
    Public Function getValores(ByVal tipVc As String, ByVal ggclatipCod As String, Optional ByVal ggclasifPad As String = "") As ArrayList
        Dim clasif As New BCb2b.CGGCLASIF()
        Dim resultado As New ArrayList
        Dim CLASIFdEFECTO As New BCb2b.CGGCLASIF("V", "", "", ConfigurationManager.AppSettings("seleccione"), "", "", "", "", "")
        resultado.Add(CLASIFdEFECTO)

        If ggclasifPad <> "" Then
            resultado.AddRange(clasif.listado_clasificaciones_todas_segun_padre(tipVc, ggclatipCod, "", "", "", "", ggclasifPad, "", Session("idioma_spyro")))
        Else
            resultado.AddRange(clasif.listado_clasificaciones_todas(tipVc, ggclatipCod, "", "", "", "", Session("idioma_spyro")))
        End If
        Return resultado
    End Function
    Private Sub configureDllClasi(ByVal ddl As DropDownList)
        ddl.DataTextField = "prop_DESCRIP"
        ddl.DataValueField = "prop_COD"
        ddl.DataBind()
    End Sub
    Protected Sub ddl_marcamotor_SelectedIndexChanged(sender As Object, e As EventArgs)
        'gestion padres hijos
        If ddl_marcamotor.SelectedValue <> "" Then
            ddl_modelmotor.DataSource = getValores(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("posclasi2"), ddl_marcamotor.SelectedValue)
            ddl_modelmotor.Enabled = True
        Else
            Dim resul As New ArrayList
            resul.Add(New BCb2b.CGGCLASIF("V", "", "", "", "", "", "", "", ""))
            ddl_modelmotor.DataSource = resul
            ddl_modelmotor.Enabled = False
        End If
        configureDllClasi(ddl_modelmotor)
    End Sub
    Protected Sub ddl_tipmaquina_SelectedIndexChanged(sender As Object, e As EventArgs)
        'gestion padres hijos
        If ddl_tipmaquina.SelectedValue <> "" Then
            ddl_modmaquina.DataSource = getValores(ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("posclasi6"), ddl_tipmaquina.SelectedValue)
            ddl_modmaquina.Enabled = True
        Else
            Dim resul As New ArrayList
            resul.Add(New BCb2b.CGGCLASIF("V", "", "", "", "", "", "", "", ""))
            ddl_modmaquina.DataSource = resul
            ddl_modmaquina.Enabled = False
        End If
        configureDllClasi(ddl_modmaquina)
    End Sub
End Class


