﻿Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration
Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports AMC_Proyectos_pkg
Imports System.Drawing.Imaging
Imports ZedGraph
Imports ZedGraph.Web
Imports System.Web.Mail
Imports BCb2b

Partial Class _servicios
    'Inherits System.Web.UI.Page
    Inherits claseBase

    Dim CR As New CrystalDecisions.CrystalReports.Engine.ReportDocument
    'Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
    '    Page.Theme = "amc"
    'End Sub
    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init

        lblError.Visible = False
        CR.Load(Server.MapPath("./informes/pedido.rpt"))


        'Código para cargar el report.
        Dim conn As New OracleConnection()
        Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
        conn.ConnectionString = conexion.cadena_conexion

        Try
            'obtengo las sqls
            Dim sql As String = DAMESQL()
            Dim sql_gridview As String = DAMESQL_GRIDVIEW()
            Dim sql_impu As String = DAMESQL_IMPU()

            'Código para cargar el report.
            Dim cmd As New OracleCommand(sql, conn)
            cmd.CommandText = sql
            cmd.CommandType = CommandType.Text
            conn.Open()

            'Dim objDS As Object
            'Dim objDA As OracleDataAdapter = New OracleDataAdapter(sql, conn)

            'objDS = New DataSet2()
            'objDA.Fill(objDS, "DataTable1")
            'CR.SetDataSource(objDS.Tables(0))


            Dim DatosDS As New DataSetPedido()
            Dim DatosDAC As New OracleDataAdapter(sql, conn)
            Dim DatosDAP As New OracleDataAdapter(sql_gridview, conn)
            Dim DatosDIM As New OracleDataAdapter(sql_impu, conn)

            DatosDAC.Fill(DatosDS.DataTablePedido)
            DatosDAP.Fill(DatosDS.DataTableGridView)
            DatosDIM.Fill(DatosDS.DataTableImpu)
            CR.SetDataSource(DatosDS)


            ' 'Configuramos del report viewer
            CrystalReportViewer1.ReportSource = CR
            CrystalReportViewer1.BestFitPage = True
            CrystalReportViewer1.CssFilename = "./default.css"
            CrystalReportViewer1.HasCrystalLogo = False
            CrystalReportViewer1.HasDrillUpButton = False
            CrystalReportViewer1.HasToggleGroupTreeButton = False
            ' CrystalReportViewer1.ToolbarImagesFolderUrl() = "../App_Themes/general/images/Toolbar/"
            CrystalReportViewer1.DisplayGroupTree = False
            CrystalReportViewer1.HasZoomFactorList = False

            CrystalReportViewer1.AutoDataBind = True

            CambiarIdiomaReport()

            '   Dim CrReport As New CrystalDecisions.CrystalReports.Engine.ReportDocument
            '   ' Asigno el reporte 
            '  CrReport = New CrystalDecisions.CrystalReports.Engine.ReportDocument()
            '  CrReport.Load(Server.MapPath("./CrystalReport.rpt"))
            ' CrReport.SetDataSource(objDS)

            ' CrystalReportViewer1.ReportSource = CrReport

            If Session("emailEnviado") = False Then

                Dim cliente As New BCb2b.ggclipr()
                cliente = Session("cliente")

                Try

                    Dim correo As String
                    correo = Metodos.dameMailCliente(cliente.prop_COD, ConfigurationManager.AppSettings("EMAILPED"), ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                    Dim fechaactual As String = DateTime.Now.ToString("yyyyMMdd_HHmmss")
                    If correo <> "" Then
                        Dim mailCliente As New System.Web.Mail.MailMessage()

                        SmtpMail.SmtpServer = ConfigurationManager.AppSettings("correoServidor") ' AMC 
                        With mailCliente
                            .From = ConfigurationManager.AppSettings("correoFrom")
                            .To = correo
                            .Priority = MailPriority.High ' Prioridades
                            .Subject = CType(GetLocalResourceObject("Asunto_Pedido_AMC.Text"), String)
                            .Body = CType(GetLocalResourceObject("Correo_Cuerpo.Text"), String)

                        End With

                        Dim adjuntoCliente As New MailAttachment(ConfigurationManager.AppSettings("rutaPDFmailPedido") & "_" & cliente.prop_COD & "_" & fechaactual & ".pdf", MailEncoding.UUEncode)
                        mailCliente.Attachments.Add(adjuntoCliente)

                        SmtpMail.Send(mailCliente) ' envia el mail
                    End If


                    Dim nom_agente As String
                    nom_agente = Metodos.dameNombreAgente(cliente.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"))

                    Dim mailEmpresa As New System.Web.Mail.MailMessage()

                    SmtpMail.SmtpServer = ConfigurationManager.AppSettings("correoServidor")
                    With mailEmpresa
                        .From = ConfigurationManager.AppSettings("correoFrom")
                        .To = ConfigurationManager.AppSettings("correo1")
                        .Cc = ConfigurationManager.AppSettings("correo2") & ";" & ConfigurationManager.AppSettings("correo3") & ";" & ConfigurationManager.AppSettings("correo4") & ";" & ConfigurationManager.AppSettings("correo5")
                        .Bcc = ConfigurationManager.AppSettings("correoOc")
                        .Priority = MailPriority.High ' Prioridades
                        .Subject = CType(GetLocalResourceObject("Asunto_Pedido_Cliente1.Text"), String) & cliente.prop_NOMBRE & "(" & cliente.prop_COD & ") " & CType(GetLocalResourceObject("Asunto_Pedido_Cliente2.Text"), String) & " " & nom_agente & "(" & cliente.prop_GVAGENTE_COD & ")"
                        .Body = CType(GetLocalResourceObject("Correo_Cuerpo.Text"), String)
                    End With


                    Dim adjuntoEmpresa As New MailAttachment(ConfigurationManager.AppSettings("rutaPDFmailPedido") & "_" & cliente.prop_COD & "_" & fechaactual & ".pdf", MailEncoding.UUEncode)
                    mailEmpresa.Attachments.Add(adjuntoEmpresa)

                    SmtpMail.Send(mailEmpresa) ' envia el mail
                    'Next i

                    Session("emailEnviado") = True

                Catch ex As Exception
                    'Throw New Exception("[Error enviando mail] " & ex.Message.ToString)
                    lblError.Visible = True
                    'lblError.Text = "[Error enviando mail] " & ex.Message.ToString
                    lblError.Text = CType(GetLocalResourceObject("Error_envMail.Text"), String) & " " & ex.Message.ToString
                End Try

            End If


        Catch ex As Exception
            lblError.Text = lblError.Text & ex.Message.ToString
            lblError.Visible = True
        End Try
    End Sub

    Private Sub CambiarIdiomaReport()
        'Idioma NÚMERO PEDIDO:
        Dim myTextObjectOnReport10 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport10 = CType(CR.ReportDefinition.ReportObjects.Item("Text10"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport10.Text = CType(GetLocalResourceObject("NPedido.Text"), String)

        'Idioma Fecha Pedido:
        Dim myTextObjectOnReport11 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport11 = CType(CR.ReportDefinition.ReportObjects.Item("Text11"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport11.Text = CType(GetLocalResourceObject("Fpedido.Text"), String)

        'Idioma Nombre:
        Dim myTextObjectOnReport8 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport8 = CType(CR.ReportDefinition.ReportObjects.Item("Text8"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport8.Text = CType(GetLocalResourceObject("Nombre.Text"), String)

        'Idioma Código:
        Dim myTextObjectOnReport12 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport12 = CType(CR.ReportDefinition.ReportObjects.Item("Text12"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport12.Text = CType(GetLocalResourceObject("Codigo.Text"), String)

        'Idioma Empresa Expeditora:
        Dim myTextObjectOnReport13 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport13 = CType(CR.ReportDefinition.ReportObjects.Item("Text13"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport13.Text = CType(GetLocalResourceObject("EmpresaExp.Text"), String)

        'Idioma Portes:
        Dim myTextObjectOnReport15 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport15 = CType(CR.ReportDefinition.ReportObjects.Item("Text15"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport15.Text = CType(GetLocalResourceObject("Portes.Text"), String)

        'Idioma Referencia del Cliente:
        Dim myTextObjectOnReport16 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport16 = CType(CR.ReportDefinition.ReportObjects.Item("Text16"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport16.Text = CType(GetLocalResourceObject("RefCliente.Text"), String)

        'Idioma Dirección de Envío:
        Dim myTextObjectOnReport17 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport17 = CType(CR.ReportDefinition.ReportObjects.Item("Text17"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport17.Text = CType(GetLocalResourceObject("DirEnvio.Text"), String)

        'Idioma Total Lineas:
        Dim myTextObjectOnReport32 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport32 = CType(CR.ReportDefinition.ReportObjects.Item("Text32"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport32.Text = CType(GetLocalResourceObject("TotLineas.Text"), String)

        'Idioma Total Descuentos:
        Dim myTextObjectOnReport31 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport31 = CType(CR.ReportDefinition.ReportObjects.Item("Text31"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport31.Text = CType(GetLocalResourceObject("TotDesc.Text"), String)

        'Idioma Caso Total Impuestos:
        Dim myTextObjectOnReport37 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport37 = CType(CR.ReportDefinition.ReportObjects.Item("Text37"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport37.Text = CType(GetLocalResourceObject("TotImpu.Text"), String)

        'Idioma TOTAL PEDIDO:
        Dim myTextObjectOnReport39 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReport39 = CType(CR.ReportDefinition.ReportObjects.Item("Text39"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReport39.Text = CType(GetLocalResourceObject("TotalPed.Text"), String)

        'Idioma CÓDIGO
        Dim myTextObjectOnReportC18 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC18 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text18"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC18.Text = CType(GetLocalResourceObject("GCodigo.Text"), String)

        'Idioma DESCRIPCIÓN
        Dim myTextObjectOnReportC19 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC19 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text19"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC19.Text = CType(GetLocalResourceObject("GDescrip.Text"), String)

        'Idioma PREVISTO
        Dim myTextObjectOnReportC26 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC26 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text26"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC26.Text = CType(GetLocalResourceObject("GPrevisto.Text"), String)

        'Idioma CANTIDAD
        Dim myTextObjectOnReportC27 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC27 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text27"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC27.Text = CType(GetLocalResourceObject("GCantidad.Text"), String)

        'Idioma DESCUENTO
        Dim myTextObjectOnReportC28 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC28 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text28"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC28.Text = CType(GetLocalResourceObject("GDescuento.Text"), String)

        'Idioma PRECIO UNIT.
        Dim myTextObjectOnReportC1 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC1 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text1"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC1.Text = CType(GetLocalResourceObject("GPrecioUnit.Text"), String)

        'Idioma TOTAL
        Dim myTextObjectOnReportC29 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportC29 = CType(CR.Subreports.Item(0).ReportDefinition.ReportObjects.Item("Text29"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportC29.Text = CType(GetLocalResourceObject("GTotal.Text"), String)

        'Idioma IMPUESTOS
        Dim myTextObjectOnReportCi38 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportCi38 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text38"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportCi38.Text = CType(GetLocalResourceObject("GImpu.Text"), String)

        'Idioma BASE IMP.
        Dim myTextObjectOnReportCi33 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportCi33 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text33"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportCi33.Text = CType(GetLocalResourceObject("GBaseImp.Text"), String)

        'Idioma % VALOR
        Dim myTextObjectOnReportCi34 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportCi34 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text34"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportCi34.Text = CType(GetLocalResourceObject("GValor.Text"), String)

        'Idioma IMPORTE
        Dim myTextObjectOnReportCi35 As CrystalDecisions.CrystalReports.Engine.TextObject
        myTextObjectOnReportCi35 = CType(CR.Subreports.Item(1).ReportDefinition.ReportObjects.Item("Text35"), CrystalDecisions.CrystalReports.Engine.TextObject)
        myTextObjectOnReportCi35.Text = CType(GetLocalResourceObject("GImporte.Text"), String)

    End Sub

    Protected Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload
        CR.Dispose()
    End Sub

    Protected Sub Page_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        CR.Dispose()
    End Sub

    Public Function DAMESQL() As String
        Dim resultado As String = ""
        Dim sql As String = ""

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = Session("RevisionSel").ToString

        Dim cabecera = Session("cabeceraPedido")
        '" N_PEDIDO ='" & cabecera.prop_N_PEDIDO & "' ) "

        sql = "  select " & _
" '" & cabecera.prop_N_PEDIDO & "' as n_pedido,  " & _
" '" & CDate(cabecera.prop_F_PED) & "' as fecha_pedido, " & _
" '" & miProyecto.prop_cod & "' as n_estudio,  " & _
" '" & cliente.PROP_DIR_ENVIO.PROP_DIR & "' as dir_envio,  " & _
" '" & cliente.PROP_DIR_ENVIO.PROP_POBLAC_NOM & "' as dir_envio_poblac,  " & _
" '" & cliente.PROP_DIR_ENVIO.PROP_PROVI_NOM & "' as dir_envio_provi,  " & _
" '" & cliente.PROP_DIR_ENVIO.PROP_PAISES_nom & "' as dir_envio_pais,  " & _
" '" & cliente.prop_COD & "' as cod_cli,  " & _
" '" & cliente.prop_NOMBRE & "' as nom_cli,  " & _
" '" & cliente.PROP_DIR_ENVIO.PROP_COD_POSTAL & "' as cod_postal,  " & _
" '" & Session("observacion") & "' AS OBSER_PEDIDO, " & _
" TOTAL_DESCUENTOS," & _
" CASE WHEN PORTES_PD = 'D' OR PORTES_PD = 'N' THEN 'incoterm EXW' ELSE 'incoterm CPT' END AS PORTES_PD,EMPRESA " & _
" from dual, " & _
" ( SELECT portes_pd,(SELECT descrip FROM(ggmenvio) WHERE  cod = ggmenvio_cod) AS empresa " & _
" FROM ggclipr WHERE cod = '" & cliente.prop_COD & "' AND tip_vc = '" & ConfigurationManager.AppSettings("venta") & "' AND empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "'),  (  select " & _
" NVL(sum(I_DTOREXT),0) AS TOTAL_DESCUENTOS " & _
" from ggpeddtoc where " & _
" EMPGRUPO_COD = '" & ConfigurationManager.AppSettings("grupo") & "' and " & _
" EMP_COD = '" & ConfigurationManager.AppSettings("empresa") & "' and  " & _
" TIP_VC = '" & ConfigurationManager.AppSettings("venta") & "' and " & _
" GGPEDTIP_COD= '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' and " & _
" N_PEDIDO = '" & cabecera.prop_N_PEDIDO & "'),(SELECT " & _
" NVL(SUM(I_IMPUEMP),0) AS TOTAL_IMPUESTOS FROM GGPEDIMPU WHERE " & _
" EMPGRUPO_COD= '" & ConfigurationManager.AppSettings("grupo") & "' AND EMP_COD='" & ConfigurationManager.AppSettings("empresa") & "' AND  " & _
" TIP_VC= '" & ConfigurationManager.AppSettings("venta") & "' AND " & _
" GGPEDTIP_COD=  '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' AND " & _
" N_PEDIDO ='" & cabecera.prop_N_PEDIDO & "' ) "



        Return sql
    End Function
    Public Function DAMESQL_GRIDVIEW() As String
        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = Session("RevisionSel").ToString
        Dim resultado As String = ""

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        Dim cabecera = Session("cabeceraPedido")

        Dim sql As String = ""

        '        sql = " SELECT gaart_cod AS gaart_cod, " & _
        '      " descrip AS gaart_descrip, " & _
        '      " c_uni1 AS cantidad, " & _
        '      " gaunitip_uni1 AS unidad, " & _
        '      " pr_precio AS precio_uni, " & _
        '      " i_dtorecgrl AS descuento, " & _
        '      " (c_uni1 * pr_precio) AS neto, " & _
        '      " f_entrprev AS fecha_entrega, " & _
        '      " '" & miProyecto.prop_cod & "' AS n_estudio, " & _
        '      " total_lineas " & _
        '" FROM ggpedlin, " & _
        '      " (SELECT SUM((c_uni1 * pr_precio)) AS total_lineas " & _
        '      " FROM   ggpedlin " & _
        '      " WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' " & _
        '      " AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' " & _
        '      " AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "' " & _
        '      " AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "') " & _
        '" WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' " & _
        '" AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' " & _
        '" AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "' " & _
        '" AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "'"

        Dim idioma As String = Session("idioma")

        'sql = " SELECT gaart_cod AS gaart_cod, "
        'sql = sql & " nvl(( SELECT descrip FROM GAARTDESCR "
        'sql = sql & " WHERE "
        'sql = sql & " EMPGRUPO_COD	 = ggpedlin.EMPGRUPO_COD AND  "
        'sql = sql & " GAART_COD	= ggpedlin.GAART_COD AND "
        'sql = sql & " GGOBSTIP_COD	= '" & ConfigurationManager.AppSettings("obstip_articulo_idiomas") & "' AND "
        'sql = sql & " IDIOMAS_COD = '" & idioma & "'	),descrip) AS gaart_descrip, "
        'sql = sql & " c_uni1 AS cantidad, "
        'sql = sql & " gaunitip_uni1 AS unidad, "
        'sql = sql & " pr_precio AS precio_uni, "
        'sql = sql & " i_dtorecgrl AS descuento, "
        'sql = sql & " (c_uni1 * pr_precio) AS neto, "
        'sql = sql & " f_entrprev AS fecha_entrega, "
        'sql = sql & " '" & miProyecto.prop_cod & "' AS n_estudio, "
        'sql = sql & " total_lineas "
        'sql = sql & " FROM ggpedlin, "
        'sql = sql & " (SELECT SUM((c_uni1 * pr_precio)) AS total_lineas "
        'sql = sql & " FROM   ggpedlin "
        'sql = sql & " WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' "
        'sql = sql & " AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' "
        'sql = sql & " AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "' "
        'sql = sql & " AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "') "
        'sql = sql & " WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' "
        'sql = sql & " AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' "
        'sql = sql & " AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "' "
        'sql = sql & " AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' "

        Dim total_descuentos As String = cabecera.LEE_DTOS_PIE()

        sql = " SELECT   gaart_cod AS gaart_cod, "
        sql = sql & " nvl((SELECT descrip "
        sql = sql & " FROM   gaartdescr "
        sql = sql & " WHERE  empgrupo_cod = g1.empgrupo_cod "
        sql = sql & " AND    gaart_cod = g1.gaart_cod "
        sql = sql & " AND    ggobstip_cod = '" & ConfigurationManager.AppSettings("obstip_articulo_idiomas") & "' "
        sql = sql & " AND    idiomas_cod = '" & idioma & "'), "
        sql = sql & " descrip) AS gaart_descrip, "
        sql = sql & " c_uni1 AS cantidad, "
        sql = sql & " gaunitip_uni1 AS unidad, "
        sql = sql & " pr_precio AS precio_uni, "
        sql = sql & " '" & total_descuentos & "' as total_descuentos, "
        sql = sql & " f_entrprev AS fecha_entrega, "
        sql = sql & " '" & miProyecto.prop_cod & "' AS n_estudio, "
        sql = sql & " i_netoext as neto, "
        sql = sql & " (SELECT sum(i_netoext) "
        sql = sql & " FROM     ggpedlin "
        sql = sql & " WHERE    empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' "
        sql = sql & " AND      emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' "
        sql = sql & " AND      n_pedido = '" & cabecera.prop_N_PEDIDO & "' "
        sql = sql & " AND      ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' "
        sql = sql & " AND      tip_vc = '" & ConfigurationManager.AppSettings("Venta") & "') as total_lineas, "
        sql = sql & " (SELECT dame_porcentaje_dto "
        sql = sql & " (g1.empgrupo_cod, "
        sql = sql & " g1.emp_cod, "
        sql = sql & " g1.tip_vc, "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " g1.ggpedtip_cod, "
        sql = sql & " g1.n_pedido, "
        sql = sql & " g1.n_lin, "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " g1.gaart_cod, "
        sql = sql & " g1.c_uni1, "
        sql = sql & " g1.c_uni2, "
        sql = sql & " g1.pr_precio, "
        sql = sql & " Null, "
        sql = sql & " g1.c_unipr, "
        sql = sql & " g1.gaunitip_uni1, "
        sql = sql & " g1.gaunitip_uni2, "
        sql = sql & " g1.gaunitip_pr, "
        sql = sql & " " & cliente.prop_COD & ", "
        sql = sql & " Null, "
        sql = sql & " g1.f_entrprev, "
        sql = sql & " '" & cabecera.prop_MONEDAS_COD & "', "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " Null, "
        sql = sql & " 'S') "
        sql = sql & " FROM   ggpedlin "
        sql = sql & " WHERE  empgrupo_cod = g1.empgrupo_cod "
        sql = sql & " AND    emp_cod = g1.emp_cod "
        sql = sql & " AND    n_pedido = g1.n_pedido "
        sql = sql & " AND    ggpedtip_cod = g1.ggpedtip_cod "
        sql = sql & " AND    tip_vc = g1.tip_vc "
        sql = sql & " AND    n_lin = g1.n_lin) AS descuento "
        sql = sql & " FROM     ggpedlin g1 "
        sql = sql & " WHERE    empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' "
        sql = sql & " AND      emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' "
        sql = sql & " AND      n_pedido = '" & cabecera.prop_N_PEDIDO & "' "
        sql = sql & " AND      ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' "
        sql = sql & " AND      tip_vc = '" & ConfigurationManager.AppSettings("Venta") & "' "
        sql = sql & " ORDER BY n_lin "


        Return sql
    End Function
    Public Function DAMESQL_IMPU() As String
        Dim miProyecto As AMC_Proyectos_pkg.CProyectos
        miProyecto = New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim revision As String = Session("RevisionSel").ToString
        Dim resultado As String = ""

        Dim cliente As New BCb2b.ggclipr()
        cliente = Session("cliente")

        Dim cabecera = Session("cabeceraPedido")

        Dim sql As String = ""

        sql = " SELECT(SELECT distinct descrip " & _
             " FROM   cfivatimpu " & _
             " WHERE  cod = CFIVATIMPU_COD) AS impu_descrip, " & _
             " i_basemp, " & _
             " pj_impu, " & _
             " i_impuemp, " & _
      " total_impuestos " & _
       " FROM   ggpedimpu,(SELECT sum(i_impuemp) as total_impuestos " & _
       " FROM   ggpedimpu " & _
       " WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' " & _
       " AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' " & _
       " AND    tip_vc = '" & ConfigurationManager.AppSettings("venta") & "' " & _
       " AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' " & _
       " AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "') " & _
       " WHERE  empgrupo_cod = '" & ConfigurationManager.AppSettings("grupo") & "' " & _
       " AND    emp_cod = '" & ConfigurationManager.AppSettings("empresa") & "' " & _
       " AND    tip_vc = '" & ConfigurationManager.AppSettings("venta") & "' " & _
       " AND    ggpedtip_cod = '" & ConfigurationManager.AppSettings("Tipo_Pedido") & "' " & _
       " AND    n_pedido = '" & cabecera.prop_N_PEDIDO & "' "

        Return sql
    End Function
End Class
