﻿Imports AMC_Proyectos_pkg
Imports System.Data.OracleClient
Imports ZedGraph
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports ZedGraph.Web
Imports System.Web.Mail
Imports System.Diagnostics
Imports System.IO
Imports BCb2b.Metodos
Imports CTI.Utilities.Log
Partial Class ver_revisiones

    Inherits claseBase
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(ver_revisiones))

        'HABILITAMOS LOS MENSAJES MODALES
        Dim mensaje As New BCb2b.Utilities
        mensaje.HabilitarModalMessages(Me, GetGlobalResourceObject("general", "MsgModalBtnAceptar"))
        mensaje.CrearModalConfirm(Me, "BorrarCalculos", GetGlobalResourceObject("general", "MsgModalBtnConfirm"), GetLocalResourceObject("EliminarCalculsQ"), GetGlobalResourceObject("general", "MsgModalBtnYes"), GetGlobalResourceObject("general", "MsgModalBtnNo"))

        'btn_enviarMail.Attributes.Add("onclick", "CrearLovAUrl('PopupEmail.aspx', '.envio_mail', '#container_lov', '1', '', '', '', '', 750, 450, 'MAIL');")
        'Para ver si el email ha ido bien o no.
        If (Request.QueryString("l") <> "") Then


            If (Request.QueryString("l") = 0) Then
                'lblEnviadoEmail.Text = GetLocalResourceObject("lblEnviadoEmailOK")
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnCorrecto") & "','" & GetLocalResourceObject("lblEnviadoEmailOK") & "','ok','',300);", True)
            Else
                'lblEnviadoEmail.Text = GetLocalResourceObject("lblEnviadoEmailErr")
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & GetLocalResourceObject("lblEnviadoEmailErr") & "','err_red','',300);", True)
            End If
        Else
            'lblEnviadoEmail.Text = ""
        End If

        If Not Page.IsPostBack Then
            Dim calculo As New CCalculos()
            Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
            miProyecto = Session("proyecto")
            Dim lista_calculos As New ArrayList
            Try
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), False)
                GridView1.DataSource = lista_calculos
                GridView1.DataBind()
            Catch ex As Exception
                Log.Error(ex, "[ver_revisiones.Load DameDatosBasicosRev] proyecto = {proyecto}", miProyecto.prop_cod)
            End Try

            If lista_calculos.Count = 0 Then
                btn_enviarMail.Visible = False
                btn_imprimirMerge.Visible = False
            Else
                btn_enviarMail.Visible = True
                btn_imprimirMerge.Visible = True
            End If

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                'If Session("tipo_usuario") = ConfigurationManager.AppSettings("TIP_ROL_INGENIERO") Then
                MostrarHistoricos.Visible = True
                GridView1.Columns(7).Visible = True
                GridView1.Columns(6).Visible = False
            Else
                MostrarHistoricos.Visible = False
                GridView1.Columns(6).Visible = True
                GridView1.Columns(7).Visible = False
            End If

            If perfiles.prop_TIPO_PERFIL = 2 Then 'cli
                btn_crearOfe.Visible = False
            End If
            'CALCULOS SEL
            Session("LISTA_CALCULOS") = Nothing

            'Dim place As ContentPlaceHolder = CType(Master.FindControl("ContentPlaceHolder_cuerpo"), ContentPlaceHolder)
            'Dim btn As System.Web.UI.HtmlControls.HtmlButton = Master.FindControl("verRev")

            'OCULTAMOS BOTON VER CALCULOS
            'Dim panelmaster = CType(Master.FindControl("ctl00_ctl00_ContentPlaceHolder1_PanelProyecto"), System.Web.UI.WebControls.Panel)
            Dim btn_ver_calculos As System.Web.UI.WebControls.Button
            'btn_ver_calculos = CType(Master.FindControl("PanelProyecto").FindControl("verRev"), System.Web.UI.WebControls.Button)


            '''''''''''''''''



            btn_ver_calculos = Master.Master.FindControl("ContentPlaceHolder1").FindControl("verRev")

            ''''''''''''''


            ' btn_ver_calculos = CType(Master.FindControl("verRev"), System.Web.UI.WebControls.Button)
            'btn_ver_calculos = CType(panelmaster.FindControl("verRev"), System.Web.UI.WebControls.Button)
            btn_ver_calculos.Visible = False
        End If
        Session("PaginaActual") = "ver_calculos"
    End Sub

    Protected Sub GridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GridView1.RowDataBound
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            'datakeys: prop_idestudio,prop_iddistribucion,PROP_micalculorev,PROP_mifecharev,PROP_miobservacionrev,PROP_estadorev
            Dim idestudio As String = GridView1.DataKeys(e.Row.RowIndex).Item(0).ToString
            Dim iddistribucion As String = GridView1.DataKeys(e.Row.RowIndex).Item(1).ToString
            Dim revision As String = GridView1.DataKeys(e.Row.RowIndex).Item(2).ToString

            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            Dim calc As New AMC_Proyectos_pkg.CCalculos(idestudio, iddistribucion, ConfigurationManager.AppSettings("grupo"), Session("idioma_spyro"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                Dim check As CheckBox = e.Row.FindControl("lblverhistoricos")
                Dim estado_calc As String = GridView1.DataKeys(e.Row.RowIndex).Item(5).ToString 'PROP_estadorev
                check.Checked = (estado_calc = ConfigurationManager.AppSettings("GGESTADO_CALCULO_OCULTO"))
            Else
                'MIRAMOS SI EL USUARIO ACTUAL ES IGUAL AL QUE HA CREADO EL CALCULO PARA DARLE PERMISOS SOBRE ÉL.
                Dim usrnom_resp_cre As String = ""
                Dim usrnom_resp_mod As String = ""
                calc.dame_responsable_calculo(idestudio, iddistribucion, revision, usrnom_resp_cre, usrnom_resp_mod)
                Dim uti As New BCb2b.Utilities()
                Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
                If usrnom_resp_cre = "" Then
                    'si no tiene usu el calculo, cogemos el del proy
                    Dim proy As New AMC_Proyectos_pkg.CProyectos()
                    proy = Session("proyecto")
                    usrnom_resp_cre = proy.prop_responsable
                End If

                Dim lbBorrar As ImageButton = e.Row.FindControl("lbBorrar")
                If Session("EsProyectoWeb") = "S" Or usrnom_resp_cre = cod_usuario Then 'SI EL USUARIO ES DUEÑO DEL CALCULO PODRÁ ELIMINARLO
                    lbBorrar.Attributes.Add("onclick", "javascript:return " & "confirm('" & GetLocalResourceObject("EliminarCalcNum") & " " & DataBinder.Eval(e.Row.DataItem, "PROP_micalculorev") + "?')")
                Else
                    lbBorrar.Visible = False
                    btn_borrarCalc.Visible = False
                End If
            End If
        End If
    End Sub

    Protected Sub GridView1_RowDeleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) Handles GridView1.RowDeleting
        Dim fila As GridViewRow
        fila = GridView1.Rows(e.RowIndex)
        Dim mifila As Integer = fila.RowIndex.ToString

        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim num_calculo As OracleNumber
        Try
            'datakeys: prop_idestudio,prop_iddistribucion,PROP_micalculorev,PROP_mifecharev,PROP_miobservacionrev,PROP_estadorev
            num_calculo = StringToOracleNumber(GridView1.DataKeys(mifila).Item(2).ToString) 'PROP_micalculorev
            AMC_Proyectos_pkg.CCalculos.cambiar_estado_calculo(miProyecto.prop_cod, num_calculo, ConfigurationManager.AppSettings("GGESTADO_CALCULO_OCULTO"))
        Catch ex As Exception
            Log.Error(ex, "[ver_revisiones.GridView1_RowDeleting cambiar_estado_calculo] proy = {proy} n_calc = {n_calc} ", miProyecto.prop_cod, num_calculo)
        End Try



        Dim respuesta As String
        Dim lista_proyectos As New ArrayList
        lista_proyectos.Clear()

        Dim grupo, empresa As String
        grupo = ConfigurationManager.AppSettings("Grupo")
        empresa = ConfigurationManager.AppSettings("Empresa")

        Dim calculo As CCalculos
        calculo = New CCalculos()

        Dim lista_calculos As New ArrayList
        Try
            If MostrarHistoricos.Checked = True Then
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), True)
            Else
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), False)
            End If
        Catch escep As Exception
            Log.Error(escep, "[ver_revisiones.GridView1_RowDeleting DameDatosBasicosRev] proy = {proy} idioma = {idioma} checked = {checked} ", miProyecto.prop_cod, Session("idioma"), MostrarHistoricos.Checked)
            respuesta = escep.Message()
        Finally
            GridView1.DataSource = lista_calculos
            GridView1.DataBind()
        End Try

    End Sub

    Protected Sub GridView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GridView1.SelectedIndexChanged

        Dim fila As GridViewRow
        fila = GridView1.SelectedRow

        'datakeys: prop_idestudio,prop_iddistribucion,PROP_micalculorev,PROP_mifecharev,PROP_miobservacionrev,PROP_estadorev
        Dim idestudio As String = GridView1.DataKeys(fila.RowIndex)("prop_idestudio")
        Dim iddistribucion As String = GridView1.DataKeys(fila.RowIndex)("prop_iddistribucion")
        Dim revision_sel As String = GridView1.DataKeys(fila.RowIndex)("PROP_micalculorev")
        Dim revision_obser_sel As String = GridView1.DataKeys(fila.RowIndex)("PROP_miobservacionrev")
        Try
            Dim perfiles As New BCb2b.USUARIOS_B2B()
            perfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
            If perfiles.prop_TIPO_PERFIL = 0 Then 'ing y svt
                Session("editarNOeditar") = True
            Else
                'MIRAMOS SI EL USUARIO ACTUAL ES IGUAL AL QUE HA CREADO EL CALCULO PARA DARLE PERMISOS SOBRE ÉL.
                Dim calc As New AMC_Proyectos_pkg.CCalculos()
                Dim usrnom_resp_cre As String = ""
                Dim usrnom_resp_mod As String = ""
                calc.dame_responsable_calculo(idestudio, iddistribucion, revision_sel, usrnom_resp_cre, usrnom_resp_mod)
                Dim uti As New BCb2b.Utilities()
                Dim cod_usuario As String = uti.Dame_Usrnom_de_Usuario(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("compra"), ConfigurationManager.AppSettings("ClasifLogin"), Session("perfil_usuario"), Session("usuario"), Session("agente"), Session("cliente"))
                If usrnom_resp_cre = "" Then
                    'si no tiene usu el calculo, cogemos el del proy
                    Dim proy As New AMC_Proyectos_pkg.CProyectos()
                    proy = Session("proyecto")
                    usrnom_resp_cre = proy.prop_responsable
                End If
                If usrnom_resp_cre = cod_usuario Or usrnom_resp_cre = ConfigurationManager.AppSettings("USUARIO_WEB") Then 'ES EL CREADOR DEL CALCULO o EL CALCULOS ES WEB
                    Session("editarNOeditar") = True
                Else
                    Session("editarNOeditar") = False
                End If
            End If

            Session("RevisionSel") = revision_sel
            Server.Transfer("distribucion.aspx")
        Catch ex As Exception
            Log.Error(ex, "[ver_revisiones.GridView1_SelectedIndexChanged] proyecto = {proyecto} iddistrib = {iddistrib} rev = {rev} obs = {obs} ", idestudio, iddistribucion, revision_sel, revision_obser_sel)
        End Try
    End Sub

    Protected Sub MostrarHistoricos_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MostrarHistoricos.CheckedChanged
        Dim calculo As New CCalculos()
        Dim respuesta As String

        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Dim lista_calculos As New ArrayList

        Try
            If MostrarHistoricos.Checked = True Then
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), True)
            Else
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), False)
            End If
        Catch escep As Exception
            Log.Error(escep, "[ver_revisiones.MostrarHistoricos_CheckedChanged] proy = {proy} idioma = {idioma} checked = {checked} ", miProyecto.prop_cod, Session("idioma"), MostrarHistoricos.Checked)
            respuesta = escep.Message()
        Finally
            GridView1.DataSource = lista_calculos
            GridView1.DataBind()
        End Try
    End Sub
    Protected Sub CambiarEstadoCalculo_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs)

        Dim check As CheckBox = sender
        Dim num_revision As String = check.ToolTip

        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")

        Try
            If check.Checked = True Then
                CCalculos.cambiar_estado_calculo(miProyecto.prop_cod, StringToOracleNumber(num_revision), ConfigurationManager.AppSettings("GGESTADO_CALCULO_OCULTO"))
            Else
                CCalculos.cambiar_estado_calculo(miProyecto.prop_cod, StringToOracleNumber(num_revision), ConfigurationManager.AppSettings("GGESTADO_CALCULO_ACTIVO"))
            End If
        Catch ex As Exception
            Log.Error(ex, "[ver_revisiones.CambiarEstadoCalculo_CheckedChanged cambiar_estado_calculo] proy = {proy} rev = {rev} chk = {chk} ", miProyecto.prop_cod, num_revision, check.Checked)
        End Try


        Dim lista_calculos As New ArrayList

        Dim calculo As New CCalculos()
        Dim respuesta As String

        Try
            If MostrarHistoricos.Checked = True Then
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), True)
            Else
                lista_calculos = calculo.DameDatosBasicosRev(miProyecto.prop_cod, Session("idioma"), False)
            End If
        Catch escep As Exception
            Log.Error(escep, "[ver_revisiones.CambiarEstadoCalculo_CheckedChanged DameDatosBasicosRev] proy = {proy} idioma = {idioma} chk = {chk} ", miProyecto.prop_cod, Session("idioma"), MostrarHistoricos.Checked)
            respuesta = escep.Message()
        Finally
            GridView1.DataSource = lista_calculos
            GridView1.DataBind()
        End Try

    End Sub

    Protected Sub btn_imprimirMerge_Click(sender As Object, e As ImageClickEventArgs) Handles btn_imprimirMerge.Click
        'Protected Sub btnImprimir_Click(sender As Object, e As System.EventArgs) Handles btnImprimir.Click

        Dim calculo As New CCalculos()
        Dim hay As Boolean = False
        If Not Session("lista_calculos") Is Nothing Then
            Dim lista_calculos As New ArrayList()
            lista_calculos = Session("lista_calculos")
            If lista_calculos.Count > 0 Then
                hay = True
            Else
                hay = False
            End If
        Else
            hay = False
        End If

        If hay Then
            'lblEnviadoEmail.Text = ""

            RegisterClientScriptBlock("test", "<script>window.open('pruebagraficos.aspx','_blank');</script>")

        Else
            'SIN CALCS CHECKEADOS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & Me.GetLocalResourceObject("errorCheck") & "','ok','',300);", True)
            'lblEnviadoEmail.Text = Me.GetLocalResourceObject("errorCheck")
        End If

    End Sub

    'Protected Sub ImageButton2_Click(sender As Object, e As ImageClickEventArgs) Handles ImageButton2.Click
    '    'Protected Sub btn_enviarEmail_Click(sender As Object, e As System.EventArgs) Handles btn_enviarEmail.Click

    '    Dim calculo As New CCalculos()

    '    Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
    '    miProyecto = Session("proyecto")

    '    Dim lista_calculos As New ArrayList()
    '    lista_calculos = Session("lista_calculos")

    '    Dim hay As Boolean = False
    '    If lista_calculos.Count > 0 Then
    '        hay = True
    '    End If

    '    'JCE. Actualizar obser email al cargar pagina
    '    miProyecto.gestionar_ResponsableProy(miProyecto.prop_cod, ConfigurationManager.AppSettings("OCAL"), txtEmail.Text)

    '    If hay Then
    '        lblEnviadoEmail.Text = ""
    '        Server.Transfer("pruebagraficos.aspx?mail=" & txtEmail.Text)
    '    Else
    '        lblEnviadoEmail.Text = Me.GetLocalResourceObject("errorCheck")
    '    End If

    'End Sub
    Protected Sub checkImprimir_CheckedChanged(sender As Object, e As EventArgs)
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim lista_calculos As New ArrayList()
        Dim chk As CheckBox
        For Each rowItem As GridViewRow In GridView1.Rows
            chk = CType(rowItem.Cells(0).FindControl("checkImprimir"), CheckBox)
            If chk.Checked Then

                'datakeys: prop_idestudio,prop_iddistribucion,PROP_micalculorev,PROP_mifecharev,PROP_miobservacionrev,PROP_estadorev
                Dim revision As String = GridView1.DataKeys(rowItem.RowIndex).Item(2).ToString 'PROP_micalculorev
                'Dim revision As String = rowItem.Cells(1).Text

                Dim calculoSeleccionado As New AMC_Proyectos_pkg.CCalculos(miProyecto.prop_cod, revision)
                lista_calculos.Add(calculoSeleccionado)
            End If
        Next

        Session("LISTA_CALCULOS") = lista_calculos
    End Sub

    Protected Sub checkImprimirAll_CheckedChanged(sender As Object, e As EventArgs)
        Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
        miProyecto = Session("proyecto")
        Dim lista_calculos As New ArrayList()
        For Each rowItem As GridViewRow In GridView1.Rows
            Dim chk As CheckBox = CType(rowItem.Cells(0).FindControl("checkImprimir"), CheckBox)
            chk.Checked = CType(sender, CheckBox).Checked
            If chk.Checked Then
                Dim revision As String = GridView1.DataKeys(rowItem.RowIndex).Item(2).ToString 'PROP_micalculorev
                Dim calculoSeleccionado As New AMC_Proyectos_pkg.CCalculos(miProyecto.prop_cod, revision)
                lista_calculos.Add(calculoSeleccionado)
            End If
        Next
        Session("LISTA_CALCULOS") = lista_calculos
    End Sub

    Protected Sub btn_borrarCalc_Click(sender As Object, e As ImageClickEventArgs) Handles btn_borrarCalc.Click
        Dim hay As Boolean = False
        If Not Session("lista_calculos") Is Nothing Then
            Dim lista_calculos As New ArrayList()
            lista_calculos = Session("lista_calculos")
            If lista_calculos.Count > 0 Then
                hay = True
            Else
                hay = False
            End If
        Else
            hay = False
        End If

        If hay Then
            'lblEnviadoEmail.Text = ""
            Dim lista_calculos As New ArrayList()
            If Not Session("lista_calculos") Is Nothing Then
                Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
                miProyecto = Session("proyecto")

                lista_calculos = Session("LISTA_CALCULOS")
                For Each calculo As AMC_Proyectos_pkg.CCalculos In lista_calculos
                    CCalculos.cambiar_estado_calculo(miProyecto.prop_cod, StringToOracleNumber(calculo.prop_revision), ConfigurationManager.AppSettings("GGESTADO_CALCULO_OCULTO"))
                Next
                ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CalculosBorrados", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalBtnCorrecto") & "','" & GetLocalResourceObject("EliminarCalculsOK") & "','ok','ver_revisiones.aspx',300);", True)
            End If
        Else
            'lblEnviadoEmail.Text = Me.GetLocalResourceObject("errorCheck")
            'SIN CALCS CHECKEADOS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & Me.GetLocalResourceObject("errorCheck") & "','ok','',300);", True)
        End If
    End Sub

    Protected Sub btn_crearOfe_Click(sender As Object, e As ImageClickEventArgs) Handles btn_crearOfe.Click
        Dim hay As Boolean = False
        If Not Session("lista_calculos") Is Nothing Then
            Dim lista_calculos As New ArrayList()
            lista_calculos = Session("lista_calculos")
            If lista_calculos.Count > 0 Then
                hay = True
            Else
                hay = False
            End If
        Else
            hay = False
        End If

        If hay Then
            'lblEnviadoEmail.Text = ""

            Dim lista_calculos As New ArrayList()
            If Not Session("LISTA_CALCULOS") Is Nothing Then
                Dim miProyecto As New AMC_Proyectos_pkg.CProyectos()
                miProyecto = Session("proyecto")

                lista_calculos = Session("LISTA_CALCULOS")

                Dim cli As New BCb2b.ggclipr()
                cli = Session("cliente")

                Dim age As New BCb2b.gvagente()
                Dim perfiles As New BCb2b.USUARIOS_B2B()
                perfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
                If perfiles.prop_TIPO_PERFIL = 0 Then 'svt ing
                    Dim usuario As New BCb2b.CUsrnom(Session("usuario").prop_cod)
                    age = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                ElseIf perfiles.prop_TIPO_PERFIL = 1 Then 'dis y age
                    If Session("perfil_usuario") = "DIS" Then
                        age = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                    Else
                        Dim usuario As New BCb2b.CUsrnom(Session("usuario").prop_cod)
                        age = New BCb2b.gvagente(usuario.PROP_COD, usuario.PROP_PASSWORD, ConfigurationManager.AppSettings("GRUPO"), "S")
                    End If
                End If

                Session("agente") = age

                Dim cadena_lis_calcs As String = ""
                For Each calculo As AMC_Proyectos_pkg.CCalculos In lista_calculos
                    cadena_lis_calcs = calculo.prop_iddistribucion & "," & cadena_lis_calcs
                Next
                cadena_lis_calcs = cadena_lis_calcs.Substring(0, cadena_lis_calcs.Length - 1)
                Dim calc_apoyo As New CCalculos.apoyo()
                Dim lineasOfe As New List(Of BCb2b.COferta_linOff)
                lineasOfe = calc_apoyo.obtener_apoyos_agrupados(cadena_lis_calcs, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), ConfigurationManager.AppSettings("serieOferta"), cli.prop_COD, age, Session("idioma"), ConfigurationManager.AppSettings("obstip_articulo_idiomas"), ConfigurationManager.AppSettings("OBPZ"))

                'FIN AMC_NE203. Agrupar apoyos iguales.

                '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
                Dim param As New BCb2b.CParametros()
                Dim valor_param_fp As String = param.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"))
                '-----------------------------------------------
                Dim cabecera As New BCb2b.COferta_Cab(cli, ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("serieOferta"), _
                  ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), _
                  ConfigurationManager.AppSettings("historico_sn"), age.prop_COD, "", "", cli.prop_RSOCDIR_ENV, "", valor_param_fp, "")


                cabecera.prop_LISTADO_IDDISTRIBUCION = lista_calculos
                Session("cabecera") = cabecera
                Session("lineasOferta") = lineasOfe
                Response.Redirect("~/CrearOferta.aspx")
            End If
        Else
            'SIN CALCS CHECKEADOS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & Me.GetLocalResourceObject("errorCheck") & "','ok','',300);", True)
            'lblEnviadoEmail.Text = Me.GetLocalResourceObject("errorCheck")
        End If
    End Sub

    Protected Sub btn_excelMerge_Click(sender As Object, e As ImageClickEventArgs) Handles btn_excelMerge.Click
        'Protected Sub btnImprimir_Click(sender As Object, e As System.EventArgs) Handles btnImprimir.Click

        Dim calculo As New CCalculos()
        Dim hay As Boolean = False
        If Not Session("lista_calculos") Is Nothing Then
            Dim lista_calculos As New ArrayList()
            lista_calculos = Session("lista_calculos")
            hay = (lista_calculos.Count > 0)
            'If lista_calculos.Count > 0 Then
            '    hay = True
            'Else
            '    hay = False
            'End If
        Else
            hay = False
        End If

        If hay Then
            'lblEnviadoEmail.Text = ""

            RegisterClientScriptBlock("testExcel", "<script>window.open('excelCalculos.aspx','_blank');</script>")

        Else
            'SIN CALCS CHECKEADOS
            ScriptManager.RegisterStartupScript(Me, Me.GetType(), "CrearCliOk", "ShowDialog('" & GetGlobalResourceObject("general", "MsgModalbtnAtencion") & "','" & Me.GetLocalResourceObject("errorCheck") & "','ok','',300);", True)
            'lblEnviadoEmail.Text = Me.GetLocalResourceObject("errorCheck")
        End If
    End Sub
End Class

Public Class NumericComparer
    Implements IComparer
    Dim mText As Boolean = False
    Public Sub New(ByRef sorttype As NumericSort)
        mText = sorttype
    End Sub

    Public Enum NumericSort
        Textual = True
        Numerical = False
    End Enum

    ' Compare the two employees.
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
    Implements System.Collections.IComparer.Compare
        If mText = False Then
            Dim txtx As Double = CDbl(x)
            Dim txty As Double = CDbl(y)
            Select Case True
                Case txtx < txty : Return -1
                Case txtx = txty : Return 0
                Case txtx > txty : Return 1
            End Select
        Else
            Dim txtx As String = CStr(x)
            Dim txty As String = CStr(y)
            Return String.Compare(txtx, txty)
        End If
        Return False
    End Function
End Class