// Plugin created by Brock Nusser - http://brocknusser.com
// Demo site: http://mlamenu.brocknusser.com/index.htm
// Download: http://mlamenu.brocknusser.com/mlamenu.zip

/*
SETUP
*/
var navWidth = 100;         //in %
var ulIndent = 0;          //in pixels
var slideSpeed = 'fast';    // 'slow', 'normal', 'fast', or miliseconds 
//var navWidth = 180;         //in pixels
//var ulIndent = 15;          //in pixels
//var slideSpeed = 'slow';    // 'slow', 'normal', 'fast', or miliseconds 
//end setup

var pathname = window.location.pathname;

$(function() {

   

    $('#nav').css('width', navWidth + '%');
    $('#nav ul').css('width', navWidth + '%');
    $('#nav ul').css('margin-left', ulIndent + 'px');

    $('#nav a').each(function() {
    var level = $(this).parents('ul').length;
    // var liWidth = navWidth - (ulIndent * level) + 30;
    var liWidth = navWidth - (ulIndent * level) ;
    $(this).parent('li').css('width', liWidth + '%');
    });    

    /*
        add 'Current' class to the current page
    */
    $('#nav a').each(function() {
        var thisHref = $(this).attr('href')
        if ((window.location.pathname.indexOf(thisHref) == 0) || (window.location.pathname.indexOf('/' + thisHref) == 0)) {
        $(this).addClass('Current');
    }
    });

    /*
        display the current page
    */
    $('.Current').parent('li').children('ul').show();
    $('.Current').parents('ul').show();

    /*
        add expand/collapse icons
    */
    $('#nav li').each(function () {
        if ($(this).children('ul').length > 0) {
            if ($(this).children('ul').is(":visible")) {
                $(this).prepend('<img src="/Content/images/imgOnOpen.gif" />');
            }
            else {
                $(this).prepend('<img src="/Content/images/imgOffClosed.gif" />');
            }
        }
    });
    
    /*
        open/close current each list on click
    */
    $('#nav img').click(function() {
        if ($(this).parent('li').children('ul').html() != null) {
            $(this).parent('li').parent('ul').children('li').children('ul').hide(slideSpeed);
            $(this).parent('li').parent('ul').children('li').children('img').attr('src', '/Content/images/imgOffClosed.gif');
            $(this).delay(100).is(':hidden');
            if ($(this).parent('li').children('ul').css('display') == "block") {
                $(this).parent('li').children('ul').hide(slideSpeed);
                $(this).attr('src', '/Content/images/imgOffClosed.gif');
            } else {
                $(this).parent('li').children('ul').show(slideSpeed);
                $(this).attr('src', '/Content/images/imgOnOpen.gif');
            }
            return false;
        }

    });

    //End Required Section
    
    //Optional Section - Show Carrots
    var imgOffClosed = "url(/Content/images/imgOffClosed.gif) no-repeat 5px ";
    var imgOnClosed = "url(/Content/images/imgOnClosed.gif) no-repeat 5px ";
    var imgOnOpen = "url(/Content/images/imgOnOpen.gif) no-repeat 5px ";
    ///var charBeforeLB = 23; //characters before line break - you must calculate this - based on font-size and LI width;
    //var paddingBig = 12; //push carrot arrow down (in pixels) when no there is a line break in the LI
    //var paddingSmall = 8;  //push carrot arrow down (in pixels) when no there is no line break in the LI
    //var maxLIHeight = 50; // max height of LI when list is closed

    var charBeforeLB = 23; //characters before line break - you must calculate this - based on font-size and LI width;
    var paddingBig = 0; //push carrot arrow down (in pixels) when no there is a line break in the LI
    var paddingSmall = 8;  //push carrot arrow down (in pixels) when no there is no line break in the LI
    var maxLIHeight = 0; // max height of LI when list is closed

    /*
        Logic to decide whether current list is open,
        and determine how much padding to give the expand/collapse icons .  
    */
    $('#nav > li').each(function() {
        var childText = $(this).children('a').text();
        var topPadding = paddingBig;
        if (childText.length < charBeforeLB) {
            topPadding = paddingSmall; 
        }
        //if list is closed
        if ($(this).height() < maxLIHeight) {
            if ($(this).children('a').attr('class') == "Current") {
                $(this).parent('li').children('img').attr('src', '/Content/images/imgOnOpen.gif');
            } else {
                $(this).parent('li').children('img').attr('src', '/Content/images/imgOffClosed.gif');
            }
        }
        //if list is open
        else {
            $(this).children('img').attr('src', '/Content/images/imgOnOpen.gif');
        }
    });
    
    //End Optional Section
});

function ExpandAll() {
    $('#nav ul').each(function () {
        $(this).show(slideSpeed);
     

    });
}

function CollapseAll() {
    $('#nav ul').each(function () {
        $(this).hide(slideSpeed);     
    });
}// JavaScript Document