﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.IO

Partial Class SeguimientoAnadirNota
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Private USRTMENSA_COD As String
    Private N_INFORME As OracleNumber
    Private N_SEQ As OracleNumber
    Public ReadOnly Property PROP_usrtmensa_cod_SEL() As String
        Get
            If Not IsNothing(Me.USRTMENSA_COD) Then
                Return Me.USRTMENSA_COD.ToString
            Else
                Return ""
            End If
        End Get
    End Property

    Public ReadOnly Property PROP_N_INFORME_SEL() As OracleNumber
        Get
            Return Me.N_INFORME
        End Get
    End Property

    Public ReadOnly Property PROP_N_SEQ_SEL() As OracleNumber
        Get
            Return Me.N_SEQ
        End Get
    End Property

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(SeguimientoAnadirNota))
        'HABILITAMOS LOS MENSAJES MODALES
        Dim uti As New BCb2b.Utilities
        uti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))

        'lblerror.Text = "La longitud máxima del mensaje es de 4000, se truncará."
        If Not Page.IsPostBack Then
            Try
                txt_n_informe.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                txt_n_informe.Value = ""
            End Try
            Try
                txt_n_seq.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                txt_n_seq.Value = ""
            End Try
            Try
                txt_tmensa.Value = Request.QueryString("c1").ToString()
            Catch ex As Exception
                txt_tmensa.Value = ""
            End Try

            Try
                vdasp.Value = Request.QueryString("vdasp").ToString()
            Catch ex As Exception
                vdasp.Value = ""
            End Try

            Try
                vage.Value = Request.QueryString("vage").ToString()
            Catch ex As Exception
                vage.Value = ""
            End Try

            Me.USRTMENSA_COD = txt_tmensa.Value
            Me.N_INFORME = txt_n_informe.Value
            Me.N_SEQ = txt_n_seq.Value

            'Dim men As New BCb2b.CUSRMail(txt_tmensa.Value.ToString, CInt(txt_n_informe.Value), CInt(txt_n_seq.Value))
            'Dim CUERPO As String = men.prop_descrip 'obtenemos aqui el cuerpo del actual mensaje para controlar longitudes
            'Dim cuerpo_a_anadir As String = ""
            'Dim age As New BCb2b.gvagente()
            'age = Session("agente")

            'Dim nombre_age, cod_age As String
            'nombre_age = age.prop_NOMBRE
            'cod_age = age.prop_COD
            'If age.prop_COD = "" Then
            '    Dim age2 = New BCb2b.CAgente(vage.Value)
            '    nombre_age = age2.prop_nombre
            '    cod_age = age2.prop_cod
            'End If

            'cuerpo_a_anadir = "<br/>" & nombre_age & " (" & cod_age & ") " & Now.Date & " > " & txtContentAdicTxtPlano.Value
            'num_carac_rest.Value = (3990 - CInt(CUERPO.Length) - CInt(cuerpo_a_anadir.Length)).ToString

            'If num_carac_rest.Value <= 0 Then
            '    btnCrearNota.Visible = False
            '    lblerror.Visible = True
            '    lblerror.Text = GetLocalResourceObject("MsgErrorTamano")
            'Else
            '    btnCrearNota.Visible = True
            '    lblerror.Visible = False
            '    lblerror.Text = ""
            'End If
        End If
    End Sub
  
    Protected Sub btnCrearNota_Click(sender As Object, e As EventArgs) Handles btnCrearNota.Click
        Dim cuerpo_a_anadir As String = ""
        Dim age As New BCb2b.gvagente()
        age = Session("agente")

        Dim nombre_age, cod_age As String
        nombre_age = age.prop_NOMBRE
        cod_age = age.prop_COD
        If age.prop_COD = "" Then
            Dim age2 = New BCb2b.CAgente(vage.Value)
            nombre_age = age2.prop_nombre
            cod_age = age2.prop_cod
        End If

        cuerpo_a_anadir = "<br/>" & nombre_age & " (" & cod_age & ") " & Now.Date & " > "

        Dim cuerpo_sin_html As String = BCb2b.Utilities.EliminarCaracteresHtml(cuerpo_a_anadir & txtContenidoAdicional.Text)
        Dim cuerpo_con_html As String = cuerpo_a_anadir & txtContenidoAdicional.Text
        
        Dim ok As Integer = 0
        Dim men As New BCb2b.CUSRMail(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value)

        Dim cuerpo_anadir_aux = men.prop_descrip & cuerpo_sin_html

        If cuerpo_anadir_aux.Length > 4000 Then
            cuerpo_anadir_aux = cuerpo_anadir_aux.Substring(0, 4000)
        End If

        ok = men.usrmail_anadir_nota(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value, cuerpo_anadir_aux)

        'INSERTAMOS EL HTML EN USRMAILHTML
        Dim txthtml As New BCb2b.usrmailhtml()
        Dim CUERPO As String = txthtml.Dame_Texto(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value)
        If CUERPO = "" Then
            CUERPO = men.prop_descrip
        End If
        CUERPO = CUERPO & cuerpo_con_html

        txthtml.Inserta_Texto(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value, CUERPO)

        Session("N_INFORME_SEL") = txt_n_informe.Value
        Session("N_SEQ_SEL") = txt_n_seq.Value
        Session("usrtmensa_cod_SEL") = txt_tmensa.Value

        Call EnviarConfirmacionNotaAñadida()

        Response.Redirect("SeguimientoDetalle.aspx?vdasp=" & vdasp.Value, True)
    End Sub
    Private Sub EnviarConfirmacionNotaAñadida()
        Dim men As New BCb2b.CUSRMail(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value)

        Dim txthtml As New BCb2b.usrmailhtml()
        Dim TXT_CUERPO_HTML As String = txthtml.Dame_Texto(txt_tmensa.Value, txt_n_informe.Value, txt_n_seq.Value)

        Dim parametro As New BCb2b.CParametros()

        Dim agente As New BCb2b.gvagente()
        agente = Session("agente")

        Dim nombre_age, cod_age As String
        nombre_age = agente.prop_NOMBRE
        cod_age = agente.prop_COD
        If agente.prop_COD = "" Then
            Dim age2 = New BCb2b.CAgente(vage.Value)
            nombre_age = age2.prop_nombre
            cod_age = age2.prop_cod
        End If

        Dim cli As New BCb2b.ggclipr()
        cli = Session("cliente")

        Dim host As String = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")
        Dim port As Int32 = CInt(ConfigurationManager.AppSettings("PUERTO_MAIL"))
        Dim user As String = ConfigurationManager.AppSettings("USU_MAIL")
        Dim password As String = ConfigurationManager.AppSettings("PASS_MAIL")
        Dim titulo As String = "AMCSA. " & nombre_age.ToUpper & " (" & cod_age & ") " & " HA AÑADIDO UNA NOTA A LA VISITA " & men.prop_N_INFORME

        Dim CUERPO As String = ""
        CUERPO = "<table border=""1"" style=""width:70%;margin:10px !important;"">"
        CUERPO = CUERPO & "<tr><th colspan=""4"" bgcolor=""#0081C6"" style=""color:#ffffff;margin:10px !important;"">DETALLE MENSAJE</th></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Fecha</td><td colspan=""3"">" & men.prop_f_prevcom & "</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Razón Social</td><td>" & cli.prop_RSOCIAL_COD & "</td><td style=""font-weight:bold;"">Cliente</td><td>" & cli.prop_NOMBRE & " (" & cli.prop_COD & ")</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Asunto</td><td colspan=""3"">" & men.prop_DESCRIPTOR & "</td></tr>"
        CUERPO = CUERPO & "<tr><td style=""font-weight:bold;"">Cuerpo</td><td colspan=""3"">" & TXT_CUERPO_HTML & "</td></tr>"
        CUERPO = CUERPO & "</table>"

        'ENVIAR MAIL A OBSERVACION EVIG DE PROVEEDOR
        Dim obsProveedor As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), agente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("EVIS"))
        Dim mails As String = obsProveedor.PROP_COMENTARIO
        If mails <> "" Then
            Dim mailing As New BCb2b.EnviarMail()
            'Dim enviado As String = mailing.SendMail(host, port, user, password, ConfigurationManager.AppSettings("EmailFrom"), ConfigurationManager.AppSettings("EmailFrom"), user, mails, titulo, CUERPO, False, "")
            Dim enviado As String = mailing.SendMail_NET("", ConfigurationManager.AppSettings("EmailFrom"), mails, titulo, CUERPO, "")
        End If
    End Sub
  
End Class
