﻿Imports System.Data.OracleClient
Imports BCb2b

Partial Class SeguimientoDetalle
    Inherits claseBase

    Private _origen As Object
    Private USRTMENSA_COD As String
    Private N_INFORME As OracleNumber
    Private N_SEQ As OracleNumber
    Public ReadOnly Property PROP_usrtmensa_cod_SEL() As String
        Get
            If Not IsNothing(Me.USRTMENSA_COD) Then
                Return Me.USRTMENSA_COD.ToString
            Else
                Return ""
            End If
        End Get
    End Property

    Public ReadOnly Property PROP_N_INFORME_SEL() As OracleNumber
        Get
            Return Me.N_INFORME
        End Get
    End Property

    Public ReadOnly Property PROP_N_SEQ_SEL() As OracleNumber
        Get
            Return Me.N_SEQ
        End Get
    End Property
    Private Property origen As Object
        Get
            Return _origen
        End Get
        Set(value As Object)
            _origen = value
        End Set
    End Property

    Public Function FileExists(ByVal FileFullPath As String) _
     As Boolean

        Dim f As New IO.FileInfo(FileFullPath)
        Return f.Exists

    End Function

    Public Function FolderExists(ByVal FolderPath As String) _
   As Boolean
        Dim f As New IO.DirectoryInfo(FolderPath)
        Return f.Exists
    End Function

    Public Sub descargar_documentos(ByVal lista_docs As ArrayList)

        'Dim ruta_upload = ConfigurationManager.AppSettings("ruta_upload_s")
        ''path_local = ConfigurationManager.AppSettings("path_local_s")
        'Dim host_ftp = ConfigurationManager.AppSettings("host_ftp_s")
        'Dim usuario_ftp = ConfigurationManager.AppSettings("usuario_ftp_s")
        'Dim pass_ftp = ConfigurationManager.AppSettings("pass_ftp_s")
        'Dim dominio_ftp = ConfigurationManager.AppSettings("dominio_ftp_s")
        ''Dim path_local_SPYRO As String = ConfigurationManager.AppSettings("path_local_s") & "LOGO_IMG_AEN_9.jpg"

        Dim ruta_upload = ConfigurationManager.AppSettings("pathlocal")
        Dim parametro As New BCb2b.CParametros()
        Dim host_ftp = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")
        Dim usuario_ftp = ConfigurationManager.AppSettings("usuarioFTP")
        Dim pass_ftp = ConfigurationManager.AppSettings("passFTP")
        Dim dominio_ftp = "MECANOCAUCHO"


        Dim elemento As New BCb2b.CUsrmailDoc()
        For Each elemento In lista_docs
            '1. Mirar si existe en el directorio web
            '2. Si no existe 
            '   Descargarlo desde el directorio de spyro
            '   fin si.
            Dim fichero As String = ConfigurationManager.AppSettings("pathlocal") & elemento.prop_nombre_fic
            If Not FileExists(fichero) Then
                Try
                    lblerror.Visible = False
                    Dim elftp As New BCb2b.ftp(ruta_upload & elemento.prop_nombre_fic, elemento.prop_PATH_FIC, host_ftp, usuario_ftp, pass_ftp, dominio_ftp)
                    elftp.impersonateValidUser()
                    elftp.FTPDownload(elemento.prop_nombre_fic, ConfigurationManager.AppSettings("pathlocal"))
                Catch ex As Exception
                    lblerror.Visible = True
                    lblerror.Text = lblerror.Text & "<br>Fichero: " & elemento.prop_nombre_fic & ":" & ex.Message.ToString & "<br>"
                End Try
            End If
        Next
    End Sub

    Protected Sub Page_Init(sender As Object, e As EventArgs) Handles Me.Init
        Dim codAgen As String = ""
        Try
            codAgen = Request.QueryString("agen")
        Catch ex As Exception
            codAgen = ""
        End Try

        Dim codcli As String = ""
        Try
            codcli = Request.QueryString("cli")
        Catch ex As Exception
            codcli = ""
        End Try

        Dim idioma As String = Request.QueryString("i")
        Dim codioUsuario As String = Request.QueryString("usuario")
        Dim perfil As String = Request.QueryString("perfil")

        Dim viendeasp As String = Request.QueryString("vdasp")

        If viendeasp = "1" Then
            If codAgen <> "" And codcli <> "" Then
                Dim cli As New BCb2b.ggclipr(codcli, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                Dim age As New BCb2b.gvagente(codioUsuario, ConfigurationManager.AppSettings("grupo"))
                Session("agente") = age
                Session("cliente") = cli

                Dim usuario As New BCb2b.CUsrnom(codioUsuario)
                Session("Usuario") = usuario
                Session("UsuarioB2B") = usuario
                Session("perfil_usuario") = perfil

                vage.Value = codAgen
            End If

            'ocultar menu de la master

            'nota para jce: txato, si viene del punto de menú del asp, como detalle de la visita, no tiene menú... da error y no navega.... 

            Try
                Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("menu_master")
                'Dim menu_master As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("menu_master")
                menu_master.Visible = False

                'ocultar cliente y agente seleccionado
                Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.Master.FindControl("ContentPlaceHolder1").FindControl("bienvenida_menu")
                'Dim bienvenida_menu As System.Web.UI.HtmlControls.HtmlGenericControl = Master.FindControl("bienvenida_menu")
                bienvenida_menu.Visible = False
            Catch ex As Exception
                'nota para jce: dejo el poner esto bien de tu cuenta.
            End Try

            vdasp.Value = "1"
        Else
            vdasp.Value = "0"
        End If
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(SeguimientoDetalle))
        'El boton volver.
        ' btnVolver.Attributes.Add("onMouseOver", "this.src = 'App_Themes/general/btn/images/btn_volver2.gif';")
        ' btnVolver.Attributes.Add("onMouseOut", "this.src = 'App_Themes/general/btn/images/btn_volver.gif';")
        ' btnVolver.ImageUrl = "App_Themes/general/btn/images/btn_volver.gif"
        'HABILITAMOS LOS MENSAJES MODALES
        Dim uti As New BCb2b.Utilities
        uti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        uti.CrearModalConfirm(Me, "BorrarDocumento", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("MsgModalBorrarDocQOk"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"))

        'btnVolver.Attributes.Add("onClick", "javascript:history.back();")
        'btnVolver.Attributes.Add("style", "cursor:pointer")

        If Not Page.IsPostBack = True Then


            Dim origen As New Object
            Try
                Try
                    origen = CType(Context.Handler, Seguimiento)
                    txt_n_informe.Value = origen.PROP_N_INFORME_SEL.ToString
                    txt_n_seq.Value = origen.PROP_N_SEQ_SEL.ToString
                    txt_tmensa.Value = origen.PROP_usrtmensa_cod_SEL
                    Session("N_INFORME_SEL") = txt_n_informe.Value
                    Session("N_SEQ_SEL") = txt_n_seq.Value
                    Session("usrtmensa_cod_SEL") = txt_tmensa.Value
                Catch ex As Exception
                    Try
                        origen = CType(Context.Handler, SeguimientoCrear)
                        txt_n_informe.Value = origen.PROP_N_INFORME_SEL.ToString
                        txt_n_seq.Value = origen.PROP_N_SEQ_SEL.ToString
                        txt_tmensa.Value = origen.PROP_usrtmensa_cod_SEL
                        Session("N_INFORME_SEL") = txt_n_informe.Value
                        Session("N_SEQ_SEL") = txt_n_seq.Value
                        Session("usrtmensa_cod_SEL") = txt_tmensa.Value
                    Catch ex2 As Exception
                        origen = CType(Context.Handler, SeguimientoDetalle)
                        txt_n_informe.Value = Session("N_INFORME_SEL")
                        txt_n_seq.Value = Session("N_SEQ_SEL")
                        txt_tmensa.Value = Session("usrtmensa_cod_SEL")
                    End Try

                End Try
            Catch ex As Exception
                Session("N_INFORME_SEL") = ""
                Session("N_SEQ_SEL") = ""
                Session("usrtmensa_cod_SEL") = ""
                txt_n_informe.Value = ""
                txt_n_seq.Value = ""
                txt_tmensa.Value = ""
                Response.Redirect("~/Expirado.aspx")
            End Try



            Me.USRTMENSA_COD = txt_tmensa.Value
            Me.N_INFORME = txt_n_informe.Value
            Me.N_SEQ = txt_n_seq.Value


            Dim url As String = ConfigurationManager.AppSettings("pathB2BAMCSADocs")
            ' Detalle del mensaje.
            Dim mensaje As New BCb2b.CUSRMail()
            mensaje.Seguimiento_Oferta_Detalle(origen.PROP_usrtmensa_cod_SEL, CInt(origen.PROP_N_INFORME_SEL.ToString), CInt(origen.PROP_N_SEQ_SEL.ToString))

            lblFecha.Text = mensaje.prop_f_creacion
            lblOrigen.Text = mensaje.prop_usrnom_ori
            lblDestino.Text = mensaje.prop_usrnom_des
            lblRSocial.Text = mensaje.prop_rsocial_cod

            Dim cliente As New BCb2b.ggclipr()
            If (mensaje.prop_ggclipr_cod <> "") Then
                cliente = New BCb2b.ggclipr(mensaje.prop_ggclipr_cod, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                lblCliente.Text = cliente.prop_NOMBRE
                lblClienteCod.Text = mensaje.prop_ggclipr_cod
            Else
                Dim razon_social As New BCb2b.CRSOCIAL(mensaje.prop_rsocial_cod)
                lblClienteCod.Text = mensaje.prop_rsocial_cod
                lblCliente.Text = razon_social.PROP_NOMBRE
            End If
            lblAsunto.Text = mensaje.prop_DESCRIPTOR

            'lblCuerpo.Text = mensaje.prop_cuerpo_sin_patron 'CONTENIDO SIN PATRON
            'EL CUERPO AHORA LO OBTENEMOS DE LA USRMAILHTML
            Dim txthtml As New BCb2b.usrmailhtml()
            lblCuerpo.Text = txthtml.Dame_Texto(mensaje.prop_USRTMENSA_COD, mensaje.prop_N_INFORME, mensaje.prop_N_SEQ)
            If lblCuerpo.Text = "" Then 'SI NO TIENE CONTENIDO CON HTML EN DICHA TABLA COGEMOS EL NORMAL.
                lblCuerpo.Text = mensaje.prop_cuerpo_sin_patron
            End If


            lblDestinos.Text = mensaje.prop_enviados_libre 'DESTINOS OBTENIDOS DE PATRON

            Call CargarDocumentosVisita(origen.PROP_usrtmensa_cod_SEL.ToString, CType(origen.PROP_N_INFORME_SEL.ToString, OracleNumber), CType(origen.PROP_N_SEQ_SEL.ToString, OracleNumber))

            'Contactos asociados al cliente y al proveedor
            Dim age As New BCb2b.gvagente()
            If Not Session("agente") Is Nothing Then
                age = Session("agente")
            Else
                Dim ag As New BCb2b.CAgente(mensaje.prop_ggclipr_cod)
                age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
            End If

            Dim provee As New BCb2b.ggclipr(age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"))
            Dim listaContactos As New ArrayList

            'AQUI OBTENGO LOS CONT ASOCIADOS AL CLIENTE Y AL PROVEEDOR
            Dim cont As New BCb2b.CUSRMailCon()
            listaContactos = cont.Obtener_Cont_Asoc(origen.PROP_usrtmensa_cod_SEL, origen.PROP_N_INFORME_SEL, origen.PROP_N_SEQ_SEL, cliente.prop_RSOCIAL_COD)
            listaContactos.AddRange(cont.Obtener_Cont_Asoc(origen.PROP_usrtmensa_cod_SEL, origen.PROP_N_INFORME_SEL, origen.PROP_N_SEQ_SEL, provee.prop_RSOCIAL_COD))

            GVContact.DataSource = listaContactos
            GVContact.DataBind()

            Dim posicion_x As Double = 0
            Dim posicion_y As Double = 0
            OpenWindow.Opennewwindow(adjuntarDocumento, ConfigurationManager.AppSettings("pathFileUpload"), "width=500,height=350,left=" + posicion_x.ToString + ",top=" + posicion_y.ToString + ",resizable=yes,scrollbars=yes", "?dest_doc=" & "USRMAIL" & "&tmensa=" & origen.PROP_usrtmensa_cod_SEL & "&n_inf=" & mensaje.prop_N_INFORME & "&n_seq=" & mensaje.prop_N_SEQ & "&idiomaUpload=" & Mid(Session("idioma"), 1, 2))
        End If

        CargarDocumentosVisita(txt_tmensa.Value, CType(txt_n_informe.Value, OracleNumber), CType(txt_n_seq.Value, OracleNumber))
    End Sub
    'Protected Sub TimerDOCSVisita_Tick(sender As Object, e As EventArgs) Handles TimerDOCSVisita.Tick
    '    CargarDocumentosVisita(txt_tmensa.Value, CType(txt_n_informe.Value, OracleNumber), CType(txt_n_seq.Value, OracleNumber))
    'End Sub
    Protected Sub elimDoc_Click(sender As Object, e As ImageClickEventArgs)

        Dim img As New ImageButton
        img = sender

        Dim codDoc As String = img.CommandName 'AQUI TRAIGO EL CODIGO DEL DOCUMENTO
        Dim rutaDoc As String = img.CommandArgument
        If codDoc <> "" Then

            'AQUI ELIMINAREMOS EL FICHERO
            'LLAMAR A EVENTO NUEVO PARA ELIMINAR DOCS DE LA USRMAILDOC

            'Dim doc As New BCb2b.CGGXXXCGRAF()
            'Dim n_ofe As String = Session("N_OFE")
            'Dim ggxxxtip_cod As String = Session("TIPO_OFE")
            'doc.CB2B_GGXXXCGRAF_ACTUALIZA_ELIMINA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), ConfigurationManager.AppSettings("venta"), ggxxxtip_cod, n_ofe, codDoc.ToUpper, rutaDoc, ConfigurationManager.AppSettings("Oferta"), ConfigurationManager.AppSettings("opcionBorrar"))

        End If
    End Sub
    Public Sub CargarDocumentosVisita(ByVal tmensa As String, ByVal n_inf As OracleNumber, ByVal n_seq As OracleNumber)
        Dim docs As New BCb2b.CUsrmailDoc()
        Dim listaDocs As New ArrayList
        If txt_n_informe.Value <> "" And txt_n_seq.Value <> "" Then
            'If tmensa = ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI") Then
            listaDocs = docs.DameGrafYDocsVisita(tmensa, n_inf, n_seq, ConfigurationManager.AppSettings("rutaBaseFTP2"), ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
            ' Else
            'listaDocs = docs.DameGrafYDocsVisita(tmensa, n_inf, n_seq, ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
            'End If


            'JCE. dejar la palabra VACIO para indicar que es vacio. hay una pequeña trampilla dentro del new
            'no he encontrado otra manera de poner un texto ni no hay valores en un repeater.
            If listaDocs.Count = 0 Then
                Dim doc As New CUsrmailDoc("", OracleNumber.Null, OracleNumber.Null, "", GetGlobalResourceObject("general", "NoDocumentAsoc"), "VACIO")
                listaDocs.Add(doc)
            End If
        Else
            Dim doc As New CUsrmailDoc("", OracleNumber.Null, OracleNumber.Null, "", GetGlobalResourceObject("general", "NoDocumentAsoc"), "VACIO")
            listaDocs.Add(doc)
        End If
        RepeaterDOCS.DataSource = listaDocs
        RepeaterDOCS.DataBind()
        'UPDocumentos.Update()
    End Sub
End Class
