﻿
Partial Class SelCliente_Excel
    Inherits claseBase
    Protected Overrides Sub InitializeCulture()
        Dim culture As String = ""

        If Not Page.IsPostBack Then
            Dim IDIOMA As String = ""
            If Not Session("idioma") Is Nothing Then
                If (Session("idioma").ToString <> "") Then
                    IDIOMA = Session("idioma")
                End If
            Else
                Session("idioma") = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
                IDIOMA = Session("IDIOMA")
            End If
            Select Case IDIOMA
                Case ConfigurationManager.AppSettings("CAS_SPYRO")
                    culture = "es-ES"
                Case ConfigurationManager.AppSettings("ING_SPYRO")
                    culture = "en-GB"
                Case ConfigurationManager.AppSettings("FRA_SPYRO")
                    culture = "fr-FR"
                Case Else
                    culture = ConfigurationManager.AppSettings("IDIOMA_DEFECTO")
            End Select
        End If

        Session("cultura") = culture
        culture = Session("cultura").ToString


        ' Aqui ponemos tambien lo botones adecuados y la imagen del logo.
        ' y el calendario.

        If (String.IsNullOrEmpty(culture)) Then
            culture = "Auto"
            'Use this
            UICulture = culture
            culture = culture
        End If
        'OR This
        If (culture <> "Auto") Then
            Dim ci As New System.Globalization.CultureInfo(culture)
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
        End If
        MyBase.InitializeCulture()

    End Sub


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Not Page.IsPostBack Then

            Dim origen As SelCliente
            origen = CType(Context.Handler, SelCliente)

            'Los criterios de búsqueda y el logo.

            lblempresa.Text = Session("EMPRESA").PROP_NOMBRE
            lblagente.Text = Session("AGENTE").PROP_NOMBRE
            lblNombre.Text = origen.PROP_nombre
            lblcodigo.Text = origen.PROP_COD



            'Ahora construimos el datagrid en otro panel.

            Dim lista As ArrayList
            ' Dim cliente As New BCb2b.ggclipr()
            Dim cliente As New listadoExcelClientes
            Dim AGENTE As String = Session("AGENTE").PROP_COD
            Dim FILTRO_CLIENTE As String = ConfigurationManager.AppSettings("Filtro_cliente_agente")


            lista = cliente.listado_Clientes(origen.PROP_GRUPO, origen.PROP_nombre, origen.PROP_COD, origen.PROP_RSOCIAL_COD, FILTRO_CLIENTE, origen.PROP_TIPVC, AGENTE)
            GVClienteExcel.AllowPaging = False
            GVClienteExcel.DataSource = lista
            GVClienteExcel.DataBind()

            '---------------------------------------------------------------------------

            Dim sb As StringBuilder = New StringBuilder()
            Dim sw As IO.StringWriter = New IO.StringWriter(sb)
            Dim htw As HtmlTextWriter = New HtmlTextWriter(sw)
            Dim pagina As Page = New Page

            GVClienteExcel.EnableViewState = False
            pagina.EnableEventValidation = False
            pagina.DesignerInitialize()
            pagina.Controls.Add(Form)
            Form.Controls.Add(GVClienteExcel)
            pagina.RenderControl(htw)


            Response.Clear()
            Response.Buffer = True
            Response.ContentType = "application/vnd.ms-excel"
            Response.AddHeader("Content-Disposition", "attachment;filename=data.xls")
            Response.Charset = "UTF-8"
            Response.ContentEncoding = Encoding.Default
            Response.Write("<table><tr><td>")
            Response.Write("<tr>")
            Response.Write("<td>   ")
            Response.Write("<img src='" & ConfigurationManager.AppSettings("ruta_logo") & "' /><br/><br/><br/><br/><br/>")
            Response.Write("</td>")
            Response.Write("</tr>")
            Response.Write("<tr>")
            Response.Write("<td>")
            Response.Write(Now().ToShortDateString)
            Response.Write("</td>")
            Response.Write("</tr>")
            Response.Write("<tr>")
            Response.Write("<td>")
            Response.Write(sb.ToString())
            Response.Write("</td></tr></table>")
            Response.End()

       
        End If











    End Sub
End Class
