Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.IO

Partial Class LOV_detalle_seguimiento
    Inherits claseBase
    Private tboxOrigen As String
    Public misql, vsql As String
    Dim conn, conn2 As New OracleConnection()
    Dim conexion As New BCb2b.Enterlan.b2b.Cconexion()
    Dim command As New OracleDataAdapter()
    Dim sql, sql2 As String
    Shared tbox As String

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then

            'Dim el_Agente As String = ""
            Try
                usrtmensa.Value = Request.QueryString("textbox").ToString()
            Catch ex As Exception
                usrtmensa.Value = ""
            End Try
            Try
                n_informe.Value = Request.QueryString("textbox2").ToString()
            Catch ex As Exception
                n_informe.Value = ""
            End Try

            Try
                n_seq.Value = Request.QueryString("c1").ToString()
            Catch ex As Exception
                n_seq.Value = ""
            End Try

            If usrtmensa.Value <> "" And n_informe.Value <> "" And n_seq.Value <> "" Then

                Dim url As String = ConfigurationManager.AppSettings("pathB2BAMCSADocs")
                ' Detalle del mensaje.
                Dim mensaje As New BCb2b.CUSRMail()
                mensaje.Seguimiento_Oferta_Detalle(usrtmensa.Value, CInt(n_informe.Value), CInt(n_seq.Value))

                lblFecha.Text = mensaje.prop_f_creacion
                lblOrigen.Text = mensaje.prop_usrnom_ori
                lblDestino.Text = mensaje.prop_usrnom_des
                lblRSocial.Text = mensaje.prop_rsocial_cod

                Dim cliente As New BCb2b.ggclipr()
                If (mensaje.prop_ggclipr_cod <> "") Then
                    cliente = New BCb2b.ggclipr(mensaje.prop_ggclipr_cod, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"))
                    lblCliente.Text = cliente.prop_NOMBRE
                    lblClienteCod.Text = mensaje.prop_ggclipr_cod
                Else
                    Dim razon_social As New BCb2b.CRSOCIAL(mensaje.prop_rsocial_cod)
                    lblClienteCod.Text = mensaje.prop_rsocial_cod
                    lblCliente.Text = razon_social.PROP_NOMBRE
                End If
                lblAsunto.Text = mensaje.prop_DESCRIPTOR

                'lblCuerpo.Text = mensaje.prop_cuerpo_sin_patron 'CONTENIDO SIN PATRON
                'EL CUERPO AHORA LO OBTENEMOS DE LA USRMAILHTML
                Dim txthtml As New BCb2b.usrmailhtml()
                lblCuerpo.Text = txthtml.Dame_Texto(mensaje.prop_USRTMENSA_COD, mensaje.prop_N_INFORME, mensaje.prop_N_SEQ)
                If lblCuerpo.Text = "" Then 'SI NO TIENE CONTENIDO CON HTML EN DICHA TABLA COGEMOS EL NORMAL.
                    lblCuerpo.Text = mensaje.prop_cuerpo_sin_patron
                End If


                lblDestinos.Text = mensaje.prop_enviados_libre 'DESTINOS OBTENIDOS DE PATRON

                Call CargarDocumentosVisita(usrtmensa.Value, CType(n_informe.Value, OracleNumber), CType(n_seq.Value, OracleNumber))

                'Contactos asociados al cliente y al proveedor
                Dim age As New BCb2b.gvagente()
                If Not Session("agente") Is Nothing Then
                    age = Session("agente")
                Else
                    Dim ag As New BCb2b.CAgente(mensaje.prop_ggclipr_cod)
                    age = New BCb2b.gvagente(ag.prop_USRNOM_COD, ConfigurationManager.AppSettings("grupo"))
                End If

                Dim provee As New BCb2b.ggclipr(age.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"))
                Dim listaContactos As New ArrayList

                'AQUI OBTENGO LOS CONT ASOCIADOS AL CLIENTE Y AL PROVEEDOR
                Dim cont As New BCb2b.CUSRMailCon()
                listaContactos = cont.Obtener_Cont_Asoc(usrtmensa.Value, n_informe.Value, n_seq.Value, cliente.prop_RSOCIAL_COD)
                listaContactos.AddRange(cont.Obtener_Cont_Asoc(usrtmensa.Value, n_informe.Value, n_seq.Value, provee.prop_RSOCIAL_COD))

                GVContact.DataSource = listaContactos
                GVContact.DataBind()
            End If
        End If
    End Sub
    Public Sub CargarDocumentosVisita(ByVal tmensa As String, ByVal n_inf As OracleNumber, ByVal n_seq As OracleNumber)
        Dim docs As New BCb2b.CUsrmailDoc()
        Dim listaDocs As New ArrayList
        If n_informe.Value <> "" And n_seq.Value.ToString <> "" And usrtmensa.Value <> "" Then
            'If tmensa = ConfigurationManager.AppSettings("TIPO_MENSAJE_CREAR_SEGUI") Then
            'listaDocs = docs.DameGrafYDocsVisita(tmensa, n_inf, n_seq, ConfigurationManager.AppSettings("pathB2BAMCSADocs"), ConfigurationManager.AppSettings("USUARIO_CREAR_SEGUI") & "/" & tmensa.ToString & "_" & n_inf.ToString)
            listaDocs = docs.DameGrafYDocsVisita(tmensa, n_inf, n_seq, ConfigurationManager.AppSettings("rutaBaseFTP2"), ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
            ' Else
            'listaDocs = docs.DameGrafYDocsVisita(tmensa, n_inf, n_seq, ConfigurationManager.AppSettings("pathB2BAMCSADocs"))
            'End If

            If listaDocs.Count = 0 Then
                Dim doc As New BCb2b.CUsrmailDoc("", OracleNumber.Null, OracleNumber.Null, "", "")
                listaDocs.Add(doc)
            End If
        Else
            Dim doc As New BCb2b.CUsrmailDoc("", OracleNumber.Null, OracleNumber.Null, "", "")
            listaDocs.Add(doc)
        End If
        RepeaterDOCS.DataSource = listaDocs
        RepeaterDOCS.DataBind()
        'UPDocumentos.Update()
    End Sub
End Class
